#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <dlfcn.h>
#include <iconv.h>
#include <errno.h>
#include <ctype.h>
#include <sys/time.h>
#include <math.h>
#include <sys/stat.h>
#include <time.h>
//#include <sys/types.h>

#include "test_func.h"

#define AUDIO_FRAME 5
#define G711A  0x01 
#define G711U  0x02 
#define ADPCM  0x03 
#define G726   0x04

int g_iLogonID = -1;

int g_iLogonID_sys[MAX_DEVICE_NUM] = {-1};
int g_iTotalChnlNum = 0;
unsigned int g_uiRecv[MAX_DATA_CHAN]; //mainгʼ
NVS_FILE_DATA fileInfo[MAX_PAGE_SIZE] = {{0}};
unsigned int g_uiFileRecvID[MAX_FILE_CHAN] = {0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF};

static unsigned int g_uiNetFileID = 0;

int g_iLanguage = 1;

FILE* file = NULL;

FILE *g_fpRawStream[32] = {0};
FILE *g_fpSdv[32] = {0};
FILE *g_fpH264[32] = {0};
FILE *g_fpG711A[32] = {0};
FILE *g_fpG711U[32] = {0};
FILE *g_fpADPCM[32] = {0};
FILE *g_fpG726[32] = {0};

extern char* g_cLogBuf;

int g_iDiskNO = 0;
int g_iPartNum = 0;
int g_iFormatNow = 0;

static inline bool IsDVR(const int _iProductModel)
{
    return ((_iProductModel & 0x100) == 0x100);
}

static inline bool IsS3(const int _iProductModel)
{
	bool bRet = false;
	switch(_iProductModel & 0xFFFF)
	{
	case TC_NC9000S3_3MP:
	case TC_NS921S3_HD_V1:
	case TC_NC9100S3_3MP_IR30:
	case TC_NC9000S3_2MP_E:
	case TC_NC9200S3_MP_E_IR15:
	case TC_NH9206S3_2MP_IVS:
	case TC_NC9000S3_MP_E:
	case TC_NC9100S3E_MP_IR30:
	case TC_NC9000S3E_MP:
	case TC_NC9200S3E_MP_IR:
		bRet = true;
		break;
	default:
		break;
	}
	return bRet;
}

int AnalyzeRecvID(unsigned int _uiRecvID,int *_iLogonID,int *_iChan)
{
    if (_iLogonID)
    {
        *_iLogonID = (_uiRecvID & 0xFFFF0000) >> 16;
    }

    if (_iChan)
    {
        *_iChan = _uiRecvID & 0x0000FFFF;
    }

    return 0;
}

int to_int_def(const char* _pstrFrom, int _iDef)
{
	if(NULL == _pstrFrom)
	{
		return _iDef;
	}

	for (size_t i=0; i<strlen(_pstrFrom); i++)
    {
        if (!isdigit(_pstrFrom[i]))
        {
			if(i == 0 && _pstrFrom[i] == '-' && strlen(_pstrFrom) > 1)
			{
				continue;
			}
            return _iDef;
        }
    }

    return atoi(_pstrFrom);
}

unsigned int to_uint_def(const char* _pstrFrom, unsigned int _uiDef)
{
	if(_pstrFrom==NULL)
		return _uiDef;
		
	unsigned int uiRet = 0;
	
	if(sscanf(_pstrFrom, "%u", &uiRet)!=1)
		return _uiDef;
	return uiRet;
}

bool to_boolean_def(const char* _pstrFrom, bool _bDef)
{
	if(NULL == _pstrFrom)
	{
		return _bDef;
	}

	if((0==strcasecmp(_pstrFrom, "n"))
		|| (0==strcasecmp(_pstrFrom, "no")))
	{
		return false;
	}
	else if((0==strcasecmp(_pstrFrom, "y"))
			|| (0==strcasecmp(_pstrFrom, "yes")))
	{
		return true;
	}

	return _bDef;
}

int SafeGetInt()
{
    char cTemp[256] = {0};
    gets_s(cTemp,8);
	if(0 == strcasecmp("q", cTemp))
    {
        exit(0);   //ܻй©
    }

    return to_int_def(cTemp,0);
}


//ת:һֱתΪһֱ 
int code_convert(char *from_charset, char *to_charset, char *inbuf, size_t inlen, char *outbuf, size_t outlen) 
{ 
	iconv_t cd; 
	char **pin = &inbuf; 
	char **pout = &outbuf; 

	cd = iconv_open(to_charset, from_charset); 
	if ((iconv_t)(-1) == cd) 
	{
		printf("iconv_open failed, errno= %d\n", errno);
		return -1; 
	}
	
	memset(outbuf, 0, outlen); 
	if ((size_t)(-1) == iconv(cd, pin, &inlen, pout, &outlen)) 
	{
		printf("iconv failed, errno= %d\n", errno);
		return -1; 
	}
	
	iconv_close(cd); 
	return 0; 
} 

//GB2312תΪUNICODE ڴwindowsתlinux
int g2u(char *inbuf, size_t inlen, char *outbuf, size_t outlen) 
{ 
	return code_convert("gb2312", "utf-8", inbuf, inlen, outbuf, outlen); 
} 

//UNICODEתΪGB2312 ڴlinuxתwindows
int u2g(char *inbuf, size_t inlen, char *outbuf, size_t outlen) 
{ 
	return code_convert("utf-8", "gb2312", inbuf, inlen, outbuf, outlen); 
} 

void signal_fn(int sig)
{
    int iUpgradePercent = NetClient_GetUpgradePercent(g_iLogonID);
    if(iUpgradePercent >= 100)
    {
        iUpgradePercent = 100;
    }
    printf("Upgrade %d \n",iUpgradePercent);
    if(iUpgradePercent < 100)
    {
        alarm(1);
    }
}

int gets_s(char *_pcStr, int _iCount)
{
    if (_pcStr == NULL)
        return -1;

	char* pcRet = fgets(_pcStr, _iCount, stdin);
    size_t uiLen = strlen(_pcStr);
    if (pcRet == NULL || uiLen == 0)
        return -2;

    if (_iCount - 1 > (int)uiLen || _pcStr[uiLen-1] == '\n')
    {
        _pcStr[uiLen-1] = '\0';
    }

    stdin->_IO_read_ptr = stdin->_IO_read_end;
    //tcflush( STDIN_FILENO, TCIFLUSH );
	return 0;
}

// ַָ
//int split_str(char* source, const char *delim, char *dst[])
//{
//    int iRet = 0;
//    int i = 0;
//
//    dst[i] =  strtok(cBuf, delim);
//    while(NULL != dst[i])
//    {
//        i++;
//        dst[i] = strtok(NULL, delim);
//    }
//
//    if (i < 2)
//    {
//        printf("The source string cannot be splited\n");
//        iRet = -1;
//    }
//    return iRet;
//}


// ص
void Proupgrade_Notify(int _iLogonID,int _iServerState,void* _iUser)
{
    if(0 == _iServerState)
    {
        printf("Update success, restart now\n");
    }
    else
    {
        printf("Update failed, please check network!\n");
    }
}

/*********************************Υͣcb@120829**********************************/
#define  MAX_PICTURE_NUM 3        //ͼƬͨ
#define  PIC_CRC_NUM 3
#define  PACKET_HEAD_LEN 16
typedef  unsigned int uint;

//picture stream 
typedef struct
{
    unsigned char	m_ui8PkgHead[PACKET_HEAD_LEN]; //ͷ //{16,14,12,10,8,6,4,2,1,3,5,7,9,11,13,15}
    uint	m_ui32DataType;						//ͣ
    int   	m_iChannelID;						// //0

    char  	m_cPlate[32];						//
                                                //ǰ16char16char Ϊ0һץͼƬȫΪ0
    int   	m_iPlateColor;			            //ɫһץͼƬò0
    int   	m_iPlateType;			            //, һץͼƬò0
    int	  	m_iCarColor;			            //ɫ, һץͼƬò0
                                                //32ɫն˰չת10ɫ
    RECT	m_stPlateRange;			            //ƷΧ, һץͼƬò0
    int   	m_iCharConfid[12];	                //ַŶ,Ϊ12ַ ǰ8 4Ϊ0,ÿֵķΧ0-1024, , һץͼƬò0
    int   	m_iCharNum;					        //ַĿ 8  --,һץͼƬò0
    int   	m_iPlateConfid;				        //Ŷ, һץͼƬò0
    int   	m_iRecoNum;					        //ʶͼƬ  //Υͣ3ͼƬʶΪڶţ̶Ϊ2ں˶ʶʹ
    float 	m_fSpeed;							//ٶ //0
    int 	m_iVehicleDirection;				// //0
    int		m_iAlarmType;						//
    char  	m_cCameraIP[16];					//IP  //ʽ磺127.0.0.1
    int   	m_iCaptureInfoNum;					//¼ͼƬ //̶Ϊ1ע˴޸ģ3Ϊ1
    int     m_iRedBeginTime;					//ƿʼʱ䣬λ //Ϊ0
    int     m_iRedEndTime;						//ƽʱ䣬λ //Ϊ0
    char  	m_stCaptureTime[MAX_PICTURE_NUM][8];//ÿͼƬץʱ:----ʱ---
                                                //ע⣬ĿǰʵӦãֻһͼƬ˴stCaptureTime[1][8]stCaptureTime[2][8]Ϊȫ0ֻץʱ䵽stCaptureTime[0][8]
    int	  	m_iCaptureLen[MAX_PICTURE_NUM];	    //ÿͼƬĳ
                                                //ע⣬ͬϣ䵱ǰͼƬȵm_iCaptureLen[0]Ϊ0
    //ΥֶͣΣĿרֶΣ
  	int 		m_iPreset;					    //Ԥλ
  	int 		m_iArea;					    //
	char 		fileName[32];				    //¼ļ
	long		m_iCarSerialNum;			    //Υͣţͬһ豸ñΨһ
	int			m_iPictureNum;				    //3ץеͼƬţ123
    unsigned char	m_ui8PkgTail[PACKET_HEAD_LEN];		//β{15,13,11,9,7,5,3,1,2,4,6,8,10,12,14,16};
}STRCT_Record;

/*********************************ʱ**********************************/
static void  cbkRecvDataEx(unsigned long _ulID,unsigned char* _ucData,int _iLen, int _iFlag, void* _lpUserData)
{
    //ÿͼƬͷһṹ壬ͼƬβڷFEOFҲֿͨƵͨͳһ͡һֿʣٷ
    //һδ˻صʾյһΪ_iLenݰ
	//һλ߶ν˻صŽյһ֡ݣṹСֽ+32ֽ֡ͷ+ͼƬ1+ͼƬ2...+4ֽ=FEOF+ 4ֽڣ
	//Ҫöÿηݵ  ȡ ҪϢ
    static  bool blNewPicStream = true;
    static  int  g_iPicCount = 0;       //ʾÿץĵͼƬ
    static  int  g_iCaptureNum = 0;     //ʾץĴ
    static  int  g_iPicNum  = 0;        //ͼƬͷжӦаͼƬ
    static  int  g_iCarSerialNum = 0;
    static  int  g_iPictureNum = 0;
    static  unsigned char ucPacketHeader[2 * sizeof(STRCT_Record)] = {0};
    static  FILE* fpPicStream = NULL;
    static  STRCT_Record* pHeader = NULL;
    static  int     iNeedDataLen = sizeof(STRCT_Record) + 32;
//  static  char*    cVehicleColor[33] = {"ɫ","Ⱥ","ɫ","","","","","","ۺ","ɫ","ɫ","","ɫ","ɫ","ɫ","",
//                                         "ɫ","̻","ɫ","ɫ","","ɫ","ɫ","","","","","Ϻ","ɫ","غ","ػ","ɫ"};
//  static  char*    cLPRPlateColor[7] = {"PC_UNKNOWN", "PC_BLUE", "PC_YELLOW", "PC_WHITE", "PC_BLACK", "PC_GREEN"};
//  static  char*    cLPRPlateType[16] =
//                      {
//                              "PT_UNKOWN"		    //= 0,	// δ֪
//                              "PT_CAR_NORMAL"	    //= 1,	// ͨС˽ҳɫɫ
//                              "PT_BIG_NORMAL"	    //= 2,	// ͨ󳵣ɫ
//                              "PT_POLICE"		    //= 4,  // ָڵһλ͵ڶλַ֮䣩ɫ
//                              "PT_WJ"		        //= 8,	// 侯
//                              "PT_HK"			    //= 16,	// ۰ĳ
//                              "PT_DOUBLELINE"	    //= 32,	// ˫
//                              "PT_MILITARY"	    //= 64,	// 
//                              "PT_AMBASSADOR"	    //= 128,	// ʹݳ
//                              "PT_POLICE_TYPE2"	//= 512,    // ڶྯָڵڶλ͵λַ֮䣩ɫ
//                              "PT_XUE"			//= 1024,	// "ѧ"
//                              "PT_MOTOR"		    //= 2048,	// Ħг
//                              "PT_LIAOTEMP"		//= 4096,   // ֳ
//                              "PT_GREEN"		    //= 8192,	// ˫ƣũó
//                              "PT_GUA"			//= 16384	// ""
//                      };

    //printf("into the last step0,_lpUserData is %d\n ", (int)_lpUserData);
	//printf("into the last step,_lpUserDatsa is %d\n ", (int)*_lpUserData);
    if(0xF000 == (int)_lpUserData)
	{
		//ifʵֽص_ucDataucPacketHeader
		//ȻתͼƬϢSTR_PacketHeaderṹ
		
		if(blNewPicStream)
		{
			//ȡṹ岿
			if(_iLen >= iNeedDataLen)
			{
				//_ucDataڽṹcopy ucPacketHeader
				memcpy(ucPacketHeader + (sizeof(STRCT_Record)+32 - iNeedDataLen), _ucData, iNeedDataLen);
				pHeader = (STRCT_Record*)(ucPacketHeader + 32);

                //ȡͼƬ
                g_iPicNum = pHeader->m_iCaptureInfoNum;
                g_iCarSerialNum = pHeader->m_iCarSerialNum;
                g_iPictureNum = pHeader->m_iPictureNum;
                //ʾ ɫ ɫ ¼ļ
                //int  iVehicleColorNumber = pHeader->m_iCarColor;
                //char*  strVehicleColor = cVehicleColor[iVehicleColorNumber];
                //int  iPlateColorNumber = pHeader->m_iPlateColor;
                //char*  strPlateColor = cLPRPlateColor[iPlateColorNumber];
//              int iPlateTypeIndex = pHeader->m_iPlateColor;
//              if(iPlateTypeIndex != 0)
//              {
//                  iPlateTypeIndex = (int)(log10(iPlateTypeIndex))/(log10(iPlateTypeIndex));
//              }
                //while(iPlateTypeIndex)   //anather
                //{
                //   iPlateTypeIndex<<1;
                //   iPlateTypeIndex++;
                //}
               // char*  strPlateType = cLPRPlateType[iPlateTypeIndex];

                //printf("VehicleColor:%s, iPlateColor:%s, iPlateType:%s", strVehicleColor, strPlateColor, strPlateType);
				// ȡṹ岿
				blNewPicStream = false;
				iNeedDataLen = iNeedDataLen - _iLen;       //ӦΪ0߸ʾṹݶ
				//printf("pHeader->m_stCaptureTime[0] %d %d %d %d %d %d %d %d\n", pHeader->m_stCaptureTime[0][0],pHeader->m_stCaptureTime[0][1],pHeader->m_stCaptureTime[0][2],pHeader->m_stCaptureTime[0][3],pHeader->m_stCaptureTime[0][4],pHeader->m_stCaptureTime[0][5],pHeader->m_stCaptureTime[0][6],pHeader->m_stCaptureTime[0][7]);
			}
			else
			{
				//_ucDatacopy ucPacketHeader
				memcpy(ucPacketHeader + (sizeof(STRCT_Record)+32 - iNeedDataLen), _ucData, _iLen);
				iNeedDataLen = iNeedDataLen - _iLen;
			}
            //printf("Pic Header, NeedLen = %d, recv len = %d\n", iNeedDataLen, _iLen);
		}

		//ݽṹϢͼƬ
		if(false == blNewPicStream)
		{
			//½յ
 			if(iNeedDataLen >= 0)
 			{
				//жǲһ֡ݵһ
				char csEnd[5] = {0};
				memcpy(csEnd, _ucData+(_iLen-8), 4);
				if(strcmp(csEnd,"FEOF") == 0)
				{
					if(NULL != fpPicStream && _iLen >= 8)
					{
						fwrite(_ucData, _iLen - 8, 1, fpPicStream);
					}
					g_iPicCount = 0;
                    g_iCaptureNum++;
                    g_iPicNum = 0;

					blNewPicStream = true;
					iNeedDataLen = sizeof(STRCT_Record) + 32;
					memset(ucPacketHeader, 0 , 2 * sizeof(STRCT_Record));

					//printf("fpPicStream111 = %d\n", fpPicStream);
					//fflush(fpPicStream);  //reverify cb
					//fclose(fpPicStream);
					fpPicStream = NULL;
                    //printf("Recv FEOF, recv len = %d\n", _iLen);
                    
					return;
				}

				//Բһݵ дļ
 				if(iNeedDataLen >= _iLen)               //add "=" cb@120530
 				{
					if(NULL != fpPicStream && _iLen >= 0)
					{
 						fwrite(_ucData, _iLen, 1, fpPicStream);
					}
 				}
 				else   //˴Ӧɾ cb@120531  ڲְ
 				{
					//ʱûҵFEOFѾǵڶͼƬĽFEOF(int)ְ
					if(NULL != fpPicStream && iNeedDataLen >= 0)
					{
 						fwrite(_ucData, iNeedDataLen, 1, fpPicStream);
					}
 				}

				//iNeedDataLenΪʾҪõһͼƬҪiNeedDataLen
				//iNeedDataLenΪ0   ʾպõõһͼƬݣwhileдͼƬ
				//iNeedDataLenΪʾһͼƬʣ-iNeedDataLenݣwhileдͼƬƣʣµ
 				iNeedDataLen = iNeedDataLen - _iLen;
 			}
            //printf("Pic Data, NeedLen = %d, recv len = %d\n", iNeedDataLen, _iLen);
 
 			//ǰδͼƬ
 			while(iNeedDataLen <= 0)             //cb <=0 Ϊ == 120602     -1116 0
            {
				//printf("fpPicStream333 = %d\n", fpPicStream);
 				if(fpPicStream)
 				{
                    //printf("fpPicStream222 = %d\n", fpPicStream);
 					fflush(fpPicStream);
 					fclose(fpPicStream);
 					fpPicStream = NULL;
 				}

                if(g_iPicCount < g_iPicNum)
                {
                    if(NULL == fpPicStream)
                    {
                        char cDirStore[256] = {0};

                        //sprintf(cDirStore, "D:\\Demo_PicStream\\PicStream_ITS%d_%d.jpg",g_iCaptureNum, g_iPicCount);
                        //sprintf(cDirStore, "D:\\Demo_PicStream\\PicStream_ITS%d_%d.jpg", g_iCarSerialNum, g_iPictureNum);
                        //sprintf(cDirStore, "D:\\Demo_PicStream\\PicStream_ITS%d_%d.jpg", g_iCarSerialNum, g_iPictureNum);  //ļȨ
						sprintf(cDirStore, "./Demo_PicStream/PicStream_ITS%d_%d.jpg", g_iCarSerialNum, g_iPictureNum);       //ļȨ
						//sprintf(cDirStore, "G:/linuxsdksvn/NVSSDK/z-demo/PicStream_ITS%d_%d.jpg", g_iCarSerialNum, g_iPictureNum);   
						//sprintf(cDirStore, "/mnt/hgfs/Demo_PicStream/PicStream_ITS%d_%d.jpg", g_iCarSerialNum, g_iPictureNum);
                        fpPicStream = fopen(cDirStore, "wb");
						//printf("creat picture in here,cDirStore is %s, fpPicStream is %p, fpPicStream is %c\n", cDirStore, fpPicStream,fpPicStream);
                        if(NULL == fpPicStream)
                            return;
                    }

                    if((0 - iNeedDataLen) > pHeader->m_iCaptureLen[g_iPicCount])
                    {
                        //Ӧòִ
                        if(NULL != fpPicStream && pHeader->m_iCaptureLen[g_iPicCount] >= 0)
                        {
                            fwrite(_ucData + _iLen + iNeedDataLen , pHeader->m_iCaptureLen[g_iPicCount], 1, fpPicStream);
                        }
                    }
                    else
                    {
                        if(NULL != fpPicStream && iNeedDataLen <= 0)
                        {
                            fwrite(_ucData + _iLen + iNeedDataLen , (0-iNeedDataLen), 1, fpPicStream);
                        }
                    }
                    //new protocol once only send one picture, iNeedDataLen now retur a Plus quantity .
                    iNeedDataLen = pHeader->m_iCaptureLen[g_iPicCount] + iNeedDataLen;
                    g_iPicCount++;
                }
                else
                    break;
			}
		}
	}
    else if(0xF001 == (int)_lpUserData)
        printf("Cap channel data...len\n");
//#ifndef PLAY_CALLBACK_STREAM
//    return;
//#else
//    if (g_iRealStreamPlayer >= 0)
//    {
//        TFmPlayer::TC_PutStreamToPlayer(g_iRealStreamPlayer, _ucData, _iLen);
//    }
//#endif
}

#define FILESZ_15G	1532*1024*1024
void NVSDATA_Notify(unsigned int _uiRecvID, unsigned char* _ucData, int _iLen, void* _iUserData)  //ȡԭʼ
{
	printf("[NVSDATA_Notify] _iUserData :%d \n", _iUserData);
    //ͼƬ
	cbkRecvDataEx( _uiRecvID, _ucData,_iLen, 0, _iUserData);
	
	int iChannel = 0;
	AnalyzeRecvID(_uiRecvID, NULL, &iChannel);

	if(NULL == g_fpRawStream[iChannel])
    {
		//S_header *pHead = (S_header*)_iUserData;
		//unsigned char ucHead[128] = {0};
		//memcpy(ucHead, pHead, sizeof(S_header));
		char cFileName[32] = {0};
		sprintf(cFileName, "NvsData%d.dat", iChannel);
		g_fpRawStream[iChannel] = fopen(cFileName, "wb");
//  	if(NULL != g_fpRawStream[iChannel])
//  	{
//  		fwrite(ucHead, sizeof(unsigned char), sizeof(S_header), g_fpRawStream[iChannel]);  // дļͷ
//  	}

        printf("[NVSDATA_Notify] create raw stream file :%s \n", cFileName);
        fprintf(stderr, "Please type interface to test:");
    }

    if(NULL != g_fpRawStream[iChannel])
    {
		if (ftell(g_fpRawStream[iChannel]) + _iLen > FILESZ_15G)
		{
			fclose(g_fpRawStream[iChannel]);
			g_fpRawStream[iChannel] = NULL;
		}
		else
		{
			fwrite(_ucData, sizeof(unsigned char), _iLen, g_fpRawStream[iChannel]);
		}
    }
    else
    {
        printf("[NVSDATA_Notify] create file failed \n");
        fprintf(stderr, "Please type interface to test:");
    }
}



void FullStream_Notify(unsigned int _ulID, unsigned int _ulStreamType, unsigned char *_ucData, int _iLen, void* _iUser)  //ȡ֡
{
    timeval g_currtime1;
    gettimeofday(&g_currtime1,NULL);
    int  systemtime = (g_currtime1.tv_sec-1313000000)*1000+g_currtime1.tv_usec/1000;
    fprintf(stderr, "Get one stream, &&&&&&&&&&&& time(%d)\n", systemtime);
	int iChannel = 0;
	AnalyzeRecvID(_ulID, NULL, &iChannel);

	if(NULL == g_fpSdv[iChannel])
    {
		S_header *pHead = (S_header*)_iUser;
		unsigned char ucHead[128] = {0};
		memcpy(ucHead, pHead, sizeof(S_header));
		char cFileName[32] = {0};
		sprintf(cFileName, "FullStream%d.sdv", iChannel);
		g_fpSdv[iChannel] = fopen(cFileName, "wb");
		if(NULL != g_fpSdv[iChannel])
		{
			fwrite(ucHead, sizeof(unsigned char), sizeof(S_header), g_fpSdv[iChannel]);  // дļͷ
		}
        printf("[FullStream_Notify] create full stream file : %s \n", cFileName);
		fprintf(stderr, "Please type interface to test:");
    }

    if(g_fpSdv[iChannel])
    {
        fwrite(_ucData, sizeof(unsigned char), _iLen, g_fpSdv[iChannel]);
    }
    else
    {
        printf("[FullStream_Notify] create file failed \n");
    }

    //fprintf(stderr, "Please type interface to test:");
}


void RawFrame_Notify(unsigned int _ulID, unsigned char* _cData, int _iLen, RAWFRAME_INFO *_pRawFrameInfo, void* _iUser)
{
    //fprintf(stderr, "[RawFrame_Notify]User data (0x%x).\n", _iUser);
	int iChannel = 0;
	AnalyzeRecvID(_ulID, NULL, &iChannel);

    if(AUDIO_FRAME != _pRawFrameInfo->nType)  // h264Ƶ
    {
        if(NULL == g_fpH264[iChannel])
        {
			char cFileName[32] = {0};
			sprintf(cFileName, "RawFrame%d.h264", iChannel);
            g_fpH264[iChannel] = fopen(cFileName, "wb");
            printf("[RawFrame_Notify] create raw frame file : %s\n", cFileName);
			fprintf(stderr, "Please type interface to test:");
        }
    
        if(g_fpH264[iChannel])
        {
            fwrite(_cData, 1, _iLen, g_fpH264[iChannel]);
        }
        else
        {
            printf("[RawFrame_Notify] create file failed \n");
        }
    }
    else    //Ƶ
    {
        switch(_pRawFrameInfo->nEnCoder)
        {
        case G711A:
            if(NULL == g_fpG711A[iChannel])
            {
				char cFileName[32] = {0};
				sprintf(cFileName, "G711A%d.dat", iChannel);
			    g_fpG711A[iChannel] = fopen(cFileName, "wb");
            }

            if(g_fpG711A[iChannel])
            {
                fwrite(_cData, 1, _iLen, g_fpG711A[iChannel]);
            }
            else
            {
                printf("[RawFrame_Notify]Create G711A%d.dat failed!\n", iChannel);
            }
            break;
        case G711U:
            if(NULL == g_fpG711U[iChannel])
            {
				char cFileName[32] = {0};
				sprintf(cFileName, "G711U%d.dat", iChannel);
				g_fpG711U[iChannel] = fopen(cFileName, "wb");
            }

            if(g_fpG711U[iChannel])
            {
                fwrite(_cData, 1, _iLen, g_fpG711U[iChannel]);
            }
            else
            {
                printf("[RawFrame_Notify]Create G711U%d.dat failed!\n", iChannel);
            }
            break;
        case ADPCM:
            if(NULL == g_fpADPCM[iChannel])
            {
				char cFileName[32] = {0};
				sprintf(cFileName, "adpcm%d.dat", iChannel);
				g_fpADPCM[iChannel] = fopen(cFileName, "wb");
            }

            if(g_fpADPCM[iChannel])
            {
                fwrite(_cData, 1, _iLen, g_fpADPCM[iChannel]);
            }
            else
            {
                printf("[RawFrame_Notify]Create adpcm%d.dat failed!\n", iChannel);
            }
            break;
        case G726:
            if(NULL == g_fpG726[iChannel])
            {
				char cFileName[32] = {0};
				sprintf(cFileName, "G726%d.dat", iChannel);				
				g_fpG726[iChannel] = fopen(cFileName, "wb");
            }

            if(g_fpG726[iChannel])
            {
                fwrite(_cData, 1, _iLen, g_fpG726[iChannel]);
            }
            else
            {
                printf("[RawFrame_Notify]Create G726%d.dat failed!\n", iChannel);
            }
            break;
        default:
            break;
    
        }
    }

    //fprintf(stderr, "Please type interface to test:");
}

void Notify_DecYUV(unsigned int _ulID, unsigned char *_cData, int _iLen, const FRAME_INFO *_pFrameInfo, void* _iUser)
{
    fprintf(stderr, "[Notify_DecYUV]====Recv id(%d), len(%d), user data(%d)\n", _ulID, _iLen, _iUser);
}
// picture stream notify@120823
void PICTURECAP_Notify(unsigned int _uiRecvID, unsigned char* _ucData, int _iLen, int _iUserData)  //ȡԭʼ
{
	int iChannel = 0;
	AnalyzeRecvID(_uiRecvID, NULL, &iChannel);

	if(NULL == g_fpRawStream[iChannel])
    {
		//S_header *pHead = (S_header*)_iUserData;
		//unsigned char ucHead[128] = {0};
		//memcpy(ucHead, pHead, sizeof(S_header));
		char cFileName[32] = {0};
		sprintf(cFileName, "NvsData%d.dat", iChannel);
		g_fpRawStream[iChannel] = fopen(cFileName, "wb");
//  	if(NULL != g_fpRawStream[iChannel])
//  	{
//  		fwrite(ucHead, sizeof(unsigned char), sizeof(S_header), g_fpRawStream[iChannel]);  // дļͷ
//  	}

        printf("[NVSDATA_Notify] create raw stream file :%s \n", cFileName);
        fprintf(stderr, "Please type interface to test:");
    }

    if(NULL != g_fpRawStream[iChannel])
    {
        fwrite(_ucData, sizeof(unsigned char), _iLen, g_fpRawStream[iChannel]);
    }
    else
    {
        printf("[NVSDATA_Notify] create file failed \n");
        fprintf(stderr, "Please type interface to test:");
    }
}
//-------------------------------------------------------------------

void ListAllInterface()
{
    fprintf(stderr,
        "(1)  StartRecv                     (2)  StopRecv              (3)  SetNVS          \n"
        "(4)  GetAlarmPortNum               (5)  GetAudioChannel       (6)  SetAudioChannel \n"
        "(7)  SetAlmVdoCovThreshold         (8)  SetOutportState       (9)  GetOutportState \n"
        "(10) GetAlmVdoCovThreshold         (11) SetAlmVideoCov        (12) GetAlmVideoCov  \n"
        "(13) GetAllSupportDeviceType       (14) DeviceCtrl            (15) DeviceCtrlEx    \n"
        "(16) GetVideoLostLinkSoundDisplay  (17) GetAlarmVLostState    (18) GetTalkingState \n"
        "(19) SetVideoLostLinkSoundDisplay  (20) SetComRecvNotify      (21) GetChannelNum   \n"
        "(22) GetMaxMinorVideoSize          (23) GetWifiDHCPParam      (24) SetWifiDHCPParam\n"
        "(25) SetReducenoiseState           (26) ReadUserData          (27) WriteUserData   \n"
        "(28) GetReducenoiseState           (29) DrawTextOnVideo       (30) GetTextOnVideo  \n"
        "(31) SetBothStreamSame             (32) GetBothStreamSame     (33) SetPPPoEInfo    \n"
        "(34) NetFileIsSupportStorage       (35) LogFileGetProperty    (36) DiskFormat      \n"
        "(37) NetFileRebuildIndexFile       (38) NetFileDownloadFile   (39) GetPPPoEInfo    \n"
        "(40) NetFileStopDownloadFile       (41) NetFileMountUSB       (42) NetFileDelFile  \n"
        "(43) LogFileSetProperty            (44) NetFileGetUSBstate    (45) DiskPart        \n"
        "(46) NetFileSetExtendname          (47) NetFileGetExtendname  (48) ClearDisk       \n"
        "(49) SetMediaStreamClient          (50) GetMediaStreamClient  (51) SetScene        \n"
        "(52) GetPrivacyProtect             (53) SetSensorFlip         (54) GetSensorFlip   \n"
        "(55) SetSensorMirror               (56) GetSensorMirror       (57) Snapshot        \n"
        "(58) SetWifiParam                  (59) GetWifiParam          (60) WifiSearch      \n"
        "(61) GetWifiSearchResult           (62) SetPrivacyProtect     (63) GetScene        \n"
        "(64) IYUVtoYV12                    (65) GetDevType            (66) BackupKernel    \n"
        "(67) SetUPNPEnable                 (68) SetFuncListArray      (69) GetUPNPEnable   \n"
        "(70) GetFuncListArray              (71) SetVencType           (72) GetVencType     \n"
        "(73) SetComServer                  (74) Get3GDeviceStatus     (75) GetComServer    \n"
        "(76) Set3GDialog                   (77) Get3GDialog           (78) Set3GMessage    \n"
        "(79) Get3GMessage                  (80) Set3GTaskSchedule     (81) Set3GNotify     \n"
        "(82) Get3GTaskSchedule             (83) Get3GNotify           (84) SetHDCame       \n"
        "(85) GetHDCamer                    (86) SetAlarmServer        (87) GetAlarmServer  \n"
        "(88) GetUpgradePercent             (89) UpgradeWebPage        (90) UpgradeProgram  \n"
        "(91) DelUser                       (92) ModifyPwd             (93) SetMaxConUser   \n"
        "(94) SetStreamType                 (95) SetDeviceType         (96) SetComFormat    \n"
        "(97) DevicePTZCtrl                 (98) SetPreferMode         (99) SetEncodeMode   \n"
        //"(371) SetOSDTypeFontSize           (372) GetOSDTypeFontSize   (373) SetMuted \n"
		"(371) SetOSDTypeFontSize           (372) GetOSDTypeFontSize   \n"
        "(374) SetPWMValue                  (375) GetPWMValue          (376) SetImgDisposal \n"
        "(377) GetImgDisposal               (378) SetSystemType        (379) GetSystemType	\n"
        "(380) SetITSLoopMode               (381) GetITSLoopMode       (382) SetITSDeviceType \n"
        "(383) GetITSDeviceType             (384) SetITSRoadwayParam   (385) GetITSRoadwayParam \n"
        "(386) SetITSLicensePlateOptimize   (387) GetITSLicensePlateOptimize (388) SetITSExtraInfo\n"
		"(389) GetITSExtraInfo              (406) SetTimeZone          (407) GetTimeZone \n"
		"(408) SetCurLanguage               (409) GetCurLanguage       (410) GetLanguageList \n"
		"(411) SetChannelEncodeProfile      (412) GetChannelEncodeProfile (413) SetAlarmClear \n"
		"(414) SetExceptionHandleParam      (415) GetExceptionHandleParam (416) SetAlarmLink_V1 \n"
		"(417) GetAlarmLink_V1              (418) SetITSBlock             (419) GetITSBlock\n"
		"(420) SetHDTimeRangeParam          (421) GetHDTimeRangeParam     (422) SetHDTemplateName\n"
		"(423) GetHDTemplateName            (424) SetHDTemplateMap        (425) GetHDTemplateMap\n"
		"(426) SetITSTimeRangeEnable        (427) GetITSTimeRangeEnable   (428) SetITSDetectMode\n"
		"(429) GetITSDetectMode             (430) GetCharSet              (431) CheckDeviceState\n"
		"(432) GetDeviceState               (433) CheckCamera             (434) GetCameraCheckInfo\n"
		"(435) SetCameraParam               (436) GetCameraParam          (437) SetColorParam\n"
		"(438) GetColorParam                (439) SetJPEGQuality          (440) GetJPEGQuality\n"
		"(441) SetPlatformApp               (442) GetPlatformApp          (443) SetATMConfig\n"
		"(444) GetATMConfig                 (445) ATMQueryFile            (446) ATMGetQueryFile\n"
		"(447) SetAudioSample               (448) GetAudioSample          (449) SetSystemTypeEx\n"
		"(450) GetSystemTypeEx             (451) SetEncryptSN            (452) GetSNReg\n"
		"(453) GetComFormat_V1              (454) SetComFormat_V2         (455) GetComFormat_V2\n"
		//"(456) GetServerVersion_V1          (457) SetLocalAudioVolumeEx   (458) GetLocalAudioVolumeEx\n"
		"(456) GetServerVersion_V1          \n"
		"(459) GetBitrateOnVideo_V4	(460) NetFileDownloadByTimeSpan	(461) ControlDeviceRecord\n"
		"(462) SetVideoModeMethod	(463) GetVideoModeMethod		(464) SetPsPackCallBack\n"
		"(465) SetComRecvNotify_V4	(466) ClearPolyLocalVideo		(467)VCAGetAlarmInfo\n"
		"(468) SetManagerServersInfo	(469) GetManagerServersInfo		  (470)BindInterface\n"
		"(471) GetNetInterface		(472) NetLogGetLogCount			  (473)SetDomainParsePara_V4\n"
		"(474) GetDomainParsePara_V4	(475) SetHTTPPort_V4			  (476)GetHTTPPort_V4\n"
		"(477) GetConnectInfo            (478) SetHXListenPortInfo     (479) GetHXListenPortInfo\n"
		"(480) NetFileLockFile  		 (481) GetGroupAuthority       (482) ModifyUserAuthority\n"
		"(483) GetUserAuthority			 (484) SetDiskGroup			   (485) GetDiskGroup\n"
		"(486) SetDiskQuota				 (487) GetDiskQuotaState	   (488) SetHolidayPlan\n"
		"(489) GetHolidayPlan\n"
        );

        fprintf(stderr, "Please type a number to test corresponding interface:\n");
}


int Test_Param(char *_pcCmd)
{
    int iRet = 0;
    if(0 == strcasecmp("1",_pcCmd) || 0 == strcasecmp("StartRecv",_pcCmd))
    {
        iRet = Test_StartRecv();
    }
    else if(0 == strcasecmp("2",_pcCmd) || 0 == strcasecmp("StopRecv",_pcCmd))
    {
        iRet = Test_StopRecv();
    }
    else if(0 == strcasecmp("3",_pcCmd) || 0 == strcasecmp("SetNVS",_pcCmd))
    {
        iRet = Test_SetNVS();
    }
    else if(0 == strcasecmp("4",_pcCmd) || 0 == strcasecmp("GetAlarmPortNum",_pcCmd))
    {
        Test_GetAlarmPortNum();
    }
    else if(0 == strcasecmp("5",_pcCmd) || 0 == strcasecmp("GetAudioChannel",_pcCmd))
    {
        iRet = Test_GetAudioChannel();
    }
    else if(0 == strcasecmp("6",_pcCmd) || 0 == strcasecmp("SetAudioChannel",_pcCmd))
    {
        iRet = Test_SetAudioChannel();
    }
    else if(0 == strcasecmp("7",_pcCmd) || 0 == strcasecmp("SetAlmVdoCovThreshold",_pcCmd))
    {
        iRet = Test_SetAlmVdoCovThreshold();
    }
    else if(0 == strcasecmp("8",_pcCmd) || 0 == strcasecmp("SetOutportState",_pcCmd))
    {
        iRet = Test_SetOutportState();
    }
    else if(0 == strcasecmp("9",_pcCmd) || 0 == strcasecmp("GetOutportState",_pcCmd))
    {
        iRet = Test_GetOutportState();
    }
    else if(0 == strcasecmp("10",_pcCmd) || 0 == strcasecmp("GetAlmVdoCovThreshold",_pcCmd))
    {
        iRet = Test_GetAlmVdoCovThreshold();
    }
    else if(0 == strcasecmp("11",_pcCmd) || 0 == strcasecmp("SetAlmVideoCov",_pcCmd))
    {
        iRet = Test_SetAlmVideoCov();
    }
    else if(0 == strcasecmp("12",_pcCmd) || 0 == strcasecmp("GetAlmVideoCov",_pcCmd))
    {
        iRet = Test_GetAlmVideoCov();
    }
    else if(0 == strcasecmp("13",_pcCmd) || 0 == strcasecmp("GetAllSupportDeviceType",_pcCmd))
    {
        Test_GetAllSupportDeviceType();
    }
    else if(0 == strcasecmp("14",_pcCmd) || 0 == strcasecmp("DeviceCtrl",_pcCmd))
    {
        //iRet = Test_DeviceCtrl();
    }
    else if(0 == strcasecmp("15",_pcCmd) || 0 == strcasecmp("DeviceCtrlEx",_pcCmd))
    {
        iRet = Test_DeviceCtrlEx();
    }
    else if(0 == strcasecmp("16",_pcCmd) || 0 == strcasecmp("GetVideoLostLinkSoundDisplay",_pcCmd))
    {
        iRet = Test_GetVideoLostLinkSoundDisplay();
    }
    else if(0 == strcasecmp("17",_pcCmd) || 0 == strcasecmp("GetAlarmVLostState",_pcCmd))
    {
        iRet = Test_GetAlarmVLostState();
    }
    else if(0 == strcasecmp("18",_pcCmd) || 0 == strcasecmp("GetTalkingState",_pcCmd))
    {
        Test_GetTalkingState();
    }
    else if(0 == strcasecmp("19",_pcCmd) || 0 == strcasecmp("SetVideoLostLinkSoundDisplay",_pcCmd))
    {
        iRet = Test_SetVideoLostLinkSoundDisplay();
    }
    else if(0 == strcasecmp("20",_pcCmd) || 0 == strcasecmp("SetComRecvNotify",_pcCmd))
    {
        Test_SetComRecvNotify();
    }
    else if(0 == strcasecmp("21",_pcCmd) || 0 == strcasecmp("GetChannelNum",_pcCmd))
    {
        Test_GetChannelNum();
    }
    else if(0 == strcasecmp("22",_pcCmd) || 0 == strcasecmp("GetMaxMinorVideoSize",_pcCmd))
    {
        Test_GetMaxMinorVideoSize();
    }
    else if(0 == strcasecmp("23",_pcCmd) || 0 == strcasecmp("GetWifiDHCPParam",_pcCmd))
    {
        Test_GetWifiDHCPParam();
    }
    else if(0 == strcasecmp("24",_pcCmd) || 0 == strcasecmp("SetWifiDHCPParam",_pcCmd))
    {
        iRet = Test_SetWifiDHCPParam();
    }
    else if(0 == strcasecmp("25",_pcCmd) || 0 == strcasecmp("SetReducenoiseState",_pcCmd))
    {
        iRet = Test_SetReducenoiseState();
    }
    else if(0 == strcasecmp("26",_pcCmd) || 0 == strcasecmp("ReadUserData",_pcCmd))
    {
        iRet = Test_ReadUserData();
    }
    else if(0 == strcasecmp("27",_pcCmd) || 0 == strcasecmp("WriteUserData",_pcCmd))
    {
        iRet = Test_WriteUserData();
    }
    else if(0 == strcasecmp("28",_pcCmd) || 0 == strcasecmp("GetReducenoiseState",_pcCmd))
    {
        iRet = Test_GetReducenoiseState();
    }
    else if(0 == strcasecmp("29",_pcCmd) || 0 == strcasecmp("DrawTextOnVideo",_pcCmd))
    {
        iRet = Test_DrawTextOnVideo();
    }
    else if(0 == strcasecmp("30",_pcCmd) || 0 == strcasecmp("GetTextOnVideo",_pcCmd))
    {
        iRet = Test_GetTextOnVideo();
    }
    else if(0 == strcasecmp("31",_pcCmd) || 0 == strcasecmp("SetBothStreamSame",_pcCmd))
    {
        iRet = Test_SetBothStreamSame();
    }
    else if(0 == strcasecmp("32",_pcCmd) || 0 == strcasecmp("GetBothStreamSame",_pcCmd))
    {
        iRet = Test_GetBothStreamSame();
    }
    else if(0 == strcasecmp("33",_pcCmd) || 0 == strcasecmp("SetPPPoEInfo",_pcCmd))
    {
        iRet = Test_SetPPPoEInfo();
    }
    else if(0 == strcasecmp("34",_pcCmd) || 0 == strcasecmp("NetFileIsSupportStorage",_pcCmd))
    {
        Test_NetFileIsSupportStorage();
    }
    else if(0 == strcasecmp("35",_pcCmd) || 0 == strcasecmp("LogFileGetProperty",_pcCmd))
    {
        Test_LogFileGetProperty();
    }
    else if(0 == strcasecmp("36",_pcCmd) || 0 == strcasecmp("DiskFormat",_pcCmd))
    {
        iRet = Test_DiskFormat();
    }
    else if(0 == strcasecmp("37",_pcCmd) || 0 == strcasecmp("NetFileRebuildIndexFile",_pcCmd))
    {
        iRet = Test_NetFileRebuildIndexFile();
    }
    else if(0 == strcasecmp("38",_pcCmd) || 0 == strcasecmp("NetFileDownloadFile",_pcCmd))
    {
        iRet = Test_NetFileDownloadFile();
    }
    else if(0 == strcasecmp("39",_pcCmd) || 0 == strcasecmp("GetPPPoEInfo",_pcCmd))
    {
        Test_GetPPPoEInfo();
    }
    else if(0 == strcasecmp("40",_pcCmd) || 0 == strcasecmp("NetFileStopDownloadFile",_pcCmd))
    {
        iRet = Test_NetFileStopDownloadFile();
    }
    else if(0 == strcasecmp("41",_pcCmd) || 0 == strcasecmp("NetFileMountUSB",_pcCmd))
    {
        iRet = Test_NetFileMountUSB();
    }
    else if(0 == strcasecmp("42",_pcCmd) || 0 == strcasecmp("NetFileDelFile",_pcCmd))
    {
        iRet = Test_NetFileDelFile();
    }
    else if(0 == strcasecmp("43",_pcCmd) || 0 == strcasecmp("LogFileSetProperty",_pcCmd))
    {
        iRet = Test_LogFileSetProperty();
    }
    else if(0 == strcasecmp("44",_pcCmd) || 0 == strcasecmp("NetFileGetUSBstate",_pcCmd))
    {
        Test_NetFileGetUSBstate();
    }
    else if(0 == strcasecmp("45",_pcCmd) || 0 == strcasecmp("DiskPart",_pcCmd))
    {
        iRet = Test_DiskPart();
    }
    else if(0 == strcasecmp("46",_pcCmd) || 0 == strcasecmp("NetFileSetExtendname",_pcCmd))
    {
        iRet = Test_NetFileSetExtendname();
    }
    else if(0 == strcasecmp("47",_pcCmd) || 0 == strcasecmp("NetFileGetExtendname",_pcCmd))
    {
        Test_NetFileGetExtendname();
    }
    else if(0 == strcasecmp("48",_pcCmd) || 0 == strcasecmp("ClearDisk",_pcCmd))
    {
        iRet = Test_ClearDisk();
    }
    else if(0 == strcasecmp("49",_pcCmd) || 0 == strcasecmp("SetMediaStreamClient",_pcCmd))
    {
        iRet = Test_SetMediaStreamClient();
    }
    else if(0 == strcasecmp("50",_pcCmd) || 0 == strcasecmp("GetMediaStreamClient",_pcCmd))
    {
        iRet = Test_GetMediaStreamClient();
    }
    else if(0 == strcasecmp("51",_pcCmd) || 0 == strcasecmp("SetScene",_pcCmd))
    {
        iRet = Test_SetScene();
    }
    else if(0 == strcasecmp("52",_pcCmd) || 0 == strcasecmp("GetPrivacyProtect",_pcCmd))
    {
        iRet = Test_GetPrivacyProtect();
    }
    else if(0 == strcasecmp("53",_pcCmd) || 0 == strcasecmp("SetSensorFlip",_pcCmd))
    {
        iRet = Test_SetSensorFlip();
    }
    else if(0 == strcasecmp("54",_pcCmd) || 0 == strcasecmp("GetSensorFlip",_pcCmd))
    {
        iRet = Test_GetSensorFlip();
    }
    else if(0 == strcasecmp("55",_pcCmd) || 0 == strcasecmp("SetSensorMirror",_pcCmd))
    {
        iRet = Test_SetSensorMirror();
    }
    else if(0 == strcasecmp("56",_pcCmd) || 0 == strcasecmp("GetSensorMirror",_pcCmd))
    {
        iRet = Test_GetSensorMirror();
    }
    else if(0 == strcasecmp("57",_pcCmd) || 0 == strcasecmp("Snapshot",_pcCmd))
    {
        iRet = Test_Snapshot();
    }
    else if(0 == strcasecmp("58",_pcCmd) || 0 == strcasecmp("SetWifiParam",_pcCmd))
    {
        iRet = Test_SetWifiParam();
    }
    else if(0 == strcasecmp("59",_pcCmd) || 0 == strcasecmp("GetWifiParam",_pcCmd))
    {
        Test_GetWifiParam();
    }
    else if(0 == strcasecmp("60",_pcCmd) || 0 == strcasecmp("WifiSearch",_pcCmd))
    {
        Test_WifiSearch();
    }
    else if(0 == strcasecmp("61",_pcCmd) || 0 == strcasecmp("SetOsdLOGO", _pcCmd))
    {
        iRet = Test_SetOsdLOGO();
    }
    else if(0 == strcasecmp("62",_pcCmd) || 0 == strcasecmp("SetPrivacyProtect",_pcCmd))
    {
        iRet = Test_SetPrivacyProtect();
    }
    else if(0 == strcasecmp("63",_pcCmd) || 0 == strcasecmp("GetScene",_pcCmd))
    {
        iRet = Test_GetScene();
    }
    else if(0 == strcasecmp("64",_pcCmd) || 0 == strcasecmp("IYUVtoYV12",_pcCmd))
    {
        Test_IYUVtoYV12();
    }
    else if(0 == strcasecmp("65",_pcCmd) || 0 == strcasecmp("GetDevType",_pcCmd))
    {
        Test_GetDevType();
    }
    else if(0 == strcasecmp("66",_pcCmd) || 0 == strcasecmp("BackupKernel",_pcCmd))
    {
        Test_BackupKernel();
    }
    else if(0 == strcasecmp("67",_pcCmd) || 0 == strcasecmp("SetUPNPEnable",_pcCmd))
    {
        iRet = Test_SetUPNPEnable();
    }
    else if(0 == strcasecmp("68",_pcCmd) || 0 == strcasecmp("SetFuncListArray",_pcCmd))
    {
        iRet = Test_SetFuncListArray();
    }
    else if(0 == strcasecmp("69",_pcCmd) || 0 == strcasecmp("GetUPNPEnable",_pcCmd))
    {
        Test_GetUPNPEnable();
    }
    else if(0 == strcasecmp("70",_pcCmd) || 0 == strcasecmp("GetFuncListArray",_pcCmd))
    {
        Test_GetFuncListArray();
    }
    else if(0 == strcasecmp("71",_pcCmd) || 0 == strcasecmp("SetVencType",_pcCmd))
    {
        iRet = Test_SetVencType();
    }
    else if(0 == strcasecmp("72",_pcCmd) || 0 == strcasecmp("GetVencType",_pcCmd))
    {
        iRet = Test_GetVencType();
    }
    else if(0 == strcasecmp("73",_pcCmd) || 0 == strcasecmp("SetComServer",_pcCmd))
    {
        iRet = Test_SetComServer();
    }
    else if(0 == strcasecmp("74",_pcCmd) || 0 == strcasecmp("Get3GDeviceStatus",_pcCmd))
    {
        Test_Get3GDeviceStatus();
    }
    else if(0 == strcasecmp("75",_pcCmd) || 0 == strcasecmp("GetComServer",_pcCmd))
    {
        Test_GetComServer();
    }
    else if(0 == strcasecmp("76",_pcCmd) || 0 == strcasecmp("Set3GDialog",_pcCmd))
    {
        iRet = Test_Set3GDialog();
    }
    else if(0 == strcasecmp("77",_pcCmd) || 0 == strcasecmp("Get3GDialog",_pcCmd))
    {
        Test_Get3GDialog();
    }
    else if(0 == strcasecmp("78",_pcCmd) || 0 == strcasecmp("Set3GMessage",_pcCmd))
    {
        iRet = Test_Set3GMessage();
    }
    else if(0 == strcasecmp("79",_pcCmd) || 0 == strcasecmp("Get3GMessage",_pcCmd))
    {
        Test_Get3GMessage();
    }
    else if(0 == strcasecmp("80",_pcCmd) || 0 == strcasecmp("Set3GTaskSchedule",_pcCmd))
    {
        iRet = Test_Set3GTaskSchedule();
    }
    else if(0 == strcasecmp("81",_pcCmd) || 0 == strcasecmp("Set3GNotify",_pcCmd))
    {
        iRet = Test_Set3GNotify();
    }
    else if(0 == strcasecmp("82",_pcCmd) || 0 == strcasecmp("Get3GTaskSchedule",_pcCmd))
    {
        Test_Get3GTaskSchedule();
    }
    else if(0 == strcasecmp("83",_pcCmd) || 0 == strcasecmp("Get3GNotify",_pcCmd))
    {
        Test_Get3GNotify();
    }
    else if(0 == strcasecmp("84",_pcCmd) || 0 == strcasecmp("SetHDCamer",_pcCmd))
    {
        iRet = Test_SetHDCamer();
    }
    else if(0 == strcasecmp("85",_pcCmd) || 0 == strcasecmp("GetHDCamer",_pcCmd))
    {
        iRet = Test_GetHDCamer();
    }
    else if(0 == strcasecmp("86",_pcCmd) || 0 == strcasecmp("SetAlarmServer",_pcCmd))
    {
        iRet = Test_SetAlarmServer();
    }
    else if(0 == strcasecmp("87",_pcCmd) || 0 == strcasecmp("GetAlarmServer",_pcCmd))
    {
        Test_GetAlarmServer();
    }
    else if(0 == strcasecmp("88",_pcCmd) || 0 == strcasecmp("GetUpgradePercent",_pcCmd))
    {
        Test_GetUpgradePercent();
    }
    else if(0 == strcasecmp("89",_pcCmd) || 0 == strcasecmp("UpgradeWebPage",_pcCmd))
    {
        iRet = Test_UpgradeWebPage();
    }
    else if(0 == strcasecmp("90",_pcCmd) || 0 == strcasecmp("UpgradeProgram",_pcCmd))
    {
        iRet = Test_UpgradeProgram();
    }
    else if(0 == strcasecmp("91",_pcCmd) || 0 == strcasecmp("DelUser",_pcCmd))
    {
        iRet = Test_DelUser();
    }
    else if(0 == strcasecmp("92",_pcCmd) || 0 == strcasecmp("ModifyPwd",_pcCmd))
    {
        iRet = Test_ModifyPwd();
    }
    else if(0 == strcasecmp("93",_pcCmd) || 0 == strcasecmp("SetMaxConUser",_pcCmd))
    {
        iRet = Test_SetMaxConUser();
    }
    else if(0 == strcasecmp("94",_pcCmd) || 0 == strcasecmp("SetStreamType",_pcCmd))
    {
        iRet = Test_SetStreamType();
    }
    else if(0 == strcasecmp("95",_pcCmd) || 0 == strcasecmp("SetDeviceType",_pcCmd))
    {
        iRet = Test_SetDeviceType();
    }
    else if(0 == strcasecmp("96",_pcCmd) || 0 == strcasecmp("SetComFormat",_pcCmd))
    {
        iRet = Test_SetComFormat();
    }
    else if(0 == strcasecmp("97",_pcCmd) || 0 == strcasecmp("DevicePTZCtrl",_pcCmd))
    {
        iRet = Test_DevicePTZCtrl();
    }
    else if(0 == strcasecmp("98",_pcCmd) || 0 == strcasecmp("SetPreferMode",_pcCmd))
    {
        iRet = Test_SetPreferMode();
    }
    else if(0 == strcasecmp("99",_pcCmd) || 0 == strcasecmp("SetEncodeMode",_pcCmd))
    {
        iRet = Test_SetEncodeMode();
    }
    else if(0 == strcasecmp("100",_pcCmd) || 0 == strcasecmp("SetMaxKByteRate",_pcCmd))
    {
		iRet = Test_SetMaxKByteRate();
    }
    else if(0 == strcasecmp("101",_pcCmd) || 0 == strcasecmp("SetDomainParsePara",_pcCmd))
    {
		iRet = Test_SetDomainParsePara();
    }
    else if(0 == strcasecmp("102",_pcCmd) || 0 == strcasecmp("SetVideoSize",_pcCmd))
    {
		iRet = Test_SetVideoSize();
    }
    else if(0 == strcasecmp("103",_pcCmd) || 0 == strcasecmp("SetVideoNPMode",_pcCmd))
    {
		iRet = Test_SetVideoNPMode();
    }
    else if(0 == strcasecmp("104",_pcCmd) || 0 == strcasecmp("SetOsdText",_pcCmd))
    {
		iRet = Test_SetOsdText();
    }
	else if(0 == strcasecmp("105",_pcCmd) || 0 == strcasecmp("SetOsdType",_pcCmd))
    {
		iRet = Test_SetOsdType();
    }
    else if(0 == strcasecmp("106",_pcCmd) || 0 == strcasecmp("SetDateFormat",_pcCmd))
    {
		iRet = Test_SetDateFormat();
    }
    else if(0 == strcasecmp("107",_pcCmd) || 0 == strcasecmp("SetVideoCovArea",_pcCmd))
    {
		iRet = Test_SetVideoCovArea();
    }
    else if(0 == strcasecmp("108",_pcCmd) || 0 == strcasecmp("SetThreshold",_pcCmd))
    {
		iRet = Test_SetThreshold();
    }
    else if(0 == strcasecmp("109",_pcCmd) || 0 == strcasecmp("SetMotionDetection",_pcCmd))
    {
		iRet = Test_SetMotionDetection();
    }
	else if(0 == strcasecmp("110",_pcCmd) || 0 == strcasecmp("SetMotionAreaEnable",_pcCmd))
    {
		iRet = Test_SetMotionAreaEnable();
    }
    else if(0 == strcasecmp("111",_pcCmd) || 0 == strcasecmp("SetMotionDecLinkOutport",_pcCmd))
    {
		iRet = Test_SetMotionDecLinkOutport();
    }
    else if(0 == strcasecmp("112",_pcCmd) || 0 == strcasecmp("SetMotionDetectSchedule",_pcCmd))
    {
		iRet = Test_SetMotionDetectSchedule();
    }
    else if(0 == strcasecmp("113",_pcCmd) || 0 == strcasecmp("SetAlarmPortEnable",_pcCmd))
    {
		//iRet = Test_SetAlarmPortEnable();
    }
    else if(0 == strcasecmp("114",_pcCmd) || 0 == strcasecmp("SetInportAlarmLinkRec",_pcCmd))
    {
		iRet = Test_SetInportAlarmLinkRec();
    }
	else if(0 == strcasecmp("115",_pcCmd) || 0 == strcasecmp("NetFileQuery",_pcCmd))
    {
		iRet = Test_NetFileQuery();
    }
    else if(0 == strcasecmp("116",_pcCmd) || 0 == strcasecmp("NetFileSetTaskSchedule",_pcCmd))
    {
		iRet = Test_NetFileSetTaskSchedule();
    }
    else if(0 == strcasecmp("117",_pcCmd) || 0 == strcasecmp("NetFileSetRecordRule",_pcCmd))
    {
		iRet = Test_NetFileSetRecordRule();
    }
    else if(0 == strcasecmp("118",_pcCmd) || 0 == strcasecmp("NetFileSetAlarmRule",_pcCmd))
    {
		iRet = Test_NetFileSetAlarmRule();
    }
    else if(0 == strcasecmp("119",_pcCmd) || 0 == strcasecmp("DiskSetUsage",_pcCmd))
    {
		iRet = Test_DiskSetUsage();
    }
	else if(0 == strcasecmp("120",_pcCmd) || 0 == strcasecmp("NetFileMapStoreDevice",_pcCmd))
    {
		iRet = Test_NetFileMapStoreDevice();
    }
    else if(0 == strcasecmp("121",_pcCmd) || 0 == strcasecmp("SetTime",_pcCmd))
    {
		iRet = Test_SetTime();
    }
    else if(0 == strcasecmp("122",_pcCmd) || 0 == strcasecmp("Reboot",_pcCmd))
    {
		iRet = Test_Reboot();
    }
    else if(0 == strcasecmp("123",_pcCmd) || 0 == strcasecmp("DefaultPara",_pcCmd))
    {
		iRet = Test_DefaultPara();
    }
    else if(0 == strcasecmp("124",_pcCmd) || 0 == strcasecmp("SetHTTPPort",_pcCmd))
    {
		iRet = Test_SetHTTPPort();
    }
	else if(0 == strcasecmp("125",_pcCmd) || 0 == strcasecmp("GetSysInfo",_pcCmd))
    {
		iRet = Test_GetSysInfo();
    }
    else if(0 == strcasecmp("126",_pcCmd) || 0 == strcasecmp("LogFileClear",_pcCmd))
    {
		iRet = Test_LogFileClear();
    }
    else if(0 == strcasecmp("127",_pcCmd) || 0 == strcasecmp("LogFileDownload",_pcCmd))
    {
		iRet = Test_LogFileDownload();
    }
    else if(0 == strcasecmp("128",_pcCmd) || 0 == strcasecmp("ChangeSvrIP",_pcCmd))
    {
		iRet = Test_ChangeSvrIP();
    }
    else if(0 == strcasecmp("129",_pcCmd) || 0 == strcasecmp("SetDHCPParam",_pcCmd))
    {
		iRet = Test_SetDHCPParam();
    }
	else if(0 == strcasecmp("130",_pcCmd) || 0 == strcasecmp("SetIpFilter",_pcCmd))
    {
		iRet = Test_SetIpFilter();
    }
    else if(0 == strcasecmp("131",_pcCmd) || 0 == strcasecmp("SetInportAlarmLinkSnap",_pcCmd))
    {
		iRet = Test_SetInportAlarmLinkSnap();
    }
    else if(0 == strcasecmp("132",_pcCmd) || 0 == strcasecmp("SetInportAlarmLinkSoundDisplay",_pcCmd))
    {
		iRet = Test_SetInportAlarmLinkSoundDisplay();
    }
    else if(0 == strcasecmp("133",_pcCmd) || 0 == strcasecmp("SetInportAlmLinkOutport",_pcCmd))
    {
		iRet = Test_SetInportAlmLinkOutport();
    }
    else if(0 == strcasecmp("134",_pcCmd) || 0 == strcasecmp("SetAlarmInMode",_pcCmd))
    {
		iRet = Test_SetAlarmInMode();
    }
	else if(0 == strcasecmp("135",_pcCmd) || 0 == strcasecmp("SetAlarmOutMode",_pcCmd))
    {
		iRet = Test_SetAlarmOutMode();
    }
    else if(0 == strcasecmp("136",_pcCmd) || 0 == strcasecmp("SetInportAlarmSchedule",_pcCmd))
    {
		iRet = Test_SetInportAlarmSchedule();
    }
    else if(0 == strcasecmp("137",_pcCmd) || 0 == strcasecmp("SetOutportAlarmSchedule",_pcCmd))
    {
		iRet = Test_SetOutportAlarmSchedule();
    }
    else if(0 == strcasecmp("138",_pcCmd) || 0 == strcasecmp("SetOutportAlarmDelay",_pcCmd))
    {
		iRet = Test_SetOutportAlarmDelay();
    }
    else if(0 == strcasecmp("139",_pcCmd) || 0 == strcasecmp("SetInportEnable",_pcCmd))
    {
		iRet = Test_SetInportEnable();
    }
	else if(0 == strcasecmp("140",_pcCmd) || 0 == strcasecmp("SetAlarmOutput",_pcCmd))
    {
		iRet = Test_SetAlarmOutput();
    }
    else if(0 == strcasecmp("141",_pcCmd) || 0 == strcasecmp("SetAlarmVideoLost",_pcCmd))
    {
		iRet = Test_SetAlarmVideoLost();
    }
    else if(0 == strcasecmp("142",_pcCmd) || 0 == strcasecmp("SetVideoLostLinkPTZ",_pcCmd))
    {
		iRet = Test_SetVideoLostLinkPTZ();
    }
    else if(0 == strcasecmp("143",_pcCmd) || 0 == strcasecmp("SetVideoLostLinkOutport",_pcCmd))
    {
		iRet = Test_SetVideoLostLinkOutport();
    }
    else if(0 == strcasecmp("144",_pcCmd) || 0 == strcasecmp("SetVideoLostSchedule",_pcCmd))
    {
		iRet = Test_SetVideoLostSchedule();
    }
	else if(0 == strcasecmp("145",_pcCmd) || 0 == strcasecmp("SetVideoLostLinkRec",_pcCmd))
    {
		iRet = Test_SetVideoLostLinkRec();
    }
    else if(0 == strcasecmp("146",_pcCmd) || 0 == strcasecmp("SetVideoLostLinkSnap",_pcCmd))
    {
		iRet = Test_SetVideoLostLinkSnap();
    }
    else if(0 == strcasecmp("147",_pcCmd) || 0 == strcasecmp("SetAudioEncoder",_pcCmd))
    {
		iRet = Test_SetAudioEncoder();
    }
    else if(0 == strcasecmp("148",_pcCmd) || 0 == strcasecmp("SetMotionDecLinkRec",_pcCmd))
    {
		iRet = Test_SetMotionDecLinkRec();
    }
    else if(0 == strcasecmp("149",_pcCmd) || 0 == strcasecmp("SetMotionDecLinkSnap",_pcCmd))
    {
		iRet = Test_SetMotionDecLinkSnap();
    }
	else if(0 == strcasecmp("150",_pcCmd) || 0 == strcasecmp("SetIFrameRate",_pcCmd))
    {
		iRet = Test_SetIFrameRate();
    }
    else if(0 == strcasecmp("151",_pcCmd) || 0 == strcasecmp("ForceIFrame",_pcCmd))
    {
		iRet = Test_ForceIFrame();
    }
    else if(0 == strcasecmp("152",_pcCmd) || 0 == strcasecmp("NetFileManualRecord",_pcCmd))
    {
		iRet = Test_NetFileManualRecord();
    }
    else if(0 == strcasecmp("153",_pcCmd) || 0 == strcasecmp("NetFileSetAlarmState",_pcCmd))
    {
		iRet = Test_NetFileSetAlarmState();
    }
    else if(0 == strcasecmp("154",_pcCmd) || 0 == strcasecmp("SetEmailAlarm",_pcCmd))
    {
		iRet = Test_SetEmailAlarm();
    }
	else if(0 == strcasecmp("155",_pcCmd) || 0 == strcasecmp("NetFileSetTaskState",_pcCmd))
    {
		iRet = Test_NetFileSetTaskState();
    }
    else if(0 == strcasecmp("156",_pcCmd) || 0 == strcasecmp("SetVideoPara",_pcCmd))
    {
		iRet = Test_SetVideoPara();
    }
    else if(0 == strcasecmp("157",_pcCmd) || 0 == strcasecmp("GetVideoPara",_pcCmd))
    {
		iRet = Test_GetVideoPara();
    }
    else if(0 == strcasecmp("158",_pcCmd) || 0 == strcasecmp("SetVideoparaSchedule",_pcCmd))
    {
		iRet = Test_SetVideoparaSchedule();
    }
    else if(0 == strcasecmp("159",_pcCmd) || 0 == strcasecmp("GetVideoparaSchedule",_pcCmd))
    {
		iRet = Test_GetVideoparaSchedule();
    }
	else if(0 == strcasecmp("160",_pcCmd) || 0 == strcasecmp("SetVideoQuality",_pcCmd))
    {
		iRet = Test_SetVideoQuality();
    }
    else if(0 == strcasecmp("161",_pcCmd) || 0 == strcasecmp("GetVideoQuality",_pcCmd))
    {
		iRet = Test_GetVideoQuality();
    }
    else if(0 == strcasecmp("162",_pcCmd) || 0 == strcasecmp("SetFrameRate",_pcCmd))
    {
		iRet = Test_SetFrameRate();
    }
    else if(0 == strcasecmp("163",_pcCmd) || 0 == strcasecmp("GetFrameRate",_pcCmd))
    {
		iRet = Test_GetFrameRate();
    }
    else if(0 == strcasecmp("164",_pcCmd) || 0 == strcasecmp("GetStreamType",_pcCmd))
    {
		iRet = Test_GetStreamType();
    }
	else if(0 == strcasecmp("165",_pcCmd) || 0 == strcasecmp("SetMotionDetetionArea",_pcCmd))
    {
		iRet = Test_SetMotionDetetionArea();
    }
    else if(0 == strcasecmp("166",_pcCmd) || 0 == strcasecmp("GetMotionDetetionArea",_pcCmd))
    {
		iRet = Test_GetMotionDetetionArea();
    }
    else if(0 == strcasecmp("167",_pcCmd) || 0 == strcasecmp("GetThreshold",_pcCmd))
    {
		iRet = Test_GetThreshold();
    }
    else if(0 == strcasecmp("168",_pcCmd) || 0 == strcasecmp("GetMotionDetection",_pcCmd))
    {
		iRet = Test_GetMotionDetection();
    }
    else if(0 == strcasecmp("169",_pcCmd) || 0 == strcasecmp("GetMotionDecLinkRec",_pcCmd))
    {
		iRet = Test_GetMotionDecLinkRec();
    }
	else if(0 == strcasecmp("170",_pcCmd) || 0 == strcasecmp("GetMotionDecLinkSnap",_pcCmd))
    {
		iRet = Test_GetMotionDecLinkSnap();
    }
    else if(0 == strcasecmp("171",_pcCmd) || 0 == strcasecmp("GetMotionDecLinkOutport",_pcCmd))
    {
		iRet = Test_GetMotionDecLinkOutport();
    }
    else if(0 == strcasecmp("172",_pcCmd) || 0 == strcasecmp("GetMotionDetectSchedule",_pcCmd))
    {
		iRet = Test_GetMotionDetectSchedule();
    }
    else if(0 == strcasecmp("173",_pcCmd) || 0 == strcasecmp("GetOsdText",_pcCmd))
    {
		iRet = Test_GetOsdText();
    }
    else if(0 == strcasecmp("174",_pcCmd) || 0 == strcasecmp("GetOsdType",_pcCmd))
    {
		iRet = Test_GetOsdType();
    }
    else if(0 == strcasecmp("175",_pcCmd) || 0 == strcasecmp("GetDateFormat",_pcCmd))
    {
		iRet = Test_GetDateFormat();
    }
    else if(0 == strcasecmp("176",_pcCmd) || 0 == strcasecmp("GetIpFilter",_pcCmd))
    {
		iRet = Test_GetIpFilter();
    }
    else if(0 == strcasecmp("177",_pcCmd) || 0 == strcasecmp("GetAlarmOutput",_pcCmd))
    {
		iRet = Test_GetAlarmOutput();
    }
    else if(0 == strcasecmp("178",_pcCmd) || 0 == strcasecmp("GetAlarmIPortState",_pcCmd))
    {
		iRet = Test_GetAlarmIPortState();
    }
    else if(0 == strcasecmp("179",_pcCmd) || 0 == strcasecmp("GetAlarmPortEnable",_pcCmd))
    {
		//iRet = Test_GetAlarmPortEnable();
    }
	else if(0 == strcasecmp("180",_pcCmd) || 0 == strcasecmp("GetInportAlarmLinkRec",_pcCmd))
    {
		iRet = Test_GetInportAlarmLinkRec();
    }
    else if(0 == strcasecmp("181",_pcCmd) || 0 == strcasecmp("GetInportAlarmLinkSnap",_pcCmd))
    {
		iRet = Test_GetInportAlarmLinkSnap();
    }
    else if(0 == strcasecmp("182",_pcCmd) || 0 == strcasecmp("SetInportAlarmLinkPTZ",_pcCmd))
    {
		iRet = Test_SetInportAlarmLinkPTZ();
    }
    else if(0 == strcasecmp("183",_pcCmd) || 0 == strcasecmp("GetInportAlarmLinkPTZ",_pcCmd))
    {
		iRet = Test_GetInportAlarmLinkPTZ();
    }
    else if(0 == strcasecmp("184",_pcCmd) || 0 == strcasecmp("GetInportAlarmLinkSoundDisplay",_pcCmd))
    {
		iRet = Test_GetInportAlarmLinkSoundDisplay();
    }
	else if(0 == strcasecmp("185",_pcCmd) || 0 == strcasecmp("GetAlarmInMode",_pcCmd))
    {
		iRet = Test_GetAlarmInMode();
    }
    else if(0 == strcasecmp("186",_pcCmd) || 0 == strcasecmp("GetAlarmOutMode",_pcCmd))
    {
		iRet = Test_GetAlarmOutMode();
    }
    else if(0 == strcasecmp("187",_pcCmd) || 0 == strcasecmp("GetInportAlarmSchedule",_pcCmd))
    {
		iRet = Test_GetInportAlarmSchedule();
    }
    else if(0 == strcasecmp("188",_pcCmd) || 0 == strcasecmp("GetOutportAlarmSchedule",_pcCmd))
    {
		iRet = Test_GetOutportAlarmSchedule();
    }
    else if(0 == strcasecmp("189",_pcCmd) || 0 == strcasecmp("GetOutportAlarmDelay",_pcCmd))
    {
		iRet = Test_GetOutportAlarmDelay();
    }
	else if(0 == strcasecmp("190",_pcCmd) || 0 == strcasecmp("GetInportEnable",_pcCmd))
    {
		iRet = Test_GetInportEnable();
    }
    else if(0 == strcasecmp("191",_pcCmd) || 0 == strcasecmp("SetOutportEnable",_pcCmd))
    {
		iRet = Test_SetOutportEnable();
    }
    else if(0 == strcasecmp("192",_pcCmd) || 0 == strcasecmp("GetOutportEnable",_pcCmd))
    {
		iRet = Test_GetOutportEnable();
    }
    else if(0 == strcasecmp("193",_pcCmd) || 0 == strcasecmp("GetDeviceType",_pcCmd))
    {
		iRet = Test_GetDeviceType();
    }
    else if(0 == strcasecmp("194",_pcCmd) || 0 == strcasecmp("GetComFormat",_pcCmd))
    {
		iRet = Test_GetComFormat();
    }
	else if(0 == strcasecmp("195",_pcCmd) || 0 == strcasecmp("GetComPortCounts",_pcCmd))
    {
		iRet = Test_GetComPortCounts();
    }
    else if(0 == strcasecmp("196",_pcCmd) || 0 == strcasecmp("GetAlarmVideoLost",_pcCmd))
    {
		iRet = Test_GetAlarmVideoLost();
    }
    else if(0 == strcasecmp("197",_pcCmd) || 0 == strcasecmp("GetVideoLostLinkPTZ",_pcCmd))
    {
		iRet = Test_GetVideoLostLinkPTZ();
    }
    else if(0 == strcasecmp("198",_pcCmd) || 0 == strcasecmp("GetVideoLostLinkOutport",_pcCmd))
    {
		iRet = Test_GetVideoLostLinkOutport();
    }
    else if(0 == strcasecmp("199",_pcCmd) || 0 == strcasecmp("GetVideoLostSchedule",_pcCmd))
    {
		iRet = Test_GetVideoLostSchedule();
    }
	else if(0 == strcasecmp("200",_pcCmd) || 0 == strcasecmp("GetVideoLostLinkRec",_pcCmd))
    {
		iRet = Test_GetVideoLostLinkRec();
    }
    else if(0 == strcasecmp("201",_pcCmd) || 0 == strcasecmp("GetVideoLostLinkSnap",_pcCmd))
    {
		iRet = Test_GetVideoLostLinkSnap();
    }
    else if(0 == strcasecmp("202",_pcCmd) || 0 == strcasecmp("GetIFrameRate",_pcCmd))
    {
		iRet = Test_GetIFrameRate();
    }
    else if(0 == strcasecmp("203",_pcCmd) || 0 == strcasecmp("GetServerVersion",_pcCmd))
    {
		iRet = Test_GetServerVersion();
    }
    else if(0 == strcasecmp("204",_pcCmd) || 0 == strcasecmp("GetHTTPPort",_pcCmd))
    {
		iRet = Test_GetHTTPPort();
    }
	else if(0 == strcasecmp("205",_pcCmd) || 0 == strcasecmp("GetUserNum",_pcCmd))
    {
		iRet = Test_GetUserNum();
    }
    else if(0 == strcasecmp("206",_pcCmd) || 0 == strcasecmp("GetUserInfo",_pcCmd))
    {
		iRet = Test_GetUserInfo();
    }
    else if(0 == strcasecmp("207",_pcCmd) || 0 == strcasecmp("GetCurUserInfo",_pcCmd))
    {
		iRet = Test_GetCurUserInfo();
    }
    else if(0 == strcasecmp("208",_pcCmd) || 0 == strcasecmp("AddUser",_pcCmd))
    {
		iRet = Test_AddUser();
    }
    else if(0 == strcasecmp("209",_pcCmd) || 0 == strcasecmp("GetMaxGetUser",_pcCmd))
    {
		iRet = Test_GetMaxGetUser();
    }
	else if(0 == strcasecmp("210",_pcCmd) || 0 == strcasecmp("TalkStart",_pcCmd))
    {
		//iRet = Test_TalkStart();
    }
    else if(0 == strcasecmp("211",_pcCmd) || 0 == strcasecmp("TalkEnd",_pcCmd))
    {
		//iRet = Test_TalkEnd();
    }
    else if(0 == strcasecmp("212",_pcCmd) || 0 == strcasecmp("InputTalkingdata",_pcCmd))
    {
		//iRet = Test_InputTalkingdata();
    }
    else if(0 == strcasecmp("213",_pcCmd) || 0 == strcasecmp("GetIpProperty",_pcCmd))
    {
		iRet = Test_GetIpProperty();
    }
    else if(0 == strcasecmp("214",_pcCmd) || 0 == strcasecmp("GetDHCPParam",_pcCmd))
    {
		iRet = Test_GetDHCPParam();
    }
	else if(0 == strcasecmp("215",_pcCmd) || 0 == strcasecmp("GetVideoCovArea",_pcCmd))
    {
		iRet = Test_GetVideoCovArea();
    }
    else if(0 == strcasecmp("216",_pcCmd) || 0 == strcasecmp("GetVideoSize",_pcCmd))
    {
		iRet = Test_GetVideoSize();
    }
    else if(0 == strcasecmp("217",_pcCmd) || 0 == strcasecmp("GetVideoSizeEx",_pcCmd))
    {
		iRet = Test_GetVideoSizeEx();
    }
    else if(0 == strcasecmp("218",_pcCmd) || 0 == strcasecmp("GetMaxKByteRate",_pcCmd))
    {
		iRet = Test_GetMaxKByteRate();
    }
    else if(0 == strcasecmp("219",_pcCmd) || 0 == strcasecmp("GetDomainParsePara",_pcCmd))
    {
		iRet = Test_GetDomainParsePara();
    }
	else if(0 == strcasecmp("220",_pcCmd) || 0 == strcasecmp("SetMotionDecLinkSoundDisplay",_pcCmd))
    {
		iRet = Test_SetMotionDecLinkSoundDisplay();
    }
    else if(0 == strcasecmp("221",_pcCmd) || 0 == strcasecmp("GetBitrateOnVideo",_pcCmd))
    {
		iRet = Test_GetBitrateOnVideo();
    }
    else if(0 == strcasecmp("222",_pcCmd) || 0 == strcasecmp("CPUCheckEnabled",_pcCmd))
    {
		iRet = Test_CPUCheckEnabled();
    }
    else if(0 == strcasecmp("223",_pcCmd) || 0 == strcasecmp("GetEncodeMode",_pcCmd))
    {
		iRet = Test_GetEncodeMode();
    }
    else if(0 == strcasecmp("224",_pcCmd) || 0 == strcasecmp("GetPreferMode",_pcCmd))
    {
		iRet = Test_GetPreferMode();
    }
	else if(0 == strcasecmp("225",_pcCmd) || 0 == strcasecmp("LogFileGetDetails",_pcCmd))
    {
		iRet = Test_LogFileGetDetails();
    }
    else if(0 == strcasecmp("226",_pcCmd) || 0 == strcasecmp("GetVideoNPMode",_pcCmd))
    {
		iRet = Test_GetVideoNPMode();
    }
    else if(0 == strcasecmp("227",_pcCmd) || 0 == strcasecmp("GetAudioEncoder",_pcCmd))
    {
		iRet = Test_GetAudioEncoder();
    }
    else if(0 == strcasecmp("228",_pcCmd) || 0 == strcasecmp("NetFileGetRecordRule",_pcCmd))
    {
		iRet = Test_NetFileGetRecordRule();
    }
    else if(0 == strcasecmp("229",_pcCmd) || 0 == strcasecmp("NetFileGetAlarmRule",_pcCmd))
    {
		iRet = Test_NetFileGetAlarmRule();
    }
	else if(0 == strcasecmp("230",_pcCmd) || 0 == strcasecmp("NetFileGetAlarmState",_pcCmd))
    {
		iRet = Test_NetFileGetAlarmState();
    }
    else if(0 == strcasecmp("231",_pcCmd) || 0 == strcasecmp("NetFileGetTaskState",_pcCmd))
    {
		iRet = Test_NetFileGetTaskState();
    }
    else if(0 == strcasecmp("232",_pcCmd) || 0 == strcasecmp("NetFileGetTaskSchedule",_pcCmd))
    {
		iRet = Test_NetFileGetTaskSchedule();
    }
    else if(0 == strcasecmp("233",_pcCmd) || 0 == strcasecmp("NetFileGetFileCount",_pcCmd))
    {
		iRet = Test_NetFileGetFileCount();
    }
    else if(0 == strcasecmp("234",_pcCmd) || 0 == strcasecmp("NetFileGetDiskInfoEx",_pcCmd))
    {
		iRet = Test_NetFileGetDiskInfo();
    }
	else if(0 == strcasecmp("235",_pcCmd) || 0 == strcasecmp("NetLogQuery",_pcCmd))
    {
		iRet = Test_NetLogQuery();
    }
    else if(0 == strcasecmp("236",_pcCmd) || 0 == strcasecmp("NetFileGetDownloadPos",_pcCmd))
    {
		Test_NetFileGetDownloadPos();
    }
    else if(0 == strcasecmp("237",_pcCmd) || 0 == strcasecmp("NetFileGetRecordState",_pcCmd))
    {
		iRet = Test_NetFileGetRecordState();
    }
    else if(0 == strcasecmp("238",_pcCmd) || 0 == strcasecmp("GetMotionDecLinkSoundDisplay",_pcCmd))
    {
		iRet = Test_GetMotionDecLinkSoundDisplay(); 
    }
    else if(0 == strcasecmp("239",_pcCmd) || 0 == strcasecmp("NetFileGetMapStoreDevice",_pcCmd))
    {
		iRet = Test_NetFileGetMapStoreDevice();
    }
    else if(0 == strcasecmp("240",_pcCmd) || 0 == strcasecmp("GetEmailAlarm",_pcCmd))
    {
		iRet = Test_GetEmailAlarm();
    }
    else if(0 == strcasecmp("241",_pcCmd) || 0 == strcasecmp("SetEmailAlarmEnable",_pcCmd))
    {
		iRet = Test_SetEmailAlarmEnable();
    }
    else if(0 == strcasecmp("242",_pcCmd) || 0 == strcasecmp("GetEmailAlarmEnable",_pcCmd))
    {
		iRet = Test_GetEmailAlarmEnable();
    }
    else if(0 == strcasecmp("243",_pcCmd) || 0 == strcasecmp("GetFactoryID",_pcCmd))
    {
		iRet = Test_GetFactoryID();
    }
	else if(0 == strcasecmp("244",_pcCmd) || 0 == strcasecmp("GetProductType",_pcCmd))
    {
		iRet = Test_GetProductType();
    }
    else if(0 == strcasecmp("245",_pcCmd) || 0 == strcasecmp("SetDDNSPara",_pcCmd))
    {
		iRet = Test_SetDDNSPara();
    }
    else if(0 == strcasecmp("246",_pcCmd) || 0 == strcasecmp("GetDDNSPara",_pcCmd))
    {
		iRet = Test_GetDDNSPara();
    }
    else if(0 == strcasecmp("247",_pcCmd) || 0 == strcasecmp("SendStringToServer",_pcCmd))
    {
		iRet = Test_SendStringToServer();
    }
	else if(0 == strcasecmp("248",_pcCmd) || 0 == strcasecmp("GetVersion", _pcCmd))
	{
		iRet = Test_GetVersion();
	}
	else if(0 == strcasecmp("249",_pcCmd) || 0 == strcasecmp("GetLogonStatus", _pcCmd))
	{
		iRet = Test_GetLogonStatus();
	}
    else if(0 == strcasecmp("250",_pcCmd) || 0 == strcasecmp("GetDevInfo", _pcCmd))
	{
		iRet = Test_GetDevInfo();
	}
    else if(0 == strcasecmp("251",_pcCmd) || 0 == strcasecmp("SendStringToCenter", _pcCmd))
	{
		iRet = Test_SendStringToCenter();
	}
    else if(0 == strcasecmp("252",_pcCmd) || 0 == strcasecmp("StartCaptureFile", _pcCmd))
	{
		iRet = Test_StartCaptureFile();
	}
    else if(0 == strcasecmp("253",_pcCmd) || 0 == strcasecmp("StopCaptureFile", _pcCmd))
	{
		iRet = Test_StopCaptureFile();
	}
    else if(0 == strcasecmp("254",_pcCmd) || 0 == strcasecmp("GetCaptureStatus", _pcCmd))
	{
		iRet = Test_GetCaptureStatus();
	}
    else if(0 == strcasecmp("255",_pcCmd) || 0 == strcasecmp("StartCaptureData", _pcCmd))
	{
		iRet = Test_StartCaptureData();
	}
    else if(0 == strcasecmp("256",_pcCmd) || 0 == strcasecmp("StopCaptureData", _pcCmd))
	{
		iRet = Test_StopCaptureData();
	}
    else if(0 == strcasecmp("257",_pcCmd) || 0 == strcasecmp("GetVideoHeader", _pcCmd))
	{
		iRet = Test_GetVideoHeader();
	}
    else if(0 == strcasecmp("258",_pcCmd) || 0 == strcasecmp("SetRawFrameCallBack", _pcCmd))
	{
		iRet = Test_SetRawFrameCallBack();
	}
    else if(0 == strcasecmp("259",_pcCmd) || 0 == strcasecmp("SetFullStreamNotify", _pcCmd))
	{
		iRet = Test_SetFullStreamNotify();
	}
	else if(0 == strcasecmp("260",_pcCmd) || 0 == strcasecmp("GetRecvID", _pcCmd))
	{
		iRet = Test_GetRecvID();
	}	
    else if(0 == strcasecmp("261",_pcCmd) || 0 == strcasecmp("GetInfoByConnectID", _pcCmd))
	{
		iRet = Test_GetInfoByConnectID();
	}
    else if(0 == strcasecmp("262",_pcCmd) || 0 == strcasecmp("GetInportAlmLinkOutport", _pcCmd))
	{
		iRet = Test_GetInportAlmLinkOutport();
	}
	else if(0 == strcasecmp("263",_pcCmd) || 0 == strcasecmp("GetNTPInfo", _pcCmd))
	{
		Test_GetNTPInfo();
	}
    else if(0 == strcasecmp("264",_pcCmd) || 0 == strcasecmp("SetNTPInfo", _pcCmd))
	{
		iRet = Test_SetNTPInfo();
	}
	else if(0 == strcasecmp("265",_pcCmd) || 0 == strcasecmp("NetFileDownloadByTimeSpanEx", _pcCmd))
	{
		iRet = Test_NetFileDownloadByTimeSpanEx();
	}
	else if(0 == strcasecmp("266",_pcCmd) || 0 == strcasecmp("NetFileDownloadByTimeSpanCallBack", _pcCmd))
	{
		iRet = Test_NetFileDownloadByTimeSpanCallBack();
	}
    else if(0 == strcasecmp("267",_pcCmd) || 0 == strcasecmp("SetCDBurnConfig", _pcCmd))
	{
		iRet = Test_SetCDBurnConfig();
	}
    else if(0 == strcasecmp("268",_pcCmd) || 0 == strcasecmp("GetCDBurnConfig", _pcCmd))
	{
		iRet = Test_GetCDBurnConfig();
	}
    else if(0 == strcasecmp("269",_pcCmd) || 0 == strcasecmp("SetVideoEncrypt", _pcCmd))
	{
		iRet = Test_SetVideoEncrypt();
	}
    else if(0 == strcasecmp("270",_pcCmd) || 0 == strcasecmp("GetVideoEncrypt", _pcCmd))
	{
		iRet = Test_GetVideoEncrypt();
	}
    else if(0 == strcasecmp("271",_pcCmd) || 0 == strcasecmp("SetVideoDecrypt", _pcCmd))
	{
		iRet = Test_SetVideoDecrypt();
	}
    else if(0 == strcasecmp("272",_pcCmd) || 0 == strcasecmp("GetVideoDecrypt", _pcCmd))
	{
		iRet = Test_GetVideoDecrypt();
	}
    else if(0 == strcasecmp("273",_pcCmd) || 0 == strcasecmp("SetPreRecEnable", _pcCmd))
	{
		iRet = Test_SetPreRecEnable();
	}
    else if(0 == strcasecmp("274",_pcCmd) || 0 == strcasecmp("GetPreRecEnable", _pcCmd))
	{
		iRet = Test_GetPreRecEnable();
	}
    else if(0 == strcasecmp("275",_pcCmd) || 0 == strcasecmp("SetVideoCombine", _pcCmd))
    {
        iRet = Test_SetVideoCombine();
    }
    else if(0 == strcasecmp("276",_pcCmd) || 0 == strcasecmp("GetVideoCombine", _pcCmd))
    {
        iRet = Test_GetVideoCombine();
    }
    else if(0 == strcasecmp("277", _pcCmd) || 0 == strcasecmp("CaptureBmpPic", _pcCmd))
    {
        iRet = Test_CaptureBmpPic();
    }
    else if(0 == strcasecmp("278", _pcCmd) || 0 == strcasecmp("SetEmailAlarmEx", _pcCmd))
    {
        iRet = Test_SetEmailAlarmEx();
    }
    else if(0 == strcasecmp("279", _pcCmd) || 0 == strcasecmp("GetEmailAlarmEx", _pcCmd))
    {
        iRet = Test_GetEmailAlarmEx();
    }
    else if(0 == strcasecmp("280", _pcCmd) || 0 == strcasecmp("SetFTPUploadConfig", _pcCmd))
    {
        iRet = Test_SetFTPUploadConfig();
    }
    else if(0 == strcasecmp("281", _pcCmd) || 0 == strcasecmp("GetFTPUploadConfig", _pcCmd))
    {
        iRet = Test_GetFTPUploadConfig();
    }
    else if (0 == strcasecmp("282", _pcCmd) || 0 == strcasecmp("SetDigitalChannelConfig", _pcCmd))
    {
        iRet = Test_SetDigitalChannelConfig();
    }
    else if (0 == strcasecmp("283", _pcCmd) || 0 == strcasecmp("GetDigitalChannelConfig", _pcCmd))
    {
        iRet = Test_GetDigitalChannelConfig();
    }
    else if (0 == strcasecmp("284", _pcCmd) || 0 == strcasecmp("DigitalChannelSend", _pcCmd))
    {
        iRet = Test_DigitalChannelSend();
    }
    else if (0 == strcasecmp("285", _pcCmd) || 0 == strcasecmp("SetVideoNPModeEx", _pcCmd))
    {
        iRet = Test_SetVideoNPModeEx();
    }
    else if (0 == strcasecmp("286", _pcCmd) || 0 == strcasecmp("GetVideoNPModeEx", _pcCmd))
    {
        iRet = Test_GetVideoNPModeEx();
    }
    else if (0 == strcasecmp("287", _pcCmd) || 0 == strcasecmp("GetDigitalChannelNum", _pcCmd))
    {
        iRet = Test_GetDigitChannelCount();
    }
    else if (0 == strcasecmp("288", _pcCmd) || 0 == strcasecmp("GetChannelProperty", _pcCmd))
    {
        iRet = Test_GetChannelProperty();
    }
    else if (0 == strcasecmp("289", _pcCmd) || 0 == strcasecmp("SetDeviceTimerReboot", _pcCmd))
    {
        iRet = Test_SetDeviceTimerReboot();
    }
    else if (0 == strcasecmp("290", _pcCmd) || 0 == strcasecmp("GetDeviceTimerReboot", _pcCmd))
    {
        iRet = Test_GetDeviceTimerReboot();
    }
    else if (0 == strcasecmp("291", _pcCmd) || 0 == strcasecmp("SetVideoCoverSchedule", _pcCmd))
    {
        iRet = Test_SetVideoCoverSchedule();
    }
    else if (0 == strcasecmp("292", _pcCmd) || 0 == strcasecmp("GetVideoCoverSchedule", _pcCmd))
    {
        iRet = Test_GetVideoCoverSchedule();
    }
    else if (0 == strcasecmp("293", _pcCmd) || 0 == strcasecmp("SetCPUMEMAlarmThreshold", _pcCmd))
    {
        iRet = Test_SetCPUMEMAlarmThreshold();
    }
    else if (0 == strcasecmp("294", _pcCmd) || 0 == strcasecmp("GetCPUMEMAlarmThreshold", _pcCmd))
    {
        iRet = Test_GetCPUMEMAlarmThreshold();
    }
    else if (0 == strcasecmp("295", _pcCmd) || 0 == strcasecmp("SetDZInfo", _pcCmd))
    {
        iRet = Test_SetDZInfo();
    }
    else if (0 == strcasecmp("296", _pcCmd) || 0 == strcasecmp("GetDZInfo", _pcCmd))
    {
        iRet = Test_GetDZInfo();
    }
    else if (0 == strcasecmp("297", _pcCmd) || 0 == strcasecmp("SetPTZAutoBack", _pcCmd))
    {
        iRet = Test_SetPTZAutoBack();
    }
    else if (0 == strcasecmp("298", _pcCmd) || 0 == strcasecmp("GetPTZAutoBack", _pcCmd))
    {
        iRet = Test_GetPTZAutoBack();
    }
    else if (0 == strcasecmp("299", _pcCmd) || 0 == strcasecmp("Set3GVPND", _pcCmd))
    {
        iRet = Test_Set3GVPND();
    }
    else if (0 == strcasecmp("300", _pcCmd) || 0 == strcasecmp("Get3GVPND", _pcCmd))
    {
        iRet = Test_Get3GVPND();
    }
    else if (0 == strcasecmp("301", _pcCmd) || 0 == strcasecmp("SetHDCamerEx", _pcCmd))
    {
        iRet = Test_SetHDCamerEx();
    }
    else if (0 == strcasecmp("302", _pcCmd) || 0 == strcasecmp("GetHDCamerEx", _pcCmd))
    {
        iRet = Test_GetHDCamerEx();
    }
    else if(0 == strcasecmp("303", _pcCmd) || 0 == strcasecmp("VCASetConfig", _pcCmd))
    {
        iRet = Test_VCASetConfig();
    }
    else if(0 == strcasecmp("304", _pcCmd) || 0 == strcasecmp("VCAGetConfig", _pcCmd))
    {
        iRet = Test_VCAGetConfig();
    }
    else if(0 == strcasecmp("305", _pcCmd) || 0 == strcasecmp("SetChannelSipConfig", _pcCmd))
    {
        iRet = Test_SetChannelSipConfig();
    }
    else if(0 == strcasecmp("306", _pcCmd) || 0 == strcasecmp("GetChannelSipConfig", _pcCmd))
    {
        iRet = Test_GetChannelSipConfig();
    }
    else if(0 == strcasecmp("307", _pcCmd) || 0 == strcasecmp("GetMaxVideoSize", _pcCmd))
    {
        iRet = Test_GetMaxVideoSize();
    }
    else if(0 == strcasecmp("308", _pcCmd) || 0 == strcasecmp("SetBitRatePercent", _pcCmd))
    {
        iRet = Test_SetBitRatePercent();
    }
    else if(0 == strcasecmp("309", _pcCmd) || 0 == strcasecmp("GetBitRatePercent", _pcCmd))
    {
        iRet = Test_GetBitRatePercent();
    }
    else if(0 == strcasecmp("310", _pcCmd) || 0 == strcasecmp("SetFTPUsage", _pcCmd))
    {
        iRet = Test_SetFTPUsage();
    }
    else if(0 == strcasecmp("311", _pcCmd) || 0 == strcasecmp("GetFTPUsage", _pcCmd))
    {
        iRet = Test_GetFTPUsage();
    }
    else if(0 == strcasecmp("312", _pcCmd) || 0 == strcasecmp("GetVideoParam", _pcCmd))
    {
        iRet = Test_GetVideoParam();
    }
    else if(0 == strcasecmp("313", _pcCmd) || 0 == strcasecmp("SetOSDAlpha", _pcCmd))
    {
        iRet = Test_SetOSDAlpha();
    }
    else if(0 == strcasecmp("314", _pcCmd) || 0 == strcasecmp("GetOSDAlpha", _pcCmd))
    {
        iRet = Test_GetOSDAlpha();
    }
//  else if(0 == strcasecmp("315", _pcCmd) || 0 == strcasecmp("DeviceSetup", _pcCmd))
//  {
//      iRet = Test_DeviceSetup();
//  }
    else if(0 == strcasecmp("315", _pcCmd) || 0 == strcasecmp("Set3GConfig", _pcCmd))
    {
        iRet = Test_Set3GDVRConfig();
    }
    else if(0 == strcasecmp("316", _pcCmd) || 0 == strcasecmp("Get3GConfig", _pcCmd))
    {
        iRet = Test_Get3GDVRConfig();
    }
    else if(0 == strcasecmp("317", _pcCmd) || 0 == strcasecmp("SetColorToGray", _pcCmd))
    {
        iRet = Test_SetColorToGray();
    }
    else if(0 == strcasecmp("318", _pcCmd) || 0 == strcasecmp("GetColorToGray", _pcCmd))
    {
        iRet = Test_GetColorToGray();
    }
    else if(0 == strcasecmp("319", _pcCmd) || 0 == strcasecmp("GetExceptionMsg", _pcCmd))
    {
        iRet = Test_GetExceptionMsg();
    }
    else if(0 == strcasecmp("320", _pcCmd) || 0 == strcasecmp("SetCHNPTZFormat", _pcCmd))
    {
        iRet = Test_SetCHNPTZFormat();
    }
    else if(0 == strcasecmp("321", _pcCmd) || 0 == strcasecmp("GetCHNPTZFormat", _pcCmd))
    {
        iRet = Test_GetCHNPTZFormat();
    }
    else if(0 == strcasecmp("322", _pcCmd) || 0 == strcasecmp("GetProtocolList", _pcCmd))
    {
        iRet = Test_GetProtocolList();
    }
    else if(0 == strcasecmp("323", _pcCmd) || 0 == strcasecmp("SetCHNPTZCRUISE", _pcCmd))
    {
        iRet = Test_SetCHNPTZCRUISE();
    }
    else if(0 == strcasecmp("324", _pcCmd) || 0 == strcasecmp("GetCHNPTZCRUISE", _pcCmd))
    {
        iRet = Test_GetCHNPTZCRUISE();
    }
    else if(0 == strcasecmp("325", _pcCmd) || 0 == strcasecmp("SetFTPUpdate", _pcCmd))
    {
        iRet = Test_SetFTPUpdate();
    }
    else if(0 == strcasecmp("326", _pcCmd) || 0 == strcasecmp("GetFTPUpdate", _pcCmd))
    {
        iRet = Test_GetFTPUpdate();
    }
    else if(0 == strcasecmp("327", _pcCmd) || 0 == strcasecmp("ChangeSvrIPEx", _pcCmd))
    {
        iRet = Test_ChangeSvrIPEx();
    }
    else if(0 == strcasecmp("328", _pcCmd) || 0 == strcasecmp("GetIpPropertyEx", _pcCmd))
    {
        iRet = Test_GetIpPropertyEx();
    }
    else if (0 == strcasecmp("329", _pcCmd) || 0 == strcasecmp("SendStringToServerEx", _pcCmd))
    {
        iRet = Test_SendStringToServerEx();
    }
    else if(0 == strcasecmp("330", _pcCmd) || 0 == strcasecmp("SetOSDTypeColor", _pcCmd))
    {
        iRet = Test_SetOSDTypeColor();
    }
    else if(0 == strcasecmp("331", _pcCmd) || 0 == strcasecmp("GetOSDTypeColor", _pcCmd))
    {
        iRet = Test_GetOSDTypeColor();
    }
    else if (0 == strcasecmp("332", _pcCmd) || 0 == strcasecmp("GetServerVersionEx", _pcCmd))
    {
        iRet = Test_GetServerVersionEx();
    }
    else if(0 == strcasecmp("333", _pcCmd) || 0 == strcasecmp("NetLogGetLogfile", _pcCmd))
    {
//      iRet = Test_NetLogGetLogfile();
    }
    else if(0 == strcasecmp("334", _pcCmd) || 0 == strcasecmp("DrawRectOnLocalVideo", _pcCmd))
    {
        iRet = Test_DrawRectOnLocalVideo();
    }
    else if(0 == strcasecmp("335", _pcCmd) || 0 == strcasecmp("DrawPolyOnLocalVideo", _pcCmd))
    {
        iRet = Test_DrawPolyOnLocalVideo();
    }
    else if(0 == strcasecmp("336", _pcCmd) || 0 == strcasecmp("NetFileQueryEx", _pcCmd))
    {
        iRet = Test_NetFileQueryEx();
    }
    else if(0 == strcasecmp("337", _pcCmd) || 0 == strcasecmp("VCARestart", _pcCmd))
    {
        iRet = Test_VCARestart();
    }
    else if(0 == strcasecmp("338", _pcCmd) || 0 == strcasecmp("ComSend", _pcCmd))
    {
        iRet = Test_ComSend();
    }
    else if(0 == strcasecmp("339", _pcCmd) || 0 == strcasecmp("SetCustomChannelName", _pcCmd))
    {
        iRet = Test_SetCustomChannelName();
    }
    else if(0 == strcasecmp("340", _pcCmd) || 0 == strcasecmp("GetCustomChannelName", _pcCmd))
    {
        iRet = Test_GetCustomChannelName();
    }
    else if(0 == strcasecmp("341", _pcCmd) || 0 == strcasecmp("SetCustomRecType", _pcCmd))
    {
        iRet = Test_SetCustomRecType();
    }
    else if(0 == strcasecmp("342", _pcCmd) || 0 == strcasecmp("GetCustomRecType", _pcCmd))
    {
        iRet = Test_GetCustomRecType();
    }
    else if(0 == strcasecmp("343", _pcCmd) || 0 == strcasecmp("VCARestartEx", _pcCmd))
    {
        iRet = Test_VCARestartEx();
    }
    else if(0 == strcasecmp("344", _pcCmd) || 0 == strcasecmp("SetDecCallBackEx", _pcCmd))
    {
        iRet = Test_SetDecCallBackEx();
    }
    else if(0 == strcasecmp("345", _pcCmd) || 0 == strcasecmp("GetDownloadStream", _pcCmd))
    {
        iRet = Test_GetDownloadStream();
    }
    else if(0 == strcasecmp("346", _pcCmd) || 0 == strcasecmp("SetDataPackCallBack", _pcCmd))
    {
        iRet = Test_SetDataPackCallBack();
    }
	else if(0 == strcasecmp("347", _pcCmd) || 0 == strcasecmp("NetFileSetChannelParam", _pcCmd))
	{
		iRet = Test_NetFileSetChannelParam();
	}
	else if(0 == strcasecmp("348", _pcCmd) || 0 == strcasecmp("NetFileGetChannelParam", _pcCmd))
	{
		iRet = Test_NetFileGetChannelParam();
	}
	else if(0 == strcasecmp("349", _pcCmd) || 0 == strcasecmp("ShutDownDev", _pcCmd))
	{
		iRet = Test_ShutDownDev();
	}
	else if(0 == strcasecmp("350", _pcCmd) || 0 == strcasecmp("BackupImage", _pcCmd))
	{
		iRet = Test_BackupImage();
	}
	else if(0 == strcasecmp("351", _pcCmd) || 0 == strcasecmp("LanParam", _pcCmd))
	{
		iRet = Test_LaneParam();
	}
    else if(0 == strcasecmp("352", _pcCmd) || 0 == strcasecmp("SetAlarmConfig", _pcCmd))
    {
        iRet = Test_SetAlarmConfig();
    }
	else if(0 == strcasecmp("353", _pcCmd) || 0 == strcasecmp("GetAlarmConfig", _pcCmd))
    {
        iRet = Test_GetAlarmConfig();
    }
	else if(0 == strcasecmp("354", _pcCmd) || 0 == strcasecmp("SetMixAudio", _pcCmd))
    {
        iRet = Test_SetMixAudio();
    }
	else if(0 == strcasecmp("355", _pcCmd) || 0 == strcasecmp("GetMixAudio", _pcCmd))
    {
        iRet = Test_GetMixAudio();
    }
	else if(0 == strcasecmp("357", _pcCmd) || 0 == strcasecmp("GetVideoSzList", _pcCmd))
    {
        iRet = Test_GetVideoSzList();
    }
	else if(0 == strcasecmp("358", _pcCmd) || 0 == strcasecmp("SetPictureCallBack", _pcCmd))
    {
        iRet = Test_SetPictureCallBack();
	}
	else if(0 == strcasecmp("369", _pcCmd) || 0 == strcasecmp("SetPlatformApp", _pcCmd))
	{
		iRet = Test_SetPlatformApp();
	}
	else if(0 == strcasecmp("370", _pcCmd) || 0 == strcasecmp("GetPlatformApp", _pcCmd))
	{
		iRet = Test_GetPlatformApp();
	}
	else if(0 == strcasecmp("371", _pcCmd) || 0 == strcasecmp("SetOSDTypeFontSize", _pcCmd))
	{
		iRet = Test_SetOSDTypeFontSize();
	}
	else if(0 == strcasecmp("372", _pcCmd) || 0 == strcasecmp("GetOSDTypeFontSize", _pcCmd))
	{
		iRet = Test_GetOSDTypeFontSize();
	}
// 	else if(0 == strcasecmp("373", _pcCmd) || 0 == strcasecmp("SetMuted", _pcCmd))
// 	{
// 		iRet = Test_SetMuted();
// 	}
	else if(0 == strcasecmp("374", _pcCmd) || 0 == strcasecmp("SetPWMValue", _pcCmd))
	{
		iRet = Test_SetPWMValue();
	}
	else if(0 == strcasecmp("375", _pcCmd) || 0 == strcasecmp("GetPWMValue", _pcCmd))
	{
		iRet = Test_GetPWMValue();
	}
	else if(0 == strcasecmp("376", _pcCmd) || 0 == strcasecmp("SetImgDisposal", _pcCmd))
	{
		iRet = Test_SetImgDisposal();
	}
	else if(0 == strcasecmp("377", _pcCmd) || 0 == strcasecmp("GetImgDisposal", _pcCmd))
	{
		iRet = Test_GetImgDisposal();
	}
	else if(0 == strcasecmp("378", _pcCmd) || 0 == strcasecmp("SetSystemType", _pcCmd))
	{
		iRet = Test_SetSystemType();
	}
	else if(0 == strcasecmp("379", _pcCmd) || 0 == strcasecmp("GetSystemType", _pcCmd))
	{
		iRet = Test_GetSystemType();
	}
	else if(0 == strcasecmp("380", _pcCmd) || 0 == strcasecmp("SetITSLoopMode", _pcCmd))
	{
		iRet = Test_SetITSLoopMode();
	}
	else if(0 == strcasecmp("381", _pcCmd) || 0 == strcasecmp("GetITSLoopMode", _pcCmd))
	{
		iRet = Test_GetITSLoopMode();
	}
	else if(0 == strcasecmp("382", _pcCmd) || 0 == strcasecmp("SetITSDeviceType", _pcCmd))
	{
		iRet = Test_SetITSDeviceType();
	}
	else if(0 == strcasecmp("383", _pcCmd) || 0 == strcasecmp("GetITSDeviceType", _pcCmd))
	{
		iRet = Test_GetITSDeviceType();
	}
	else if(0 == strcasecmp("384", _pcCmd) || 0 == strcasecmp("SetITSRoadwayParam", _pcCmd))
	{
		iRet = Test_SetITSRoadwayParam();
	}
	else if(0 == strcasecmp("385", _pcCmd) || 0 == strcasecmp("GetITSRoadwayParam", _pcCmd))
	{
		iRet = Test_GetITSRoadwayParam();
	}
	else if(0 == strcasecmp("386", _pcCmd) || 0 == strcasecmp("SetITSLicensePlateOptimize", _pcCmd))
	{
		iRet = Test_SetITSLicensePlateOptimize();
	}
	else if(0 == strcasecmp("387", _pcCmd) || 0 == strcasecmp("GetITSLicensePlateOptimize", _pcCmd))
	{
		iRet = Test_GetITSLicensePlateOptimize();
	}
	else if(0 == strcasecmp("388", _pcCmd) || 0 == strcasecmp("SetITSExtraInfo", _pcCmd))
	{
		iRet = Test_SetITSExtraInfo();
	}
	else if(0 == strcasecmp("389", _pcCmd) || 0 == strcasecmp("GetITSExtraInfo", _pcCmd))
	{
		iRet = Test_GetITSExtraInfo();
	}
	else if(0 == strcasecmp("390", _pcCmd) || 0 == strcasecmp("SetITSSwitchTime", _pcCmd))
	{
		iRet = Test_SetITSSwitchTime();
	}
	else if(0 == strcasecmp("391", _pcCmd) || 0 == strcasecmp("GetITSSwitchTime", _pcCmd))
	{
		iRet = Test_GetITSSwitchTime();
	}
	else if(0 == strcasecmp("392", _pcCmd) || 0 == strcasecmp("SetITSRecoParam", _pcCmd))
	{
		iRet = Test_SetITSRecoParam();
	}
	else if(0 == strcasecmp("393", _pcCmd) || 0 == strcasecmp("GetITSRecoParam", _pcCmd))
	{
		iRet = Test_GetITSRecoParam();
	}
	else if(0 == strcasecmp("394", _pcCmd) || 0 == strcasecmp("SetITSDayNight", _pcCmd))
	{
		iRet = Test_SetITSDayNight();
	}
	else if(0 == strcasecmp("395", _pcCmd) || 0 == strcasecmp("GetITSDayNight", _pcCmd))
	{
		iRet = Test_GetITSDayNight();
	}
	else if(0 == strcasecmp("396", _pcCmd) || 0 == strcasecmp("SetITSCamLocation", _pcCmd))
	{
		iRet = Test_SetITSCamLocation();
	}
	else if(0 == strcasecmp("397", _pcCmd) || 0 == strcasecmp("GetITSCamLocation", _pcCmd))
	{
		iRet = Test_GetITSCamLocation();
	}
	else if(0 == strcasecmp("398", _pcCmd) || 0 == strcasecmp("SetITSWorkMode", _pcCmd))
	{
		iRet = Test_SetITSWorkMode();
	}
	else if(0 == strcasecmp("399", _pcCmd) || 0 == strcasecmp("GetITSWorkMode", _pcCmd))
	{
		iRet = Test_GetITSWorkMode();
	}
	else if(0 == strcasecmp("400", _pcCmd) || 0 == strcasecmp("SetWaterMarkEnable", _pcCmd))
	{
		iRet = Test_SetWaterMarkEnable();
	}
	else if(0 == strcasecmp("401", _pcCmd) || 0 == strcasecmp("GetWaterMarkEnable", _pcCmd))
	{
		iRet = Test_GetWaterMarkEnable();
	}
	else if(0 == strcasecmp("402", _pcCmd) || 0 == strcasecmp("SetITSLightInfo", _pcCmd))
	{
		iRet = Test_SetITSLightInfo();
	}
	else if(0 == strcasecmp("403", _pcCmd) || 0 == strcasecmp("GetITSLightInfo", _pcCmd))
	{
		iRet = Test_GetITSLightInfo();
	}
	else if(0 == strcasecmp("404", _pcCmd) || 0 == strcasecmp("SetHardWareParam", _pcCmd))
	{
		iRet = Test_SetHardWareParam();
	}
	else if(0 == strcasecmp("405", _pcCmd) || 0 == strcasecmp("GetHardWareParam", _pcCmd))
	{
		iRet = Test_GetHardWareParam();
	}
	//add V4.0
	else if(0 == strcasecmp("406", _pcCmd) || 0 == strcasecmp("SetTimeZone", _pcCmd))
	{
		iRet = Test_SetTimeZone();
	}
	else if(0 == strcasecmp("407", _pcCmd) || 0 == strcasecmp("GetTimeZone", _pcCmd))
	{
		iRet = Test_GetTimeZone();
	}
	else if(0 == strcasecmp("408", _pcCmd) || 0 == strcasecmp("SetCurLanguage", _pcCmd))
	{
		iRet = Test_SetCurLanguage();
	}
	else if(0 == strcasecmp("409", _pcCmd) || 0 == strcasecmp("GetCurLanguage", _pcCmd))
	{
		iRet = Test_GetCurLanguage();
	}
	else if(0 == strcasecmp("410", _pcCmd) || 0 == strcasecmp("GetLanguageList", _pcCmd))
	{
		iRet = Test_GetLanguageList();
	}
	else if(0 == strcasecmp("411", _pcCmd) || 0 == strcasecmp("SetChannelEncodeProfile", _pcCmd))
	{
		iRet = Test_SetChannelEncodeProfile();
	}
	else if(0 == strcasecmp("412", _pcCmd) || 0 == strcasecmp("GetChannelEncodeProfile", _pcCmd))
	{
		iRet = Test_GetChannelEncodeProfile();
	}
	else if(0 == strcasecmp("413", _pcCmd) || 0 == strcasecmp("SetAlarmClear", _pcCmd))
	{
		iRet = Test_SetAlarmClear();
	}
	else if(0 == strcasecmp("414", _pcCmd) || 0 == strcasecmp("SetExceptionHandleParam", _pcCmd))
	{
		iRet = Test_SetExceptionHandleParam();
	}
	else if(0 == strcasecmp("415", _pcCmd) || 0 == strcasecmp("GetExceptionHandleParam", _pcCmd))
	{
		iRet = Test_GetExceptionHandleParam();
	}
	else if(0 == strcasecmp("416", _pcCmd) || 0 == strcasecmp("SetAlarmLink_V1", _pcCmd))
	{
		iRet = Test_SetAlarmLink_V1();
	}
	else if(0 == strcasecmp("417", _pcCmd) || 0 == strcasecmp("GetAlarmLink_V1", _pcCmd))
	{
		iRet = Test_GetAlarmLink_V1();
	}
	else if (0 ==  strcasecmp("418", _pcCmd) || 0 == strcasecmp("SetITSBlock", _pcCmd)) 
	{
		iRet = Test_SetITSBlock();
	}
	else if (0 ==  strcasecmp("419", _pcCmd) || 0 == strcasecmp("GetITSBlock", _pcCmd)) 
	{
		iRet = Test_GetITSBlock();
	}
	else if (0 ==  strcasecmp("420", _pcCmd) || 0 == strcasecmp("SetHDTimeRangeParam", _pcCmd)) 
	{
		iRet = Test_SetHDTimeRangeParam();
	}
	else if (0 ==  strcasecmp("421", _pcCmd) || 0 == strcasecmp("GetHDTimeRangeParam", _pcCmd)) 
	{
		iRet = Test_GetHDTimeRangeParam();
	}
	else if (0 ==  strcasecmp("422", _pcCmd) || 0 == strcasecmp("SetHDTemplateName", _pcCmd)) 
	{
		iRet = Test_SetHDTemplateName();
	}
	else if (0 ==  strcasecmp("423", _pcCmd) || 0 == strcasecmp("GetHDTemplateName", _pcCmd)) 
	{
		iRet = Test_GetHDTemplateName();
	}
	else if (0 ==  strcasecmp("424", _pcCmd) || 0 == strcasecmp("SetHDTemplateMap", _pcCmd)) 
	{
		iRet = Test_SetHDTemplateMap();
	}
	else if (0 ==  strcasecmp("425", _pcCmd) || 0 == strcasecmp("GetHDTemplateMap", _pcCmd)) 
	{
		iRet = Test_GetHDTemplateMap();
	}
	else if (0 ==  strcasecmp("426", _pcCmd) || 0 == strcasecmp("SetITSTimeRangeEnable", _pcCmd)) 
	{
		iRet = Test_SetITSTimeRangeEnable();
	}
	else if (0 ==  strcasecmp("427", _pcCmd) || 0 == strcasecmp("GetITSTimeRangeEnable", _pcCmd)) 
	{
		iRet = Test_GetITSTimeRangeEnable();
	}
	else if (0 ==  strcasecmp("428", _pcCmd) || 0 == strcasecmp("SetITSDetectMode", _pcCmd)) 
	{
		iRet = Test_SetITSDetectMode();
	}
	else if (0 ==  strcasecmp("429", _pcCmd) || 0 == strcasecmp("GetITSDetectMode", _pcCmd)) 
	{
		iRet = Test_GetITSDetectMode();
	}

	else if (0 ==  strcasecmp("430", _pcCmd) || 0 == strcasecmp("GetCharSet", _pcCmd)) 
	{
		iRet = Test_GetCharSet();
	}
	else if (0 ==  strcasecmp("431", _pcCmd) || 0 == strcasecmp("CheckDeviceState", _pcCmd)) 
	{
		iRet = Test_CheckDeviceState();
	}
	else if (0 ==  strcasecmp("432", _pcCmd) || 0 == strcasecmp("GetDeviceState", _pcCmd)) 
	{
		iRet = Test_GetDeviceState();
	}
	else if (0 ==  strcasecmp("433", _pcCmd) || 0 == strcasecmp("CheckCamera", _pcCmd)) 
	{
		iRet = Test_CheckCamera();
	}
	else if (0 ==  strcasecmp("434", _pcCmd) || 0 == strcasecmp("GetCameraCheckInfo", _pcCmd)) 
	{
		iRet = Test_GetCameraCheckInfo();
	}
	else if (0 ==  strcasecmp("435", _pcCmd) || 0 == strcasecmp("SetCameraParam", _pcCmd)) 
	{
		iRet = Test_SetCameraParam();
	}
	else if (0 ==  strcasecmp("436", _pcCmd) || 0 == strcasecmp("GetCameraParam", _pcCmd)) 
	{
		iRet = Test_GetCameraParam();
	}
	else if (0 ==  strcasecmp("437", _pcCmd) || 0 == strcasecmp("SetColorParam", _pcCmd)) 
	{
		iRet = Test_SetColorParam();
	}
	else if (0 ==  strcasecmp("438", _pcCmd) || 0 == strcasecmp("GetColorParam", _pcCmd)) 
	{
		iRet = Test_GetColorParam();
	}
	else if (0 ==  strcasecmp("439", _pcCmd) || 0 == strcasecmp("SetJPEGQuality", _pcCmd)) 
	{
		iRet = Test_SetJPEGQuality();
	}

	else if (0 ==  strcasecmp("440", _pcCmd) || 0 == strcasecmp("GetJPEGQuality", _pcCmd)) 
	{
		iRet = Test_GetJPEGQuality();
	}
	else if (0 ==  strcasecmp("441", _pcCmd) || 0 == strcasecmp("SetPlatformApp", _pcCmd)) 
	{
		iRet = Test_SetPlatformApp();
	}
	else if (0 ==  strcasecmp("442", _pcCmd) || 0 == strcasecmp("GetPlatformApp", _pcCmd)) 
	{
		iRet = Test_GetPlatformApp();
	}
	else if (0 ==  strcasecmp("443", _pcCmd) || 0 == strcasecmp("SetATMConfig", _pcCmd)) 
	{
		iRet = Test_SetATMConfig();
	}
	else if (0 ==  strcasecmp("444", _pcCmd) || 0 == strcasecmp("GetATMConfig", _pcCmd)) 
	{
		iRet = Test_GetATMConfig();
	}
	else if (0 ==  strcasecmp("445", _pcCmd) || 0 == strcasecmp("ATMQueryFile", _pcCmd)) 
	{
		iRet = Test_ATMQueryFile();
	}
	else if (0 ==  strcasecmp("446", _pcCmd) || 0 == strcasecmp("ATMGetQueryFile", _pcCmd)) 
	{
		iRet = Test_ATMGetQueryFile();
	}
	else if (0 ==  strcasecmp("447", _pcCmd) || 0 == strcasecmp("SetAudioSample", _pcCmd)) 
	{
		iRet = Test_SetAudioSample();
	}
	else if (0 ==  strcasecmp("448", _pcCmd) || 0 == strcasecmp("GetAudioSample", _pcCmd)) 
	{
		iRet = Test_GetAudioSample();
	}
	else if (0 ==  strcasecmp("449", _pcCmd) || 0 == strcasecmp("SetSystemTypeEx", _pcCmd)) 
	{
		iRet = Test_SetSystemTypeEx();
	}

	else if (0 ==  strcasecmp("450", _pcCmd) || 0 == strcasecmp("GetSystemTypeEx", _pcCmd)) 
	{
		iRet = Test_GetSystemTypeEx();
	}
	else if (0 ==  strcasecmp("451", _pcCmd) || 0 == strcasecmp("SetEncryptSN", _pcCmd)) 
	{
		iRet = Test_SetEncryptSN();
	}
	else if (0 ==  strcasecmp("452", _pcCmd) || 0 == strcasecmp("GetSNReg", _pcCmd)) 
	{
		iRet = Test_GetSNReg();
	}
	else if (0 ==  strcasecmp("453", _pcCmd) || 0 == strcasecmp("GetComFormat_V1", _pcCmd)) 
	{
		iRet = Test_GetComFormat_V1();
	}
	else if (0 ==  strcasecmp("454", _pcCmd) || 0 == strcasecmp("SetComFormat_V2", _pcCmd)) 
	{
		iRet = Test_SetComFormat_V2();
	}
	else if (0 ==  strcasecmp("455", _pcCmd) || 0 == strcasecmp("GetComFormat_V2", _pcCmd)) 
	{
		iRet = Test_GetComFormat_V2();
	}
	else if (0 ==  strcasecmp("456", _pcCmd) || 0 == strcasecmp("GetServerVersion_V1", _pcCmd)) 
	{
		iRet = Test_GetServerVersion_V1();
	}
// 	else if (0 ==  strcasecmp("457", _pcCmd) || 0 == strcasecmp("SetLocalAudioVolumeEx", _pcCmd)) 
// 	{
// 		iRet = Test_SetLocalAudioVolumeEx();
// 	}
// 	else if (0 ==  strcasecmp("458", _pcCmd) || 0 == strcasecmp("GetLocalAudioVolumeEx", _pcCmd)) 
// 	{
// 		iRet = Test_GetLocalAudioVolumeEx();
// 	}
	else if (0 ==  strcasecmp("459", _pcCmd) || 0 == strcasecmp("GetBitrateOnVideo_V4", _pcCmd)) 
	{
		iRet = Test_GetBitrateOnVideo_V4();
	}
	else if (0 ==  strcasecmp("460", _pcCmd) || 0 == strcasecmp("NetFileDownloadByTimeSpan", _pcCmd)) 
	{
		iRet = Test_NetFileDownloadByTimeSpan();
	}
	else if (0 ==  strcasecmp("461", _pcCmd) || 0 == strcasecmp("ControlDeviceRecord", _pcCmd)) 
	{
		iRet = Test_ControlDeviceRecord();
	}
	else if (0 ==  strcasecmp("462", _pcCmd) || 0 == strcasecmp("SetVideoModeMethod", _pcCmd)) 
	{
		iRet = Test_SetVideoModeMethod();
	}
	else if (0 ==  strcasecmp("463", _pcCmd) || 0 == strcasecmp("GetVideoModeMethod", _pcCmd)) 
	{
		iRet = Test_GetVideoModeMethod();
	}
	else if (0 ==  strcasecmp("464", _pcCmd) || 0 == strcasecmp("SetPsPackCallBack", _pcCmd)) 
	{
		iRet = Test_SetPsPackCallBack();
	}
	else if (0 ==  strcasecmp("465", _pcCmd) || 0 == strcasecmp("SetComRecvNotify_V4", _pcCmd)) 
	{
		iRet = Test_SetComRecvNotify_V4();
	}
	else if (0 ==  strcasecmp("466", _pcCmd) || 0 == strcasecmp("ClearPolyLocalVideo", _pcCmd)) 
	{
		iRet = Test_ClearPolyLocalVideo();
	}
	else if (0 ==  strcasecmp("467", _pcCmd) || 0 == strcasecmp("VCAGetAlarmInfo", _pcCmd)) 
	{
		iRet = Test_VCAGetAlarmInfo();
	}
	else if (0 ==  strcasecmp("468", _pcCmd) || 0 == strcasecmp("SetManagerServersInfo", _pcCmd)) 
	{
		iRet = Test_SetManagerServersInfo();
	}
	else if (0 ==  strcasecmp("469", _pcCmd) || 0 == strcasecmp("GetManagerServersInfo", _pcCmd)) 
	{
		iRet = Test_GetManagerServersInfo();
	}
	else if (0 ==  strcasecmp("470", _pcCmd) || 0 == strcasecmp("BindInterface", _pcCmd))
	{
		iRet = Test_BindInterface();
	}
	else if (0 == strcasecmp("471", _pcCmd) || 0 == strcasecmp("GetNetInterface", _pcCmd))
	{
		iRet = Test_GetNetInterface();
	}
	else if (0 == strcasecmp("472", _pcCmd) || 0 == strcasecmp("NetLogGetLogCount", _pcCmd))
	{
		iRet = Test_NetLogGetLogCount();
	}
	else if (0 == strcasecmp("473", _pcCmd) || 0 == strcasecmp("SetDomainParsePara_V4", _pcCmd))
	{
		iRet = Test_SetDomainParsePara_V4();
	}
	else if (0 == strcasecmp("474", _pcCmd) || 0 == strcasecmp("GetDomainParsePara_V4", _pcCmd))
	{
		iRet = Test_GetDomainParsePara_V4();
	}
	else if (0 == strcasecmp("475", _pcCmd) || 0 == strcasecmp("SetHTTPPort_V4", _pcCmd))
	{
		iRet = Test_SetHTTPPort_V4();
	}
	else if (0 == strcasecmp("476", _pcCmd) || 0 == strcasecmp("GetHTTPPort_V4", _pcCmd))
	{
		iRet = Test_GetHTTPPort_V4();
	}
	else if (0 == strcasecmp("477", _pcCmd) || 0 == strcasecmp("GetConnectInfo", _pcCmd))
	{
		iRet = Test_GetConnectInfo();
	}
	else if (0 == strcasecmp("478", _pcCmd) || 0 == strcasecmp("SetHXListenPortInfo", _pcCmd))
	{
		iRet = Test_SetHXListenPortInfo();
	}
	else if (0 == strcasecmp("479", _pcCmd) || 0 == strcasecmp("GetHXListenPortInfo", _pcCmd))
	{
		iRet = Test_GetHXListenPortInfo();
	}
	else if (0 == strcasecmp("480", _pcCmd) || 0 == strcasecmp("NetFileLockFile", _pcCmd))
	{
		iRet = Test_NetFileLockFile();
	}
	else if (0 == strcasecmp("481", _pcCmd) || 0 == strcasecmp("GetGroupAuthority", _pcCmd))
	{
		iRet = Test_GetGroupAuthority();
	}
	else if (0 == strcasecmp("482", _pcCmd) || 0 == strcasecmp("ModifyUserAuthority", _pcCmd))
	{
		iRet = Test_ModifyUserAuthority();
	}
	else if (0 == strcasecmp("483", _pcCmd) || 0 == strcasecmp("GetUserAuthority", _pcCmd))
	{
		iRet = Test_GetUserAuthority();
	}
	else if (0 == strcasecmp("484", _pcCmd) || 0 == strcasecmp("SetDiskGroup", _pcCmd))
	{
		iRet = Test_SetDiskGroup();
	}
	else if (0 == strcasecmp("485", _pcCmd) || 0 == strcasecmp("GetDiskGroup", _pcCmd))
	{
		iRet = Test_GetDiskGroup();
	}
	else if (0 == strcasecmp("486", _pcCmd) || 0 == strcasecmp("SetDiskQuota", _pcCmd))
	{
		iRet = Test_SetDiskQuota();
	}
	else if (0 == strcasecmp("487", _pcCmd) || 0 == strcasecmp("GetDiskQuotaState", _pcCmd))
	{
		iRet = Test_GetDiskQuotaState();
	}
	else if (0 == strcasecmp("488", _pcCmd) || 0 == strcasecmp("SetHolidayPlan", _pcCmd))
	{
		iRet = Test_SetHolidayPlan();
	}
	else if (0 == strcasecmp("489", _pcCmd) || 0 == strcasecmp("GetHolidayPlan", _pcCmd))
	{
		iRet = Test_GetHolidayPlan();
	}
	else
	{
		ListAllInterface();
	}

    return iRet;
}

int Test_GetVersion()
{
	SDK_VERSION ver;
	memset(&ver, 0, sizeof(ver));
	fprintf(stderr, "You choose to test NetClient_GetVersion, number is 248\n");

	int iRet = NetClient_GetVersion(&ver);
	if(0 == iRet)
	{
		fprintf(stderr, "GetVersion is successful!\n");
		fprintf(stderr, "The SDK version is %d.%d.%d\n",
				ver.m_ulMajorVersion,
				ver.m_ulMinorVersion,
				ver.m_ulBuilder);
	}
	else
	{
		fprintf(stderr, "GetVersion is failed!\n");
	}

	fprintf(stderr, "Please type interface to test:");
	return 0;
}

int Test_GetLogonStatus()
{
	fprintf(stderr, "You choose to test NetClient_GetLogonStatus, number is 249\n");

	int iRet = NetClient_GetLogonStatus(g_iLogonID);
	switch(iRet)
	{
		case LOGON_SUCCESS:
			fprintf(stderr, "Logon status is successfull\n");
			break;
			case LOGON_ING:
				fprintf(stderr, "Logon status is logoning\n");
				break;
			case LOGON_RETRY:
				fprintf(stderr, "Logon status is logon retry\n");
				break;
			case LOGON_DSMING:
				fprintf(stderr, "Logon status is logon dsming\n");
				break;
			case LOGON_FAILED:
				fprintf(stderr, "Logon status is failed\n");
				break;
			case LOGON_TIMEOUT:
				fprintf(stderr, "Logon status is timeout\n");
				break;
			case NOT_LOGON:
				fprintf(stderr, "Logon status is not logon\n");
				break;
			case LOGON_DSMFAILED:
				fprintf(stderr, "Logon status is logon dsm failed\n");
				break;
			case LOGON_DSMTIMEOUT:
				fprintf(stderr, "Logon status is logon dsm timeout\n");
				break;
			default:
				break;
	}

	fprintf(stderr, "Please type interface to test:");
	return 0;
}

int Test_GetDevInfo()
{
	ENCODERINFO encoderInfo;
	memset(&encoderInfo, 0, sizeof(encoderInfo));

	fprintf(stderr, "You choose to test NetClient_GetDevInfo, number is 250\n");

	int iRet = NetClient_GetDevInfo(g_iLogonID, &encoderInfo);
	if(0 == iRet)
	{
		fprintf(stderr, "GetDevInfo is successful\n");
		fprintf(stderr, "Device IP is %s\n", encoderInfo.m_cEncoder);
		fprintf(stderr, "Device factory id is %s\n", encoderInfo.m_cFactoryID);
		fprintf(stderr, "Device host name is %s\n", encoderInfo.m_cHostName);
		fprintf(stderr, "Device proxy IP is %s\n", encoderInfo.m_cProxy);
		fprintf(stderr, "Device channel number is %d\n", encoderInfo.m_iChanNum);
		fprintf(stderr, "Device logon status is %d\n", encoderInfo.m_iLogonState);
		fprintf(stderr, "Device port is %d\n", encoderInfo.m_iPort);
		fprintf(stderr, "Device net mode is %d\n", encoderInfo.m_iRecvMode);
		fprintf(stderr, "Device server type is %d\n", encoderInfo.m_iServerType);
		fprintf(stderr, "Device type is %d\n", encoderInfo.m_nvsType);
	}

	fprintf(stderr, "Please type interface to test:");
	return 0;
}

void __stdcall GetNotifyTest(unsigned int _ulID, unsigned int _ulStreamType, unsigned char *_cData, int _iLen, void* _iUser, void* _iUserData)
{
	fprintf(stderr, "Enter In GetNotifyTest \n");
	int i = 0;
}

int Test_StartRecv()
{

/*
    memset(&cltInfo,0,sizeof(CLIENTINFO));
    char cFile[255] = {0};

    fprintf(stderr,"You choose to test NetClient_StartRecv\n");

    fprintf(stderr, "Please input channel number:");
    scanf("%d",&cltInfo.m_iChannelNo);

    //fprintf(stderr, "Please input file name:");
    //scanf("%s",cFile);
    //strcpy(cltInfo.m_cNetFile,cFile);

    cltInfo.m_iServerID = g_iLogonID;
    cltInfo.m_iBufferCount = 5;
    cltInfo.m_iNetMode = NETMODE_TCP;
    cltInfo.m_iTimeout = 2000;
    cltInfo.m_iTTL = 8;
    cltInfo.m_iStreamNO = MAIN_STREAM;
    cltInfo.m_iFlag = 0;
    cltInfo.m_iPosition = -1;
    cltInfo.m_iSpeed = 1;
*/
    int iChannel = 0;
    int iNetMode = 0;
    int iStreamNo = 0;
    char cTemp[8] = {0};

    fprintf(stderr,"You choose to test NetClient_StartRecv, number is 1\n");

    fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, 
            "net mode:\n"
            "1: TCP\n"
            "2: UDP\n"
            "3: Multicast\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iNetMode = to_int_def(cTemp, -1);

    fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNo = to_int_def(cTemp, -1);

    CLIENTINFO cltInfo;
    memset(&cltInfo,0,sizeof(CLIENTINFO));
    cltInfo.m_iServerID = g_iLogonID;
    cltInfo.m_iBufferCount = 5;
    cltInfo.m_iChannelNo = iChannel;
    cltInfo.m_iNetMode = iNetMode;
    cltInfo.m_iTimeout = 2000;
    cltInfo.m_iTTL = 8;
    cltInfo.m_iStreamNO = iStreamNo;

    int iRet = NetClient_StartRecv(&g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum], &cltInfo, NVSDATA_Notify, (void*)0);
    if(0 == iRet)
    {
        fprintf(stderr, "NetClient_StartRecv success\n");
    }
    else
    {
        fprintf(stderr, "NetClient_StartRecv failed\n");
    }

	////
	NetClient_SetFullStreamNotify_V4(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum], GetNotifyTest, (void*)NULL);

	fprintf(stderr, "Please type interface to test:");

    return 0;
}

int Test_StopRecv()
{
	int iChannel = 0;
	int iStreamNo = 0;
    char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_StopRecv, number is 2\n");


    fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNo = to_int_def(cTemp, -1);

    int iRet = NetClient_StopRecv(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum]);
    if(0 == iRet)
    {
        fprintf(stderr, "NetClient_StopRecv success\n");
    }
    else
    {
        fprintf(stderr, "NetClient_StopRecv failed\n");
    }

    g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum] = 0xFFFFFFFF;

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetNVS()
{
    int iCheck = 0;
    int iVideo = 0;
    char cTemp[16] = {0};

    fprintf(stderr, "You choose to test NetClient_SetNVS, number is 3\n");

    fprintf(stderr, "Please input check:");
	gets_s(cTemp, 16);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iCheck = to_int_def(cTemp, -1);

    if(740101213 == iCheck)
    {
        fprintf(stderr, "Please input max video size:");
    }
    else
    {
        fprintf(stderr, "Please input channel:");
    }

    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 16);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iVideo = to_int_def(cTemp, -1);

    int iRet = NetClient_SetNVS(g_iLogonID, iVideo, iCheck);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

void Test_GetChannelNum()
{
    int iChannelNum = 0;

    fprintf(stderr,"You choose to test NetClient_GetChannelNum, number is 21\n");

    int iRet = NetClient_GetChannelNum(g_iLogonID, &iChannelNum);
    if(0 == iRet)
    {
        fprintf(stderr, "GetChannelNum success\n");
        fprintf(stderr, "The total channel number is %d\n", iChannelNum);
    }
    else
    {
        fprintf(stderr, "GetChannelNum failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
}

int Test_SetAudioChannel()
{
    int iChannel = 0;
    int iAudioChannel = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetAudioChannel, number is 6\n");

    fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input audio channel number to be set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iAudioChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_SetAudioChannel(g_iLogonID, iChannel, iAudioChannel);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");

    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_GetAudioChannel()
{
    int iChannel = 0;
    int iAudioChannel = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetChannelNum, number is 5\n");

    fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetAudioChannel(g_iLogonID, iChannel, &iAudioChannel);
    if(0 == iRet)
    {
        fprintf(stderr, "GetAudioChannel success\n");
        fprintf(stderr, "The audio channel number is %d\n", iAudioChannel);
    }
    else
    {
        fprintf(stderr, "GetAudioChannel failed\n");
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

void Test_GetAlarmPortNum()
{
    int iAlarmInPortNum = 0;
    int iAlarmOutPortNum = 0;

    fprintf(stderr, "You choose to test NetClient_GetAlarmPortNum, number is 4\n");

    int iRet = NetClient_GetAlarmPortNum(g_iLogonID, &iAlarmInPortNum, &iAlarmOutPortNum);
    if(0 == iRet)
    {
        fprintf(stderr, "GetAlarmPortNum success\n");
        fprintf(stderr, "The alarm in port number is %d\n", iAlarmInPortNum);
        fprintf(stderr, "The alarm out port number is %d\n", iAlarmOutPortNum);
    }
    else
    {
        fprintf(stderr, "GetAlarmPortNum failed\n");
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");
}

int Test_GetOutportState()
{
    int iPort = 0;
    int iState = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_GetOutportState, number is 9\n");

    fprintf(stderr, "Please input out port number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iPort = to_int_def(cTemp, -1);

    int iRet = NetClient_GetOutportState(g_iLogonID, iPort, &iState);
    if(0 == iRet)
    {
        fprintf(stderr, "GetOutportState is successfull\n");
        if(0 == iState)
        {
            fprintf(stderr, "The out port state is off\n");
        }
        else if(1 == iState)
        {
            fprintf(stderr, "The out port state is on\n");
        }
    }
    else
    {
        fprintf(stderr, "GetOutportState failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_SetOutportState()
{
    int iPort = 0;
    int iState = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetOutportState, number is 8\n");

    fprintf(stderr,"Please type output port:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iPort = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set output port state\n"
        "0: off\n"
        "1: on\n"
        "Please choose a number to be set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iState = to_int_def(cTemp, -1);

    int iRet = NetClient_SetOutportState(g_iLogonID, iPort, iState);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

int Test_SetAlmVdoCovThreshold()
{
    int iChannel = 0;
    int iThreshold = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetAlmVdoCovThreshold, number is 7\n");

    fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input alarm video cover sensitivity you want to set[0-255]:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iThreshold = to_int_def(cTemp, -1);

    int iRet = NetClient_SetAlmVdoCovThreshold(g_iLogonID, iChannel, iThreshold);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetAlmVdoCovThreshold()
{
    int iChannel = 0;
    int iThreshold = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetAlmVdoCovThreshold, number is 10\n");

    fprintf(stderr,"Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetAlmVdoCovThreshold(g_iLogonID, iChannel, &iThreshold);
    if(0 == iRet)
    {
        fprintf(stderr, "GetAlmVdoCovThreshold success\n");
        fprintf(stderr, "The alarm video cover sensitivity is %d\n", iThreshold);
    }
    else
    {
        fprintf(stderr, "GetAlmVdoCovThreshold failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

int Test_SetAlmVideoCov()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr,"You choose to test NetClient_SetAlmVideoCov, number is 11\n");

    fprintf(stderr,"Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set alarm video cover status\n"
        "0: Disabled\n"
        "1: Enabled\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iEnable = to_int_def(cTemp, -1);

    int iRet = NetClient_SetAlmVideoCov(g_iLogonID, iChannel, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetAlmVideoCov()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr,"You choose to test NetClient_GetAlmVideoCov, number is 12\n");

    fprintf(stderr,"Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetAlmVideoCov(g_iLogonID, iChannel, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetAlmVideoCov success\n");
        if(0 == iEnable)
        {
            fprintf(stderr, "Alarm video cover status is disabled\n");
        }
        else if(1 == iEnable)
        {
            fprintf(stderr, "Alarm video cover status is enabled\n");
        }
    }
    else
    {
        fprintf(stderr, "GetAlmVideoCov failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

void Test_GetAllSupportDeviceType()
{
    fprintf(stderr,"You choose to test NetClient_GetAllSupportDeviceType, number is 13\n");

    int iSumDeviceType = 0;
    char cDeviceType[32][32];
    for(int i=0;i<32;i++)
    {
        memset(cDeviceType[i], 0, sizeof(cDeviceType[i]));
    }

    int iRet = NetClient_GetAllSupportDeviceType(g_iLogonID, &iSumDeviceType, (char*)cDeviceType);
    if(0 == iRet)
    {
        fprintf(stderr, "GetAllSupportDeviceType success\n");
        fprintf(stderr, "The sum of supported device type is %d\n", iSumDeviceType);

        for(int i=1; i<=iSumDeviceType; i++)
        {
            fprintf(stderr, "The device type[%d] is %s\n", i, cDeviceType[i-1]);
        }

    }
    else
    {
        fprintf(stderr, "GetAllSupportDeviceType failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
}


int Test_DeviceCtrl()
{
    int iChannel = 0;
    char cTemp[8] = {0};

    fprintf(stderr,"You choose to test NetClient_DeviceCtrl, number is 14\n");

	fprintf(stderr,"Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_DeviceCtrl(g_iLogonID, iChannel, 6, 50, 50);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

int Test_DeviceCtrlEx()
{
    int iChannel = 0;
    int iControlType = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_DeviceCtrlEx, number is 15\n");

    fprintf(stderr,"Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Control type\n"
        "0: Normal\n"
        "1: e_PTZ\n"
        "Please choose a number to be set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iControlType = to_int_def(cTemp, -1);

    fprintf(stderr,
            "Please input direction, x speed, y speed:\n"
            "0: To up(1, 50, 50)\n"
            "1: To down(2, 100, 100\n"
            "2: To left(3, 25, 25)\n"
            "3: To right(4, 75, 75)\n"
            "4: To upleft(6, 50, 50)\n"
            "5: To stop(9, 50, 50)\n"
            "Please choose a number to be set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iDir_Speed = to_int_def(cTemp, 0);

    int iRet = -1;
    switch (iDir_Speed)
    {
        case 0:
            iRet = NetClient_DeviceCtrlEx(g_iLogonID, iChannel, 1, 50, 50, iControlType);
            break;
        case 1:
            iRet = NetClient_DeviceCtrlEx(g_iLogonID, iChannel, 2, 50, 50, iControlType);
            break;
        case 2:
            iRet = NetClient_DeviceCtrlEx(g_iLogonID, iChannel, 3, 50, 50, iControlType);
            break;
        case 3:
            iRet = NetClient_DeviceCtrlEx(g_iLogonID, iChannel, 4, 50, 50, iControlType);
            break;
        case 4:
            iRet = NetClient_DeviceCtrlEx(g_iLogonID, iChannel, 6, 50, 50, iControlType);
            break;
        case 5:
            iRet = NetClient_DeviceCtrlEx(g_iLogonID, iChannel, 9, 50, 50, iControlType);
            break;
        default:
            break;
    }

    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetVideoLostLinkSoundDisplay()
{
    int iChannel = 0;
    int iSoundEnable = 0;
    int iDisplayEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetVideoLostLinkSoundDisplay, number is 16\n");

    fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetVideoLostLinkSoundDisplay(g_iLogonID, iChannel, &iSoundEnable, &iDisplayEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetVideoLostLinkSoundDisplay success\n");
        if(0 == iSoundEnable)
        {
            fprintf(stderr, "Video lost link sound is off\n");
        }
        else if(1 == iSoundEnable)
        {
            fprintf(stderr, "Video lost link sound is on\n");
        }

        if(0 == iDisplayEnable)
        {
            fprintf(stderr, "Video lost link display is off\n");
        }
        else if(1 == iDisplayEnable)
        {
            fprintf(stderr, "Video lost link display is on\n");
        }
    }
    else
    {
        fprintf(stderr, "GetVideoLostLinkSoundDisplay failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_SetVideoLostLinkSoundDisplay()
{
    int iChannel = 0;
    int iSoundEnable = 0;
    int iDisplayEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr,"You choose to test NetClient_SetVideoLostLinkSoundDisplay, number is 19\n");

    fprintf(stderr,"Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set video lost link sound off or on\n"
        "0: off\n"
        "1: on\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iSoundEnable = to_int_def(cTemp, -1);


    fprintf(stderr,
        "Set video lost link display off or on\n"
        "0: off\n"
        "1: on\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iDisplayEnable = to_int_def(cTemp, -1);


    int iRet = NetClient_SetVideoLostLinkSoundDisplay(g_iLogonID, iChannel, iSoundEnable, iDisplayEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetAlarmVLostState()
{
    int iChannel = 0;
    int iState = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetAlarmVLostState, number is 17\n");

    fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetAlarmVLostState(g_iLogonID, iChannel, &iState);
    if(0 == iRet)
    {
        fprintf(stderr, "GetAlarmVLostState success\n");
        if(0 == iState)
        {
            fprintf(stderr, "Video lost alarm do not happen\n");
        }
        else if(1 == iState)
        {
            fprintf(stderr, "Video lost alarm happen\n");
        }
    }
    else
    {
        fprintf(stderr, "GetAlarmVLostState failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

void Test_GetTalkingState()
{
    int iTalkState = 0;
    fprintf(stderr, "You choose to test NetClient_GetTalkingState, number is 18\n");

    int iRet = NetClient_GetTalkingState(g_iLogonID, &iTalkState);
    if(0 == iRet)
    {
        fprintf(stderr, "GetTalkingState success\n");
        if(0 == iTalkState)
        {
            fprintf(stderr, "The talk state is TALK_STATE_NO_TALK\n");
        }
        else if(2 == iTalkState)
        {
            fprintf(stderr, "The talk state is TALK_STATE_TALKING\n");
        }
    }
    else
    {
        fprintf(stderr, "GetTalkingState failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

void Test_SetComRecvNotify()
{
    fprintf(stderr, "You choose to test NetClient_SetComRecvNotify, number is 20\n");

    int iRet = NetClient_SetComRecvNotify(NULL);
    if(0 == iRet)
    {
        fprintf(stderr, "SetComRecvNotify success\n");
    }
    else
    {
        fprintf(stderr, "SetComRecvNotify failed\n");
    }
}

void Test_GetMaxMinorVideoSize()
{
    int iMinorVideoSize = 0;
    fprintf(stderr, "You choose to test NetClient_GetMaxMinorVideoSize, number is 22\n");

    int iRet = NetClient_GetMaxMinorVideoSize(g_iLogonID, &iMinorVideoSize);
    if(0 == iRet)
    {
        fprintf(stderr, "GetMaxMinorVideoSize success\n");
        fprintf(stderr, "The sub stream's max video size is %d\n", iMinorVideoSize);
    }
    else
    {
        fprintf(stderr, "GetMaxMinorVideoSize failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

void Test_GetWifiDHCPParam()
{
    int iDHCP = 0;
    fprintf(stderr, "You choose to test NetClient_GetWifiDHCPParam, number is 23\n");

    int iRet = NetClient_GetWifiDHCPParam(g_iLogonID, &iDHCP);
    if(0 == iRet)
    {
        fprintf(stderr, "GetWifiDHCPParam success\n");
        if(0 == iDHCP)
        {
            fprintf(stderr, "DHCP is disabled\n");
        }
        else if(1 == iDHCP)
        {
            fprintf(stderr, "DHCP is enabled\n");
        }
    }
    else
    {
        fprintf(stderr, "GetWifiDHCPParam failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_SetWifiDHCPParam()
{
    int iDHCP = 0;
    char cTemp[8] = {0};

    fprintf(stderr,"You choose to test NetClient_SetWifiDHCPParam, 24\n");

    fprintf(stderr,
        "Set DHCP status\n"
        "0: Disable DHCP\n"
        "1: Enable DHCP\n"
        "Please choose a number to be set:");

    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iDHCP = to_int_def(cTemp, -1);

    int iRet = NetClient_SetWifiDHCPParam(g_iLogonID, iDHCP);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_SetReducenoiseState()
{
    int iState = 0;
    int iChannel = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_SetReducenoiseState, number is 25\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Reduce noise type to be set\n"
        "0: Disable reducing noise\n"
        "1: Ensable reducing noise\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iState = to_int_def(cTemp, -1);

    int iRet = NetClient_SetReducenoiseState(g_iLogonID, iChannel, iState);
    if(0 == iRet)
    {
        fprintf(stderr, "Send command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send command to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_ReadUserData()
{
    int iOffset = 0;
    int iLength = 0;
    char cTemp[8] = {0};
    unsigned char u8Buf[128] = {0};

    fprintf(stderr,"You choose to test NetClient_ReadUserData, number is 26\n");

    fprintf(stderr, "Plsase input data offset:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iOffset = to_int_def(cTemp, -1);

    fprintf(stderr, "Plsase input data length to read:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iLength = to_int_def(cTemp, -1);

    int iRet = NetClient_ReadUserData(g_iLogonID, iOffset, u8Buf, iLength);
    if(0 == iRet)
    {
        fprintf(stderr, "ReadUserData success, userdata is %s\n", u8Buf);
        printf("ASCII: ");
        for(int i=0; i<iLength; i++)
        {
            printf("%d ", u8Buf[i]);
        }

        printf("\n");

    }
    else
    {
        fprintf(stderr, "ReadUserData failed,errno is 0x%08x and return value is %d\n", errno, iRet);
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_WriteUserData()
{
    int iOffset = 0;
    int iLength = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_WriteUserData, number is 27\n");

    fprintf(stderr, "Plsase input data offset:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iOffset = to_int_def(cTemp, -1);

    fprintf(stderr, "Plsase input data length to write:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iLength = to_int_def(cTemp, -1);

	if(iLength + iOffset > 32)
	{
		fprintf(stderr, "Length Add Offset over 32, Err!");
		return 0;
	}
    fprintf(stderr, "Plsase input user data to write:\n");
    unsigned char u8Buf[32] = {0};
    int iTemp = 0;
    for(int i=0; i<iLength; i++)
    {
        memset(cTemp, 0, sizeof(cTemp));
        gets_s(cTemp, 8);
        iTemp = to_int_def(cTemp, -1);
        if(iTemp > 255 || iTemp < 0)
        {
            fprintf(stderr, "Invalid number.\n");
            return 0;
        }
        u8Buf[i] = iTemp;
    } 

    int iRet = NetClient_WriteUserData(g_iLogonID, iOffset, u8Buf, iLength);
    if(0 == iRet)
    {
        fprintf(stderr, "\nSend command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send command to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetReducenoiseState()
{
    int iChannel = 0;
    int iState = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_GetReducenoiseState, number is 28\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetReducenoiseState(g_iLogonID, iChannel, &iState);
    if(0 == iRet)
    {
        fprintf(stderr, "GetReducenoiseState success\n");
        if(0 == iState)
        {
            fprintf(stderr, "Reduce noise state is off\n");
        }
        else if(1 == iState)
        {
            fprintf(stderr, "Reduce noise state is on\n");
        }
    }
    else
    {
        fprintf(stderr, "GetReducenoiseState failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_DrawTextOnVideo()
{
    int iChannel = 0;
    int iStreamType = 0;
    int iX = 0;
    int iY = 0;
    char cText[256] = {0};
    char cTemp[8] = {0};

    fprintf(stderr,"You choose to test NetClient_DrawTextOnVideo, number is 29\n");

    fprintf(stderr,"Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: Main stream\n"
        "1: Sub stream\n"
        "Please choose a number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamType = to_int_def(cTemp, 0);

    fprintf(stderr, "Plsase input X:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iX = to_int_def(cTemp, 0);

    fprintf(stderr, "Plsase input Y:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iY = to_int_def(cTemp, 0);

    fprintf(stderr, "Plsase input text:");
    gets_s(cText, 256);
    if(0 == strcasecmp("q", cText))
    {
        return -1;
    }

    int iRet = NetClient_DrawTextOnVideo(g_iLogonID, iChannel, iX, iY, cText, 1, iStreamType);
    if(0 == iRet)
    {
        fprintf(stderr, "DrawTextOnVideo success\n");
    }
    else
    {
        fprintf(stderr, "DrawTextOnVideo failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetTextOnVideo()
{
    int iChannel = 0;
    int iStreamType = 0;
    int iX = 0;
    int iY = 0;
    char cText[256] = {0};
    char cTemp[8] = {0};

    fprintf(stderr,"You choose to test NetClient_GetTextOnVideo, number is 30\n");

    fprintf(stderr,"Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: Main stream\n"
        "1: Sub stream\n"
        "Please choose a number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamType = to_int_def(cTemp, 0);

    int iRet = NetClient_GetTextOnVideo(g_iLogonID, iChannel, &iX, &iY, cText, iStreamType);
    if(0 == iRet)
    {
        fprintf(stderr, "Text on video,X = %d, Y = %d, text is %s\n", iX, iY, cText);
    }
    else
    {
        fprintf(stderr, "GetTextOnVideo failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

//------------------------------------------------------------------------------------

int Test_SetBothStreamSame()
{
    int iState = 0;
    int iChannel = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_SetBothStreamSame, number is 31\n");

    fprintf(stderr,"Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set stream type\n"
        "0: Main stream and sub stream is different\n"
        "1: Main stream and sub stream is same\n"
        "Please choose a number to set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iState = to_int_def(cTemp, -1);

    int iRet = NetClient_SetBothStreamSame(g_iLogonID, iChannel, iState);
    if(0 == iRet)
    {
        fprintf(stderr, "Send command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send command to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetBothStreamSame()
{
    int iState = 0;
    int iChannel = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetBothStreamSame, number is 32\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetBothStreamSame(g_iLogonID, iChannel, &iState);
    if(0 == iRet)
    {
        fprintf(stderr,"GetBothStreamSame success!\n");
        if(0 == iState)
        {
            fprintf(stderr, "Main stream and sub stream is different\n");
        }
        else if(1 == iState)
        {
            fprintf(stderr, "Main stream and sub stream is same\n");
        }
    }
    else
    {
        fprintf(stderr, "GetBothStreamSame failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_SetPPPoEInfo()
{
    int iEnable = 0;
    char cAccount[256] = {0};
    char cPassword[256] = {0};
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetPPPoEInfo, num is 33\n");

    fprintf(stderr, "Plsase input PPPoE account:");
    gets_s(cAccount, 256);
    if(0 == strcasecmp("q", cAccount))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input PPPoE password:");
    gets_s(cPassword, 256);
    if(0 == strcasecmp("q", cPassword))
    {
        return -1;
    }

    fprintf(stderr,
        "PPPoE status\n"
        "0: disable PPPoE\n"
        "1: enable PPPoE\n"
        "Please choose a number to set:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iEnable = to_int_def(cTemp, -1);

    int iRet = NetClient_SetPPPoEInfo(g_iLogonID, cAccount, cPassword, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}
void Test_GetPPPoEInfo()
{
    int iEnable = 0;
    char cAccount[256] = {0};
    char cPassword[256] = {0};

    fprintf(stderr, "You choose to test NetClient_GetPPPoEInfo, number is 39\n");

    int iRet = NetClient_GetPPPoEInfo(g_iLogonID, cAccount, cPassword, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetPPPoEInfo success\n");
        fprintf(stderr, "PPPoE account is %s\n", cAccount);
        fprintf(stderr, "PPPoE password is %s\n", cPassword);
        if(0 == iEnable)
        {
            fprintf(stderr, "PPPoE is disabled\n");
        }
        else if(1 == iEnable)
        {
            fprintf(stderr, "PPPoE is enabled\n");
        }
    }
    else
    {
        fprintf(stderr, "GetPPPoEInfo failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_LogFileSetProperty()
{
    int iLevel = 0;
    int iSize = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_LogFileSetProperty, number is 43\n");

    fprintf(stderr, 
            "Set log file level as bit:\n"
            "bit0: LOG_LEVEL_SYSTEM    \n"
            "bit1: LOG_LEVEL_WARNING   \n"
            "bit2: LOG_LEVEL_ALARM     \n"
            "bit3: LOG_LEVEL_OPERATION \n"
            "bit4: LOG_LEVEL_USER      \n"
            "bit5: LOG_LEVEL_OTHER     \n"
            "bit6: LOG_LEVEL_DEBUG1    \n"
            "Please input decimal number to set:");

    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iLevel = to_int_def(cTemp, -1);

    fprintf(stderr, "Plsase input log file size[8-512]:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iSize = to_int_def(cTemp, -1);

    int iRet = NetClient_LogFileSetProperty(g_iLogonID, iLevel, iSize);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

void Test_LogFileGetProperty()
{
    int iLevel = 0;
    int iSize = 0;

    fprintf(stderr, "You choose to test NetClient_LogFileGetProperty, number is 35\n");

    int iRet = NetClient_LogFileGetProperty(g_iLogonID, &iLevel, &iSize);
    if(0 == iRet)
    {
        fprintf(stderr, "LogFileGetProperty is successful\n");
        fprintf(stderr, "Log file decimal level is %d\n", iLevel);
		fprintf(stderr, 
			"bit0: LOG_LEVEL_SYSTEM    \n"
			"bit1: LOG_LEVEL_WARNING   \n"
			"bit2: LOG_LEVEL_ALARM     \n"
			"bit3: LOG_LEVEL_OPERATION \n"
			"bit4: LOG_LEVEL_USER      \n"
			"bit5: LOG_LEVEL_OTHER     \n"
			"bit6: LOG_LEVEL_DEBUG1    \n");

        fprintf(stderr, "Log file size is %d\n", iSize);
    }
    else
    {
        fprintf(stderr, "LogFileGetProperty failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
}

int Test_NetFileRebuildIndexFile()
{
    int iState = 0;
    char cTemp[8] = {0};
    fprintf(stderr,"You choose to test NetClient_NetFileRebuildIndexFile,number is 37\n");

    fprintf(stderr,"Plsase input state:");
    fprintf(stderr,
        "Rebuild index status\n"
        "0: Stop rebuild index\n"
        "1: Start rebuild index\n"
        "Please choose a number to set:");

    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iState = to_int_def(cTemp, -1);


    int iRet = NetClient_NetFileRebuildIndexFile(g_iLogonID, iState);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

void Test_NetFileIsSupportStorage()
{
    fprintf(stderr, "You choose to test NetClient_NetFileIsSupportStorage, number is 34\n");

    int iRet = NetClient_NetFileIsSupportStorage(g_iLogonID);
    if(0 == iRet)
    {
        fprintf(stderr, "The device does not support camera site storage\n");
    }
    else if(1 == iRet)
    {
        fprintf(stderr, "The device support camera site storage\n");
    }
    else
    {
        fprintf(stderr, "NetFileIsSupportStorage failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_NetFileDownloadFile()
{
    fprintf(stderr, "You choose to test NetClient_NetFileDownloadFile, number is 38\n");

    int iFileIndex = 0; 
    char cTemp[8] = {0};   
    
    fprintf(stderr, "Please input file index you want to download[0-32):");           
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iFileIndex = to_int_def(cTemp, -1);

    if(iFileIndex >=0 && iFileIndex < 32)
    {
        unsigned int iRecvContext = 0xFFFFFFFF;
        char cLocal[512] = {0};
        sprintf(cLocal,"/root/download-%d-%s",iFileIndex,fileInfo[iFileIndex].cFileName);
        int iRet = NetClient_NetFileDownloadFile(&iRecvContext,
                                                 g_iLogonID,
                                                 fileInfo[iFileIndex].cFileName,
                                                 cLocal,
                                                 0,
                                                 0,
                                                 1);
        if(iRet >= 0)
        {
            for(int i=0;i<MAX_FILE_CHAN;++i)
            {
                if(0xFFFFFFFF == g_uiFileRecvID[i])
                {
                    g_uiFileRecvID[i] = iRecvContext;
                    break;
                }

            }
        }
        else
        {
            fprintf(stderr, "There is no file in remote!\n");
        }
    }
    else
    {
        fprintf(stderr, "File index is out of range\n");
    }

    fprintf(stderr, "Please type other interface to test:");
    return 0;
    
}

int Test_NetFileStopDownloadFile()
{
    fprintf(stderr, "You choose to test NetClient_NetFileStopDownloadFile, number is 40\n");
    int iRecvID = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "Please input file recv id:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iRecvID = to_int_def(cTemp, -1);
    
    int iRet = NetClient_NetFileStopDownloadFile((unsigned int)iRecvID);
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileStopDownloadFile is OK!\n");
    }
    else
    {
        fprintf(stderr, "NetFileStopDownloadFile is failed!\n");
    }

    fprintf(stderr, "Please type interface:");

    return 0;
}

int Test_NetFileMountUSB()
{
    int iState = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_NetFileMountUSB, number is 41\n");

    fprintf(stderr,
        "USB status\n"
        "0: Unmount USB\n"
        "1: Mount USB\n"
        "Please choose a number to set:");

    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iState = to_int_def(cTemp, -1);


    int iRet = NetClient_NetFileMountUSB(g_iLogonID, iState);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_NetFileDelFile()
{
    char cFileName[256] = {0};
    fprintf(stderr, "You choose to test NetClient_NetFileDelFile, number is 42\n");

    fprintf(stderr, "Plsase input file name you want to delete:");
    gets_s(cFileName, 256);
    if(0 == strcasecmp("q", cFileName))
    {
        return -1;
    }

    int iRet = NetClient_NetFileDelFile(g_iLogonID, cFileName);
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileDelFile success\n");
    }
    else
    {
        fprintf(stderr, "NetFileDelFile failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_DiskFormat()
{
    int iDiskNo = 0;
    int iFsType = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_DiskFormat, number is 36\n");

    fprintf(stderr,
        "Disk number\n"
        "0-7: SATA\n"
        "8-11: USB\n"
    	"32: ESATA"
        "Please choose a disk number to set:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iDiskNo = to_int_def(cTemp, -1);


    fprintf(stderr,"Plsase input file system type:");
    fprintf(stderr,
        "File system type\n"
        "0: EXT3\n"
        "1: EXT2\n"
        "2: FAT32\n"
        "Please choose a number to set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iFsType = to_int_def(cTemp, -1);


    int iRet = NetClient_DiskFormat(g_iLogonID, iDiskNo, iFsType);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_DiskPart()
{
    int iDiskNo = 0;
    int iPartNo = 0;
    int iFormatNow = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_DiskPart, number is 45\n");

    fprintf(stderr,
        "Disk number\n"
        "0-7: SATA\n"
        "8-11: USB\n"
    	"32: ESATA\n"
        "Please choose a disk number to set:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iDiskNo = to_int_def(cTemp, -1);


    fprintf(stderr,"Plsase input part number[1-4]:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iPartNo = to_int_def(cTemp, -1);


    fprintf(stderr,
        "format now or not\n"
        "0: Do not format now\n"
        "1: Format now\n"
        "Please choose a number to set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iFormatNow = to_int_def(cTemp, -1);

    g_iDiskNO = iDiskNo;
    g_iPartNum = iPartNo;
    g_iFormatNow = iFormatNow;
    int iRet = NetClient_DiskPart(g_iLogonID, iDiskNo, iPartNo, iFormatNow);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

void Test_NetFileGetUSBstate()
{
    int iState = 0;
    fprintf(stderr,"You choose to test NetClient_NetFileGetUSBstate, number is 44\n");

    int iRet = NetClient_NetFileGetUSBstate(g_iLogonID, &iState);
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileGetUSBstate success\n");
        if(0 == iState)
        {
            fprintf(stderr, "USB is unmounted\n");
        }
        else
        {
            fprintf(stderr, "USB is mounted, state is %d\n", iState);
        }
    }
    else
    {
        fprintf(stderr, "NetFileGetUSBstate failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_NetFileSetExtendname()
{
    char cExtendname[256] = {0};

    fprintf(stderr, "You choose to test NetClient_NetFileSetExtendname, number is 46\n");

    fprintf(stderr, "Plsase input extend name you want to set:");
    gets_s(cExtendname, 256);
    if(0 == strcasecmp("q", cExtendname))
    {
        return -1;
    }

    int iRet = NetClient_NetFileSetExtendname(g_iLogonID, cExtendname);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr,"Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

void Test_NetFileGetExtendname()
{
    char cExtendname[256] = {0};
    fprintf(stderr, "You choose to test NetClient_NetFileGetExtendname, number is 47\n");

    int iRet = NetClient_NetFileGetExtendname(g_iLogonID, cExtendname);
    if(0 == iRet)
    {
        fprintf(stderr, "Net file extendname is %s\n", cExtendname);
    }
    else
    {
        fprintf(stderr,"NetFileGetExtendname failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_ClearDisk()
{
    int iDiskNo = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_ClearDisk, number is 48\n");

    fprintf(stderr,
        "Disk number\n"
        "0-7: SATA\n"
        "8-11: USB\n"
    	"32: ESATA\n"
        "Please choose a disk number to set:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iDiskNo = to_int_def(cTemp, -1);

    int iRet = NetClient_ClearDisk(g_iLogonID, iDiskNo);
    if(0 == iRet)
    {
        fprintf(stderr, "ClearDisk success\n");
    }
    else
    {
        fprintf(stderr, "ClearDisk failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

int Test_SetMediaStreamClient()
{
    int iChannel = 0;
    char cClientIP[16] = {0};
    int iClientPort = 0;
    int iStreamType = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetMediaStreamClient, number is 49\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Plsase input stream media client IP:");
    gets_s(cClientIP, 16);
    if(0 == strcasecmp("q", cClientIP))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input stream media client port:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iClientPort = to_int_def(cTemp, -1);

    fprintf(stderr,
        "stream type\n"
        "0: pure audio video stream\n"
        "1: audio video stream with Tiandy frame head\n"
        "Please choose a number to set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamType = to_int_def(cTemp, -1);

    int iRet = NetClient_SetMediaStreamClient(g_iLogonID, iChannel, cClientIP, iClientPort, iStreamType);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetMediaStreamClient()
{
    int iChannel = 0;
    char cClientIP[256] = {0};
    unsigned short iClientPort = 0;
    int iStreamType = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetMediaStreamClient, number is 50\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetMediaStreamClient(g_iLogonID, iChannel, cClientIP, &iClientPort, &iStreamType);
    if(0 == iRet)
    {
        fprintf(stderr, "GetMediaStreamClient success\n");
        fprintf(stderr, "Stream media client IP is %s\n", cClientIP);
        fprintf(stderr, "Stream media client Port is %d\n", iClientPort);
        if(0 == iStreamType)
        {
            fprintf(stderr, "pure audio video stream\n");
        }
        else if(1 == iStreamType)
        {
            fprintf(stderr, "Audio video stream with Tiandy frame head\n");
        }
    }
    else
    {
        fprintf(stderr,"GetMediaStreamClient failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

int Test_SetScene()
{
    int iChannel = 0;
    int iScene = 0;
    char cTemp[8] = {0};

    fprintf(stderr,"You choose to test NetClient_SetScene, number is 51\n");

    fprintf(stderr,"Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Plsase input scene, [0-7] 0 for auto:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iScene = to_int_def(cTemp, -1);

    int iRet = NetClient_SetScene(g_iLogonID, iChannel, iScene);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetScene()
{
    int iChannel = 0;
    int iScene = 0;
    char cTemp[8] = {0};

    fprintf(stderr,"You choose to test NetClient_GetScene, number is 63\n");

    fprintf(stderr,"Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetScene(g_iLogonID, iChannel, &iScene);
    if(0 == iRet)
    {
        if(0 == iScene)
        {
            fprintf(stderr, "Scene is auto\n");
        }
        else
        {
            fprintf(stderr, "Scene is %d\n",iScene);
        }
    }
    else
    {
        fprintf(stderr, "GetScene failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_SetSensorFlip()
{
    int iChannel = 0;
    int iFlip = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetSensorFlip, number is 53\n");

    fprintf(stderr,"Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);


    fprintf(stderr,
        "Flip or not\n"
        "0: Disable flip\n"
        "1: Enable flip\n"
        "Please choose a number to set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iFlip = to_int_def(cTemp, -1);

    int iRet = NetClient_SetSensorFlip(g_iLogonID, iChannel, iFlip);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetSensorFlip()
{
    int iChannel = 0;
    int iFlip = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_GetSensorFlip, number is 54\n");

    fprintf(stderr,"Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetSensorFlip(g_iLogonID, iChannel, &iFlip);
    if(0 == iRet)
    {
        if(0 == iFlip)
        {
            fprintf(stderr, "Flip is disabled\n");
        }
        else if(1 == iFlip)
        {
            fprintf(stderr, "Flip is enabled\n");
        }
    }
    else
    {
        fprintf(stderr, "GetSensorFlip failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

int Test_SetSensorMirror()
{
    int iChannel = 0;
    int iMirror = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetSensorMirror, number is 55\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Mirror or not\n"
        "0: Disable mirror\n"
        "1: Enable mirror\n"
        "Please choose a number to set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iMirror = to_int_def(cTemp, -1);


    int iRet = NetClient_SetSensorMirror(g_iLogonID, iChannel, iMirror);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetSensorMirror()
{
    int iChannel = 0;
    int iMirror = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetSensorMirror, number is 56\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);


    int iRet = NetClient_GetSensorMirror(g_iLogonID, iChannel, &iMirror);
    if(0 == iRet)
    {
        fprintf(stderr, "GetSensorMirror success\n");
        if(0 == iMirror)
        {
            fprintf(stderr, "Mirror is disabled\n");
        }
        else if(1 == iMirror)
        {
            fprintf(stderr, "Mirror is enabled\n");
        }
    }
    else
    {
        fprintf(stderr, "GetSensorMirror failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_Snapshot()
{
    int iChannel = 0;
    int iQvalue = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_Snapshot, number is 57\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);


    fprintf(stderr, "Plsase input snap picture quality value [20-100]:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iQvalue = to_int_def(cTemp, -1);

    int iRet = NetClient_Snapshot(g_iLogonID, iChannel, iQvalue);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr,"Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_SetWifiParam()
{
    NVS_WIFI_PARAM wifiParam;
    memset(&wifiParam, 0, sizeof(wifiParam));

    fprintf(stderr, "You choose to test NetClient_SetWifiParam, number is 58\n");

    fprintf(stderr, "Plsase input wifi server ip:");
    gets_s(wifiParam.cWifiSvrIP, 16);
    if(0 == strcasecmp("q", wifiParam.cWifiSvrIP))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifi mask ip:");
    gets_s(wifiParam.cWifiMask, 16);
    if(0 == strcasecmp("q", wifiParam.cWifiMask))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifi gateway:");
    gets_s(wifiParam.cWifiGateway, 16);
    if(0 == strcasecmp("q", wifiParam.cWifiGateway))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifi DNS:");
    gets_s(wifiParam.cWifiDNS, 16);
    if(0 == strcasecmp("q", wifiParam.cWifiDNS))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifi ESSID:");
    gets_s(wifiParam.cESSID, 33);
    if(0 == strcasecmp("q", wifiParam.cESSID))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifi key type[ascii or hex]:");
    gets_s(wifiParam.cWifiKeyType, 16);
    if(0 == strcasecmp("q", wifiParam.cWifiKeyType))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifi password:");
    gets_s(wifiParam.cWifiPassword, 32);
    if(0 == strcasecmp("q", wifiParam.cWifiPassword))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifi encryption:");
    gets_s(wifiParam.cEncryption, 16);
    if(0 == strcasecmp("q", wifiParam.cEncryption))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifi key number [1-4]:");
    gets_s(wifiParam.cWifiKeyNum, 2);
    if(0 == strcasecmp("q", wifiParam.cWifiKeyNum))
    {
        return -1;
    }

    int iRet = NetClient_SetWifiParam(g_iLogonID, &wifiParam);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

void Test_GetWifiParam()
{
    NVS_WIFI_PARAM wifiParam;
    memset(&wifiParam, 0, sizeof(wifiParam));

    fprintf(stderr, "You choose to test NetClient_GetWifiParam, number is 59\n");

    int iRet = NetClient_GetWifiParam(g_iLogonID, &wifiParam);
    if(0 == iRet)
    {
        fprintf(stderr, "GetWifiParam success\n");
        fprintf(stderr, "Wifi server IP is %s\n", wifiParam.cWifiSvrIP);
        fprintf(stderr, "Wifi mask is %s\n", wifiParam.cWifiMask);
        fprintf(stderr, "Wifi gateway is %s\n", wifiParam.cWifiGateway);
        fprintf(stderr, "Wifi DNS is %s\n", wifiParam.cWifiDNS);
        fprintf(stderr, "Wifi ESSID is %s\n", wifiParam.cESSID);
        fprintf(stderr, "Wifi encryption is %s\n", wifiParam.cEncryption);
        fprintf(stderr, "Wifi key type is %s\n", wifiParam.cWifiKeyType);
        fprintf(stderr, "Wifi key num is %s\n", wifiParam.cWifiKeyNum);
        fprintf(stderr, "Wifi password is %s\n", wifiParam.cWifiPassword);

        if(0 == wifiParam.iHaveCard)
        {
            fprintf(stderr, "Do not have wifi card\n");
        }
        else if(1 == wifiParam.iHaveCard)
        {
            fprintf(stderr, "Have wifi card\n");
        }

        if(0 == wifiParam.iCardOnline)
        {
            fprintf(stderr, "Wifi state is offline\n");
        }
        else if(1 == wifiParam.iCardOnline)
        {
            fprintf(stderr, "Wifi state is online\n");
        }

    }
    else
    {
        fprintf(stderr, "GetWifiParam failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
}

void Test_WifiSearch()
{
    fprintf(stderr,"You choose to test NetClient_WifiSearch, number is 60\n");

    int iRet = NetClient_WifiSearch(g_iLogonID);
    if(0 == iRet)
    {
        fprintf(stderr, "WifiSearch success\n");
    }
    else
    {
        fprintf(stderr, "WifiSearch failed\n");
    }

    //fprintf(stderr, "Please type a number to test corresponding interface:");
}

void Test_GetWifiSearchResult()
{
//  WIFI_INFO *pWifiInfo = NULL;
//  int iWifiCount = 0;
//  fprintf(stderr, "You choose to test NetClient_GetWifiSearchResult, number is 61\n");
//
//  int iRet = NetClient_GetWifiSearchResult(g_iLogonID, &pWifiInfo, &iWifiCount);
//  if(0 == iRet)
//  {
//      fprintf(stderr, "GetWifiSearchResult success, the wifi count is %d\n", iWifiCount);
//      for(int i=0; i<iWifiCount; i++)
//      {
//          fprintf(stderr, "Wifi %d: ESSID is %s\n", i+1, pWifiInfo[i].cESSID);
//          fprintf(stderr, "Wifi %d: encryption is %s\n", i+1, pWifiInfo[i].cEncryption);
//      }
//  }
//  else
//  {
//      fprintf(stderr, "GetWifiSearchResult failed\n");
//  }
//
//  fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_SetPrivacyProtect()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_SetPrivacyProtect, number is 62\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);


    fprintf(stderr,
        "Privacy protect\n"
        "0: disable\n"
        "1: enable\n"
        "Please choose a number to set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iEnable = to_int_def(cTemp, -1);

    int iRet = NetClient_SetPrivacyProtect(g_iLogonID, iChannel, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr,"Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetPrivacyProtect()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};
    fprintf(stderr,"You choose to test NetClient_GetPrivacyProtect, number is 52\n");

    fprintf(stderr,"Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetPrivacyProtect(g_iLogonID, iChannel, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetPrivacyProtect success\n");

        if(0 == iEnable)
        {
        	fprintf(stderr, "Privacy protect is disabled\n");
        }
        else if(1 == iEnable)
        {
        	fprintf(stderr, "Privacy protect is enabled\n");
        }
        else
        {
        	fprintf(stderr, "Privacy protect enable is %d\n", iEnable);
        }
    }
    else
    {
        fprintf(stderr, "GetPrivacyProtect failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

void Test_IYUVtoYV12()
{
    fprintf(stderr, "You choose to test NetClient_IYUVtoYV12, number is 64\n");
}

void Test_GetDevType()
{
    int iDevType = 0;
    fprintf(stderr, "You choose to test NetClient_GetDevType, number is 65\n");

    int iRet = NetClient_GetDevType(g_iLogonID, &iDevType);
    if(0 == iRet)
    {
        fprintf(stderr, "GetDevType success\n");
        if(0 == iDevType)
        {
        	fprintf(stderr, "Device type is T\n");
        }
        else if(1 == iDevType)
        {
        	fprintf(stderr, "Device type is S\n");
        }
        else if(2 == iDevType)
        {
        	fprintf(stderr, "Device type is T+\n");
        }
        else
        {
            fprintf(stderr, "Device type is %d\n", iDevType);
        }
    }
    else
    {
        fprintf(stderr, "GetDevType failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_GetProductType()
{
	int iType = 0;
	fprintf(stderr, "You choose to test NetClient_GetProductType, number is 244\n");

	int iRet = NetClient_GetProductType(g_iLogonID, &iType);
	if(0 == iRet)
	{
		fprintf(stderr, "GetProductType success\n");
		iType = iType & 0xFFFF;
		if(TC_NVSS == iType)
		{
			fprintf(stderr, "Device type is TC-NVSS\n");
		}
		if(TC_NS621S == iType)
		{
			fprintf(stderr, "Device type is TC-NS621\n");
		}
		else if(TC_NS621S_USB == iType)
		{
			fprintf(stderr, "Device type is TC-NS621S-USB\n");
		}
		else if(TC_NS224S == iType)
		{
			fprintf(stderr, "Device type is TC-NS224S\n");
		}
		else if(TC_NC621S == iType)
		{
			fprintf(stderr, "Device type is TC-NC621S\n");
		}
		else if(TC_NC8000S == iType)
		{
			fprintf(stderr, "Device type is TC-NC8000S\n");
		}
		else if(TC_NC8001S == iType)
		{
			fprintf(stderr, "Device type is TC-NC8001S\n");
		}
		else if(TC_NC8100S == iType)
		{
			fprintf(stderr, "Device type is TC-NC8100S\n");
		}
		else if(TC_NC8101S == iType)
		{
			fprintf(stderr, "Device type is TC-NC8101S\n");
		}
		else if(TC_NC8200S == iType)
		{
			fprintf(stderr, "Device type is TC-NC8200S\n");
		} 
		else if(TC_NC8700S2 == iType)
		{
			fprintf(stderr, "Device type is TC-NC8200S\n");
		}
		else if(TC_NC9100S1_MP_IR == iType)
		{
			fprintf(stderr, "Device type is TC-NC9100S1-MP-IR\n");
		}
		else if(TC_NC8250 == iType)
		{
			fprintf(stderr, "Device type is TC-NC8250\n");
		}
		else if(TC_NC9010S2_MP == iType)
		{
			fprintf(stderr, "Device type is TC-NC9010S2-MP\n");
		}
		else if (TC_NC9000S2_2MP == iType)
		{
			fprintf(stderr,"Device type is TC-NC9000S2-2MP\n");//200CMOS, 20110413, @cmz@
		}
		else if (TC_NC9010N1_2MP == iType)
		{
			fprintf(stderr,"Device type is TC-NC9010N1-2MP\n");
		}
		else if (TC_NC9000S3_3MP == iType)
		{
			fprintf(stderr,"Device type is TC-NC9000S3-3MP\n");
		}
		else if (TC_NH9106N1_2MPIR == iType)
		{
			fprintf(stderr,"Device type is TC-NH9106N1-2MPIR\n");
		}
		else if (TC_NS921_N1_2MP == iType)
		{
			fprintf(stderr,"Device type is TC-NS921-N1-2MP\n");
		}
		else if (TC_NS921S3_HD_V1 == iType)
		{
			fprintf(stderr,"Device type is TC-NS921S3-HD-V1\n");
		}
		else if (TC_CC9118_MP_E == iType)
		{
			fprintf(stderr,"Device type is TC-CC9118-MP-E\n");
		}
		else if (TC_NH9206N1_MPIR_IVS == iType)
		{
			fprintf(stderr,"Device type is TC-NH9206N1-MPIR-IVS\n");
		}
		else if (TC_NC9100S3_3MP_IR30 == iType)
		{
			fprintf(stderr,"Device type is TC-NC9100S3-3MP-IR30\n");
		}
		else if (TC_NT9054S2_MPIR == iType)
		{
			fprintf(stderr,"Device type is TC-NT9054S2-MPIR\n");
		}
		else if (TC_NC9000S3_2MP_E == iType)
		{
			fprintf(stderr,"Device type is TC-NC9000S3-2MP-E\n");
		}
		else if (TC_NC9200S3_MP_E_IR15 == iType)
		{
			fprintf(stderr,"Device type is TC-NC9200S3-MP-E-IR15\n");
		}
		else if (TC_NH9206S3_2MP_IVS == iType)
		{
			fprintf(stderr,"Device type is TC-NH9206S3-2MP-IVS\n");
		}
		else if (TC_NC9000S3_MP_E == iType)
		{
			fprintf(stderr,"Device type is TC-NC9000S3-MP-E\n");
		}
		else if(TC_NS621S2 == iType)
		{
			fprintf(stderr, "Device type is TC-NS621S2\n");
		}
		else if(TC_NS622S2 == iType)
		{
			fprintf(stderr, "Device type is TC-NS622S2\n");
		}
		else if(TC_NS324S2 == iType)
		{
			fprintf(stderr, "Device type is TC-NS324S2\n");
		}
		else if(TC_NS628S2 == iType)
		{
			fprintf(stderr, "Device type is TC-NS628S2\n");
		}
		else if(TC_FS0013ERS_HD == iType)
		{
			fprintf(stderr, "Device type is TC-FS0013ERS-HD\n");
		}
		else if(TC_NC9100S3E_MP_IR30 == iType)
		{
			fprintf(stderr, "Device type is TC-NC9100S3E-MP-IR30\n");
		}
		else if(TC_NC9000S3E_MP == iType)
		{
			fprintf(stderr, "Device type is TC-NC9000S3E-MP\n");
		}
		else if(TC_NC9200S3E_MP_IR == iType)
		{
			fprintf(stderr, "Device type is TC-NC9200S3E-MP-IR\n");
		}
		else if(TC_NC9010I_2MP == iType)
		{
			fprintf(stderr, "Device type is TC-NC9010I-2MP\n");
		}
		else if (TC_NC9000I_5MP == iType)
		{
			fprintf(stderr, "Device type is TC-NC9000I-5MP\n");
		}
		else if (TC_21X_R2 == iType)
		{
			fprintf(stderr, "Device type is TC-21X-R2\n");
		}
		else if (TC_21X_R3 == iType)
		{
			fprintf(stderr, "Device type is TC-21X-R3\n");
		}
		else if (TC_21X_R5 == iType)
		{
			fprintf(stderr, "Device type is TC-21X-R5\n");
		}
		else if(TC_2816AN_SH == iType)
		{
			fprintf(stderr, "Device type is TC-2816AN-SH\n");
		}
		else if(TC_2808AN_S_3511 == iType)
		{
			fprintf(stderr, "Device type is TC-2808AN-S-3511\n");
		}
		else if (TC_2816AN_SD == iType)
		{
			fprintf(stderr, "Device type is TC-2816AN-SD\n");
		}
		else if (TC_2808AN_S_3515 == iType)
		{
			fprintf(stderr, "Device type is TC-2808AN-S-3515\n");
		}
		else if (TC_2804AN_MX == iType)
		{
			fprintf(stderr, "Device type is TC-2804AN-MX\n");
		}
		else if (TC_2816AN_S == iType)
		{
			fprintf(stderr, "Device type is TC-2816AN-S\n");
		}
		else if (TC_H802BHX_T == iType)
		{
			fprintf(stderr, "Device type is TC-H802BHX-T\n");
		} 
		else if (TC_2832AN_SS == iType)
		{
			fprintf(stderr, "Device type is TC-2832AN-SS\n");
		}
		else if (TC_H804BE_HD == iType)
		{
			fprintf(stderr, "Device type is TC-H804BE-HD\n");
		}
		else if (TC_1002S2_3C == iType)
		{
			fprintf(stderr, "Device type is TC-1002S2-3C\n");
		}
		else if (TC_H804N_HD == iType)
		{
			fprintf(stderr, "Device type is TC-H804N-HD\n");
		}
		else if (TC_2802AN_SDI == iType)
		{
			fprintf(stderr, "Device type is TC-2802AN-SDI\n");
		}
		else if (TC_H908NC_H_V50 == iType)
		{
			fprintf(stderr, "Device type is TC-H908NC-H-V50\n");
		}
		else if (TC_2800AN_SF_L_H == iType)
		{
			fprintf(stderr, "Device type is TC-2800AN-SF-L-H\n");
		}
		else if (TC_2800AN_SF_H == iType)
		{
			fprintf(stderr, "Device type is TC-2800AN-SF-H\n");
		}
		else if (TC_2804AN_SA == iType)
		{
			fprintf(stderr, "Device type is TC-2804AN-SA\n");
		}
		else if (TC_2800AN_SF_L == iType)
		{
			fprintf(stderr, "Device type is TC-2800AN-SF-L\n");
		}
		else if (TC_2800AN_SF == iType)
		{
			fprintf(stderr, "Device type is TC-2800AN-SF\n");
		}
		else if (TC_H804BE_P == iType)
		{
			fprintf(stderr, "Device type is TC-H804BE-P\n");
		}
		else if (TC_2808AN_SF_L == iType)
		{
			fprintf(stderr, "Device type is TC-2808AN-SF-L\n");
		}
		else if (TC_2804AN_SQ == iType)
		{
			fprintf(stderr, "Device type is TC-2804AN-SQ\n");
		}
		else if (TC_ND921S2_MP == iType)
		{
			fprintf(stderr, "Device type is TC-ND921S2-MP\n");
		}
		else if (TC_ND921S2_2MP == iType)
		{
			fprintf(stderr, "Device type is TC-ND921S2-2MP\n");
		}
		else if (TC_ND921S2_SDI == iType)
		{
			fprintf(stderr, "Device type is TC-ND921S2-SDI\n");
		}
		else if (TC_2804AN_SDI == iType)
		{
			fprintf(stderr, "Device type is TC-2804AN-SDI\n");
		}
		else
		{
			fprintf(stderr, "Device type is 0x%x\n", iType);
		}
	}
	else
	{
		fprintf(stderr, "GetProductType failed\n");
	}

    fprintf(stderr, "Please type a number to test corresponding interface:");
	return 0;
}

void Test_BackupKernel()
{

    fprintf(stderr,"You choose to test NetClient_BackupKernel, number is 66\n");

    int iRet = NetClient_BackupKernel(g_iLogonID);
    if(0 == iRet)
    {
        fprintf(stderr, "BackupKernel success\n");
    }
    else
    {
        fprintf(stderr, "BackupKernel failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_SetUPNPEnable()
{
    int iEnable = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_SetUPNPEnable, number is 67\n");

    fprintf(stderr,
            "UPNP enable\n"
            "0: disable\n"
            "1: enable\n"
            "Please choose a number to set:");

    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iEnable = to_int_def(cTemp, -1);


    int iRet = NetClient_SetUPNPEnable(g_iLogonID, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr,"Send string to server is failed!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

void Test_GetUPNPEnable()
{
    int iEnable = 0;
    fprintf(stderr,"You choose to test NetClient_GetUPNPEnable, number is 69\n");

    int iRet = NetClient_GetUPNPEnable(g_iLogonID, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetUPNPEnable success, enable is %d\n",iEnable);
        if(0 == iEnable)
        {
            fprintf(stderr, "UPNP is disabled\n");
        }
        else if(1 == iEnable)
        {
            fprintf(stderr, "UPNP is enabled\n");
        }
        else
        {
            fprintf(stderr, "UPNP enable is %d\n", iEnable);
        }
    }
    else
    {
        fprintf(stderr, "GetUPNPEnable failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_SetFuncListArray()
{
    int iEnableArray = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_SetFuncListArray, number is 68\n");

    fprintf(stderr, "Plsase input function list value [0-0x7FFFFFFF],each bit show one function:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iEnableArray = to_int_def(cTemp, -1);

    int iRet = NetClient_SetFuncListArray(g_iLogonID, iEnableArray);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr,"Send string to server is failed!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

void Test_GetFuncListArray()
{
    int iEnableArray = 0;
    fprintf(stderr, "You choose to test NetClient_GetFuncListArray, number is 70\n");

    int iRet = NetClient_GetFuncListArray(g_iLogonID, &iEnableArray);
    if(0 == iRet)
    {
        fprintf(stderr, "GetFuncListArray success\n");
        fprintf(stderr, "Function list is %d\n", iEnableArray);
    }
    else
    {
        fprintf(stderr, "GetFuncListArray failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_SetVencType()
{
    int iChannel = 0;
    int iType = 0;
    char cTemp[8] = {0};
    fprintf(stderr,"You choose to test NetClient_SetVencType, number is 71\n");

    fprintf(stderr,"Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
            "Decode type\n"
            "0: H264\n"
            "1: Motion JPEG\n"
            "Please choose a number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iType = to_int_def(cTemp, -1);

    int iRet = NetClient_SetVencType(g_iLogonID, iChannel, iType);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetVencType()
{
    int iChannel = 0;
    int iType = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_GetVencType, number is 72\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetVencType(g_iLogonID, iChannel, &iType);
    if(0 == iRet)
    {
        fprintf(stderr, "GetVencType success\n");
        if(0 == iType)
        {
            fprintf(stderr, "Decode Type is H264\n");
        }
        else if(1 == iType)
        {
            fprintf(stderr, "Decode Type is Motion JPEG\n");
        }
        else
        {
            fprintf(stderr, "Decode Type is %d\n", iType);
        }
    }
    else
    {
        fprintf(stderr,"GetVencType failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

int Test_SetComServer()
{
    char cComSrv[16] = {0};
    char cTemp[8] = {0};
    int iComSrvPort = 0;
    fprintf(stderr,"You choose to test NetClient_SetComServer, number is 73\n");

    fprintf(stderr, "Plsase input COM server:");
    gets_s(cComSrv, 16);
    if(0 == strcasecmp("q", cComSrv))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input COM server port:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iComSrvPort = to_int_def(cTemp, -1);


    int iRet = NetClient_SetComServer(g_iLogonID, cComSrv, iComSrvPort);
    if(0 == iRet)
    {
//      fprintf(stderr, "Send string to server is OK!\n");
        fprintf(stderr, "Send string to server is OK,the server will restart,please wait!\n");
    }
    else
    {
        fprintf(stderr, "Send string to server is failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

void Test_GetComServer()
{
    char cComSrv[256] = {0};
    int iComSrvPort = 0;
    fprintf(stderr, "You choose to test NetClient_GetComServer, number is 75\n");

    int iRet = NetClient_GetComServer(g_iLogonID, cComSrv, &iComSrvPort);
    if(0 == iRet)
    {
        fprintf(stderr, "GetComServer success\n");
        fprintf(stderr, "COM server IP is %s\n", cComSrv);
        fprintf(stderr, "COM server port is %d\n", iComSrvPort);
    }
    else
    {
        fprintf(stderr,"GetComServer failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
}

void Test_Get3GDeviceStatus()
{
    int i3GDeviceType = 0;
    int i3GStatus = 0;
    int i3GIntensity = 0;
    char c3GIP[128] = {0};
    char c3GStarttime[128] = {0};
    fprintf(stderr, "You choose to test NetClient_Get3GDeviceStatus, number is 74\n");

    int iRet = NetClient_Get3GDeviceStatus(g_iLogonID, &i3GDeviceType, &i3GStatus, &i3GIntensity, c3GIP, c3GStarttime);
    if(0 == iRet)
    {
        fprintf(stderr, "Get3GDeviceStatus success\n");
        if(0 == i3GDeviceType)
        {
            fprintf(stderr, "3G device type is DTM\n");
        }
        else if(1 == i3GDeviceType)
        {
            fprintf(stderr, "3G device type is EVDO\n");
        }
        else if(2 == i3GDeviceType)
        {
            fprintf(stderr, "3G device type is WCDMA\n");
        }
        else
        {
            fprintf(stderr, "3G device type is  %d\n", i3GDeviceType);
        }

        fprintf(stderr, "3G intensity is %d\n", i3GIntensity);

        fprintf(stderr, "3G IP is %s\n", c3GIP);

        fprintf(stderr, "3G start time is %s\n", c3GStarttime);
    }
    else
    {
        fprintf(stderr,"Get3GDeviceStatus failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
}

int Test_Set3GDialog()
{
    int iStartType = 0;
    int iStopType = 0;
    int iDuration = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_Set3GDialog, number is 76\n");

    fprintf(stderr, "Start type\n");
    fprintf(stderr,
            "0: auto dial-up\n"
            "1: SMS dial-up\n"
            "2: phone dial-up\n"
            "3: alarm dial-up\n"
            "please choose a number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStartType = to_int_def(cTemp, -1);


    fprintf(stderr, "Stop type\n");
    fprintf(stderr,
            "0: initiative\n"
            "1: passive\n"
            "please choose a number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStopType = to_int_def(cTemp, -1);

    fprintf(stderr, "Plsase input duration [2-1440] minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iDuration = to_int_def(cTemp, -1);

    int iRet = NetClient_Set3GDialog(g_iLogonID, iStartType, iStopType, iDuration);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending string to server is OK!\n");
    }
    else
    {
        fprintf(stderr,"Sending string to server is failed!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

void Test_Get3GDialog()
{
    int iStartType = 0;
    int iStopType = 0;
    int iDuration = 0;
    fprintf(stderr,"You choose to test NetClient_Get3GDialog, number is 77\n");

    int iRet = NetClient_Get3GDialog(g_iLogonID, &iStartType, &iStopType, &iDuration);
    if(0 == iRet)
    {
        fprintf(stderr, "Get3GDialog success\n");
        if(0 == iStartType)
        {
            fprintf(stderr, "Start type is auto dial-up\n");
        }
        else if(1 == iStartType)
        {
            fprintf(stderr, "Start type is SMS dial-up\n");
        }
        else if(2 == iStartType)
        {
            fprintf(stderr, "Start type is phone dial-up\n");
        }
        else if(3 == iStartType)
        {
            fprintf(stderr, "Start type is alarm dial-up\n");
        }
        else
        {
            fprintf(stderr, "Start type is %d\n", iStartType);
        }

        if(0 == iStopType)
        {
            fprintf(stderr, "Stop type is initiative\n");
        }
        else if(1 == iStopType)
        {
            fprintf(stderr, "Stop type is passive\n");
        }
        else
        {
            fprintf(stderr, "Stop type is %d\n", iStopType);
        }

        fprintf(stderr, "Duration is %d\n", iDuration);
    }
    else
    {
        fprintf(stderr,"Get3GDialog failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
}

int Test_Set3GMessage()
{
    char cNotify[256] = {0};
    char cPhone1[256] = {0};
    char cPhone2[256] = {0};
    char cPhone3[256] = {0};
    char cPhone4[256] = {0};
    char cPhone5[256] = {0};

    fprintf(stderr, "You choose to test NetClient_Set3GMessage, number is 78\n");

    fprintf(stderr, "Plsase input cNotify:");
    gets_s(cNotify, 256);
    if(0 == strcasecmp("q", cNotify))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input cPhone1:");
    gets_s(cPhone1, 256);
    if(0 == strcasecmp("q", cPhone1))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input cPhone2:");
    gets_s(cPhone2, 256);
    if(0 == strcasecmp("q", cPhone2))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input cPhone3:");
    gets_s(cPhone3, 256);
    if(0 == strcasecmp("q", cPhone3))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input cPhone4:");
    gets_s(cPhone4, 256);
    if(0 == strcasecmp("q", cPhone4))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input cPhone5:");
    gets_s(cPhone5, 256);
    if(0 == strcasecmp("q", cPhone5))
    {
        return -1;
    }

    int iRet = NetClient_Set3GMessage(g_iLogonID, cNotify, cPhone1, cPhone2, cPhone3, cPhone4, cPhone5);
    if(0 == iRet)
    {
        fprintf(stderr, "Send string to server is OK!\n");
    }
    else
    {
        fprintf(stderr,"Send string to server is failed,please check the network!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

void Test_Get3GMessage()
{
    char cNotify[256] = {0};
    char cPhone1[256] = {0};
    char cPhone2[256] = {0};
    char cPhone3[256] = {0};
    char cPhone4[256] = {0};
    char cPhone5[256] = {0};

    fprintf(stderr, "You choose to test NetClient_Get3GMessage, number is 79\n");

    int iRet = NetClient_Get3GMessage(g_iLogonID, cNotify, cPhone1, cPhone2, cPhone3, cPhone4, cPhone5);
    if(0 == iRet)
    {
        fprintf(stderr, "Get3GMessage success\n");
        fprintf(stderr,
                "Notify is %s\n"
                "Phone1 is %s\n"
                "Phone2 is %s\n"
                "Phone3 is %s\n"
                "Phone4 is %s\n"
                "Phone5 is %s\n"
                ,cNotify, cPhone1, cPhone2, cPhone3, cPhone4, cPhone5);
    }
    else
    {
        fprintf(stderr, "Get3GMessage failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_Set3GTaskSchedule()
{
    int iEnable = 0;
    int iStartHour = 0;
    int iStartMin = 0;
    int iStopHour = 0;
    int iStopMin = 0;
    char cTemp[8] = {0};

    NVS_SCHEDTIME timeSeg;
    memset(&timeSeg, 0, sizeof(timeSeg));
    fprintf(stderr, "You choose to test NetClient_Set3GTaskSchedule, number is 80\n");

    fprintf(stderr,
            "0: disenable\n"
            "1: enable\n"
            "Plsase choose a number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iEnable = to_int_def(cTemp, -1);


    fprintf(stderr,"Plsase input time StartHour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr,"Plsase input time StartMin:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr,"Plsase input time StopHour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr,"Plsase input time StopMin:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStopMin = to_int_def(cTemp, -1);

    timeSeg.iStartHour = (unsigned short)iStartHour;
    timeSeg.iStartMin = (unsigned short)iStartMin;
    timeSeg.iStopHour = (unsigned short)iStopHour;
    timeSeg.iStopMin = (unsigned short)iStopMin;

    int iRet = NetClient_Set3GTaskSchedule(g_iLogonID, iEnable, &timeSeg);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending string to server is OK!\n");
    }
    else
    {
        fprintf(stderr,"Sending string to server is failed,please check network!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

void Test_Get3GTaskSchedule()
{
    int iEnable = 0;
    NVS_SCHEDTIME timeSeg;
    memset(&timeSeg, 0, sizeof(timeSeg));
    fprintf(stderr, "You choose to test NetClient_Get3GTaskSchedule, number is 82\n");

    int iRet = NetClient_Get3GTaskSchedule(g_iLogonID, &iEnable, &timeSeg);
    if(0 == iRet)
    {
        if(0 == iEnable)
        {
            fprintf(stderr, "Get3GTaskSchedule success, Disable\n");
        }
        else if(1 == iEnable)
        {
            fprintf(stderr, "Get3GTaskSchedule success, Enbale\n");
        }
        else
        {
            fprintf(stderr, "Get3GTaskSchedule success, enable is %d\n", iEnable);
        }

        fprintf(stderr, "Start time is %02d:%02d, stop time is %02d:%02d\n",
                timeSeg.iStartHour, timeSeg.iStartMin, timeSeg.iStopHour, timeSeg.iStopMin);

    }
    else
    {
        fprintf(stderr,"Get3GTaskSchedule failed\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
}

int Test_Set3GNotify()
{
    int iType = 0;
    char cTemp[8] = {0};
    char cMessage[2048] = {0};

    fprintf(stderr,"You choose to test NetClient_Set3GNotify, number is 81\n");

    fprintf(stderr,
            "0: do not notify\n"
            "1: notify after success\n"
            "2: notify after failure\n"
            "Please choose a number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iType = to_int_def(cTemp, -1);


    fprintf(stderr, "Please input notify message:");
    gets_s(cMessage, 2048);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }

    int iRet = NetClient_Set3GNotify(g_iLogonID, iType, cMessage);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending string to server is OK!\n");
    }
    else
    {
        fprintf(stderr,"Sending string to server is failed,please check network!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

void Test_Get3GNotify()
{
    int iType = 0;
    char cMessage[2048] = {0};

    fprintf(stderr,"You choose to test NetClient_Get3GNotify, number is 83\n");


    int iRet = NetClient_Get3GNotify(g_iLogonID, &iType, cMessage);
    if(0 == iRet)
    {
        if(0 == iType)
        {
            fprintf(stderr, "Get3GNotify success, no notify\n");
        }
        else if(1 == iType)
        {
            fprintf(stderr, "Get3GNotify success, notify after success\n");
        }
        else if(2 == iType)
        {
            fprintf(stderr, "Get3GNotify success, notify after failure\n");
        }
        else
        {
            fprintf(stderr, "Get3GNotify success, Type is %d\n", iType);
        }

        fprintf(stderr, "Get3GNotify success, notify message is %s\n", cMessage);
    }
    else
    {
        fprintf(stderr, "Get3GNotify failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_SetHDCamer()
{
    int iChannel = 0;
    int iFuncNum = 0;
    int iValue = 0;
    int iRet = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetHDCamer, number is 84\n");

    fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
            "Function code:\n"
            "0: auto aperture\n"
            "1: electron aperture\n"
            "2: width dynamic\n"
            "3: apheliotropic\n"
            "Please choose a number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iFuncNum = to_int_def(cTemp, -1);

    if(0 == iFuncNum)
    {
        fprintf(stderr,
            "0: disenable auto aperture\n"
            "1: enable auto aperture\n"
            "Please choose a number:");
    }
    else if(1 == iFuncNum)
    {
        fprintf(stderr, "please input electron aperture value:");
    }
    else if(2 == iFuncNum)
    {
        fprintf(stderr,
            "0: disenable width dynamic\n"
            "1: enable width dynamic\n"
            "Please choose a number:");
    }
    else if(3 == iFuncNum)
    {
        fprintf(stderr,
            "0: disenable apheliotropic\n"
            "1: enable apheliotropic\n"
            "Please choose a number:");
    }
    else
    {
        fprintf(stderr, "FuncNum is %d that out of range\n", iFuncNum);
        fprintf(stderr,"Please type a number to test corresponding interface:");
        return 0;
    }

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iValue = to_int_def(cTemp, -1);

    iRet = NetClient_SetHDCamer(g_iLogonID, iChannel, iFuncNum, iValue);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending string to server is OK!\n");
    }
    else
    {
        fprintf(stderr,"Sending string to server is failed,please check the network!\n");
    }

    fprintf(stderr,"Please type a number to test corresponding interface:");
    return 0;
}

int Test_GetHDCamer()
{
    int iChannel = 0;
    int iFuncNum = 0;
    int iValue = 0;
    int iRet = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetHDCamer, number is 85\n");

    fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
            "Function code:\n"
            "0: auto aperture\n"
            "1: electron aperture\n"
            "2: width dynamic\n"
            "3: apheliotropic\n"
            "Please choose a number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iFuncNum = to_int_def(cTemp, -1);

    iRet = NetClient_GetHDCamer(g_iLogonID, iChannel, iFuncNum, &iValue);

    if(0 == iRet)
    {
        if(0 == iFuncNum)
        {
            if(0 == iValue)
            {
                fprintf(stderr, "GetHDCamer success,do not support auto aperture\n");
            }
            else if(1 == iValue)
            {
                fprintf(stderr, "GetHDCamer success,support auto aperture\n");
            }
            else
            {
                fprintf(stderr, "value is %d\n", iValue);
            }
        }
        else if(1 == iFuncNum)
        {
            fprintf(stderr, "GetHDCamer success,electron aperture value is %d\n", iValue);
        }
        else if(2 == iFuncNum)
        {
            if(0 == iValue)
            {
                fprintf(stderr, "GetHDCamer success,do not support width dynamic\n");
            }
            else if(1 == iValue)
            {
                fprintf(stderr, "GetHDCamer success,support width dynamic\n");
            }
            else
            {
                fprintf(stderr, "value is %d\n", iValue);
            }
        }
        else if(3 == iFuncNum)
        {
            if(0 == iValue)
            {
                fprintf(stderr, "GetHDCamer success,do not support apheliotropic\n");
            }
            else if(1 == iValue)
            {
                fprintf(stderr, "GetHDCamer success,support apheliotropic\n");
            }
            else
            {
                fprintf(stderr, "value is %d\n", iValue);
            }
        }
        else
        {
            fprintf(stderr, "FuncNum is %d that out of range\n", iFuncNum);
        }
    }
    else
    {
        fprintf(stderr, "GetHDCamer failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");

    return 0;
}

int Test_SetAlarmServer()
{
    char cAlarmServer[16] = {0};
    char cTemp[8] = {0};
    int iServerPort = 0;

    fprintf(stderr, "You choose to test NetClient_SetAlarmServer, number is 86\n");

    fprintf(stderr, "Please input alarm server ip:");
    gets_s(cAlarmServer, 16);
    if(0 == strcasecmp("q", cAlarmServer))
    {
        return -1;
    }

    fprintf(stderr, "Please input server port:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iServerPort = to_int_def(cTemp, -1);

    int iRet = NetClient_SetAlarmServer(g_iLogonID, cAlarmServer, iServerPort);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending string to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending string to server is failed,please check the network!\n");
        fprintf(stderr,"Please type a number to test corresponding interface:");
    }

    return 0;
}

void Test_GetAlarmServer()
{
    char cAlarmServer[16] = {0};
    int iSeverPort = 0;

    fprintf(stderr,"You choose to test NetClient_GetAlarmServer, number is 87\n");

    int iRet = NetClient_GetAlarmServer(g_iLogonID, cAlarmServer, &iSeverPort);
    if(0 == iRet)
    {
        fprintf(stderr, "GetAlarmServer success,alarm server is %s,server port is %d!\n",cAlarmServer,iSeverPort);
    }
    else
    {
        fprintf(stderr, "GetAlarmServer failed!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

void Test_GetUpgradePercent()
{
    fprintf(stderr, "You choose to test NetClient_GetUpgradePercent, number is 88\n");

    int iUpgradePercent = NetClient_GetUpgradePercent(g_iLogonID);

    fprintf(stderr, "UpgradePercent is %d\n", iUpgradePercent);

    fprintf(stderr, "Please type a number to test corresponding interface:");
}

int Test_UpgradeWebPage()
{
    char cFileName[256] = {0};

    fprintf(stderr, "You choose to test NetClient_UpgradeWebPage, number is 89\n");

    fprintf(stderr, "please input upgrade web file name:");
    gets_s(cFileName, 256);
    if(0 == strcasecmp("q", cFileName))
    {
        return -1;
    }

    int iRet = NetClient_UpgradeWebPage(g_iLogonID, cFileName, Proupgrade_Notify);
    signal(SIGALRM,signal_fn);
    alarm(1);
    if(0 == iRet)
    {
        fprintf(stderr, "UpgradeWebPage return 0\n");
    }
    else
    {
        fprintf(stderr, "UpgradeWebPage failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

int Test_UpgradeProgram()
{
    char cFileName[256] = {0};

    fprintf(stderr, "You choose to test NetClient_UpgradeProgram, number is 90\n");

    fprintf(stderr, "please input upgrade file name:");
    gets_s(cFileName, 256);
    if(0 == strcasecmp("q", cFileName))
    {
        return -1;
    }

    int iRet = NetClient_UpgradeProgram(g_iLogonID, cFileName, Proupgrade_Notify);
    signal(SIGALRM,signal_fn);
    alarm(1);
    if(0 == iRet)
    {
        fprintf(stderr, "UpgradeProgram return 0\n");
    }
    else
    {
        fprintf(stderr, "UpgradeProgram failed\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:");
    return 0;
}

//---------------------------------------------------------------------------------------------

int Test_AddUser()
{
    char cUserName[256] = {0};
	char cPassword[256] = {0};
	int iAuthtype = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_AddUser, number is 208\n");

    fprintf(stderr, "please input user name:");
    gets_s(cUserName, 256);
    if(0 == strcasecmp("q", cUserName))
    {
        return -1;
    }

	fprintf(stderr, "please input user password:");
    gets_s(cPassword, 256);
    if(0 == strcasecmp("q", cPassword))
    {
        return -1;
    }

	fprintf(stderr, "Please set user authority rank[1-4]:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iAuthtype = to_int_def(cTemp, 0);

    int iRet = NetClient_AddUser(g_iLogonID, cUserName, cPassword, iAuthtype);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_DelUser()
{
    char cUserName[256] = {0};

    fprintf(stderr, "You choose to test NetClient_DelUser, number is 91\n");

    fprintf(stderr, "please input user name:");
    gets_s(cUserName, 256);
    if(0 == strcasecmp("q", cUserName))
    {
        return -1;
    }

    int iRet = NetClient_DelUser(g_iLogonID, cUserName);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_ModifyPwd()
{
    char cUserName[256] = {0};
    char cNewPwd[256] = {0};

    fprintf(stderr, "You choose to test NetClient_ModifyPwd, number is 92\n");

    fprintf(stderr, "please input user name:");
    gets_s(cUserName, 256);
    if(0 == strcasecmp("q", cUserName))
    {
        return -1;
    }

    fprintf(stderr, "please input new password:");
    gets_s(cNewPwd, 256);
    if(0 == strcasecmp("q", cNewPwd))
    {
        return -1;
    }

    int iRet = NetClient_ModifyPwd(g_iLogonID, cUserName, cNewPwd);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetMaxConUser()
{
    int iMaxConUser = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetMaxConUser, number is 93\n");

    fprintf(stderr, "please input max connect user number to be set:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iMaxConUser = to_int_def(cTemp, -1);

    int iRet = NetClient_SetMaxConUser(g_iLogonID, iMaxConUser);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetMaxGetUser()
{
    int iMaxConUser = 0;

    fprintf(stderr, "You choose to test NetClient_GetMaxGetUser, number is 209\n");

    int iRet = NetClient_GetMaxGetUser(g_iLogonID, &iMaxConUser);
    if(0 == iRet)
    {
        fprintf(stderr, "GetMaxGetUser is OK!\n");
		fprintf(stderr, "The max connect user number is %d\n", iMaxConUser);
    }
    else
    {
        fprintf(stderr, "GetMaxGetUser is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;

}

int Test_SetStreamType()
{
    int iChannel = 0;
    int iStreamType = 0;
    int iStreamNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetStreamType, number is 94\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream encode type\n"
        "0: NO_STREAM\n"
        "1: ONLY_VIDEO\n"
        "2: ONLY_AUDIO\n"
        "3: VIDEO_AUDIO\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamType = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    int iRet = NetClient_SetStreamType(g_iLogonID, iChannel, iStreamType, iStreamNum);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetStreamType()
{
    int iChannel = 0;
    int iStreamType = 0;
    int iStreamNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetStreamType, number is 164\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);


    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetStreamType(g_iLogonID, iChannel, &iStreamType, iStreamNum);
    if(0 == iRet)
    {
        fprintf(stderr, "GetStreamType is OK!\n");
		if(1 == iStreamType)
		{
			fprintf(stderr, "Stream type is ONLY_VIDEO!\n");
		}
		else if(2 == iStreamType)
		{
			fprintf(stderr, "Stream type is ONLY_AUDIO!\n");
		}
		else if(3 == iStreamType)
		{
			fprintf(stderr, "Stream type is VIDEO_AUDIO!\n");
		}
		else
		{
			fprintf(stderr, "Stream type is NO_STREAM!\n");
		}
    }
    else
    {
        fprintf(stderr, "GetStreamType is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetDeviceType()
{
    int iChannel = 0;
    int iComNum = 0;
    int iDevAddress = 0;
	int iProtocolType = 0;
    char cProtocol[256] = {0};
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetDeviceType, number is 95\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Plsase input COM number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iComNum = to_int_def(cTemp, -1);

    fprintf(stderr, "Plsase input device address[0-255]:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iDevAddress = to_int_def(cTemp, -1);

    fprintf(stderr, 
			"protocol name:\n"
			"1: DOME_TIANDY\n"
			"2: DOME_PELCO_D\n"
			"3: DOME_PELCO_P\n"
			"4: PTZ_PELCO_D\n"
			"5: PTZ_PELCO_P\n"
			"6: PTZ_TC615_P\n"
			"Please select a number to set:");

	iProtocolType = SafeGetInt();
	switch (iProtocolType)
	{
		case 1:
			strcpy(cProtocol, "DOME_TIANDY");
			break;
		case 2:
			strcpy(cProtocol, "DOME_PELCO_D");
			break;
		case 3:
			strcpy(cProtocol, "DOME_PELCO_P");
			break;
		case 4:
			strcpy(cProtocol, "PTZ_PELCO_D");
			break;
		case 5:
			strcpy(cProtocol, "PTZ_PELCO_P");
			break;
		case 6:
			strcpy(cProtocol, "PTZ_TC615_P");
			break;
		default:
			strcpy(cProtocol, "DOME_TIANDY");
			break;
	}

    int iRet = NetClient_SetDeviceType(g_iLogonID, iChannel, iComNum, iDevAddress, cProtocol);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetDeviceType()
{
    int iChannel = 0;
    int iComNum = 0;
    int iDevAddress = 0;
    char cProtocol[256] = {0};
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetDeviceType, number is 193\n");

    fprintf(stderr, "Plsase input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetDeviceType(g_iLogonID, iChannel, &iComNum, &iDevAddress, cProtocol);
    if(0 == iRet)
    {
        fprintf(stderr, "GetDeviceType is OK!\n");
		fprintf(stderr, "COM number is %d\n", iComNum);
		fprintf(stderr, "Device address is %d\n", iDevAddress);
		fprintf(stderr, "Protocol name is %s\n", cProtocol);
    }
    else
    {
        fprintf(stderr, "GetDeviceType is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetComFormat()
{
    int iComNum = 0;
    int iWorkMode = 0;
	int iProtocolType = 0;
	//int iFormatType = 0;
	int iType = 0;
    char cProtocol[256] = {0};
    char cComFormat[256] = {0};
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetComFormat,number is 96\n");

    fprintf(stderr, "Plsase input COM number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iComNum = to_int_def(cTemp, -1);

    fprintf(stderr, 
			"protocol name:\n"
			"1: DOME_TIANDY\n"
			"2: DOME_PELCO_D\n"
			"3: DOME_PELCO_P\n"
			"4: PTZ_PELCO_D\n"
			"5: PTZ_PELCO_P\n"
			"6: PTZ_TC615_P\n"
			"Please select a number to set:");

	iProtocolType = SafeGetInt();
	switch (iProtocolType)
	{
		case 1:
			strcpy(cProtocol, "DOME_TIANDY");
			break;
		case 2:
			strcpy(cProtocol, "DOME_PELCO_D");
			break;
		case 3:
			strcpy(cProtocol, "DOME_PELCO_P");
			break;
		case 4:
			strcpy(cProtocol, "PTZ_PELCO_D");
			break;
		case 5:
			strcpy(cProtocol, "PTZ_PELCO_P");
			break;
		case 6:
			strcpy(cProtocol, "PTZ_TC615_P");
			break;
		default:
			strcpy(cProtocol, "DOME_TIANDY");
			break;
	}

/*
    fprintf(stderr, 
			"COM format:\n"
			"1: [2400,n,8,1]\n"
			"2: [9600,n,8,1]\n"
			"Please select a number to set:");
	iFormatType = SafeGetInt();
	if(1 == iFormatType)
	{
		strcpy(cComFormat, "2400,n,8,1");
	}
	else
	{
		strcpy(cComFormat, "9600,n,8,1");
	}
*/
	fprintf(stderr, 
			"Please input the com format(e.g. 9600,n,8,1):");
	gets_s(cComFormat, 256);

	NetClient_GetProductType(g_iLogonID, &iType);
    iType = iType & 0xFFFF;
//  if(PRODUCT_MODEL_3511_DVR_8 == iType || PRODUCT_MODEL_3511_DVR_16 == iType || PRODUCT_MODEL_3520_DVR_16 == iType)
//  if(TC_2808AN_S_3511 == iType || TC_2816AN_SH == iType || TC_2816AN_SD == iType)
//  {
	
		fprintf(stderr,
			"COM Work mode\n"
			"1: Protocol\n"
			"2: Transparence channel\n"
			"3: Industry reserve\n"
			"4: 7601B\n"
			"5: 485KeyBoard\n"
			"6: GPS\n"
			"7: ATM\n"
			"Please choose a number to be set:");
	
		memset(cTemp, 0, sizeof(cTemp));
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		iWorkMode = to_int_def(cTemp, -1);
//  }
//  else
//  {
//  	iWorkMode = 2;
//  }

    int iRet = NetClient_SetComFormat(g_iLogonID, iComNum, cProtocol, cComFormat, iWorkMode);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetComFormat()
{
    int iComNum = 0;
    int iWorkMode = 0;
    char cComFormat[256] = {0};
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetComFormat, number is 194\n");

    fprintf(stderr, "Plsase input COM number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iComNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetComFormat(g_iLogonID, iComNum, cComFormat, &iWorkMode);
    if(0 == iRet)
    {
        fprintf(stderr, "GetComFormat is OK!\n");
		fprintf(stderr, "COM format is %s\n", cComFormat);
		if(1 == iWorkMode)
		{
			fprintf(stderr, "COM Work mode is protocol\n");
		}
		else if(2 == iWorkMode)
		{
			fprintf(stderr, "COM Work mode is transparence channel\n");
		}
		else if (3 == iWorkMode) {
			fprintf(stderr, "COM Work mode is Industry reserve\n");
		}
		else if (4 == iWorkMode) {
			fprintf(stderr, "COM Work mode is 7601B\n");
		}
		else if (5 == iWorkMode) {
			fprintf(stderr, "COM Work mode is 485KeyBoard\n");
		}
		else if (6 == iWorkMode) {
			fprintf(stderr, "COM Work mode is GPS\n");
		}
		else if (7 == iWorkMode) {
			fprintf(stderr, "COM Work mode is ATM\n");
		}
		else
		{
			fprintf(stderr, "COM Work mode is %d\n", iWorkMode);
		}
    }
    else
    {
        fprintf(stderr, "GetComFormat is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_DevicePTZCtrl()
{
    int iComNum = 0;
    int iProtocolType = 0;
    int iAction = 0;
    int iSpeed = 0;
	int iDeviceAddress = 0;
	int iPresetNum = 0;
    char cTemp[8] = {0};
    int iRet = 0;

    fprintf(stderr, "You choose to test NetClient_DevicePTZCtrl, number is 97\n");

    fprintf(stderr,
            "DOME_TIANDY: 150\n"
            "DOME_PELCO_D: 151\n"
            "DOME_PELCO_P: 152\n"
            "Plsase set protocol type:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iProtocolType = to_int_def(cTemp, 0);


    fprintf(stderr, "Plsase input COM number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iComNum = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input device address:");
	memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iDeviceAddress = to_int_def(cTemp, -1);


    fprintf(stderr, "Plsase input speed[0-100]:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iSpeed = to_int_def(cTemp, -1);
    
    fprintf(stderr, 
            "up: 1\n"
            "down: 3\n"
            "left: 5\n"
            "right: 7\n"
            "up left: 9\n"
            "up right: 11\n"
            "down left: 13\n"
            "down right: 15\n"
            "stop: 61\n"
			"zoom in: 31\n"
			"zoom in stop: 32\n"
			"zoom out: 33\n"
			"zoom out stop: 34\n"
			"focus far: 35\n"
			"focus far stop: 36\n"
			"focus near: 37\n"
			"focus near stop: 38\n"
			"iris open: 39\n"
			"iris open stop: 40\n"
			"iris close: 41\n"
			"iris close stop: 42\n"
            "light on: 43\n"
            "light off: 44\n"
            "power on: 45\n"
            "power off: 46\n"
            "rain on: 47\n"
            "rain off: 48\n"
			"call preset: 62\n"
			"set preset: 63\n"
            "Plsase input action:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iAction = to_int_def(cTemp, -1);

	if(62 == iAction || 63 == iAction)
	{
		fprintf(stderr, "please input preset number:");
		iPresetNum = SafeGetInt();
	}

    iRet = NetClient_DevicePTZCtrl(g_iLogonID, iProtocolType, iAction, iComNum, iDeviceAddress, iSpeed, iPresetNum);
    if(0 == iRet)
    {
        fprintf(stderr, "DevicePTZCtrl is OK!\n");
    }
    else
    {
        fprintf(stderr, "DevicePTZCtrl is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetPreferMode()
{
    int iChannel = 0;
    int iStreamNum = 0;
    int iMode = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetPreferMode, number is 98\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Mode\n"
        "0: image quality first\n"
        "1: Frame rate first\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iMode = to_int_def(cTemp, -1);

    int iRet = NetClient_SetPreferMode(g_iLogonID, iChannel, iStreamNum, iMode);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetPreferMode()
{
    int iChannel = 0;
    int iStreamNum = 0;
    int iMode = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetPreferMode, number is 224\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetPreferMode(g_iLogonID, iChannel, iStreamNum, &iMode);
    if(0 == iRet)
    {
        fprintf(stderr, "GetPreferMode is OK!\n");
		if(0 == iMode)
		{
			fprintf(stderr, "Image quality first!\n");
		}
		else if(1 == iMode)
		{
			fprintf(stderr, "Frame rate first!\n");
		}
    }
    else
    {
        fprintf(stderr, "GetPreferMode is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetEncodeMode()
{
    int iChannel = 0;
    int iStreamNum = 0;
    int iMode = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetEncodeMode, number is 99\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Encode mode\n"
        "0: CBR\n"
        "1: VBR\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iMode = to_int_def(cTemp, -1);

    int iRet = NetClient_SetEncodeMode(g_iLogonID, iChannel, iStreamNum, iMode);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetEncodeMode()
{
    int iChannel = 0;
    int iStreamNum = 0;
    int iMode = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetEncodeMode, number is 223\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetEncodeMode(g_iLogonID, iChannel, iStreamNum, &iMode);
    if(0 == iRet)
    {
        fprintf(stderr, "GetEncodeMode is OK!\n");
		if(0 == iMode)
		{
			fprintf(stderr, "Encode mode is CBR!\n");
		}
		else if(1 == iMode)
		{
			fprintf(stderr, "Encode mode is VBR!\n");
		}
    }
    else
    {
        fprintf(stderr, "GetEncodeMode is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetMaxKByteRate()
{
    int iChannel = 0;
    int iStreamNum = 0;
    int iBitRate = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetMaxKByteRate, number is 100\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input bit rate 64-8192:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iBitRate = to_int_def(cTemp, -1);
	iBitRate = iBitRate/8;


    int iRet = NetClient_SetMaxKByteRate(g_iLogonID, iChannel, iBitRate, iStreamNum);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetMaxKByteRate()
{
    int iChannel = 0;
    int iStreamNum = 0;
    int iBitRate = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetMaxKByteRate, number is 218\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetMaxKByteRate(g_iLogonID, iChannel, &iBitRate, iStreamNum);
    if(0 == iRet)
    {
        fprintf(stderr, "GetMaxKByteRate is OK!\n");
		fprintf(stderr, "Max bit rate is %d Kbps\n", iBitRate*8);
    }
    else
    {
        fprintf(stderr, "GetMaxKByteRate is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetDomainParsePara()
{
    int iInterval = 0;
    char cUserID[256] = {0};
    char cPassword[256] = {0};
    char cHost[256] = {0};
    char cDomain1[256] = {0};
    char cDomain2[256] = {0};
    int iPort1 = 0;
    int iPort2 = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetDomainParsePara, number is 101\n");

    fprintf(stderr, "Please input domain register interval:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iInterval = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input domain register account:");
    gets_s(cUserID, 256);
    if(0 == strcasecmp("q", cUserID))
    {
        return -1;
    }

    fprintf(stderr, "Please input domain register password:");
    gets_s(cPassword, 256);
    if(0 == strcasecmp("q", cPassword))
    {
        return -1;
    }

    fprintf(stderr, "Please input domain register host name:");
    gets_s(cHost, 256);
    if(0 == strcasecmp("q", cHost))
    {
        return -1;
    }

    fprintf(stderr, "Please input domain register center IP:");
    gets_s(cDomain1, 256);
    if(0 == strcasecmp("q", cDomain1))
    {
        return -1;
    }

    fprintf(stderr, "Please input domain register center IP for backup:");
    gets_s(cDomain2, 256);
    if(0 == strcasecmp("q", cDomain2))
    {
        return -1;
    }

    fprintf(stderr, "Please input domain register center port:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iPort1 = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input domain register center port for backup:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iPort2 = to_int_def(cTemp, -1);

    int iRet = NetClient_SetDomainParsePara(g_iLogonID,
                                            iInterval,
                                            cUserID,
                                            cPassword,
                                            cHost,
                                            cDomain1,
                                            cDomain2,
                                            iPort1,
                                            iPort2);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetDomainParsePara()
{
    int iInterval = 0;
    char cUserID[256] = {0};
    char cPassword[256] = {0};
    char cHost[256] = {0};
    char cDomain1[256] = {0};
    char cDomain2[256] = {0};
    int iPort1 = 0;
    int iPort2 = 0;


    fprintf(stderr, "You choose to test NetClient_GetDomainParsePara, number is 219\n");

    int iRet = NetClient_GetDomainParsePara(g_iLogonID,
                                            &iInterval,
                                            cUserID,
                                            cPassword,
                                            cHost,
                                            cDomain1,
                                            cDomain2,
                                            &iPort1,
                                            &iPort2);
    if(0 == iRet)
    {
        fprintf(stderr, "GetDomainParsePara is OK!\n");
		fprintf(stderr, "Register interval is %d\n", iInterval);
		fprintf(stderr, "Register account is %s\n", cUserID);
		fprintf(stderr, "Register password is %s\n", cPassword);
		fprintf(stderr, "Register host name is %s\n", cHost);
		fprintf(stderr, "Register center IP is %s\n", cDomain1);
		fprintf(stderr, "Register center IP for backup is %s\n", cDomain2);
		fprintf(stderr, "Register center port is %d\n", iPort1);
		fprintf(stderr, "Register center port for backup is %d\n", iPort2);
    }
    else
    {
        fprintf(stderr, "GetDomainParsePara is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetVideoSize()
{
    int iChannel = 0;
    int iStreamNum = 0;
    int iVideoSize = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetVideoSize, number is 102\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set video size\n"
        "0: QCIF\n"
        "1: HCIF\n"
        "2: FCIF\n"
		"3: HD1(720*288)\n"
        "4: FD1\n"
		"5: MD1(720*288)\n"
        "6: QVGA\n"
        "7: VGA\n"
        "8: HVGA\n"
        "9: 720P\n"
        "10:960P\n"
        "11:UXGA(1600*1200)\n"
        "12:1080P\n"
		"13:HD_QXGA\n"
		"256:QHD(960*540)\n"
		"512:960H(960*576)\n"
		"768:VZ_5MA(2448*2048)\n"
		"1024:VZ_5M(2560*1920)\n"
		"1280:VZ_QSXGA(2560*2048)\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iVideoSize = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    int iRet = NetClient_SetVideoSize(g_iLogonID, iChannel, iVideoSize, iStreamNum);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
 
        int iProductType = 0;
        NetClient_GetProductType(g_iLogonID, &iProductType);
        iProductType = iProductType&0xFFFF;
    
        if(IsDVR(iProductType) || IsS3(iProductType))
        {
           fprintf(stderr, "SetVideoSize OK\n");
        }
        else
        {
            fprintf(stderr, "SetVideoSize OK, reboot now...\n");
            NetClient_Reboot(g_iLogonID);
        }
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetVideoSize()
{
    int iChannel = 0;
    int iStreamNum = 0;
    int iWidth = 0;
	int iHeight = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetVideoSize, number is 216\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);


    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetVideoSize(g_iLogonID, iChannel, &iWidth, &iHeight, iStreamNum);
    if(0 == iRet)
    {
        fprintf(stderr, "GetVideoSize is OK!\n");
		fprintf(stderr, "Video width is %d\n", iWidth);
		fprintf(stderr, "Video height is %d\n", iHeight);
    }
    else
    {
        fprintf(stderr, "GetVideoSize is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetVideoSizeEx()
{
	int iChannel = 0;
    int iStreamNum = 0;
    int iVideoSize = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetVideoSizeEx, number is 217\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

	int iRet = NetClient_GetVideoSizeEx(g_iLogonID, iChannel, &iVideoSize, iStreamNum);
	if(0 == iRet)
    {
        fprintf(stderr, "GetVideoSizeEx is OK!\n");
		if(0 == iVideoSize)
		{
			fprintf(stderr, "Video size is QCIF!\n");
		}
		else if(1 == iVideoSize)
		{
			fprintf(stderr, "Video size is HCIF!\n");
		}
		else if(2 == iVideoSize)
		{
			fprintf(stderr, "Video size is FCIF!\n");
		}
		else if(3 == iVideoSize)
		{
			fprintf(stderr, "Video size is HD1!\n");
		}
		else if(4 == iVideoSize)
		{
			fprintf(stderr, "Video size is FD1!\n");
		}
		else if(6 == iVideoSize)
		{
			fprintf(stderr, "Video size is QVGA!\n");
		}
		else if(7 == iVideoSize)
		{
			fprintf(stderr, "Video size is VGA!\n");
		}
		else if(8 == iVideoSize)
		{
			fprintf(stderr, "Video size is HVGA!\n");
		}
		else if(9 == iVideoSize)
		{
			fprintf(stderr, "Video size is HD_720P!\n");
		}
        else if (10 == iVideoSize)
        {
            fprintf(stderr, "Video size is 960P!\n");
        }
        else if (11 == iVideoSize)
		{
			fprintf(stderr, "Video size is 200W(1600*1200)!\n");
		}
        else if (12 == iVideoSize)
        {
            fprintf(stderr, "Video size is 1080P!\n");
        }
		else if (13 == iVideoSize) 
		{
			fprintf(stderr, "Video size is HD_QXGA!\n");
		}
		else if (0x100 == iVideoSize) 
		{
			fprintf(stderr, "Video size is QHD(960*540)!\n");
		}
		else if (0x200 == iVideoSize) 
		{
			fprintf(stderr, "Video size is 960H(960*576)!\n");
		}
		else if (0x300 == iVideoSize) 
		{
			fprintf(stderr, "Video size is VZ_5MA(2448*2048)!\n");
		}
		else if (0x400 == iVideoSize) 
		{
			fprintf(stderr, "Video size is VZ_5M(2560*1920)!\n");
		}
		else if (0x500 == iVideoSize) 
		{
			fprintf(stderr, "Video size is VZ_QSXGA(2560*2048)!\n");
		}
        else 
        {
            fprintf(stderr, "---------------Video size is %d----------------\n", iVideoSize);
        }
    }
    else
    {
        fprintf(stderr, "GetVideoSizeEx is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetVideoNPMode()
{
    VIDEO_NORM vMode;
    int iMode = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetVideoNPMode, number is 103\n");

    fprintf(stderr,
            "Video mode:\n"
            "0: PAL\n"
            "1: NTSC\n"
            "Please choose a number to be set:");

    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iMode = to_int_def(cTemp, -1);

    if(0 == iMode)
    {
        vMode = VIDEO_MODE_PAL;
    }
    else if(1 == iMode)
    {
        vMode = VIDEO_MODE_NTSC;
    }

    int iRet = NetClient_SetVideoNPMode(g_iLogonID, vMode);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
        int iProductType = 0;
        NetClient_GetProductType(g_iLogonID, &iProductType);

        iProductType = iProductType&0xFFFF;  
        if (iProductType != TC_1002S2_3C)
        {  
            fprintf(stderr, "SetVideoNPMode OK, reboot now...\n");
            NetClient_Reboot(g_iLogonID);
        }
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetVideoNPMode()
{
    VIDEO_NORM vMode;

    fprintf(stderr, "You choose to test NetClient_GetVideoNPMode, number is 226\n");

    int iRet = NetClient_GetVideoNPMode(g_iLogonID, &vMode);
    if(0 == iRet)
    {
        fprintf(stderr, "GetVideoNPMode is OK!\n");
		if(0 == vMode)
		{
			fprintf(stderr, "Video NP mode is VIDEO_MODE_PAL\n");
		}
		else if(1 == vMode)
		{
			fprintf(stderr, "Video NP mode is VIDEO_MODE_NTSC\n");
		}
		else
		{
			fprintf(stderr, "Video NP mode is VIDEO_MODE_AUTO\n");
		}
    }
    else
    {
        fprintf(stderr, "GetVideoNPMode is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetOsdText()
{
    int iChannel = 0;
    char cText[256] = {0};
    //int iTextColor = 0;
    char cTemp[256] = {0};

    fprintf(stderr, "You choose to test NetClient_SetOsdText, number is 104\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input text you want to osd:");
	gets_s(cText, 256);
	if(0 == strcasecmp("q", cText))
	{
	    return -1;
	}

	char outBuf[256] = {0};
	u2g(cText, strlen(cText)+1, outBuf, 256);   // תgb2312Աwindows²Ϊ

    int iOSDColor;
	fprintf(stderr, "Please input OSD color:");

	fprintf(stderr, "Please input Color(0-black, 32768-green, 8421504-gray, 255-red, 65280-lime"
		", 65535-yellow, 16711680-blue, 16777215-white:\n");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	iOSDColor = to_int_def(cTemp, 0x00ffffff);

    int iRet = NetClient_SetOsdText(g_iLogonID, iChannel, (unsigned char*)outBuf, iOSDColor);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetOsdText()
{
    int iChannel = 0;
    char cText[256] = {0};
    unsigned long ulTextColor = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetOsdText, number is 173\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetOsdText(g_iLogonID, iChannel, (unsigned char*)cText, &ulTextColor);
	int iColor = (int)ulTextColor;


	char outBuf[256] = {0};
	g2u(cText, strlen(cText)+1, outBuf, 256);   //תutf-8Աlinux²Ϊ

    if(0 == iRet)
    {
        fprintf(stderr, "GetOsdText is OK!\n");
		fprintf(stderr, "Osd text is %s, text color is %d\n", outBuf, iColor);
    }
    else
    {
        fprintf(stderr, "GetOsdText is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetOsdType()
{
    int iChannel = 0;
    int iXpos = 0;
    int iYpos = 0;
    int iOsdType = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetOsdType, number is 105\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input osd X position:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iXpos = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input osd Y position:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iYpos = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set osd type\n"
        "1: OSDTYPE_TIME\n"
        "2: OSDTYPE_TITLE\n"
        "5: OSDTYPE_ITS\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iOsdType = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set osd state\n"
        "0: off\n"
        "1: on\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iEnable = to_int_def(cTemp, -1);

    int iRet = NetClient_SetOsdType(g_iLogonID, iChannel, iXpos, iYpos, iOsdType, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetOsdType()
{
    int iChannel = 0;
    int iXpos = 0;
    int iYpos = 0;
    int iOsdType = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetOsdType, number is 174\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Select osd type you want to get:\n"
        "1: OSDTYPE_TIME\n"
        "2: OSDTYPE_TITLE\n"
        "4: OSDTYPE_LOGO\n"
        "5: OSDTYPE_ITS\n"
        "Please choose a number to set:");

    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iOsdType = to_int_def(cTemp, -1);

    int iRet = NetClient_GetOsdType(g_iLogonID, iChannel, iOsdType, &iXpos, &iYpos, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetOsdType is OK!\n");
		fprintf(stderr, "Osd x position is %d\n", iXpos);
		fprintf(stderr, "Osd y position is %d\n", iYpos);
        fprintf(stderr, "Osd state is %d\n", iEnable);		
    }
    else
    {
        fprintf(stderr, "GetOsdType is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetOsdLOGO()
{
	int iChannel = 0;
	char cTemp[8] = {0};
	char cLogoFile[64] = {0};

	fprintf(stderr, "You choose to test NetClient_SetOsdLOGO, number is 61\n");

	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input logo file name:");
	gets_s(cLogoFile, 64);
	if(0 == strcasecmp("q", cLogoFile))
	{
	    return -1;
	}

	int iRet = NetClient_SetOsdLOGO(g_iLogonID, iChannel, (unsigned char*)cLogoFile, 0x00FFFFFF);
	if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;

}

int Test_SetDateFormat()
{
    int iFormat = 0;
    int iSeparator = 0;
    char cSeparator = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetDateFormat, number is 106\n");

    fprintf(stderr,
        "Set date format\n"
        "0: yyyy/mm/dd \n"
        "1: mm/dd/yyyy \n"
        "2: dd/mm/yyyy \n"
        "3: M.day yyyy \n"
        "4: day M.yyyy \n"
        "Please choose a number to be set:");

	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iFormat = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set date separator\n"
        "0: / \n"
        "1: - \n"
        "2: . \n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iSeparator = to_int_def(cTemp, -1);

    if(0 == iSeparator)
    {
        cSeparator = '/';
    }
    else if(1 == iSeparator)
    {
        cSeparator = '-';
    }
    else
    {
        cSeparator = '.';
    }


    int iRet = NetClient_SetDateFormat(g_iLogonID, iFormat, cSeparator);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetDateFormat()
{
    int iFormat = 0;
    char cSeparator = 0;

    fprintf(stderr, "You choose to test NetClient_GetDateFormat, number is 175\n");

    int iRet = NetClient_GetDateFormat(g_iLogonID, &iFormat, &cSeparator);
    if(0 == iRet)
    {
        fprintf(stderr, "GetDateFormat is OK!\n");
		if(0 == iFormat)
		{
			fprintf(stderr, "Date format is yyyy/mm/dd\n");
		}
		else if(1 == iFormat)
		{
			fprintf(stderr, "Date format is mm/dd/yyyy\n");
		}
		else if(2 == iFormat)
		{
			fprintf(stderr, "Date format is dd/mm/yyyy\n");
		}
		else if(3 == iFormat)
		{
			fprintf(stderr, "Date format is M.day yyyy\n");
		}
		else if(4 == iFormat)
		{
			fprintf(stderr, "Date format is day M.yyyy\n");
		}

		fprintf(stderr, "Separator is %c\n", cSeparator);
    }
    else
    {
        fprintf(stderr, "GetDateFormat failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetVideoCovArea()
{
    int iChannel = 0;
    int iStreamNum = 0;
    char cTemp[8] = {0};
    RECT rect[4];
    for (int i=0;i<4;i++)
    {
        rect[i].left   = 0;
        rect[i].top    = 0;
        rect[i].right  = 0;
        rect[i].bottom = 0;
    }

    fprintf(stderr, "You choose to test NetClient_SetVideoCovArea, number is 107\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    for(int j=0; j<4; j++)
    {

        fprintf(stderr, "Please input video cover rectangle %d coordinate left:", j);
        memset(cTemp, 0, sizeof(cTemp));
        gets_s(cTemp, 8);
        if(0 == strcasecmp("q", cTemp))
        {
            return -1;
        }
        rect[j].left = to_int_def(cTemp, -1);

        fprintf(stderr, "Please input video cover rectangle %d coordinate top:", j);
        memset(cTemp, 0, sizeof(cTemp));
        gets_s(cTemp, 8);
        if(0 == strcasecmp("q", cTemp))
        {
            return -1;
        }
        rect[j].top = to_int_def(cTemp, -1);

        fprintf(stderr, "Please input video cover rectangle %d coordinate right:", j);
        memset(cTemp, 0, sizeof(cTemp));
        gets_s(cTemp, 8);
        if(0 == strcasecmp("q", cTemp))
        {
            return -1;
        }
        rect[j].right = to_int_def(cTemp, -1);

        fprintf(stderr, "Please input video cover rectangle %d coordinate bottom:", j);
        memset(cTemp, 0, sizeof(cTemp));
        gets_s(cTemp, 8);
        if(0 == strcasecmp("q", cTemp))
        {
            return -1;
        }
        rect[j].bottom = to_int_def(cTemp, -1);
    }

    int iRet = NetClient_SetVideoCovArea(g_iLogonID, iChannel, rect, iStreamNum);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetVideoCovArea()
{
    int iChannel = 0;
    int iStreamNum = 0;
    char cTemp[8] = {0};
    RECT coverArea[4];
    for(int i=0;i<4;i++)
    {
        coverArea[i].left=0;
        coverArea[i].top=0;
        coverArea[i].right=0;
        coverArea[i].bottom=0;
    }

    fprintf(stderr, "You choose to test NetClient_GetVideoCovArea, number is 215\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetVideoCovArea(g_iLogonID, iChannel, coverArea, iStreamNum);
    if(0 == iRet)
    {
        fprintf(stderr, "GetVideoCovArea is OK!\n");
        for(int j=0; j<4; j++)
        {
            fprintf(stderr, "Video cover rectangle %d coordinate left is %d\n", j, coverArea[j].left);
            fprintf(stderr, "Video cover rectangle %d coordinate top is %d\n", j, coverArea[j].top);
            fprintf(stderr, "Video cover rectangle %d coordinate right is %d\n", j, coverArea[j].right);
            fprintf(stderr, "Video cover rectangle %d coordinate bottom is %d\n", j, coverArea[j].bottom);
        }
    }
    else
    {
        fprintf(stderr, "GetVideoCovArea is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetThreshold()
{
    int iChannel = 0;
    int iThreshold = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetThreshold, number is 108\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input video move alarm sensitivity[0-255]:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iThreshold = to_int_def(cTemp, -1);

	if(iThreshold < 0 || iThreshold > 255)
	{
		fprintf(stderr, "Wrong input\n");
		return 0;
	}

    int iRet = NetClient_SetThreshold(g_iLogonID, iChannel, iThreshold);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetThreshold()
{
    int iChannel = 0;
    int iThreshold = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetThreshold, number is 167\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);


    int iRet = NetClient_GetThreshold(g_iLogonID, iChannel, &iThreshold);
    if(0 == iRet)
    {
        fprintf(stderr, "GetThreshold is OK!\n");
		fprintf(stderr, "video move alarm sensitivity is %d\n", iThreshold);
    }
    else
    {
        fprintf(stderr, "GetThreshold is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetMotionDetection()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetMotionDetection, number is 109\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set motion detect state\n"
        "0: off\n"
        "1: on\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iEnable = to_int_def(cTemp, -1);

    int iRet = NetClient_SetMotionDetection(g_iLogonID, iChannel, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetMotionDetection()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetMotionDetection, number is 168\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);


    int iRet = NetClient_GetMotionDetection(g_iLogonID, iChannel, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetMotionDetection is OK!\n");
		if(0 == iEnable)
		{
			fprintf(stderr, "Motion detect state is disabled\n");
		}
		else if(1 == iEnable)
		{
			fprintf(stderr, "Motion detect state is enabled\n");
		}
    }
    else
    {
        fprintf(stderr, "GetMotionDetection is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetMotionAreaEnable()
{
    int iChannel = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetMotionAreaEnable, number is 110\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_SetMotionAreaEnable(g_iLogonID, iChannel);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetMotionDecLinkOutport()
{
    int iChannel = 0;
    int iOutportArray = 0;
    char cTemp[64] = {0};

    fprintf(stderr, "You choose to test NetClient_SetMotionDecLinkOutport, number is 111\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input outport bit:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iOutportArray = (int)to_uint_def(cTemp, -1);

    int iRet = NetClient_SetMotionDecLinkOutport(g_iLogonID, iChannel, iOutportArray);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetMotionDecLinkOutport()
{
    int iChannel = 0;
    int iOutportArray = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetMotionDecLinkOutport, number is 171\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetMotionDecLinkOutport(g_iLogonID, iChannel, &iOutportArray);
    if(0 == iRet)
    {
        fprintf(stderr, "GetMotionDecLinkOutport is OK!\n");
		fprintf(stderr, "Motion detect link outport bit is %u (0x%08X)\n", (unsigned int)iOutportArray, (unsigned int)iOutportArray);
    }
    else
    {
        fprintf(stderr, "GetMotionDecLinkOutport is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetMotionDetectSchedule()
{
    int iChannel = 0;
    int iWeekday = 0;
    char cTemp[8] = {0};
    NVS_SCHEDTIME timeSeg[4];

    memset(timeSeg,0,sizeof(timeSeg));


    PNVS_SCHEDTIME schedule[] = {&timeSeg[0],&timeSeg[1],&timeSeg[2],&timeSeg[3]};

    fprintf(stderr, "You choose to test NetClient_SetMotionDetectSchedule, number is 112\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set week day\n"
        "0: Sunday\n"
        "1: Monday\n"
        "2: Tuesday\n"
        "3: Wednesday\n"
        "4: Thursday\n"
        "5: Friday\n"
        "6: Saturday\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iWeekday = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[0].iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[0].iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[0].iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[0].iStopMin = to_int_def(cTemp, -1);
    fprintf(stderr, "Choose time1 state:0 disable, 1 enable:");
    timeSeg[0].iRecordMode = SafeGetInt();

    //-----------------
    fprintf(stderr, "Please input time2 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[1].iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[1].iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[1].iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[1].iStopMin = to_int_def(cTemp, -1);
    fprintf(stderr, "Choose time2 state:0 disable, 1 enable:");
    timeSeg[1].iRecordMode = SafeGetInt();

    //-----------------
    fprintf(stderr, "Please input time3 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[2].iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[2].iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[2].iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[2].iStopMin = to_int_def(cTemp, -1);
    fprintf(stderr, "Choose time3 state:0 disable, 1 enable:");
    timeSeg[2].iRecordMode = SafeGetInt();

    //-----------------
    fprintf(stderr, "Please input time4 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[3].iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[3].iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[3].iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg[3].iStopMin = to_int_def(cTemp, -1);
    fprintf(stderr, "Choose time4 state:0 disable, 1 enable:");
    timeSeg[3].iRecordMode = SafeGetInt();

    //-----------------
	for(int i = 0; i < 4; i++)
	{
		int iStart = timeSeg[i].iStartHour*60 + timeSeg[i].iStartMin;
		int iEnd   =  timeSeg[i].iStopHour*60 + timeSeg[i].iStopMin;
		if(iStart > iEnd)
		{
			fprintf(stderr, "timeSeg[%d], Start > End,Return -1\n");
            return -1;
		}
		
	}

    int iRet = NetClient_SetMotionDetectSchedule(g_iLogonID, iChannel, iWeekday, schedule);

    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetMotionDetectSchedule()
{
    int iChannel = 0;
    int iWeekday = 0;
    char cTemp[8] = {0};
    NVS_SCHEDTIME timeSeg[MAX_TIMESEGMENT];

	for(int i=0; i<MAX_TIMESEGMENT; i++)
	{
		memset(&timeSeg[i], 0, sizeof(NVS_SCHEDTIME));
	}

    PNVS_SCHEDTIME schedule[] = {&timeSeg[0], &timeSeg[1], &timeSeg[2], &timeSeg[3]};


    fprintf(stderr, "You choose to test NetClient_GetMotionDetectSchedule, number is 172\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set week day\n"
        "0: Sunday\n"
        "1: Monday\n"
        "2: Tuesday\n"
        "3: Wednesday\n"
        "4: Thursday\n"
        "5: Friday\n"
        "6: Saturday\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iWeekday = to_int_def(cTemp, -1);

	int iRet = NetClient_GetMotionDetectSchedule(g_iLogonID, iChannel, iWeekday, schedule);
    if(0 == iRet)
    {
        fprintf(stderr, "GetMotionDetectSchedule is OK!\n");
		for(int i=0; i<MAX_TIMESEGMENT; i++)
		{
			fprintf(stderr, "Time section %d start time is %d:%d, stop time is %d:%d, enable is %d\n", i+1,
					timeSeg[i].iStartHour, timeSeg[i].iStartMin, timeSeg[i].iStopHour, timeSeg[i].iStopMin,  timeSeg[i].iRecordMode);
		}
    }
    else
    {
        fprintf(stderr, "GetMotionDetectSchedule is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetMotionDecLinkSoundDisplay()
{
	int iChannel = 0;
	int iSoundEnable = 0;
	int iDisplayEnable = 0;
	char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_SetMotionDecLinkSoundDisplay, number is 220\n");

	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, 
			"Please set sound enable:\n"
			"0:disabled\n"
			"1:enabled\n"
			"select a number:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iSoundEnable = to_int_def(cTemp, -1);

	fprintf(stderr,
			"Please set display enable:\n"
			"0:disabled\n"
			"1:enabled\n"
			"select a number:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iDisplayEnable = to_int_def(cTemp, -1);

	int iRet = NetClient_SetMotionDecLinkSoundDisplay(g_iLogonID, iChannel, iSoundEnable, iDisplayEnable);
	if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

	fprintf(stderr, "Please type interface to test:");
    return 0;
}
                                                                           
int Test_GetMotionDecLinkSoundDisplay()
{
	int iChannel = 0;
	int iSoundEnable = 0;
	int iDisplayEnable = 0;
	char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_GetMotionDecLinkSoundDisplay, number is 238\n");

	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

	int iRet = NetClient_GetMotionDecLinkSoundDisplay(g_iLogonID, iChannel, &iSoundEnable, &iDisplayEnable);
	if(0 == iRet)
    {
		fprintf(stderr, "GetMotionDecLinkSoundDisplay OK!\n");
		if(0 == iSoundEnable)
		{
			fprintf(stderr, "Sound is disabled\n");
		}
		else
		{
			fprintf(stderr, "Sound is enabled\n");
		}

		if(0 == iDisplayEnable)
		{
			fprintf(stderr, "Display is disabled\n");
		}
		else
		{
			fprintf(stderr, "Display is enabled\n");
		}
    }
    else
    {
        fprintf(stderr, "GetMotionDecLinkSoundDisplay failed!\n");
    }

	fprintf(stderr, "Please type interface to test:");
    return 0;
}

//ӦЭϣȥ˽ӿ
//int Test_SetAlarmPortEnable()
//{
//    int iInport = 0;
//    int iEnable = 0;
//    char cTemp[8] = {0};
//
//    fprintf(stderr, "You choose to test NetClient_SetAlarmPortEnable, number is 113\n");
//
//    fprintf(stderr, "Please input channel alarm in port:");
//	gets_s(cTemp, 8);
//	if(0 == strcasecmp("q", cTemp))
//	{
//	    return -1;
//	}
//	iInport = to_int_def(cTemp, -1);
//
//    fprintf(stderr,
//        "Set alarm port state\n"
//        "0: disabled\n"
//        "1: enabled\n"
//        "Please choose a number to be set:");
//    memset(cTemp, 0, sizeof(cTemp));
//	gets_s(cTemp, 8);
//	if(0 == strcasecmp("q", cTemp))
//	{
//	    return -1;
//	}
//	iEnable = to_int_def(cTemp, -1);
//
//    int iRet = NetClient_SetAlarmPortEnable(g_iLogonID, iInport, iEnable);
//    if(0 == iRet)
//    {
//        fprintf(stderr, "Sending command to server is OK!\n");
//    }
//    else
//    {
//        fprintf(stderr, "Sending command to server is failed!\n");
//    }
//
//    fprintf(stderr, "Please type interface to test:");
//    return 0;
//}
//
//int Test_GetAlarmPortEnable()
//{
//    int iInport = 0;
//    int iEnable = 0;
//    char cTemp[8] = {0};
//
//    fprintf(stderr, "You choose to test NetClient_GetAlarmPortEnable, number is 179\n");
//
//    fprintf(stderr, "Please input channel alarm in port:");
//	gets_s(cTemp, 8);
//	if(0 == strcasecmp("q", cTemp))
//	{
//	    return -1;
//	}
//	iInport = to_int_def(cTemp, -1);
//
//    int iRet = NetClient_GetAlarmPortEnable(g_iLogonID, iInport, &iEnable);
//    if(0 == iRet)
//    {
//        fprintf(stderr, "GetAlarmPortEnable is OK!\n");
//		if(0 == iEnable)
//		{
//			fprintf(stderr, "Alarm port state is disabled!\n");
//		}
//		else if(1 == iEnable)
//		{
//			fprintf(stderr, "Alarm port state is enabled!\n");
//		}
//    }
//    else
//    {
//        fprintf(stderr, "GetAlarmPortEnable is failed!\n");
//    }
//
//    fprintf(stderr, "Please type interface to test:");
//    return 0;
//}

int Test_SetInportAlarmLinkRec()
{
    int iInport = 0;
    int iEnable = 0;
    char cTemp[64] = {0};

    fprintf(stderr, "You choose to test NetClient_SetInportAlarmLinkRec, number is 114\n");

    fprintf(stderr, "Please input channel alarm port:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iInport = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input bit:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iEnable = (int)to_uint_def(cTemp, 0);

    int iRet = NetClient_SetInportAlarmLinkRec(g_iLogonID, iInport, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetInportAlarmLinkRec()
{
    int iInport = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetInportAlarmLinkRec, number is 180\n");

    fprintf(stderr, "Please input channel alarm port:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iInport = to_int_def(cTemp, -1);


    int iRet = NetClient_GetInportAlarmLinkRec(g_iLogonID, iInport, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetInportAlarmLinkRec is OK!\n");
        fprintf(stderr, "Link channel bit is %u (0x%08X)\n", (unsigned int)iEnable, (unsigned int)iEnable);
    }
    else
    {
        fprintf(stderr, "GetInportAlarmLinkRec is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileQuery()
{
	char cTemp[256] = {0};

	fprintf(stderr, "You choose to test NetClient_NetFileQuery, number is 115\n");

    NVS_FILE_QUERY fileQuery;
    memset(&fileQuery, 0, sizeof(fileQuery)); 

	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	fileQuery.iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set file type:\n"
        "0: All\n"
        "1: AVstream\n"
        "2: picture\n"
        "Please choose a number to be set:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	fileQuery.iFiletype = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input page number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	fileQuery.iPageNo = to_int_def(cTemp, -1);

//  fprintf(stderr, "Please input page size:");
//  memset(cTemp, 0, sizeof(cTemp));
//  gets_s(cTemp, 8);
//  if(0 == strcasecmp("q", cTemp))
//  {
//      return -1;
//  }
	fileQuery.iPageSize = 20;

    fprintf(stderr, "Please input start time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	unsigned short iYear = 0;   
    unsigned short iMonth = 0;  
    unsigned short iDay = 0;    
    unsigned short iHour = 0;   
    unsigned short iMinute = 0; 
    unsigned short iSecond = 0;

	
	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		   &iYear,
		   &iMonth,
		   &iDay,
		   &iHour,
		   &iMinute,
		   &iSecond);

	fileQuery.struStartTime.iYear = iYear;
	fileQuery.struStartTime.iMonth = iMonth;
	fileQuery.struStartTime.iDay = iDay;
	fileQuery.struStartTime.iHour = iHour;
	fileQuery.struStartTime.iMinute = iMinute;
	fileQuery.struStartTime.iSecond = iSecond;
	

    fprintf(stderr, "Please input stop time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	iYear = 0;   
    iMonth = 0;  
    iDay = 0;    
    iHour = 0;   
    iMinute = 0; 
    iSecond = 0;

	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		   &iYear,
		   &iMonth,
		   &iDay,
		   &iHour,
		   &iMinute,
		   &iSecond);

	fileQuery.struStopTime.iYear = iYear;
	fileQuery.struStopTime.iMonth = iMonth;
	fileQuery.struStopTime.iDay = iDay;
	fileQuery.struStopTime.iHour = iHour;
	fileQuery.struStopTime.iMinute = iMinute;
	fileQuery.struStopTime.iSecond = iSecond;


	fprintf(stderr,
        "Set record type:\n"
        "255: All\n"
        "1: Manual record\n"
        "2: Schedule record\n"
        "3: Alarm record\n"
        "Please choose a number to be set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	fileQuery.iType = to_int_def(cTemp, -1);


    int iRet = NetClient_NetFileQuery(g_iLogonID, &fileQuery);
    if(0 == iRet)
    {
        fprintf(stderr, "Send command successful!\n");
    }
    else
    {
        fprintf(stderr, "Send command is failed!\n");
    }

    return 0;
}

int Test_NetFileSetTaskSchedule()
{
    int iChannel = 0;
    int iWeekday = 0;
    char cTemp[8] = {0};
    NVS_SCHEDTIME timeSeg1,timeSeg2,timeSeg3,timeSeg4;

    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    PNVS_SCHEDTIME schedule[] = {&timeSeg1,&timeSeg2,&timeSeg3,&timeSeg4};


    fprintf(stderr, "You choose to test NetClient_NetFileSetTaskSchedule, number is 116\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set week day\n"
        "0: Sunday\n"
        "1: Monday\n"
        "2: Tuesday\n"
        "3: Wednesday\n"
        "4: Thursday\n"
        "5: Friday\n"
        "6: Saturday\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iWeekday = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input time1 Enbale bit(0:time 1:port 2:motion 3:video lost):");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iRecordMode = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input time2 Enbale bit(0:time 1:port 2:motion 3:video lost):");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	timeSeg2.iRecordMode = to_int_def(cTemp, -1);


    fprintf(stderr, "Please input time3 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input time3 Enbale bit(0:time 1:port 2:motion 3:video lost):");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	timeSeg3.iRecordMode = to_int_def(cTemp, -1);


    fprintf(stderr, "Please input time4 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input time4 Enbale bit(0:time 1:port 2:motion 3:video lost):");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	timeSeg4.iRecordMode = to_int_def(cTemp, -1);


    int iRet = NetClient_NetFileSetTaskSchedule(g_iLogonID, iChannel, iWeekday, schedule);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileGetTaskSchedule()
{
    int iChannel = 0;
    int iWeekday = 0;
    char cTemp[8] = {0};
    NVS_SCHEDTIME timeSeg[MAX_TIMESEGMENT];

	for(int i=0; i<MAX_TIMESEGMENT; i++)
	{
		memset(&timeSeg[i], 0, sizeof(NVS_SCHEDTIME));
	}

    PNVS_SCHEDTIME schedule[] = {&timeSeg[0], &timeSeg[1], &timeSeg[2], &timeSeg[3]};


    fprintf(stderr, "You choose to test NetClient_NetFileGetTaskSchedule, number is 232\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set week day\n"
        "0: Sunday\n"
        "1: Monday\n"
        "2: Tuesday\n"
        "3: Wednesday\n"
        "4: Thursday\n"
        "5: Friday\n"
        "6: Saturday\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iWeekday = to_int_def(cTemp, -1);

	int iRet = NetClient_NetFileGetTaskSchedule(g_iLogonID, iChannel, iWeekday, schedule);
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileGetTaskSchedule is OK!\n");
		for(int i=0; i<MAX_TIMESEGMENT; i++)
		{
			fprintf(stderr, "Time section %d start time is %d:%d, stop time is %d:%d, Enbale bit(%d)\n", i+1,
					timeSeg[i].iStartHour, timeSeg[i].iStartMin, timeSeg[i].iStopHour, timeSeg[i].iStopMin, timeSeg[i].iRecordMode);
		}
    }
    else
    {
        fprintf(stderr, "NetFileGetTaskSchedule is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileSetRecordRule()
{
    int iRule = 0;
    int iTimeLen = 0;
    int iFreeDisk = 0;
    int iFileSize = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_NetFileSetRecordRule, number is 117\n");

    fprintf(stderr,
        "Set record rule \n"
        "0: Stop record  \n"
        "1: delete circularly \n"
        "2: delete circularly without deleting alarm record \n"
        "Please choose a number to be set:");

    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iRule = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input Record file package time length[minute]:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iTimeLen = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input minimum free disk[MB]:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iFreeDisk = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input size of recording package[MB]:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iFileSize = to_int_def(cTemp, -1);

    int iRet = NetClient_NetFileSetRecordRule(g_iLogonID, iRule, iTimeLen, iFreeDisk, iFileSize);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileGetRecordRule()
{
    int iRule = 0;
    int iTimeLen = 0;
    int iFreeDisk = 0;
    int iFileSize = 0;

    fprintf(stderr, "You choose to test NetClient_NetFileGetRecordRule, number is 228\n");

    int iRet = NetClient_NetFileGetRecordRule(g_iLogonID, &iRule, &iTimeLen, &iFreeDisk, &iFileSize);
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileGetRecordRule is OK!\n");
		if(0 == iRule)
		{
			fprintf(stderr, "Net file record rule is stop record\n");
		}
		else if(1 == iRule)
		{
			fprintf(stderr, "Net file record rule is delete circularly\n");
		}
		else if(2 == iRule)
		{
			fprintf(stderr, "Net file record rule is delete circularly without deleting alarm record\n");
		}

		fprintf(stderr, "Record file package time length is %d minute\n", iTimeLen);
		fprintf(stderr, "Minimum free disk is %d MB\n", iFreeDisk);
		fprintf(stderr, "Size of recording package is %d MB\n", iFileSize);
    }
    else
    {
        fprintf(stderr, "NetFileGetRecordRule is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileSetAlarmRule()
{
    int iPreRecordEnable = 0;
    int iPreRecordTime = 0;
    int iDelayTime = 0;
    int iDelayEnable = 1;
    int iChannel = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_NetFileSetAlarmRule, number is 118\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set preview Record  state\n"
        "0: Disabled\n"
        "1: Enabled\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPreRecordEnable = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input Pre-record time[nvs:5-15s, dvr:5-60s]:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPreRecordTime = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input Alarm record delay [nvs:10-60s dvr:10-600s]:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iDelayTime = to_int_def(cTemp, -1);


    int iRet = NetClient_NetFileSetAlarmRule(g_iLogonID, iPreRecordEnable, iPreRecordTime, iDelayTime, iDelayEnable, iChannel);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileGetAlarmRule()
{
    int iPreRecordEnable = 0;
    int iPreRecordTime = 0;
    int iDelayTime = 0;
    int iDelayEnable = 0;
    int iChannel = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_NetFileGetAlarmRule, number is 229\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_NetFileGetAlarmRule(g_iLogonID, &iPreRecordEnable, &iPreRecordTime, &iDelayTime, &iDelayEnable, iChannel);
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileGetAlarmRule is OK!\n");
		if(0 == iPreRecordEnable)
		{
			fprintf(stderr, "Preview record state is disabled\n");
		}
		else if(1 == iPreRecordEnable)
		{
			fprintf(stderr, "Preview record state is enabled\n");
		}

		fprintf(stderr, "Pre-record time is %d seconds\n", iPreRecordTime);
		fprintf(stderr, "Alarm record delay is %d seconds\n", iDelayTime);
    }
    else
    {
        fprintf(stderr, "NetFileGetAlarmRule is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_DiskSetUsage()
{
    int iDiskNo = 0;
    int iUsage = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_DiskSetUsage, number is 119\n");

    fprintf(stderr,
        "Disk number\n"
        "0-7: SATA\n"
        "8-11: USB\n"
		"12: NFS\n"
    	"32: ESATA\n"
        "Please choose a disk number to set:");

    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iDiskNo = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set usage\n"
        "0: Record\n"
        "1: Backup\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iUsage = to_int_def(cTemp, -1);

    int iRet = NetClient_DiskSetUsage(g_iLogonID, iDiskNo, iUsage);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileMapStoreDevice()
{
    NVS_NFS_DEV nfsDev;
    memset(&nfsDev, 0, sizeof(NVS_NFS_DEV));

    fprintf(stderr, "You choose to test NetClient_NetFileMapStoreDevice, number is 120\n");

    fprintf(stderr, "Please input device IP:");
    gets_s(nfsDev.cDeviceIP, 16);
    if(0 == strcasecmp("q", nfsDev.cDeviceIP))
	{
	    return -1;
	}

    fprintf(stderr, "Please input store path:");
    gets_s(nfsDev.cStorePath, 250);
    if(0 == strcasecmp("q", nfsDev.cStorePath))
	{
	    return -1;
	}

    int iRet = NetClient_NetFileMapStoreDevice(g_iLogonID, &nfsDev);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileGetMapStoreDevice()
{
    NVS_NFS_DEV nfsDev;
    memset(&nfsDev, 0, sizeof(NVS_NFS_DEV));

    fprintf(stderr, "You choose to test NetClient_NetFileGetMapStoreDevice, number is 239\n");

    int iRet = NetClient_NetFileGetMapStoreDevice(g_iLogonID, &nfsDev);
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileGetMapStoreDevice is OK!\n");
		fprintf(stderr, "Device IP is %s\n", nfsDev.cDeviceIP);
		fprintf(stderr, "Store path is %s\n", nfsDev.cStorePath);
    }
    else
    {
        fprintf(stderr, "NetFileGetMapStoreDevice is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetTime()
{
    int iyy = 0;
    int imo = 0;
    int idd = 0;
    int ihh = 0;
    int imi = 0;
    int iss = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetTime, number is 121\n");

    fprintf(stderr, "Please input year:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iyy = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input month:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	imo = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input day:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	idd = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input hour:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	ihh = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input minimum:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	imi = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input second:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iss = to_int_def(cTemp, -1);

    int iRet = NetClient_SetTime(g_iLogonID, iyy, imo, idd, ihh, imi, iss);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_Reboot()
{
    fprintf(stderr, "You choose to test NetClient_Reboot, number is 122\n");

    int iRet = NetClient_Reboot(g_iLogonID);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_DefaultPara()
{
    fprintf(stderr, "You choose to test NetClient_DefaultPara,number is 123\n");

    int iRet = NetClient_DefaultPara(g_iLogonID);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetHTTPPort()
{
    int iPort = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetHTTPPort, number is 124\n");

    fprintf(stderr, "Please input http port:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPort = to_int_def(cTemp, -1);

    int iRet = NetClient_SetHTTPPort(g_iLogonID, iPort);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetHTTPPort()
{
    int iPort = 0;

    fprintf(stderr, "You choose to test NetClient_GetHTTPPort, number is 204\n");


    int iRet = NetClient_GetHTTPPort(g_iLogonID, &iPort);
    if(0 == iRet)
    {
        fprintf(stderr, "GetHTTPPort is OK!\n");
		fprintf(stderr, "Http port is %d\n", iPort);
    }
    else
    {
        fprintf(stderr, "GetHTTPPort is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetSysInfo()
{
    fprintf(stderr, "You choose to test NetClient_GetSysInfo, number is 125\n");

    int iRet = NetClient_GetSysInfo(g_iLogonID);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_LogFileClear()
{
    fprintf(stderr, "You choose to test NetClient_LogFileClear, number is 126\n");

    int iRet = NetClient_LogFileClear(g_iLogonID);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_LogFileDownload()
{
    fprintf(stderr, "You choose to test NetClient_LogFileDownload, number is 127\n");

    int iRet = NetClient_LogFileDownload(g_iLogonID);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_ChangeSvrIP()
{
    char cNewSvrIP[16] = {0};
    char cMask[16] = {0};
    char cGateway[16] = {0};
    char cDNS[16] = {0};

    fprintf(stderr, "You choose to test NetClient_ChangeSvrIP, number is 128\n");

    fprintf(stderr, "Please input new server ip:");
    gets_s(cNewSvrIP, 16);
    if(0 == strcasecmp("q", cNewSvrIP))
    {
        return -1;
    }

    fprintf(stderr, "Please input mask:");
    gets_s(cMask, 16);
    if(0 == strcasecmp("q", cMask))
    {
        return -1;
    }

    fprintf(stderr, "Please input gateway:");
    gets_s(cGateway, 16);
    if(0 == strcasecmp("q", cGateway))
    {
        return -1;
    }

    fprintf(stderr, "Please input DNS:");
    gets_s(cDNS, 16);
    if(0 == strcasecmp("q", cDNS))
    {
        return -1;
    }

    int iRet = NetClient_ChangeSvrIP(g_iLogonID, cNewSvrIP, cMask, cGateway, cDNS);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
		if (0 == NetClient_Reboot(g_iLogonID)) 
		{
			fprintf(stderr, "ChangeSvrIP is OK!\n");
		}
		else
		{
			fprintf(stderr, "ChangeSvrIP failed, Reboot failed!!\n");
		}
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetDHCPParam()
{
    int iDHCP = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetDHCPParam, number is 129\n");

    fprintf(stderr,
        "Set DHCP state\n"
        "0: Disabled\n"
        "1: Enabled\n"
        "Please choose a number to be set:");

	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iDHCP = to_int_def(cTemp, -1);

    int iRet = NetClient_SetDHCPParam(g_iLogonID, iDHCP);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetDHCPParam()
{
    int iDHCP = 0;

    fprintf(stderr, "You choose to test NetClient_GetDHCPParam, number is 214\n");

    int iRet = NetClient_GetDHCPParam(g_iLogonID, &iDHCP);
    if(0 == iRet)
    {
        fprintf(stderr, "GetDHCPParam is OK!\n");
		if(0 == iDHCP)
		{
			fprintf(stderr, "DHCP state is disabled!\n");
		}
		else if(1 == iDHCP)
		{
			fprintf(stderr, "DHCP state is enabled!\n");
		}
    }
    else
    {
        fprintf(stderr, "GetDHCPParam is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetIpFilter()
{
    char cFilterIP[16] = {0};
    char cMask[16] = {0};

    fprintf(stderr, "You choose to test NetClient_SetIpFilter, number is 130\n");

    fprintf(stderr, "Please input filter IP:");
    gets_s(cFilterIP, 16);
    if(0 == strcasecmp("q", cFilterIP))
	{
	    return -1;
	}

    fprintf(stderr, "Please input filter mask:");
    gets_s(cMask, 16);
    if(0 == strcasecmp("q", cMask))
	{
	    return -1;
	}

    int iRet = NetClient_SetIpFilter(g_iLogonID, cFilterIP, cMask);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetInportAlarmLinkSnap()
{
    int iPortNum = 0;
    int iEnable = 0;
    char cTemp[64] = {0};

    fprintf(stderr, "You choose to test NetClient_SetInportAlarmLinkSnap, number is 131\n");
	fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input bit:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iEnable = (int)to_uint_def(cTemp, 0);

    int iRet = NetClient_SetInportAlarmLinkSnap(g_iLogonID, iPortNum, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetInportAlarmLinkSnap()
{
    int iPortNum = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetInportAlarmLinkSnap, number is 181\n");
	fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetInportAlarmLinkSnap(g_iLogonID, iPortNum, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetInportAlarmLinkSnap is OK!\n");
		fprintf(stderr, "Inport Alarm link snap bit is %u (0x%08X)\n", (unsigned int)iEnable, (unsigned int)iEnable);
    }
    else
    {
        fprintf(stderr, "GetInportAlarmLinkSnap is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetInportAlarmLinkSoundDisplay()
{
    int iSoundEnable = 0;
    int iDisplayEnable = 0;
    int iPortNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetInportAlarmLinkSoundDisplay, number is 132\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set alarm link sound off or on\n"
        "0: off\n"
        "1: on\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iSoundEnable = to_int_def(cTemp, -1);


    fprintf(stderr,
        "Set alarm link display off or on\n"
        "0: off\n"
        "1: on\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iDisplayEnable = to_int_def(cTemp, -1);

    int iRet = NetClient_SetInportAlarmLinkSoundDisplay(g_iLogonID, iPortNum, iSoundEnable, iDisplayEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetInportAlarmLinkSoundDisplay()
{
    int iSoundEnable = 0;
    int iDisplayEnable = 0;
    int iPortNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetInportAlarmLinkSoundDisplay, number is 184\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetInportAlarmLinkSoundDisplay(g_iLogonID, iPortNum, &iSoundEnable, &iDisplayEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetInportAlarmLinkSoundDisplay is OK!\n");
		if(0 == iSoundEnable)
        {
            fprintf(stderr, "Alarm link sound is off\n");
        }
        else if(1 == iSoundEnable)
        {
            fprintf(stderr, "Alarm link sound is on\n");
        }

        if(0 == iDisplayEnable)
        {
            fprintf(stderr, "Alarm link display is off\n");
        }
        else if(1 == iDisplayEnable)
        {
            fprintf(stderr, "Alarm link display is on\n");
        }
    }
    else
    {
        fprintf(stderr, "GetInportAlarmLinkSoundDisplay is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetInportAlmLinkOutport()
{
    int iOutportArray = 0;
    int iPortNum = 0;
    char cTemp[64] = {0};

    fprintf(stderr, "You choose to test NetClient_SetInportAlmLinkOutport, number is 133\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input outport bit:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iOutportArray = (int)to_uint_def(cTemp, 0);

    int iRet = NetClient_SetInportAlmLinkOutport(g_iLogonID, iPortNum, iOutportArray);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetInportAlmLinkOutport()
{
    int iOutportArray = 0;
    int iPortNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetInportAlmLinkOutport, number is 262\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetInportAlmLinkOutport(g_iLogonID, iPortNum, &iOutportArray);
    if(0 == iRet)
    {
        fprintf(stderr, "GetInportAlmLinkOutport is OK!\n");
		fprintf(stderr, "Alarm link outport bit is %u (0x%08X)\n", (unsigned int)iOutportArray, (unsigned int)iOutportArray);
    }
    else
    {
        fprintf(stderr, "GetInportAlmLinkOutport is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetAlarmInMode()
{
    int iOnOrOff = 0;
    int iPortNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetAlarmInMode, number is 134\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set alarm in state\n"
        "0: close circuit \n"
        "1: open circuit \n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iOnOrOff = to_int_def(cTemp, -1);

    int iRet = NetClient_SetAlarmInMode(g_iLogonID, iPortNum, iOnOrOff);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetAlarmInMode()
{
    int iOnOrOff = 0;
    int iPortNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetAlarmInMode, number is 185\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetAlarmInMode(g_iLogonID, iPortNum, &iOnOrOff);
    if(0 == iRet)
    {
        fprintf(stderr, "GetAlarmInMode ok,iOnOrOff is %d \n",iOnOrOff);		
    }
    else
    {
        fprintf(stderr, "GetAlarmInMode is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetAlarmOutMode()
{
    int iOnOrOff = 0;
    int iPulseWidth = 0;
    int iPortNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetAlarmOutMode, number is 135\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set alarm in state\n"
        "0: close circuit \n"
        "1: open circuit \n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iOnOrOff = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input purse width:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPulseWidth = to_int_def(cTemp, -1);

    int iRet = NetClient_SetAlarmOutMode(g_iLogonID, iPortNum, iOnOrOff, iPulseWidth);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetAlarmOutMode()
{
    int iOnOrOff = 0;
    int iPulseWidth = 0;
    int iPortNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetAlarmOutMode, number is 186\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetAlarmOutMode(g_iLogonID, iPortNum, &iOnOrOff, &iPulseWidth);
    if(0 == iRet)
    {
        fprintf(stderr, "GetAlarmOutMode is OK!\n");
        fprintf(stderr, "Purse iOnOrOff is %d\n", iOnOrOff);
		fprintf(stderr, "Purse width is %d\n", iPulseWidth);
    }
    else
    {
        fprintf(stderr, "GetAlarmOutMode is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetInportAlarmSchedule()
{
    int iPortNum = 0;
    int iWeekday = 0;
    char cTemp[8] = {0};
    NVS_SCHEDTIME timeSeg1,timeSeg2,timeSeg3,timeSeg4;

    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    PNVS_SCHEDTIME schedule[] = {&timeSeg1,&timeSeg2,&timeSeg3,&timeSeg4};


    fprintf(stderr, "You choose to test NetClient_SetInportAlarmSchedule, number is 136\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set week day\n"
        "0: Sunday\n"
        "1: Monday\n"
        "2: Tuesday\n"
        "3: Wednesday\n"
        "4: Thursday\n"
        "5: Friday\n"
        "6: Saturday\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iWeekday = to_int_def(cTemp, -1);

	// time seg1
    fprintf(stderr, "Please input time1 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time1 state:0 disable, 1 enable:");
    timeSeg1.iRecordMode = SafeGetInt();

	//time seg2
    fprintf(stderr, "Please input time2 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time2 state:0 disable, 1 enable:");
	timeSeg2.iRecordMode = SafeGetInt();

	//time seg3
    fprintf(stderr, "Please input time3 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time3 state:0 disable, 1 enable:");
	timeSeg3.iRecordMode = SafeGetInt();

	//time seg4
    fprintf(stderr, "Please input time4 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time4 state:0 disable, 1 enable:");
	timeSeg4.iRecordMode = SafeGetInt();

    int iRet = NetClient_SetInportAlarmSchedule(g_iLogonID, iPortNum, iWeekday, schedule);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetInportAlarmSchedule()
{
    int iPortNum = 0;
    int iWeekday = 0;
    char cTemp[8] = {0};
    NVS_SCHEDTIME timeSeg[MAX_TIMESEGMENT];

	for(int i=0; i<MAX_TIMESEGMENT; i++)
	{
		memset(&timeSeg[i], 0, sizeof(NVS_SCHEDTIME));
	}

    PNVS_SCHEDTIME schedule[] = {&timeSeg[0], &timeSeg[1], &timeSeg[2], &timeSeg[3]};


    fprintf(stderr, "You choose to test NetClient_GetInportAlarmSchedule, number is 187\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set week day\n"
        "0: Sunday\n"
        "1: Monday\n"
        "2: Tuesday\n"
        "3: Wednesday\n"
        "4: Thursday\n"
        "5: Friday\n"
        "6: Saturday\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iWeekday = to_int_def(cTemp, -1);

	int iRet = NetClient_GetInportAlarmSchedule(g_iLogonID, iPortNum, iWeekday, schedule);
    if(0 == iRet)
    {
        fprintf(stderr, "GetInportAlarmSchedule is OK!\n");
		for(int i=0; i<MAX_TIMESEGMENT; i++)
		{
			fprintf(stderr, "Time section %d start time is %d:%d, stop time is %d:%d, enalbe = %d\n", i+1,
					timeSeg[i].iStartHour, timeSeg[i].iStartMin, timeSeg[i].iStopHour, timeSeg[i].iStopMin, timeSeg[i].iRecordMode);
		}
    }
    else
    {
        fprintf(stderr, "GetInportAlarmSchedule failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetOutportAlarmSchedule()
{
    int iPortNum = 0;
    int iWeekday = 0;
    char cTemp[8] = {0};
    NVS_SCHEDTIME timeSeg1,timeSeg2,timeSeg3,timeSeg4;

    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    PNVS_SCHEDTIME schedule[] = {&timeSeg1,&timeSeg2,&timeSeg3,&timeSeg4};


    fprintf(stderr, "You choose to test NetClient_SetOutportAlarmSchedule, number is 137\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set week day\n"
        "0: Sunday\n"
        "1: Monday\n"
        "2: Tuesday\n"
        "3: Wednesday\n"
        "4: Thursday\n"
        "5: Friday\n"
        "6: Saturday\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iWeekday = to_int_def(cTemp, -1);

	// time seg1
    fprintf(stderr, "Please input time1 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time1 state:0 disable, 1 enable:");
    timeSeg1.iRecordMode = SafeGetInt();

	//time seg2
    fprintf(stderr, "Please input time2 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time2 state:0 disable, 1 enable:");
    timeSeg2.iRecordMode = SafeGetInt();

	// time seg3
    fprintf(stderr, "Please input time3 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time3 state:0 disable, 1 enable:");
    timeSeg3.iRecordMode = SafeGetInt();

	// time seg4
    fprintf(stderr, "Please input time4 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time4 state:0 disable, 1 enable:");
    timeSeg4.iRecordMode = SafeGetInt();

    int iRet = NetClient_SetOutportAlarmSchedule(g_iLogonID, iPortNum, iWeekday, schedule);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetOutportAlarmSchedule()
{
    int iPortNum = 0;
    int iWeekday = 0;
    char cTemp[8] = {0};
    NVS_SCHEDTIME timeSeg[MAX_TIMESEGMENT];

	for(int i=0; i<MAX_TIMESEGMENT; i++)
	{
		memset(&timeSeg[i], 0, sizeof(NVS_SCHEDTIME));
	}

    PNVS_SCHEDTIME schedule[] = {&timeSeg[0], &timeSeg[1], &timeSeg[2], &timeSeg[3]};


    fprintf(stderr, "You choose to test NetClient_GetOutportAlarmSchedule, number is 188\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set week day\n"
        "0: Sunday\n"
        "1: Monday\n"
        "2: Tuesday\n"
        "3: Wednesday\n"
        "4: Thursday\n"
        "5: Friday\n"
        "6: Saturday\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iWeekday = to_int_def(cTemp, -1);

	int iRet = NetClient_GetOutportAlarmSchedule(g_iLogonID, iPortNum, iWeekday, schedule);
    if(0 == iRet)
    {
        fprintf(stderr, "GetOutportAlarmSchedule is OK!\n");
		for(int i=0; i<MAX_TIMESEGMENT; i++)
		{
			fprintf(stderr, "Time section %d start time is %d:%d, stop time is %d:%d, enable = %d\n", i+1,
					timeSeg[i].iStartHour, timeSeg[i].iStartMin, timeSeg[i].iStopHour, timeSeg[i].iStopMin, timeSeg[i].iRecordMode);
		}
    }
    else
    {
        fprintf(stderr, "GetOutportAlarmSchedule failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetOutportAlarmDelay()
{
    int iPortNum = 0;
    int iClearType = 0;
    int iDelayTime = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetOutportAlarmDelay, number is 138\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr, "Please ouput Alarm delay time:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iDelayTime = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set clear alarm mode\n"
        "0: Manual\n"
        "1: Delay\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iClearType = to_int_def(cTemp, -1);

    int iRet = NetClient_SetOutportAlarmDelay(g_iLogonID, iPortNum, iClearType, iDelayTime);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetOutportAlarmDelay()
{
    int iPortNum = 0;
    int iClearType = 0;
    int iDelayTime = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetOutportAlarmDelay, number is 189\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetOutportAlarmDelay(g_iLogonID, iPortNum, &iClearType, &iDelayTime);
    if(0 == iRet)
    {
        fprintf(stderr, "GetOutportAlarmDelay is OK!\n");
		if(0 == iClearType)
		{
			fprintf(stderr, "Clear alarm type is manual!\n");
		}
		else if(1 == iClearType)
		{
			fprintf(stderr, "GetOutportAlarmDelay is delay!\n");
		}

		fprintf(stderr, "Alarm delay time is %d!\n", iDelayTime);

    }
    else
    {
        fprintf(stderr, "GetOutportAlarmDelay is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetInportEnable()
{
    int iPortNum = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetInportEnable, number is 139\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set in port state\n"
        "0: disabled\n"
        "1: enabled\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iEnable = to_int_def(cTemp, -1);

    int iRet = NetClient_SetInportEnable(g_iLogonID, iPortNum, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetInportEnable()
{
    int iPortNum = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetInportEnable, number is 190\n");

    fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetInportEnable(g_iLogonID, iPortNum, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetInportEnable is OK!\n");
		if(0 == iEnable)
        {
            fprintf(stderr, "Inport state status is disabled\n");
        }
        else if(1 == iEnable)
        {
            fprintf(stderr, "Inport state status is enabled\n");
        }
    }
    else
    {
        fprintf(stderr, "GetInportEnable is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetAlarmOutput()
{
    int iInputPort = 0;
    int iAlarmOutput = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetAlarmOutput, number is 140\n");

    fprintf(stderr, "Please type alarm input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iInputPort = to_int_def(cTemp, -1);

    fprintf(stderr, "Please type alarm output port bit:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iAlarmOutput = to_int_def(cTemp, -1);

    int iRet = NetClient_SetAlarmOutput(g_iLogonID, iInputPort, iAlarmOutput);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetAlarmOutput()
{
    int iInputPort = 0;
	int iAlarmOutput = 0;
    unsigned long ulAlarmOutput = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetAlarmOutput, number is 177\n");

    fprintf(stderr, "Please type alarm input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iInputPort = to_int_def(cTemp, -1);

    int iRet = NetClient_GetAlarmOutput(g_iLogonID, iInputPort, &ulAlarmOutput);
	iAlarmOutput = ulAlarmOutput;
    if(0 == iRet)
    {
		fprintf(stderr, "GetAlarmOutput is OK!\n");
		fprintf(stderr, "Alarm output is %d!\n", iAlarmOutput);
    }
    else
    {
        fprintf(stderr, "GetAlarmOutput is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetAlarmVideoLost()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_SetAlarmVideoLost, number is 141\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set video lost detect state\n"
        "0: disabled\n"
        "1: enabled\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iEnable = to_int_def(cTemp, -1);

    int iRet = NetClient_SetAlarmVideoLost(g_iLogonID, iChannel, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetAlarmVideoLost()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_GetAlarmVideoLost, number is 196\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetAlarmVideoLost(g_iLogonID, iChannel, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetAlarmVideoLost is OK!\n");
		if(0 == iEnable)
		{
			fprintf(stderr, "Video lost detect state is disabled!\n");
		}
		else if(1 == iEnable)
		{
			fprintf(stderr, "Video lost detect state is enabled!\n");
		}
	}
	else
	{
		fprintf(stderr, "GetAlarmVideoLost is failed!\n");
	}

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetVideoLostLinkPTZ()
{
    int iChannel = 0;
    int iLinkChannelNum = 0;
    int iLinkType = 0;
    int iActNum = 0;
    char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_SetVideoLostLinkPTZ, number is 142\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input link channel number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iLinkChannelNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set link type\n"
        "0: not link Channel PTZ\n"
        "1: preset\n"
        "2: track\n"
        "3: path \n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iLinkType = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input act number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iActNum = to_int_def(cTemp, -1);

    int iRet = NetClient_SetVideoLostLinkPTZ(g_iLogonID, iChannel, iLinkChannelNum, iLinkType, iActNum);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetVideoLostLinkPTZ()
{
    int iChannel = 0;
    int iLinkChannelNum = 0;
    int iLinkType = 0;
    int iActNum = 0;
    char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_GetVideoLostLinkPTZ, number is 197\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input link channel number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iLinkChannelNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetVideoLostLinkPTZ(g_iLogonID, iChannel, iLinkChannelNum, &iLinkType, &iActNum);
    if(0 == iRet)
    {
        fprintf(stderr, "GetVideoLostLinkPTZ is OK!\n");
		if(0 == iLinkType)
		{
			fprintf(stderr, "Video lost link type is not link Channel PTZ!\n");
		}
		else if(1 == iLinkType)
		{
			fprintf(stderr, "Video lost link type is preset!\n");
		}
		else if(2 == iLinkType)
		{
			fprintf(stderr, "Video lost link type is track!\n");
		}
		else if(3 == iLinkType)
		{
			fprintf(stderr, "Video lost link type is path!\n");
		}

		fprintf(stderr, "Video lost link act number is %d!\n", iActNum);
    }
    else
    {
        fprintf(stderr, "GetVideoLostLinkPTZ is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetVideoLostLinkOutport()
{
    int iChannel = 0;
    int iOutportArray = 0;
    char cTemp[64] = {0};

	fprintf(stderr, "You choose to test NetClient_SetVideoLostLinkOutport, number is 143\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input video lost link outport bit:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iOutportArray = (int)to_uint_def(cTemp, 0);

    int iRet = NetClient_SetVideoLostLinkOutport(g_iLogonID, iChannel, iOutportArray);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetVideoLostLinkOutport()
{
    int iChannel = 0;
    int iOutportArray = 0;
    char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_GetVideoLostLinkOutport, number is 198\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetVideoLostLinkOutport(g_iLogonID, iChannel, &iOutportArray);
    if(0 == iRet)
    {
        fprintf(stderr, "GetVideoLostLinkOutport is OK!\n");
		fprintf(stderr, "Video lost link outport bit is %u (0x%08X)\n", (unsigned int)iOutportArray, (unsigned int)iOutportArray);
    }
    else
    {
        fprintf(stderr, "GetVideoLostLinkOutport is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}


int Test_SetVideoLostSchedule()
{
    int iChannel = 0;
    int iWeekday = 0;
    char cTemp[8] = {0};
    NVS_SCHEDTIME timeSeg1,timeSeg2,timeSeg3,timeSeg4;

    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    PNVS_SCHEDTIME schedule[] = {&timeSeg1,&timeSeg2,&timeSeg3,&timeSeg4};


    fprintf(stderr, "You choose to test NetClient_SetVideoLostSchedule, number is 144\n");

	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set week day\n"
        "0: Sunday\n"
        "1: Monday\n"
        "2: Tuesday\n"
        "3: Wednesday\n"
        "4: Thursday\n"
        "5: Friday\n"
        "6: Saturday\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iWeekday = to_int_def(cTemp, -1);

	//time seg1
    fprintf(stderr, "Please input time1 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time1 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time1 state:0 disable, 1 enable:");
	timeSeg1.iRecordMode = SafeGetInt();

	//time seg2
    fprintf(stderr, "Please input time2 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time2 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time2 state:0 disable, 1 enable:");
	timeSeg2.iRecordMode = SafeGetInt();

	//time seg3
	fprintf(stderr, "Please input time3 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time3 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time3 state:0 disable, 1 enable:");
	timeSeg3.iRecordMode = SafeGetInt();

	//time seg4
    fprintf(stderr, "Please input time4 start hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStartHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 start minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStartMin = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 stop hour:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStopHour = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input time4 stop minute:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStopMin = to_int_def(cTemp, -1);

	fprintf(stderr, "Choose time4 state:0 disable, 1 enable:");
	timeSeg4.iRecordMode = SafeGetInt();

    int iRet = NetClient_SetVideoLostSchedule(g_iLogonID, iChannel, iWeekday, schedule);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;

}

int Test_GetVideoLostSchedule()
{
    int iChannel = 0;
    int iWeekday = 0;
    char cTemp[8] = {0};
    NVS_SCHEDTIME timeSeg[MAX_TIMESEGMENT];

	for(int i=0; i<MAX_TIMESEGMENT; i++)
	{
		memset(&timeSeg[i], 0, sizeof(NVS_SCHEDTIME));
	}

    PNVS_SCHEDTIME schedule[] = {&timeSeg[0], &timeSeg[1], &timeSeg[2], &timeSeg[3]};


    fprintf(stderr, "You choose to test NetClient_GetVideoLostSchedule, number is 199\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set week day\n"
        "0: Sunday\n"
        "1: Monday\n"
        "2: Tuesday\n"
        "3: Wednesday\n"
        "4: Thursday\n"
        "5: Friday\n"
        "6: Saturday\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iWeekday = to_int_def(cTemp, -1);

	int iRet = NetClient_GetVideoLostSchedule(g_iLogonID, iChannel, iWeekday, schedule);
    if(0 == iRet)
    {
        fprintf(stderr, "GetVideoLostSchedule is OK!\n");
		for(int i=0; i<MAX_TIMESEGMENT; i++)
		{
			fprintf(stderr, "Time section %d start time is %d:%d, stop time is %d:%d, enable=%d\n", i+1,
					timeSeg[i].iStartHour, timeSeg[i].iStartMin, timeSeg[i].iStopHour, timeSeg[i].iStopMin, timeSeg[i].iRecordMode);
		}
    }
    else
    {
        fprintf(stderr, "GetVideoLostSchedule failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetVideoLostLinkRec()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[64] = {0};

    fprintf(stderr, "You choose to test NetClient_SetVideoLostLinkRec, number is 145\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input lost link bit:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iEnable = (int)to_uint_def(cTemp, 0);

    int iRet = NetClient_SetVideoLostLinkRec(g_iLogonID, iChannel, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetVideoLostLinkRec()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetVideoLostLinkRec, number is 200\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);


    int iRet = NetClient_GetVideoLostLinkRec(g_iLogonID, iChannel, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetVideoLostLinkRec is OK!\n");
		fprintf(stderr, "Lost link bit is %u (0x%08X)\n", (unsigned int)iEnable, (unsigned int)iEnable);
    }
    else
    {
        fprintf(stderr, "GetVideoLostLinkRec is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetVideoLostLinkSnap()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[64] = {0};

    fprintf(stderr, "You choose to test NetClient_SetVideoLostLinkSnap, number is 146\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input bit:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iEnable = (int)to_uint_def(cTemp, 0);

    int iRet = NetClient_SetVideoLostLinkSnap(g_iLogonID, iChannel, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetVideoLostLinkSnap()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetVideoLostLinkSnap, number is 201\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetVideoLostLinkSnap(g_iLogonID, iChannel, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetVideoLostLinkSnap is OK!\n");
		fprintf(stderr, "Video lost link snap bit is %u (0x%08X)\n", (unsigned int)iEnable, (unsigned int)iEnable);
    }
    else
    {
        fprintf(stderr, "GetVideoLostLinkSnap is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetAudioEncoder()
{
    int iChannel = 0;
    AUDIO_ENCODER aCoder;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetAudioEncoder, number is 147\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set motion detect state\n"
        "0:  G711_A\n"
        "1:  G711_U\n"
        "2:  ADPCM_DVI4\n"
        "3:  ADPCM_IMA\n"
        "4:  MEDIA_G726_16KBPS\n"
        "5:  MEDIA_G726_24KBPS\n"
        "6:  MEDIA_G726_32KBPS\n"
        "7:  MEDIA_G726_40KBPS\n"
        "8:  AMR_NB\n"
        "9:  G726_24KBPS\n"
        "10: G726_32KBPS\n"
        "11: G726_40KBPS\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}

	int iIndexItem = to_int_def(cTemp, -1);

    switch(iIndexItem)
    {
        case 0:     aCoder = G711_A;                break;
        case 1:     aCoder = G711_U;                break;
        case 2:     aCoder = ADPCM_DVI4;            break;
        case 3:     aCoder = ADPCM_IMA;             break;
        case 4:     aCoder = MEDIA_G726_16KBPS;     break;
        case 5:     aCoder = MEDIA_G726_24KBPS;     break;
        case 6:     aCoder = MEDIA_G726_32KBPS;     break;
        case 7:     aCoder = MEDIA_G726_40KBPS;     break;
        case 8:     aCoder = AMR_NB;                break;
        case 9:     aCoder = G726_24KBPS;           break;
        case 10:    aCoder = G726_32KBPS;           break;
        case 11:    aCoder = G726_40KBPS;           break;
        default:
            aCoder = G711_A;
    }

    int iRet = NetClient_SetAudioEncoder(g_iLogonID, iChannel, aCoder);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetAudioEncoder()
{
	int iChannel = 0;
    AUDIO_ENCODER aCoder;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetAudioEncoder, number is 227\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetAudioEncoder(g_iLogonID, iChannel, &aCoder);
    if(0 == iRet)
    {
        fprintf(stderr, "GetAudioEncoder ok, aCoder=%d \n",aCoder);
		if(G711_A == aCoder)
		{
			fprintf(stderr, "Audio encoder is G711_A\n");
		}
		else if(G711_U == aCoder)
		{
			fprintf(stderr, "Audio encoder is G711_U\n");
		}
		else if(ADPCM_DVI4 == aCoder)
		{
			fprintf(stderr, "Audio encoder is ADPCM_DVI4\n");
		}
		else if(G726_16KBPS == aCoder)
		{
			fprintf(stderr, "Audio encoder is G726_16KBPS\n");
		}
		else if(G726_24KBPS == aCoder)
		{
			fprintf(stderr, "Audio encoder is G726_24KBPS\n");
		}
		else if(G726_32KBPS == aCoder)
		{
			fprintf(stderr, "Audio encoder is G726_32KBPS\n");
		}
		else if(G726_40KBPS == aCoder)
		{
			fprintf(stderr, "Audio encoder is G726_40KBPS\n");
		}
		else if(MPEG_LAYER2 == aCoder)
		{
			fprintf(stderr, "Audio encoder is MPEG_LAYER2\n");
		}
		else if(AMR_NB == aCoder)
		{
			fprintf(stderr, "Audio encoder is AMR_NB\n");
		}
		else if(ADPCM_IMA == aCoder)
		{
			fprintf(stderr, "Audio encoder is ADPCM_IMA\n");
		}
		else if(MEDIA_G726_16KBPS == aCoder)
		{
			fprintf(stderr, "Audio encoder is MEDIA_G726_16KBPS\n");
		}
		else if(MEDIA_G726_24KBPS == aCoder)
		{
			fprintf(stderr, "Audio encoder is MEDIA_G726_24KBPS\n");
		}
        else if(MEDIA_G726_32KBPS == aCoder)
		{
			fprintf(stderr, "Audio encoder is MEDIA_G726_32KBPS\n");
		}
        else if(MEDIA_G726_40KBPS == aCoder)
		{
			fprintf(stderr, "Audio encoder is MEDIA_G726_40KBPS\n");
		}
    }
    else
    {
        fprintf(stderr, "GetAudioEncoder is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetMotionDecLinkRec()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[64] = {0};

    fprintf(stderr, "You choose to test NetClient_SetMotionDecLinkRec, number is 148\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input motion detect link bit:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iEnable = (int)to_uint_def(cTemp, 0);

    int iRet = NetClient_SetMotionDecLinkRec(g_iLogonID, iChannel, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetMotionDecLinkRec()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetMotionDecLinkRec, number is 169\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetMotionDecLinkRec(g_iLogonID, iChannel, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetMotionDecLinkRec is OK!\n");
		fprintf(stderr, "The motion detect link bit is %u (0x%08X)\n", (unsigned int)iEnable, (unsigned int)iEnable);
    }
    else
    {
        fprintf(stderr, "GetMotionDecLinkRec is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetMotionDecLinkSnap()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[64] = {0};

    fprintf(stderr, "You choose to test NetClient_SetMotionDecLinkSnap, number is 149\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input bit:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iEnable = (int)to_uint_def(cTemp, 0);

    int iRet = NetClient_SetMotionDecLinkSnap(g_iLogonID, iChannel, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetMotionDecLinkSnap()
{
    int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetMotionDecLinkSnap, number is 170\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);


    int iRet = NetClient_GetMotionDecLinkSnap(g_iLogonID, iChannel, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetMotionDecLinkSnap is OK!\n");
		fprintf(stderr, "Motion detect link snap bit is %u (0x%08X)\n", (unsigned int)iEnable, (unsigned int)iEnable);
    }
    else
    {
        fprintf(stderr, "GetMotionDecLinkSnap is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetIFrameRate()
{
    int iChannel = 0;
    int iFrameRate = 0;
    int iStreamNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetIFrameRate, number is 150\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input frame rate:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iFrameRate = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    int iRet = NetClient_SetIFrameRate(g_iLogonID, iChannel, iFrameRate, iStreamNum);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetIFrameRate()
{
    int iChannel = 0;
    int iFrameRate = 0;
    int iStreamNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetIFrameRate, number is 202\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetIFrameRate(g_iLogonID, iChannel, &iFrameRate, iStreamNum);
    if(0 == iRet)
    {
        fprintf(stderr, "GetIFrameRate is OK!\n");
		fprintf(stderr, "Frame rate is %d\n", iFrameRate);
    }
    else
    {
        fprintf(stderr, "GetIFrameRate is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_ForceIFrame()
{
    int iChannel = 0;
    int iStreamNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_ForceIFrame, number is 151\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

    int iRet = NetClient_ForceIFrame(g_iLogonID, iChannel, iStreamNum);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileManualRecord()
{
    int iChannel = 0;
    int iState = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_NetFileManualRecord, number is 152\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set record state\n"
        "0: Stop record\n"
        "1: Start record\n"
        "Please choose a number to be set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iState = to_int_def(cTemp, -1);
    //add by cmz 20110412
    if (0 == iState || 1 == iState)
    {
    int iRet = NetClient_NetFileManualRecord(g_iLogonID, iChannel, iState);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }
    }
    else
    {
        fprintf(stderr, "please input 0 or 1!\n");
    }
    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileSetAlarmState()
{
    int iChannel = 0;
    int iState = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_NetFileSetAlarmState, number is 153\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set alarm record state\n"
        "0: Stop alarm record\n"
        "1: Start alarm record\n"
        "Please choose a number to be set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iState = to_int_def(cTemp, -1);

    int iRet = NetClient_NetFileSetAlarmState(g_iLogonID, iChannel, iState);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileGetAlarmState()
{
    int iChannel = 0;
    int iState = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_NetFileGetAlarmState, number is 230\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_NetFileGetAlarmState(g_iLogonID, iChannel, &iState);
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileGetAlarmState is OK!\n");
		if(0 == iState)
		{
			fprintf(stderr, "Alarm record state stoped!\n");
		}
		else if(1 == iState)
		{
			fprintf(stderr, "Alarm record state started!\n");
		}
    }
    else
    {
        fprintf(stderr, "NetFileGetAlarmState is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetEmailAlarm()
{
    SMTP_INFO smtp;
    int iPort = 0;
    int iAuthenType = 0;
    char cTemp[8] = {0};
    memset(&smtp, 0, sizeof(smtp));
	char cServer[32] = {0};
	char cAccount[32] = {0};
	char cPassword[32] = {0};
	char cAddress[32] = {0};
	char cSubject[32] = {0};

    fprintf(stderr, "You choose to test NetClient_SetEmailAlarm, number is 154\n");

    fprintf(stderr, "Please input smpt server :");
	gets_s(cServer, 32);
	if(0 == strcasecmp("q", cServer))
	{
	    return -1;
	}
	u2g(cServer, strlen(cServer)+1, smtp.cSmtpServer, 32);

    fprintf(stderr, "Please input smpt port :");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
    iPort = to_int_def(cTemp, -1);
    smtp.wdSmtpPort = (unsigned short)iPort;

    fprintf(stderr, "Please input smpt account :");
	gets_s(cAccount, 32);
	if(0 == strcasecmp("q", cAccount))
	{
	    return -1;
	}
	u2g(cAccount, strlen(cAccount)+1, smtp.cEmailAccount, 32);

    fprintf(stderr, "Please input smpt password :");
	gets_s(cPassword, 32);
	if(0 == strcasecmp("q", cPassword))
	{
	    return -1;
	}
	u2g(cPassword, strlen(cPassword)+1, smtp.cEmailPassword, 32);

    fprintf(stderr, "Please input smpt address :");
	gets_s(cAddress, 32);
	if(0 == strcasecmp("q", cAddress))
	{
	    return -1;
	}
	u2g(cAddress, strlen(cAddress)+1, smtp.cEmailAddress, 32);

    fprintf(stderr, "Please input smpt subject :");
	gets_s(cSubject, 32);
	if(0 == strcasecmp("q", cSubject))
	{
	    return -1;
	}
	u2g(cSubject, strlen(cSubject)+1, smtp.cMailSubject, 32);

    fprintf(stderr, "Please input smpt Authentication type.\n");
    printf("0: off \n");
    printf("1: plain \n");
    printf("2: cram-md5 \n");
    printf("3: digest-md5 \n");
    printf("4: gssapi \n");
    printf("5: external \n");
    printf("6: login \n");
    printf("7: ntlm \n");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
    iAuthenType = to_int_def(cTemp, -1);
    smtp.iAuthtype = iAuthenType;

    int iRet = NetClient_SetEmailAlarm(g_iLogonID, &smtp);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetEmailAlarm()
{
    SMTP_INFO smtp;
	char cServer[32] = {0};
	char cAccount[32] = {0};
	char cPassword[32] = {0};
	char cAddress[32] = {0};
	char cSubject[32] = {0};

    memset(&smtp, 0, sizeof(smtp));

    fprintf(stderr, "You choose to test NetClient_GetEmailAlarm, number is 240\n");

    int iRet = NetClient_GetEmailAlarm(g_iLogonID, &smtp);
	g2u(smtp.cSmtpServer, strlen(smtp.cSmtpServer)+1, cServer, 32);
	g2u(smtp.cEmailAccount, strlen(smtp.cEmailAccount)+1, cAccount, 32);
	g2u(smtp.cEmailPassword, strlen(smtp.cEmailPassword)+1, cPassword, 32);
	g2u(smtp.cEmailAddress, strlen(smtp.cEmailAddress)+1, cAddress, 32);
	g2u(smtp.cMailSubject, strlen(smtp.cMailSubject)+1, cSubject, 32);

    if(0 == iRet)
    {
        fprintf(stderr, "GetEmailAlarm is OK!\n");
		fprintf(stderr, "Smpt server is %s\n", cServer);
		fprintf(stderr, "Smpt port is %d\n", (int)smtp.wdSmtpPort);
		fprintf(stderr, "Smpt account is %s\n", cAccount);
		fprintf(stderr, "Smpt password is %s\n", cPassword);
		fprintf(stderr, "Smpt address is %s\n", cAddress);
		fprintf(stderr, "Smpt subject is %s\n", cSubject);
		fprintf(stderr, "Smpt Authentication type is %d\n", smtp.iAuthtype);
    }
    else
    {
        fprintf(stderr, "GetEmailAlarm is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetEmailAlarmEnable()
{
	int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetEmailAlarmEnable, number is 241\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

	fprintf(stderr,
        "Set email alarm state\n"
        "0: disabled\n"
        "1: enabled\n"
        "Please choose a number to be set:");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iEnable = to_int_def(cTemp, -1);

    int iRet = NetClient_SetEmailAlarmEnable(g_iLogonID, iChannel, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetEmailAlarmEnable()
{
	int iChannel = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetEmailAlarmEnable, number is 242\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_GetEmailAlarmEnable(g_iLogonID, iChannel, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetEmailAlarmEnable is OK!\n");
		if(0 == iEnable)
		{
			fprintf(stderr, "Email alarm state is disabled\n");
		}
		else if(1 == iEnable)
		{
			fprintf(stderr, "Email alarm state is enabled\n");
		}
    }
    else
    {
        fprintf(stderr, "GetEmailAlarmEnable is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}


int Test_NetFileSetTaskState()
{
    int iChannel = 0;
    int iState = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_NetFileSetTaskState, number is 155\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set Schedule record state\n"
        "0: Stop Schedule record\n"
        "1: Start Schedule record\n"
        "Please choose a number to be set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iState = to_int_def(cTemp, -1);

    int iRet = NetClient_NetFileSetTaskState(g_iLogonID, iChannel, iState);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileGetTaskState()
{
    int iChannel = 0;
    int iState = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_NetFileGetTaskState, number is 231\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_NetFileGetTaskState(g_iLogonID, iChannel, &iState);
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileGetTaskState is OK!\n");
		if(0 == iState)
		{
			fprintf(stderr, "Schedule record state stoped!\n");
		}
		else if(1 == iState)
		{
			fprintf(stderr, "Schedule record state started!\n");
		}
    }
    else
    {
        fprintf(stderr, "NetFileGetTaskState is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetVideoPara()
{
	int iChannel = 0;
    STR_VideoParam sp;
	memset(&sp, 0, sizeof(sp));
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetVideoPara, number is 156\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input video bright:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	sp.m_u16Brightness = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input video contrast:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	sp.m_u16Contrast = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input video hue:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	sp.m_u16Hue = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input video saturation:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	sp.m_u16Saturation = to_int_def(cTemp, -1);

	int iRet = NetClient_SetVideoPara(g_iLogonID, iChannel, &sp);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetVideoPara()
{
	int iChannel = 0;
    STR_VideoParam sp;
	memset(&sp, 0, sizeof(sp));
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetVideoPara, number is 157\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

	int iRet = NetClient_GetVideoPara(g_iLogonID, iChannel, &sp);
	if(0 == iRet)
    {
        fprintf(stderr, "GetVideoPara is successful!\n");
		fprintf(stderr, "video bright is %d\n", sp.m_u16Brightness);
		fprintf(stderr, "video contrast is %d\n", sp.m_u16Contrast);
		fprintf(stderr, "video hue is %d\n", sp.m_u16Hue);
		fprintf(stderr, "video saturation is %d\n", sp.m_u16Saturation);
    }
    else
    {
        fprintf(stderr, "GetVideoPara is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetVideoparaSchedule()
{
    int iChannel = 0;
    int iRet = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetVideoparaSchedule, number is 158\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

	STR_VideoParam sp[MAX_TIMESEGMENT];
	for(int i=0; i<MAX_TIMESEGMENT; i++)
	{
		memset(&sp[i], 0, sizeof(STR_VideoParam));

		fprintf(stderr, "Please input time section %d video bright:", i);
		memset(cTemp, 0, sizeof(cTemp));
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		sp[i].m_u16Brightness = to_int_def(cTemp, -1);

		fprintf(stderr, "Please input time section %d video contrast:", i);
		memset(cTemp, 0, sizeof(cTemp));
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		sp[i].m_u16Contrast = to_int_def(cTemp, -1);

		fprintf(stderr, "Please input time section %d video hue:", i);
		memset(cTemp, 0, sizeof(cTemp));
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		sp[i].m_u16Hue = to_int_def(cTemp, -1);

		fprintf(stderr, "Please input time section %d video saturation:", i);
		memset(cTemp, 0, sizeof(cTemp));
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		sp[i].m_u16Saturation = to_int_def(cTemp, -1);


        fprintf(stderr, "Please input time section %d start time [hour:minute]:", i);
        memset(cTemp, 0, sizeof(cTemp));
        gets_s(cTemp, 8);
        if(0 == strcasecmp("q", cTemp))
        {
            return -1;
        }

		unsigned short iHour = 0;
		unsigned short iMin = 0;

		sscanf(cTemp, "%hd:%hd", 
			   &iHour,
			   &iMin);

		sp[i].strctTempletTime.iStartHour = iHour;
        sp[i].strctTempletTime.iStartMin = iMin;

		fprintf(stderr, "Please input time section %d stop time[hour:minute]:", i);
		memset(cTemp, 0, sizeof(cTemp));
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}

		sscanf(cTemp, "%hd:%hd", 
			   &iHour,
			   &iMin);
		sp[i].strctTempletTime.iStopHour = iHour;
		sp[i].strctTempletTime.iStopMin = iMin;

	}
	STR_VideoParam *pSP[] = {&sp[0], &sp[1], &sp[2], &sp[3]};

    iRet = NetClient_SetVideoparaSchedule(g_iLogonID, iChannel, pSP);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetVideoparaSchedule()
{
	int iChannel = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetVideoparaSchedule, number is 159\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

	STR_VideoParam sp[MAX_TIMESEGMENT];
	for(int i=0; i<MAX_TIMESEGMENT; i++)
	{
		memset(&sp[i], 0, sizeof(STR_VideoParam));
	}

	STR_VideoParam *pSP[] = {&sp[0], &sp[1], &sp[2], &sp[3]};
	int iRet = NetClient_GetVideoparaSchedule(g_iLogonID, iChannel, pSP);
    if(0 == iRet)
    {
        fprintf(stderr, "GetVideoparaSchedule is successful!\n");
		for(int i=0; i<MAX_TIMESEGMENT; i++)
		{
			fprintf(stderr, "time section %d video bright is %d\n", i, sp[i].m_u16Brightness);
			fprintf(stderr, "time section %d video contrast is %d\n", i, sp[i].m_u16Contrast);
			fprintf(stderr, "time section %d video hue is %d\n", i, sp[i].m_u16Hue);
			fprintf(stderr, "time section %d video saturation is %d\n", i, sp[i].m_u16Saturation);
			fprintf(stderr, "time section %d start time is %d:%02d, stop time is %d:%02d\n",
					i, sp[i].strctTempletTime.iStartHour, sp[i].strctTempletTime.iStartMin,
					sp[i].strctTempletTime.iStopHour, sp[i].strctTempletTime.iStopMin);
		}
    }
    else
    {
        fprintf(stderr, "GetVideoparaSchedule is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetVideoQuality()
{
	int iChannel = 0;
	int iVideoQuality = 0;
	int iStreamNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetVideoQuality, number is 160\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input video quality:");//[4,6,8,10,12,14]
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iVideoQuality = to_int_def(cTemp, -1);
//  if(4  != iVideoQuality &&
//     6  != iVideoQuality &&
//     8  != iVideoQuality &&
//     10 != iVideoQuality &&
//     12 != iVideoQuality &&
//     14 != iVideoQuality)
//  {
//  	fprintf(stderr, "Wrong input\n");
//  	return 0;
//  }

	int iRet = NetClient_SetVideoQuality(g_iLogonID, iChannel, iVideoQuality, iStreamNum);
	if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetVideoQuality()
{
	int iChannel = 0;
	int iVideoQuality = 0;
	int iStreamNum = 0;
	char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_GetVideoQuality, number is 161\n");

	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iChannel = to_int_def(cTemp, -1);

	fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

	int iRet = NetClient_GetVideoQuality(g_iLogonID, iChannel, &iVideoQuality, iStreamNum);
	if(0 == iRet)
    {
        fprintf(stderr, "GetVideoQuality is OK!\n");
		fprintf(stderr, "Video Quality is %d\n", iVideoQuality);
    }
    else
    {
        fprintf(stderr, "GetVideoQuality is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetFrameRate()
{
	int iChannel = 0;
	int iFrameRate = 0;
	int iStreamNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetFrameRate, number is 162\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input frame rate:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iFrameRate = to_int_def(cTemp, -1);

	int iRet = NetClient_SetFrameRate(g_iLogonID, iChannel, iFrameRate, iStreamNum);
	if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetFrameRate()
{
	int iChannel = 0;
	int iFrameRate = 0;
	int iStreamNum = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetFrameRate, number is 163\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);


	fprintf(stderr,
        "Stream type\n"
        "0: MAIN_STREAM\n"
        "1: SUB_STREAM\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNum = to_int_def(cTemp, -1);

	int iRet = NetClient_GetFrameRate(g_iLogonID, iChannel, &iFrameRate, iStreamNum);
	if(0 == iRet)
    {
        fprintf(stderr, "GetFrameRate is OK!\n");
		fprintf(stderr, "Frame rate is %d\n", iFrameRate);
    }
    else
    {
        fprintf(stderr, "GetFrameRate is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetMotionDetetionArea()
{
	int iChannel = 0;
	int iX = 0;
	int iY = 0;
	int iEnable = 0;
    char cTemp[8] = {0};
    bool bFlag = false;

    fprintf(stderr, "You choose to test NetClient_SetMotionDetetionArea, number is 165\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    for(int i=0; i<22; i++)
    {
        if(true == bFlag)
        {
            break;
        }

        for(int j=0; j<18; j++)
        {

            fprintf(stderr, "Please input  x-coordinate [0-21]:");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 8);
            if(0 == strcasecmp("q", cTemp))
            {
                return -1;
            }
            iX = to_int_def(cTemp, -1);

            fprintf(stderr, "Please input  y-coordinate [0-17]:");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 8);
            if(0 == strcasecmp("q", cTemp))
            {
                return -1;
            }
            iY = to_int_def(cTemp, -1);

            fprintf(stderr,
                "Set this point motion detect state\n"
                "0: disabled\n"
                "1: enabled\n"
                "Please choose a number to be set:");

            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 8);
            if(0 == strcasecmp("q", cTemp))
            {
                return -1;
            }
            iEnable = to_int_def(cTemp, -1);
            
			int iRet = NetClient_SetMotionDetetionArea(g_iLogonID, iChannel, iX, iY, iEnable);
            if (0 != iRet)
			{
				fprintf(stderr, "Sending command to server is failed!,errno is 0x%08x, return value is %d\n", errno, iRet);
				j--;
				continue;
			}
			

            fprintf(stderr, "Do you want to set motion detect point again:[y/n]");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 8);
            if(0 == strcasecmp("q", cTemp))
            {
                return -1;
            }
            else if(0 == strcasecmp("y", cTemp))
            {
                continue;
            }
            else
            {
                bFlag = true;
                break;
            }
        }
    }

	int iRet = NetClient_SetMotionAreaEnable(g_iLogonID, iChannel);
	if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetMotionDetetionArea()
{
	int iChannel = 0;
	int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetMotionDetetionArea, number is 166\n");

    fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "The motion detection area cotain following points:\n");

    for(int x=0; x<22; x++)
    {
        for(int y=0; y<18; y++)
        {
            NetClient_GetMotionDetetionArea(g_iLogonID, iChannel, x, y, &iEnable);
            if(1 == iEnable)
            {
                fprintf(stderr, "(%d,%d)\n", x, y);
            }
        }
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetIpFilter()
{
	char cFilterIP[16] = {0};
	char cFilterMask[16] = {0};

	fprintf(stderr, "You choose to test NetClient_GetIpFilter, number is 176\n");

	int iRet = NetClient_GetIpFilter(g_iLogonID, cFilterIP, cFilterMask);
	if(0 == iRet)
    {
        fprintf(stderr, "GetIpFilter is OK!\n");
		fprintf(stderr, "Filter IP is %s\n", cFilterIP);
		fprintf(stderr, "Filter mask is %s\n", cFilterMask);
    }
    else
    {
        fprintf(stderr, "GetOsdDiaphaneity is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetAlarmIPortState()
{
	int iInPort = 0;
	int iState = 0;
	char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_GetAlarmIPortState, number is 178\n");

    fprintf(stderr, "Please input alarm in port:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iInPort = to_int_def(cTemp, -1);

	int iRet = NetClient_GetAlarmIPortState(g_iLogonID, iInPort, &iState);
	if(0 == iRet)
    {
        fprintf(stderr, "GetAlarmIPortState is OK!\n");
		if(0 == iState)
		{
			fprintf(stderr, "Alarm state is disabled\n");
		}
		else if(1 == iState)
		{
			fprintf(stderr, "Alarm state is enabled\n");
		}
    }
    else
    {
        fprintf(stderr, "GetAlarmIPortState is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetInportAlarmLinkPTZ()
{
	int iPortNum = 0;
	int iLinkChannelNum = 0;
	int iLinkType = 0;
	int iActNum = 0;
	char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_SetInportAlarmLinkPTZ, number is 182\n");

	fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input link channel number:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iLinkChannelNum = to_int_def(cTemp, -1);

	fprintf(stderr,
		"Set link type\n"
		"0: not link Channel PTZ\n"
		"1: preset\n"
		"2: track\n"
		"3: path \n"
		"Please choose a number to be set:");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iLinkType = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input act number:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iActNum = to_int_def(cTemp, -1);

	int iRet = NetClient_SetInportAlarmLinkPTZ(g_iLogonID, iPortNum, iLinkChannelNum, iLinkType, iActNum);
	if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetInportAlarmLinkPTZ()
{
	int iPortNum = 0;
	int iLinkChannelNum = 0;
	int iLinkType = 0;
	int iActNum = 0;
	char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_GetInportAlarmLinkPTZ, number is 183\n");

	fprintf(stderr, "Please input port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input link channel number:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iLinkChannelNum = to_int_def(cTemp, -1);

	int iRet = NetClient_GetInportAlarmLinkPTZ(g_iLogonID, iPortNum, iLinkChannelNum, &iLinkType, &iActNum);
	if(0 == iRet)
    {
        fprintf(stderr, "GetInportAlarmLinkPTZ is OK!\n");
		if(0 == iLinkType)
		{
			fprintf(stderr, "Link type is not link Channel PTZ!\n");
		}
		else if(1 == iLinkType)
		{
			fprintf(stderr, "Link type is preset!\n");
		}
		else if(2 == iLinkType)
		{
			fprintf(stderr, "Link type is track!\n");
		}
		else if(3 == iLinkType)
		{
			fprintf(stderr, "Link type is path!\n");
		}

		fprintf(stderr, "Link act number is %d!\n", iActNum);
    }
    else
    {
        fprintf(stderr, "GetInportAlarmLinkPTZ is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetOutportEnable()
{
    int iPortNum = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetOutportEnable, number is 191\n");

    fprintf(stderr, "Please input out port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set out port state\n"
        "0: disabled\n"
        "1: enabled\n"
        "Please choose a number to be set:");

    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iEnable = to_int_def(cTemp, -1);

    int iRet = NetClient_SetOutportEnable(g_iLogonID, iPortNum, iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetOutportEnable()
{
    int iPortNum = 0;
    int iEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetOutportEnable, number is 192\n");

    fprintf(stderr, "Please output port number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iPortNum = to_int_def(cTemp, -1);

    int iRet = NetClient_GetOutportEnable(g_iLogonID, iPortNum, &iEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetOutportEnable is OK!\n");
		if(0 == iEnable)
        {
            fprintf(stderr, "Outport state status is disabled\n");
        }
        else if(1 == iEnable)
        {
            fprintf(stderr, "Outport state status is enabled\n");
        }
    }
    else
    {
        fprintf(stderr, "GetOutportEnable is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetComPortCounts()
{
	int iComPortCounts = 0;
    int iComPortEnable = 0;

    fprintf(stderr, "You choose to test NetClient_GetComPortCounts, number is 195\n");

    int iRet = NetClient_GetComPortCounts(g_iLogonID, &iComPortCounts, &iComPortEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetComPortCounts is OK!\n");
		fprintf(stderr, "COM port count is %d\n", iComPortCounts);
		fprintf(stderr, "COM port status is 0x%x\n", iComPortEnable);
    }
    else
    {
        fprintf(stderr, "GetComPortCounts is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetServerVersion()
{
	char cVersion[256] = {0};

	fprintf(stderr, "You choose to test NetClient_GetServerVersion, number is 203\n");

    int iRet = NetClient_GetServerVersion(g_iLogonID, cVersion);
    if(0 == iRet)
    {
        fprintf(stderr, "GetServerVersion is OK!\n");
		fprintf(stderr, "Server version is %s\n", cVersion);
    }
    else
    {
        fprintf(stderr, "GetServerVersion is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetUserNum()
{
	int iUserNum = 0;

	fprintf(stderr, "You choose to test NetClient_GetUserNum, number is 205\n");

    int iRet = NetClient_GetUserNum(g_iLogonID, &iUserNum);
    if(0 == iRet)
    {
        fprintf(stderr, "GetUserNum is OK!\n");
		fprintf(stderr, "User number is %d\n", iUserNum);
    }
    else
    {
        fprintf(stderr, "GetUserNum is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetUserInfo()
{
	int iUserNum = 0;
	char cUserName[16] = {0};
	char cPassword[16] = {0};
	int  iAuthority = 0;
	int iRet = 0;

	fprintf(stderr, "You choose to test NetClient_GetUserInfo, number is 206\n");

	NetClient_GetUserNum(g_iLogonID, &iUserNum);
	for(int i=0; i<iUserNum; i++)
	{
		iRet = NetClient_GetUserInfo(g_iLogonID, i, cUserName, cPassword, &iAuthority);
		if(0 == iRet)
		{
			fprintf(stderr, "GetUserInfo is OK!\n");
			fprintf(stderr, "User%d's name is %s\n", i, cUserName);
			fprintf(stderr, "User%d's password is %s\n", i, cPassword);
			fprintf(stderr, "User%d's authority rank is %d\n", i, iAuthority);
		}
		else
		{
			fprintf(stderr, "GetUserInfo is failed!\n");
		}
	}

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetCurUserInfo()
{
	char cUserName[16] = {0};
	char cPassword[16] = {0};
	int  iAuthority = 0;

	fprintf(stderr, "You choose to test NetClient_GetCurUserInfo, number is 207\n");
    int iRet = NetClient_GetCurUserInfo(g_iLogonID, cUserName, cPassword, &iAuthority);
    if(0 == iRet)
    {
        fprintf(stderr, "GetCurUserInfo is OK!\n");
		fprintf(stderr, "Current user name is %s\n", cUserName);
		fprintf(stderr, "Current user password is %s\n", cPassword);
		fprintf(stderr, "Current user authority rank is %d\n", iAuthority);

    }
    else
    {
        fprintf(stderr, "GetCurUserInfo is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetIpProperty()
{
	char cMAC[32] = {0};
	char cMask[16] = {0};
	char cGateway[16] = {0};
	char cDNS[16] = {0};

	fprintf(stderr, "You choose to test NetClient_GetIpProperty, number is 213\n");

    int iRet = NetClient_GetIpProperty(g_iLogonID, cMAC, cMask, cGateway, cDNS);
    if(0 == iRet)
    {
        fprintf(stderr, "GetIpProperty is OK!\n");
		fprintf(stderr, "MAC is %s\n", cMAC);
		fprintf(stderr, "Mask is %s\n", cMask);
		fprintf(stderr, "Gateway is %s\n", cGateway);
		fprintf(stderr, "DNS is %s\n", cDNS);
    }
    else
    {
        fprintf(stderr, "GetIpProperty is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_ShowBitrateOnVideo()
{
    return 0;
}

int Test_GetBitrateOnVideo()
{
	return 0;
}

int Test_CPUCheckEnabled()
{
	int iInterval = 0;
	int iEnable = 0;
	char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_CPUCheckEnabled, number is 222\n");

	fprintf(stderr,
        "Set CPU check state\n"
        "0: Disabled\n"
        "1: Enabled\n"
        "Please choose a number to be set:");
	gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iEnable = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input interval:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iInterval = to_int_def(cTemp, -1);

    int iRet = NetClient_CPUCheckEnabled(iEnable, iInterval);
    if(0 == iRet)
    {
		fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_LogFileGetDetails()
{
    fprintf(stderr, "You choose to test NetClient_LogFileGetDetails, number is 225\n");
    if(NULL == g_cLogBuf)
    {
        g_cLogBuf = new char[1024*512];
    }

    if(g_cLogBuf)
    {
        int iLen = 0;
        int iRet = NetClient_LogFileGetDetails(g_iLogonID, g_cLogBuf, &iLen);
        if(iRet >= 0)
        {           
            fprintf(stderr, "Log file data is %s \n", g_cLogBuf);
            fprintf(stderr, "LogFileGetDetails OK! length is %d\n",iLen);
        }
        else
        {
            fprintf(stderr, "LogFileGetDetails is failed!\n");
        } 
    }
    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileGetFileCount()
{
	int iTotalCount = 0;
	int iCurCount = 0;

    fprintf(stderr, "You choose to test NetClient_NetFileGetFileCount, number is 233\n");

    int iRet = NetClient_NetFileGetFileCount(g_iLogonID, &iTotalCount, &iCurCount);
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileGetFileCount is OK!\n");
		fprintf(stderr, "Total file count is %d, current file count is %d\n", iTotalCount, iCurCount);
    }
    else
    {
        fprintf(stderr, "NetFileGetFileCount is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_NetFileGetDiskInfo()
{
	NVS_STORAGEDEV storage;
	memset(&storage, 0, sizeof(storage));

	fprintf(stderr, "You choose to test NetClient_NetFileGetDiskInfoEx, number is 234\n");

    int iRet = NetClient_NetFileGetDiskInfoEx(g_iLogonID, &storage, sizeof(storage));
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileGetDiskInfo is OK!\n");
        for(int i=0; i<DISK_SATA_NUM; i++)
        {
            fprintf(stderr, "sata%d's part number is %d\n", i, storage.m_strctSATA[i].m_u16PartNum);
            fprintf(stderr, "sata%d's status is %d\n", i, storage.m_strctSATA[i].m_u16Status);
            fprintf(stderr, "sata%d's usage is %d\n", i, storage.m_strctSATA[i].m_u16Usage);
            fprintf(stderr, "sata%d's free space is %d\n", i, storage.m_strctSATA[i].m_u32FreeSpace);
            fprintf(stderr, "sata%d's total space is %d\n", i, storage.m_strctSATA[i].m_u32TotalSpace);
        }

        for(int j=0; j<DISK_USB_NUM; j++)
        {
            fprintf(stderr, "usb%d's part number is %d\n", j, storage.m_strctUSB[j].m_u16PartNum);
            fprintf(stderr, "usb%d's status is %d\n", j, storage.m_strctUSB[j].m_u16Status);
            fprintf(stderr, "usb%d's usage is %d\n", j, storage.m_strctUSB[j].m_u16Usage);
            fprintf(stderr, "usb%d's free space is %d\n", j, storage.m_strctUSB[j].m_u32FreeSpace);
            fprintf(stderr, "usb%d's total space is %d\n", j, storage.m_strctUSB[j].m_u32TotalSpace);
        }

        for(int k=0; k<DISK_NFS_NUM; k++)
        {
            fprintf(stderr, "NFS%d's part number is %d\n", k, storage.m_strctNFS[k].m_u16PartNum);
            fprintf(stderr, "NFS%d's status is %d\n", k, storage.m_strctNFS[k].m_u16Status);
            fprintf(stderr, "NFS%d's usage is %d\n", k, storage.m_strctNFS[k].m_u16Usage);
            fprintf(stderr, "NFS%d's free space is %d\n", k, storage.m_strctNFS[k].m_u32FreeSpace);
            fprintf(stderr, "NFS%d's total space is %d\n", k, storage.m_strctNFS[k].m_u32TotalSpace);
        }

        for(int k=0; k<DISK_ESATA_NUM; k++)
        {
            fprintf(stderr, "ESATA%d's part number is %d\n", k, storage.m_strctESATA[k].m_u16PartNum);
            fprintf(stderr, "ESATA%d's status is %d\n", k, storage.m_strctESATA[k].m_u16Status);
            fprintf(stderr, "ESATA%d's usage is %d\n", k, storage.m_strctESATA[k].m_u16Usage);
            fprintf(stderr, "ESATA%d's free space is %d\n", k, storage.m_strctESATA[k].m_u32FreeSpace);
            fprintf(stderr, "ESATA%d's total space is %d\n", k, storage.m_strctESATA[k].m_u32TotalSpace);
        }

    }
    else
    {
        fprintf(stderr, "NetFileGetDiskInfo is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

void Test_NetFileGetDownloadPos()
{
    fprintf(stderr, "You choose to test NetClient_NetFileGetDownloadPos, number is 236\n");
    for(int i=0;i<MAX_FILE_CHAN;++i)
    {
        if(0xFFFFFFFF != g_uiFileRecvID[i])
        {
            int iPos = 0;
            int iDLSize = 0;
            int iRet = NetClient_NetFileGetDownloadPos(g_uiFileRecvID[i],&iPos,&iDLSize);
            if(0 == iRet)
            {
                st_ConnectInfo stConnectInfo;
                NetClient_GetInfoByConnectID(g_uiFileRecvID[i],&stConnectInfo);
                printf("[NetClient_NetFileGetDownloadPos] revcID=%u,pos=%d,size=%d,file=%s \n",
                       g_uiFileRecvID[i],iPos,iDLSize,stConnectInfo.m_cDownLoadFile);
            }
        }
        else 
        {
            fprintf(stderr, "There is no file recv id\n");
        }
    }

    fprintf(stderr, "Please type interface to test:");
    
}

int Test_NetFileGetRecordState()
{
	int iChannel = 0;
    RECORD_STATE iState;
    char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_NetFileGetRecordState, number is 237\n");
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    int iRet = NetClient_NetFileGetRecordState(g_iLogonID, iChannel, &iState);
    if(0 == iRet)
    {
        fprintf(stderr, "NetFileGetRecordState is OK!\n");
		if(0 == iState)
		{
			fprintf(stderr, "Record state is REC_STOP\n");
		}
		else if(1 == iState)
		{
			fprintf(stderr, "Record state is REC_MANUAL\n");
		}
		else if(2 == iState)
		{
			fprintf(stderr, "Record state is REC_TIME\n");
		}
		else if(3 == iState)
		{
			fprintf(stderr, "Record state is REC_ALARM\n");
		}
		else
		{
			fprintf(stderr, "Other record state(%d)\n",iState);
		}
    }
    else
    {
        fprintf(stderr, "NetFileGetRecordState is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetFactoryID()
{
	char cFactory[256] = {0};

	fprintf(stderr, "You choose to test NetClient_GetFactoryID, number is 243\n");

    int iRet = NetClient_GetFactoryID(g_iLogonID, cFactory);
    if(0 == iRet)
    {
        fprintf(stderr, "GetFactoryID is OK!\n");
		fprintf(stderr, "Factory ID is %s\n", cFactory);
    }
    else
    {
        fprintf(stderr, "GetFactoryID is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetDDNSPara()
{
	char cDUserName[256] = {0};
    char cDPassword[256] = {0};
	char cDNvsName[256] = {0};
    char cDomain[256] = {0};
    int iPort = 0;
    int iDEnable = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetDDNSPara, number is 245\n");


    fprintf(stderr, "Please input DDNS user name:");
    gets_s(cDUserName, 256);
    if(0 == strcasecmp("q", cDUserName))
    {
        return -1;
    }

    fprintf(stderr, "Please input DDNS  password:");
    gets_s(cDPassword, 256);
    if(0 == strcasecmp("q", cDPassword))
    {
        return -1;
    }

	fprintf(stderr, "Please input Nvs name:");
    gets_s(cDNvsName, 256);
    if(0 == strcasecmp("q", cDNvsName))
    {
        return -1;
    }

    fprintf(stderr, "Please input domain  IP:");
    gets_s(cDomain, 256);
    if(0 == strcasecmp("q", cDomain))
    {
        return -1;
    }


    fprintf(stderr, "Please input domain  port:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iPort = to_int_def(cTemp, -1);

	fprintf(stderr,
        "Set DDNS state\n"
        "0: disabled\n"
        "1: enabled\n"
        "Please choose a number to be set:");

	memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iDEnable = to_int_def(cTemp, -1);


    int iRet = NetClient_SetDDNSPara(g_iLogonID,
									 cDUserName,
									 cDPassword,
									 cDNvsName,
									 cDomain,
									 iPort,
									 iDEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "Sending command to server is OK!\n");
    }
    else
    {
        fprintf(stderr, "Sending command to server is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetDDNSPara()
{
	char cDUserName[256] = {0};
    char cDPassword[256] = {0};
	char cDNvsName[256] = {0};
    char cDomain[256] = {0};
    int iPort = 0;
    int iDEnable = 0;

    fprintf(stderr, "You choose to test NetClient_GetDDNSPara, number is 246\n");

    int iRet = NetClient_GetDDNSPara(g_iLogonID,
									 cDUserName,
									 cDPassword,
									 cDNvsName,
									 cDomain,
									 &iPort,
									 &iDEnable);
    if(0 == iRet)
    {
        fprintf(stderr, "GetDDNSPara is OK!\n");
		fprintf(stderr, "DDNS user name is %s\n", cDUserName);
		fprintf(stderr, "DDNS  password is %s\n", cDPassword);
		fprintf(stderr, "Nvs name is %s\n", cDNvsName);
		fprintf(stderr, "Domain IP is %s\n", cDomain);
		fprintf(stderr, "Domain  port is %d\n", iPort);
		if(0 == iDEnable)
		{
			fprintf(stderr, "DDNS state is disabled\n");
		}
		else if(1 == iDEnable)
		{
			fprintf(stderr, "DDNS state is enabled\n");
		}
    }
    else
    {
        fprintf(stderr, "GetDDNSPara is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SendStringToServer()
{
	char cMsg[2048] = {0};
	int iLen = 0;
    fprintf(stderr, "You choose to test NetClient_SendStringToServer, number is 247\n");

	fprintf(stderr, "Please input data you want to send:");
	gets_s(cMsg, 2048);
	if(0 == strcasecmp("q", cMsg))
	{
		return -1;
	}
    iLen = strlen(cMsg);

    int iRet = NetClient_SendStringToServer(g_iLogonID, cMsg, iLen);
	if(0 == iRet)
    {
        fprintf(stderr, "SendStringToServer(%s) is OK!\n",cMsg);
    }
    else
    {
        fprintf(stderr, "SendStringToServer is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SendStringToCenter()
{
    char cCenterIP[16] = {0};
    char cMsg[1032] = {0}; 
    char cTemp[8] = {0};
    int iPort = 0;

    fprintf(stderr, "You choose to test NetClient_SendStringToCenter, number is 251\n");

    fprintf(stderr, "Please input center ip:");
    gets_s(cCenterIP, 16);
    if(0 == strcasecmp("q", cCenterIP))
    {
        return -1;
    }

    fprintf(stderr, "Please input center port(default port:0):");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iPort = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input message (less than 1024 characters):");
    gets_s(cMsg, 1032); 
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }

    int iRet = NetClient_SendStringToCenter(cCenterIP,iPort,cMsg,strlen(cMsg));
    if(0 == iRet)
    {
        fprintf(stderr, "SendStringToCenter is OK!\n");
    }
    else
    {
        fprintf(stderr, "SendStringToCenter is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}


int Test_StartCaptureFile()
{
	int iChannel = 0;
	int iStreamNo = 0;
	char cFileName[512] = {0};
    char cTemp[8] = {0};
    int iType = REC_FILE_TYPE_NORMAL;
    int iRet = 0;


    fprintf(stderr, "You choose to test NetClient_StartCaptureFile, number is 252\n");
	fprintf(stderr, "Please connect video before use this interface\n");

	fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNo = to_int_def(cTemp, -1);

    if(0xFFFFFFFF == g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum])
    {
        fprintf(stderr, "Please first call NetClient_StartRecv, then call NetClient_StartCaptureFile\n");
        fprintf(stderr, "Please type interface to test:");
        return 0;
    }
    
    fprintf(stderr, "Please input record file name:");
    gets_s(cFileName, 512);
    if(0 == strcasecmp("q", cFileName))
    {
        return -1;
    }

    fprintf(stderr, "Please input record type: \n"
					"0 is sdv \n"
					"1 is avi \n"
					"2 is asf \n"
					"3 is audio \n"
					"4 is aac \n"
					"5 is video \n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iType = to_int_def(cTemp, 0);           
    
    if(	 iType != REC_FILE_TYPE_NORMAL 
		 && iType != REC_FILE_TYPE_ASF
		 && iType != REC_FILE_TYPE_AVI
		 && iType != REC_FILE_TYPE_AUDIO
		 && iType != REC_FILE_TYPE_RAWAAC
		 && iType != REC_FILE_TYPE_VIDEO)
    {
        fprintf(stderr, "input record type error\n");
        fprintf(stderr, "Please type interface to test:");
        return 0;
    }
    else
    {    
        iRet = NetClient_StartCaptureFile(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum], cFileName, iType);     

        if(0 == iRet)
        {
            fprintf(stderr, "StartCaptureFile is OK!\n");
        }
        else
        {
            fprintf(stderr, "StartCaptureFile is failed! Return value is %d\n", iRet);
        }
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}
                                                                                                                   
int Test_StopCaptureFile()
{
	int iChannel = 0;
	int iStreamNo = 0;
    char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_StopCaptureFile, number is 253\n");

	fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNo = to_int_def(cTemp, -1);

    if(0xFFFFFFFF == g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum])
    {
        fprintf(stderr, "Please first call NetClient_StartRecv, then call NetClient_StopCaptureFile\n");
        return 0;
    } 

    int iRet = NetClient_StopCaptureFile(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum]);
    if(0 == iRet)
    {
        fprintf(stderr, "StopCaptureFile is OK!\n");
    }
    else
    {
        fprintf(stderr, "StopCaptureFile is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
	return 0;

}
                                                                                                                     
int Test_GetCaptureStatus()
{
	int iChannel = 0;
	int iStreamNo = 0;
    char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_GetCaptureStatus, number is 254\n");

	fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNo = to_int_def(cTemp, -1);

    if(0xFFFFFFFF == g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum])
    {
        fprintf(stderr, "Please first call NetClient_StartRecv, then call NetClient_GetCaptureStatus\n");
        return 0;
    } 

    int iRet = NetClient_GetCaptureStatus(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum]);
    if(0 == iRet)
    {
        fprintf(stderr, "Not record!\n");
    }
    else if(1 == iRet)
    {
        fprintf(stderr, "Recording!\n");
    }
    else
    {
        fprintf(stderr, "NetClient_GetCaptureStatus is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
	return 0;
}

int Test_StartCaptureData()
{
	int iChannel = 0;
	int iStreamNo = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_StartCaptureData, number is 255\n");

	fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNo = to_int_def(cTemp, -1);


    if(0xFFFFFFFF == g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum])
    {
        fprintf(stderr, "Please first call NetClient_StartRecv, then call NetClient_StartCaptureData\n");
    }   
    else
    {    
        int iRet = NetClient_StartCaptureData(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum]);     

        if(0 == iRet)
        {
            fprintf(stderr, "StartCaptureData is OK!\n");
        }
        else
        {
            fprintf(stderr, "StartCaptureData is failed!\n");
        }
    }

    fprintf(stderr, "Please type interface to test:");
	return 0;

}

int Test_StopCaptureData()
{
	int iChannel = 0;
	int iStreamNo = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_StopCaptureData, number is 256\n");

	fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNo = to_int_def(cTemp, -1);

    if(0xFFFFFFFF == g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum])
    {
        fprintf(stderr, "Please first call NetClient_StartRecv, then call NetClient_StopCaptureData\n");
    }   
    else
    {    
        int iRet = NetClient_StopCaptureData(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum]);     

        if(0 == iRet)
        {
            fprintf(stderr, "StopCaptureData is OK!\n");
        }
        else
        {
            fprintf(stderr, "StopCaptureData is failed!\n");
        }
    }

    fprintf(stderr, "Please type interface to test:");

	return 0;
}

int Test_GetVideoHeader()
{
    unsigned char ucHeader[128] = {0};
	int iChannel = 0;
	int iStreamNo = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_GetVideoHeader, number is 257\n");

	fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNo = to_int_def(cTemp, -1);

    if(0xFFFFFFFF == g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum])
    {
        fprintf(stderr, "Please first call NetClient_StartRecv, then call NetClient_GetVideoHeader\n");
    }   
    else
    {    
        int iRet = NetClient_GetVideoHeader(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum], ucHeader);     

        if(iRet >= 0)
        {
            fprintf(stderr, "StopCaptureData is OK!\n");
            fprintf(stderr, "Video header is %s!\n", ucHeader);
        }
        else
        {
            fprintf(stderr, "StopCaptureData is failed!\n");
        }
    }

    fprintf(stderr, "Please type interface to test:");

	return 0;
}

int Test_SetRawFrameCallBack()
{
	int iChannel = 0;
	int iStreamNo = 0;
    char cTemp[8] = {0};

    fprintf(stderr, "You choose to test NetClient_SetRawFrameCallBack, number is 258\n");

	fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNo = to_int_def(cTemp, -1);

    if(0xFFFFFFFF == g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum])
    {
        fprintf(stderr, "Please first call NetClient_StartRecv, then call NetClient_SetRawFrameCallBack\n");
    }   
    else
    {    
        int iRet = NetClient_SetRawFrameCallBack(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum], RawFrame_Notify, (void*)0x12345678);     

        if(0 == iRet)
        {
            fprintf(stderr, "SetRawFrameCallBack is OK!\n");
        }
        else
        {
            fprintf(stderr, "SetRawFrameCallBack is failed!\n");
        }
    }

    //fprintf(stderr, "Please type interface to test:");
	return 0;
}

int Test_SetFullStreamNotify()
{
	int iChannel = 0;
	int iStreamNo = 0;
    char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_SetFullStreamNotify, number is 259\n");

	fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNo = to_int_def(cTemp, -1);

    if(0xFFFFFFFF == g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum])
    {
        fprintf(stderr, "Please first call NetClient_StartRecv, then call NetClient_SetFullStreamNotify\n");
    }   
    else
    {    
        int iRet = NetClient_SetFullStreamNotify(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum], FullStream_Notify);     

        if(0 == iRet)
        {
            fprintf(stderr, "SetFullStreamNotify is OK!\n");
        }
        else
        {
            fprintf(stderr, "SetFullStreamNotify is failed!\n");
        }
    }

    //fprintf(stderr, "Please type interface to test:");
	return 0;
}

int Test_GetRecvID()
{
	int iChannel = 0;
	int iStreamNo = 0;
    char cTemp[8] = {0};
	
	fprintf(stderr, "You choose to test NetClient_GetRecvID, number is 260\n");
	
	fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);
	
	
	fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iStreamNo = to_int_def(cTemp, -1);

	unsigned int uiRecvID = NetClient_GetRecvID(g_iLogonID, iChannel, iStreamNo);
	if(uiRecvID >= 0)
	{
		fprintf(stderr, "GetRecvID is successful, recvID = %d\n", uiRecvID);
	}
	else
	{
		fprintf(stderr, "GetRecvID is failed\n");
	}

	fprintf(stderr, "Please type interface to test:");
	return 0;

}

int Test_GetInfoByConnectID()
{
    int iRecvID = 0;
    char cTemp[8] = {0};
    st_ConnectInfo cntInfo;
    memset(&cntInfo, 0, sizeof(cntInfo));

    fprintf(stderr, "You choose to test NetClient_GetInfoByConnectID, number is 261\n");
	
	fprintf(stderr, "Please input recvID:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iRecvID = to_int_def(cTemp, 0);

    int iRet = NetClient_GetInfoByConnectID((unsigned int)iRecvID, &cntInfo);
    if(0 == iRet)
    {
        fprintf(stderr, "GetInfoByConnectID is OK!\n");
        fprintf(stderr, "Device id is %s\n", cntInfo.m_cDeviceID);
        fprintf(stderr, "Device ip is %s\n", cntInfo.m_cIP);
        fprintf(stderr, "Channel number is %d\n", cntInfo.m_iChannel);
        fprintf(stderr, "Download file is %s\n", cntInfo.m_cDownLoadFile);
        fprintf(stderr, "Logon id is %d\n", cntInfo.m_iLogonID);
        fprintf(stderr, "Draw index is %d\n", cntInfo.m_iDrawIndex);
        if(0 == cntInfo.m_iStreamNO)
        {
            fprintf(stderr, "Stream type is main stream\n");
        }
        else
        {
            fprintf(stderr, "Stream type is substream\n");
        }
    }
    else
    {
        fprintf(stderr, "GetInfoByConnectID is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");

    return 0;
    
}

int Test_NetLogQuery()
{
	char cTemp[256] = {0};
	NVS_LOG_QUERY logQuery;
	memset(&logQuery, 0, sizeof(logQuery));

	fprintf(stderr, "You choose to test NetClient_NetLogQuery, number is 235\n");


	fprintf(stderr, "Please input channel number or inpurt 'all':");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	else if(0 == strcasecmp("all", cTemp))
	{
		logQuery.iChannelNo = 0xFF;
	}
	else
	{
		logQuery.iChannelNo = to_int_def(cTemp, 0);
	}


    fprintf(stderr,
        "Set file type:\n"
        "0: System Log\n"
        "1: Warning\n"
        "2: Alarm\n"
		"3: Operation\n"
		"4: User\n"
		"5: Other\n"
		"255: All\n"
        "Please choose a number to be set:");
	memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	else if(0 == strcasecmp("255", cTemp))
	{
		logQuery.iLogType = 0xFF;
	}
	else
	{
		logQuery.iLogType = to_int_def(cTemp, 0);
	}

	fprintf(stderr,
        "Set language:\n"
        "0: English\n"
        "1: Chinese\n"
		"2: Chinese-Taiwan\n"
		"3: Korean\n"
		"4: Spanish-Ecuador\n"
		"5: Italian-Italy\n"
        "Please choose a number to be set:");
	memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	logQuery.iLanguage = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input page number:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	logQuery.iPageNo = to_int_def(cTemp, 0);

	logQuery.iPageSize = MAX_PAGE_LOG_SIZE;

    fprintf(stderr, "Please input start time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	unsigned short iYear = 0;   
    unsigned short iMonth = 0;  
    unsigned short iDay = 0;    
    unsigned short iHour = 0;   
    unsigned short iMinute = 0; 
    unsigned short iSecond = 0;

	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		   &iYear,
		   &iMonth,
		   &iDay,
		   &iHour,
		   &iMinute,
		   &iSecond);


	logQuery.struStartTime.iYear = iYear;
	logQuery.struStartTime.iMonth = iMonth;
	logQuery.struStartTime.iDay = iDay;
	logQuery.struStartTime.iHour = iHour;
	logQuery.struStartTime.iMinute = iMinute;
	logQuery.struStartTime.iSecond = iSecond;
	

    fprintf(stderr, "Please input stop time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	unsigned short uYear = 0;   
    unsigned short uMonth = 0;  
    unsigned short uDay = 0;    
    unsigned short uHour = 0;   
    unsigned short uMinute = 0; 
    unsigned short uSecond = 0;

	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		   &uYear,
		   &uMonth,
		   &uDay,
		   &uHour,
		   &uMinute,
		   &uSecond);

	logQuery.struStopTime.iYear = uYear;
	logQuery.struStopTime.iMonth = uMonth;
	logQuery.struStopTime.iDay = uDay;
	logQuery.struStopTime.iHour = uHour;
	logQuery.struStopTime.iMinute = uMinute;
	logQuery.struStopTime.iSecond = uSecond;

	g_iLanguage = logQuery.iLanguage;
	int iRet = NetClient_NetLogQuery(g_iLogonID, &logQuery);
	if(0 == iRet)
	{
		fprintf(stderr, "Send command is successful\n");
	}
	else
	{
		fprintf(stderr, "Send command is failed\n");
	}

	return 0;
}

void Test_GetNTPInfo()
{
	char cNTPServer[32] = {0};
	unsigned short iPort = 0;
	int iInterval = 0;

	fprintf(stderr, "You choose to test NetClient_GetNTPInfo, number is 263\n");

	int iRet = NetClient_GetNTPInfo(g_iLogonID, cNTPServer, &iPort, &iInterval);
	if(0 == iRet)
	{
		fprintf(stderr, "NetClient_GetNTPInfo is successful\n");
		fprintf(stderr, "NTPServer is %s\n", cNTPServer);
		fprintf(stderr, "Port is %d\n", iPort);
		fprintf(stderr, "iInterval is %d\n", iInterval);
	}
	else
	{
		fprintf(stderr, "NetClient_GetNTPInfo is failed\n");
	}

	fprintf(stderr, "Please type interface to test:");
}

int Test_SetNTPInfo()
{
	char cNTPServer[32] = {0};
	unsigned short iPort = 0;
	int iInterval = 0;	

	fprintf(stderr, "You choose to test NetClient_SetNTPInfo, number is 264\n");

	fprintf(stderr, "Please input NTP server ip:");
	gets_s(cNTPServer, 32);
	if(0 == strcasecmp("q", cNTPServer))
	{
		return -1;
	}

	fprintf(stderr, "Please input NTP server port:");
	iPort = (unsigned short)SafeGetInt();

	fprintf(stderr, "Please input interval:");
	iInterval = (unsigned short)SafeGetInt();

	int iRet = NetClient_SetNTPInfo(g_iLogonID, cNTPServer, iPort, iInterval);
	if(0 == iRet)
	{
		fprintf(stderr, "Send command is successful\n");
	}
	else
	{
		fprintf(stderr, "Send command is is failed\n");
	}
	
	fprintf(stderr, "Please type interface to test:");

	return 0;

}


int Test_NetFileDownloadByTimeSpanEx()
{
	int iChannel = 0; 
    char cTemp[256] = {0};
	NVS_FILE_TIME timeBegin;
	memset(&timeBegin, 0, sizeof(timeBegin));
	NVS_FILE_TIME timeEnd;   
	memset(&timeEnd, 0, sizeof(timeEnd));

	fprintf(stderr, "You choose to test NetClient_NetFileDownloadByTimeSpanEx, number is 265\n");

	fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input start time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	unsigned short iYear = 0;   
    unsigned short iMonth = 0;  
    unsigned short iDay = 0;    
    unsigned short iHour = 0;   
    unsigned short iMinute = 0; 
    unsigned short iSecond = 0;

	
	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		   &iYear,
		   &iMonth,
		   &iDay,
		   &iHour,
		   &iMinute,
		   &iSecond);

	timeBegin.iYear = iYear;
	timeBegin.iMonth = iMonth;
	timeBegin.iDay = iDay;
	timeBegin.iHour = iHour;
	timeBegin.iMinute = iMinute;
	timeBegin.iSecond = iSecond;
	

    fprintf(stderr, "Please input stop time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	iYear = 0;   
    iMonth = 0;  
    iDay = 0;    
    iHour = 0;   
    iMinute = 0; 
    iSecond = 0;

	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		   &iYear,
		   &iMonth,
		   &iDay,
		   &iHour,
		   &iMinute,
		   &iSecond);

	timeEnd.iYear = iYear;
	timeEnd.iMonth = iMonth;
	timeEnd.iDay = iDay;
	timeEnd.iHour = iHour;
	timeEnd.iMinute = iMinute;
	timeEnd.iSecond = iSecond;


	unsigned int iRecvContext = 0xFFFFFFFF;
	char cLocal[512] = {0};
	sprintf(cLocal,"/root/download_by_time_span.sdv");
	int iRet = NetClient_NetFileDownloadByTimeSpanEx(&iRecvContext,
													 g_iLogonID,
													 cLocal,
													 iChannel,
													 &timeBegin,
													 &timeEnd,
													 0,
													 -1,
													 1);


	if(0 == iRet)
		fprintf(stderr, "NetFileDownloadByTimeSpanEx is successful\n");
	else
		fprintf(stderr, "NetFileDownloadByTimeSpanEx is fail\n");

    fprintf(stderr, "Please type other interface to test:");
    g_uiNetFileID = iRecvContext;
    return 0;

}


int Test_NetFileDownloadByTimeSpanCallBack()
{
	int iChannel = 0; 
    char cTemp[256] = {0};
	NVS_FILE_TIME timeBegin;
	memset(&timeBegin, 0, sizeof(timeBegin));
	NVS_FILE_TIME timeEnd;   
	memset(&timeEnd, 0, sizeof(timeEnd));

	fprintf(stderr, "You choose to test NetClient_NetFileDownloadByTimeSpanCallBack, number is 266\n");

	fprintf(stderr, "Please input channel number:");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input start time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;

	unsigned short iYear = 0;   
    unsigned short iMonth = 0;  
    unsigned short iDay = 0;    
    unsigned short iHour = 0;   
    unsigned short iMinute = 0; 
    unsigned short iSecond = 0;

	
	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		   &iYear,
		   &iMonth,
		   &iDay,
		   &iHour,
		   &iMinute,
		   &iSecond);

	timeBegin.iYear = iYear;
	timeBegin.iMonth = iMonth;
	timeBegin.iDay = iDay;
	timeBegin.iHour = iHour;
	timeBegin.iMinute = iMinute;
	timeBegin.iSecond = iSecond;
	

    fprintf(stderr, "Please input stop time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	iYear = 0;   
    iMonth = 0;  
    iDay = 0;    
    iHour = 0;   
    iMinute = 0; 
    iSecond = 0;

	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		   &iYear,
		   &iMonth,
		   &iDay,
		   &iHour,
		   &iMinute,
		   &iSecond);

	timeEnd.iYear = iYear;
	timeEnd.iMonth = iMonth;
	timeEnd.iDay = iDay;
	timeEnd.iHour = iHour;
	timeEnd.iMinute = iMinute;
	timeEnd.iSecond = iSecond;


	unsigned int iRecvContext = 0xFFFFFFFF;
	char cLocal[512] = {0};
	sprintf(cLocal,"/root/download_by_time_span_callback.sdv");
	int iRet = NetClient_NetFileDownloadByTimeSpanCallBack(&iRecvContext,
														   g_iLogonID,
														   cLocal,
														   iChannel,
														   &timeBegin,
														   &timeEnd,
														   NVSDATA_Notify,
														   0,
														   -1,
														   1,
														   NULL
														   );


	if(0 == iRet)
		fprintf(stderr, "NetClient_NetFileDownloadByTimeSpanCallBack is successful\n");
	else
		fprintf(stderr, "NetClient_NetFileDownloadByTimeSpanCallBack is fail\n");

    fprintf(stderr, "Please type other interface to test:");
    return 0;

}

//Test CD Burn
int Test_SetCDBurnConfig()
{
    fprintf(stderr, "You choose to test NetClient_SetCDBurnConfig, number is 267\n");

    char cTemp[256] = {0};
	fprintf(stderr, "Please choose operation:1-Start 2-Stop 3-Set Mode\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iOp = to_int_def(cTemp);
    if(iOp <=0 || iOp > 3)
    {
        fprintf(stderr, "Wrong number!");
        return -1;
    }
    
    TCDBurnPolicy pol = {0};
    int iRet = -1;

    int iCount = 0;
    iRet = NetClient_GetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_GET_CDROMCOUNT, &iCount, sizeof(int));
    if(iRet >= 0)
        fprintf(stderr, "CDRomCount: %d\n", iCount);
    else
    {
        fprintf(stderr, "Get CDRom count failed!\n");
        return -1;
    }

    fprintf(stderr, "Please choose cdrom id to set config, no :\n");
    gets_s(cTemp, 256);
    int iID = to_int_def(cTemp);
    if(0 == strcasecmp("q", cTemp))
        return -1;

    switch(iOp)
    {
    case 1:
        {
			TCBurnStopMode tcBurnStopMode = {0};
			tcBurnStopMode.iDeviceNum = iID;

			fprintf(stderr, "Please input FlagByBits:\n");
			gets_s(cTemp, 256);
			if(0 == strcasecmp("q", cTemp))
				return -1;
			tcBurnStopMode.iFlagByBits = to_int_def(cTemp);

            iRet = NetClient_SetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_SET_START, &tcBurnStopMode, sizeof(TCBurnStopMode)); 
            break;
        }
    case 2:
        {
			TCBurnStopMode tcBurnStopMode = {0};
			tcBurnStopMode.iDeviceNum = iID;

			fprintf(stderr, "Please input FlagByBits:\n");
			gets_s(cTemp, 256);
			if(0 == strcasecmp("q", cTemp))
				return -1;
			tcBurnStopMode.iFlagByBits = to_int_def(cTemp);

            iRet = NetClient_SetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_SET_STOP, &tcBurnStopMode, sizeof(TCBurnStopMode)); 
            break;
        }
    case 3:
        {
            fprintf(stderr, "Select mode 0--Sigle,1--Mutli,2--Loop!\n");
            gets_s(cTemp, 256);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            int iMode = to_int_def(cTemp);
            pol.iMode = iMode;

            fprintf(stderr, "Please input device bits\n");
            gets_s(cTemp, 256);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            int iDeviceBits = to_int_def(cTemp);

            fprintf(stderr, "Please input channel bits\n");
            gets_s(cTemp, 256);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            int iChannelBits = to_int_def(cTemp);

            if(pol.iMode == 0)
            {
                pol.iCDRomID = iID;
                if(pol.iCDRomID < 0)
                {
                    return -1;
                }
                
                int iTemp = 1 << pol.iCDRomID;
                if(iTemp != iDeviceBits)
                {
                    fprintf(stderr, "DeviceBits is invalid!\n");
                    iDeviceBits = iTemp;
                }
            }
            pol.iDeviceBits[0] = iDeviceBits;
            pol.iChannelBits[0] = iChannelBits;

			fprintf(stderr, "Please input disk type(0:auto test 1:DVD 2:BLUE)\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
				return -1;
			pol.iDiskType = to_int_def(cTemp);

			fprintf(stderr, "Please input burn speed(4,6,8,16)\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
				return -1;
			pol.iBurnSpeed = to_int_def(cTemp);
			
			fprintf(stderr, "Please input burn hour\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
				return -1;
			pol.iBurnHour = to_int_def(cTemp);
			
			fprintf(stderr, "Please input reserve space\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
				return -1;
			pol.iResSpace = to_int_def(cTemp);

			fprintf(stderr, "Please input DVD Name\n");
			gets_s(cTemp, MAX_DVDNAME_LEN+1);
			if(0 == strcasecmp("q", cTemp))
				return -1;
			u2g(cTemp,strlen(cTemp)+1,pol.cDVDName,sizeof(pol.cDVDName));

            iRet = NetClient_SetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_SET_MODE, &pol, sizeof(TCDBurnPolicy));
            break;
        }
    }

    if(iRet < 0)
        fprintf(stderr, "SetCDBurnConfig failed!\n");
    else
        fprintf(stderr, "SetCDBurnConfig success!\n");

    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return iRet;
}

int Test_GetCDBurnConfig()
{
    fprintf(stderr, "You choose to test NetClient_GetCDBurnConfig, number is 268\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please choose the para which you will get:1-Mode, 2-CDRomList, 3-CDRomCount, 4-Status\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iOp = to_int_def(cTemp);
    if(iOp <=0 || iOp > 4)
    {
        fprintf(stderr, "Wrong number!");
        return -1;
    }
    

    int iRet = -1;
    switch (iOp)
    {
    case 1:
        {
            fprintf(stderr, "Please choose cdrom id, no :\n");
            gets_s(cTemp, 256);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            int iID = to_int_def(cTemp);

            TCDBurnPolicy tBp = {0};
            tBp.iCDRomID = iID;
            iRet = NetClient_GetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_GET_MODE, &tBp, sizeof(TCDBurnPolicy));
            if(iRet >= 0)
            {
				g2u(tBp.cDVDName,strlen(tBp.cDVDName)+1,cTemp,256);
				fprintf(stderr, "Mode: %d\nChannelBits: %d\nDeviceBits: %d\nDiskType:%d\nBurnSpeed:%d\nBurnHour:%d\nResSpace:%d\nDVDName:%s\n"
					 , tBp.iMode, tBp.iChannelBits[0], tBp.iDeviceBits[0],tBp.iDiskType,tBp.iBurnSpeed
					 ,tBp.iBurnHour,tBp.iResSpace,cTemp);
            }
        }
        break;
    case 2:
        {
            int iList = 0;
            iRet = NetClient_GetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_GET_CDROMLIST, &iList, sizeof(int));
            if(iRet >= 0)
            {
                fprintf(stderr, "CDRomList: %d\n", iList);
            }
        }
        break;
    case 3:
        {
            int iCount = 0;
            iRet = NetClient_GetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_GET_CDROMCOUNT, &iCount, sizeof(int));
            if(iRet >= 0)
            {
                fprintf(stderr, "CDRomCount: %d\n", iCount);
            }
        }
        break;
    case 4:
        {
            fprintf(stderr, "Please choose cdrom id, no :\n");
            gets_s(cTemp, 256);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            int iID = to_int_def(cTemp);

            TCDBurnStatus tBs = {0};
            tBs.iCDRomID = iID;
            iRet = NetClient_GetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_GET_STATUS, &tBs, sizeof(TCDBurnStatus));
            if(iRet >= 0)
            {
                fprintf(stderr, "Status: %d.\n Total space: %lu.\n Free space: %lu.\n Reserved: %s.\n", 
                        tBs.iState, tBs.ulTotal, tBs.ulFree, tBs.cReserved);
            }
        }
        break;
    }
    if(iRet < 0)
    {
        fprintf(stderr, "GetCDBurnConfig failed!\n");
    }
    else
    {
        fprintf(stderr, "GetCDBurnConfig success!\n");
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

//Test En/Decrpt 
int Test_SetVideoEncrypt()
{
    fprintf(stderr, "You choose to test NetClient_SetVideoEncrypt, number is 269\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iChan = to_int_def(cTemp);

    fprintf(stderr, "Please input encrypt type: 0-no encrypt, 1-AES\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iType = to_int_def(cTemp);

    fprintf(stderr, "Please input password: (max len = 16)\n");
    gets_s(cTemp, 256);
    if(strlen(cTemp) > 16)
    {
        fprintf(stderr, "Password is too long.\n");
        return 0;
    }
    if(0 == strcasecmp("q", cTemp))
        return -1;
    char cPwd[17] = {0};
    strcpy(cPwd, cTemp);
    
    //call interface
    TVideoEncrypt pVE = {0};
    pVE.iChannel = iChan;
    pVE.iType = iType;
    strcpy(pVE.cPassword, cPwd);

    int iRet = NetClient_SetVideoEncrypt(g_iLogonID, iChan, &pVE, sizeof(TVideoEncrypt));
    if(iRet < 0)
        fprintf(stderr, "SetVideoEncrypt failed, ret = %d, err = 0x%08x\n", iRet, errno);
    else
        fprintf(stderr, "SetVideoEncrypt success!\n");

    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

int Test_GetVideoEncrypt()
{
    fprintf(stderr, "You choose to test NetClient_GetVideoEncrypt, number is 270\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iChan = to_int_def(cTemp);
    fprintf(stderr, "Input %d\n", iChan);

    //call interface
    TVideoEncrypt tVE = {0};
    tVE.iChannel = iChan;

    int iRet = NetClient_GetVideoEncrypt(g_iLogonID, iChan, &tVE, sizeof(TVideoEncrypt));

    if(iRet < 0)
    {
        fprintf(stderr, "GetVideoEncrypt failed!\n");
    }
    else
    {
        fprintf(stderr, "Type = %d, Pwd = %s\n", tVE.iType, tVE.cPassword);
        fprintf(stderr, "GetVideoEncrypt success!\n");
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

int Test_SetVideoDecrypt()
{
    fprintf(stderr, "You choose to test NetClient_SetVideoDecrypt, number is 271\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iChan = to_int_def(cTemp);

    fprintf(stderr, "Please input password: (max len = 16)\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    if(strlen(cTemp) > 16)
    {
        fprintf(stderr, "Password is too long.\n");
        return 0;
    }
    char cPwd[17] = {0};
    strcpy(cPwd, cTemp);

    //call interface
    TVideoDecrypt tVD = {0};
    tVD.iChannel = iChan;
    strcpy(tVD.cDecryptKey, cPwd);

    int iRet = NetClient_SetVideoDecrypt(g_iLogonID, iChan, &tVD, sizeof(TVideoDecrypt));
    if(iRet < 0)
    {
        fprintf(stderr, "SetVideoDecrypt failed, err = 0x%08x.\n", errno);
    }
    else
    {
        fprintf(stderr, "SetVideoDecrypt success!\n");
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

int Test_GetVideoDecrypt()
{
    fprintf(stderr, "You choose to test NetClient_GetVideoDecrypt, number is 272\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iChan = to_int_def(cTemp);

    TVideoDecrypt tVD = {0};
    tVD.iChannel = iChan;
    int iRet = NetClient_GetVideoDecrypt(g_iLogonID, iChan, &tVD, sizeof(TVideoDecrypt));

    if(iRet < 0)
    {
        fprintf(stderr, "GetVideoDecrypt failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Pwd = %s\n", tVD.cDecryptKey);
        fprintf(stderr, "GetVideoDecrypt success!\n");
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

int Test_SetPreRecEnable()
{
    fprintf(stderr, "You choose to test NetClient_SetPreRecEnable, number is 273\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iChan = to_int_def(cTemp);

    fprintf(stderr, "Please set enable :0-disable, 1-enable\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iEnable = to_int_def(cTemp);

    int iRet = NetClient_SetPreRecEnable(g_iLogonID, iChan, iEnable);
    if(iRet < 0)
    {
        fprintf(stderr, "SetPreRecEnable failed! return %d, errno = %d\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "SetPreRecEnable success!\n");
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

int Test_GetPreRecEnable()
{
    fprintf(stderr, "You choose to test NetClient_GetPreRecEnable, number is 274\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iChan = to_int_def(cTemp);

    int iEnable = 0;
    int iRet = NetClient_GetPreRecEnable(g_iLogonID, iChan, &iEnable);
    if(iRet < 0)
    {
        fprintf(stderr, "GetPreRecEnable failed! return %d, errno = %d\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "GetPreRecEnable success!Enable = %d\n", iEnable);
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

int Test_SetVideoCombine()
{
    fprintf(stderr, "You choose to test NetClient_SetVideoCombine, number is 275\n");

    char cTemp[256] = {0};
	fprintf(stderr, "Please choose setting type:\n");
	fprintf(stderr, "0:mix picture:\n");
	fprintf(stderr, "1:mix audio:\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iType = to_int_def(cTemp);
	if (iType == 0)
	{
    fprintf(stderr, "Please input picture num :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iPicNum = to_int_def(cTemp);

		fprintf(stderr, "Please input layout mode :\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		int iLayMode = to_int_def(cTemp);

		fprintf(stderr, "Please input combine channel no :(eg: 1:3:4)\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;

		TVideoCombine vc;
		vc.iPicNum = iPicNum;
		vc.iRec = iLayMode;
		strcpy(vc.cChannelID, cTemp);
		int iRet = NetClient_SetVideoCombine(g_iLogonID, &vc, sizeof(vc));
		if(iRet < 0)
		{
			fprintf(stderr, "SetVideoCombine failed! return %d, errno = %d\n", iRet, errno);
		}
		else
		{
			fprintf(stderr, "SetVideoCombine success!\n");
		}
	}
	else if (iType == 1)
	{
		fprintf(stderr, "Please input mix audio enable num:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		int iEnable = to_int_def(cTemp);

		fprintf(stderr, "Please input generate channel No:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		int iFinChannel = to_int_def(cTemp);

		fprintf(stderr, "Please input combine channel no :(eg: 1:3:4):\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;

		TAudioMix mix = {0};
		mix.iEnable = iEnable;
		mix.iChannel = iFinChannel;
		strcpy(mix.cMixChannels, cTemp);
		int iRet = NetClient_SetVideoCombine(g_iLogonID, &mix, sizeof(mix));
		if(iRet < 0)
		{
			fprintf(stderr, "SetVideoCombine failed! return %d, errno = %d\n", iRet, errno);
		}
		else
		{
			fprintf(stderr, "SetVideoCombine success!\n");
		}
	}
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

int Test_GetVideoCombine()
{
    fprintf(stderr, "You choose to test NetClient_GetVideoCombine, number is 276\n");
	char cTemp[256] = {0};
	fprintf(stderr, "Please choose setting type:\n");
	fprintf(stderr, "0:mix picture:\n");
	fprintf(stderr, "1:mix audio:\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iType = to_int_def(cTemp);
	if (iType == 0)
	{
    TVideoCombine vc;
    memset(&vc, 0, sizeof(TVideoCombine));
    int iRet = NetClient_GetVideoCombine(g_iLogonID, &vc, sizeof(vc));
    if(iRet < 0)
    {
        fprintf(stderr, "GetVideoCombine failed! return %d, errno = %d\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "GetVideoCombine success! Result\n");
        fprintf(stderr, "PicNum: %d, Layout Mode: %d, Channel list: %s\n", vc.iPicNum, vc.iRec, vc.cChannelID);
    }
	}
	else if (iType == 1)
	{
		TAudioMix mix = {0};
		memset(&mix, 0, sizeof(TAudioMix));
		int iRet = NetClient_GetVideoCombine(g_iLogonID, &mix, sizeof(mix));
		if(iRet < 0)
		{
			fprintf(stderr, "GetVideoCombine failed! return %d, errno = %d\n", iRet, errno);
		}
		else
		{
			fprintf(stderr, "GetVideoCombine success! Result\n");
			fprintf(stderr, "mix audio enable num: %d\ngenerate channel: %d\nChannel list: %s\n", mix.iEnable, mix.iChannel, mix.cMixChannels );
		}
	}
   
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

int Test_SetMixAudio()
{
    fprintf(stderr, "You choose to test SetMixAudio, number is 354\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input iEnable num :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iEnable = to_int_def(cTemp);

    fprintf(stderr, "Please input iChannel num :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iChannel = to_int_def(cTemp);

    fprintf(stderr, "Please input Mix channel no :(eg: 1:3:4)\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    

    TAudioMix mix = {0};
    mix.iEnable = iEnable;
    mix.iChannel = iChannel;
    strcpy(mix.cMixChannels, cTemp);
    int iRet = NetClient_SetVideoCombine(g_iLogonID, &mix, sizeof(mix));
    if(iRet < 0)
    {
        fprintf(stderr, "SetMixAudio failed! return %d, errno = %d\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "SetMixAudio success!\n");
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

int Test_GetMixAudio()
{
    fprintf(stderr, "You choose to test Get Audio mix, number is 355\n");

	TAudioMix Mix;
    memset(&Mix, 0, sizeof(TAudioMix));
	fprintf(stderr, "Please input iChannel num :\n");

	char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iChannel = to_int_def(cTemp);

	Mix.iChannel = iChannel;
    int iRet = NetClient_GetVideoCombine(g_iLogonID, &Mix, sizeof(Mix));
    if(iRet < 0)
    {
        fprintf(stderr, "GetAudioMix failed! return %d, errno = %d\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "GetAudioMixsuccess! Result\n");
        fprintf(stderr, "GetAudioMix, Enable: %d, Channel list: %s\n", Mix.iEnable, Mix.cMixChannels);
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

int Test_CaptureBmpPic()
{
    fprintf(stderr, "You choose to test NetClient_CaptureBmpPic, number is 277\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iChan = to_int_def(cTemp);

    fprintf(stderr, "Please input bmp file name :(default:/root/1.bmp)\n");
    char cBmpName[256] = "/root/1.bmp";
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    if(0 != strcasecmp("", cTemp))
        strcpy(cBmpName, cTemp);

    int iRet = NetClient_CaptureBmpPic(g_uiRecv[iChan], cBmpName);
    if(iRet < 0)
    {
        fprintf(stderr, "CaptureBmpPic failed, err = 0x%08x\n", errno);
    }
    else
    {
        fprintf(stderr, "CaptureBmpPic success, size = %d\n", iRet);
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;

}

int Test_SetEmailAlarmEx()
{
    fprintf(stderr, "You choose to test NetClient_SetEmailAlarmEx, number is 278\n");
    SMTP_INFOEX smtpEx;
    memset(&smtpEx, 0, sizeof(smtpEx));
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the smtpserver:");
    gets_s(smtpEx.smtpInfo.cSmtpServer, 32);
    if(0 == strcasecmp("q", smtpEx.smtpInfo.cSmtpServer))
        return -1;

    fprintf(stderr, "Please input the port of smtpserver:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 160);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    smtpEx.smtpInfo.wdSmtpPort = to_int_def(cTemp);
    
    fprintf(stderr, "Please input the name of the EamailAccount:");
    gets_s(smtpEx.smtpInfo.cEmailAccount, 160);
    if(0 == strcasecmp("q", smtpEx.smtpInfo.cEmailAccount))
        return -1;

    fprintf(stderr, "Please input the password of the EamailAccount:");
    gets_s(smtpEx.smtpInfo.cEmailPassword, 160);
    if(0 == strcasecmp("q", smtpEx.smtpInfo.cEmailPassword))
        return -1;
    
    fprintf(stderr, "Please input the Authtype of smtpserver:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
       return -1;
    smtpEx.smtpInfo.iAuthtype = to_int_def(cTemp);

    fprintf(stderr, "Please input the EmailAddress:");
    gets_s(smtpEx.smtpInfo.cEmailAddress, 32);
    if(0 == strcasecmp("q", smtpEx.smtpInfo.cEmailAddress))
        return -1;

    fprintf(stderr, "Please input the MailSubject:");
    gets_s(smtpEx.smtpInfo.cMailSubject, 32);
    if(0 == strcasecmp("q", smtpEx.smtpInfo.cMailSubject))
        return -1;
    
    fprintf(stderr, "Please input the MailAddress0:");
    gets_s(smtpEx.cMailAddr[0], 32);
    if(0 == strcasecmp("q", smtpEx.cMailAddr[0]))
        return -1;

    fprintf(stderr, "Please input the MailAddress1:");
    gets_s(smtpEx.cMailAddr[1], 32);
    if(0 == strcasecmp("q", smtpEx.cMailAddr[1]))
        return -1;

    fprintf(stderr, "Please input the MailAddress2:");
    gets_s(smtpEx.cMailAddr[2], 32);
    if(0 == strcasecmp("q", smtpEx.cMailAddr[2]))
        return -1;

    fprintf(stderr, "which function do you want to Exec:\n 0:NetClient_SetEmailAlarmEx \n 1:NetClient_SetEmailAlarm\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iSize = 0;
    if (to_int_def(cTemp) == 0)
        iSize = sizeof(SMTP_INFOEX);
    else
        iSize = sizeof(SMTP_INFO);


    int iRet = NetClient_SetEmailAlarmEx(g_iLogonID, (PSMTP_INFO)(&smtpEx), iSize);
    if(iRet < 0)
    {
        fprintf(stderr, "SetEmailAlarmEx failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "SetEmailAlarmEx success! Result\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_GetEmailAlarmEx()
{
    fprintf(stderr, "You choose to test NetClient_GetEmailAlarmEx, number is 279\n");
    SMTP_INFOEX smtpEx;
    memset(&smtpEx, 0, sizeof(smtpEx));
    char cTemp[256] = {0};
    fprintf(stderr, "which function do you want to Exec:\n 0:NetClient_GetEmailAlarmEx \n 1:NetClient_GetEmailAlarm\n");
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
        return -1;

    int iSize = 0;
    int iGet = to_int_def(cTemp);
    if (iGet == 0)
        iSize = sizeof(SMTP_INFOEX);
    else
        iSize = sizeof(SMTP_INFO);

    int iRet = NetClient_GetEmailAlarmEx(g_iLogonID, (PSMTP_INFO)(&smtpEx), iSize);
    if (0 == iRet)
    {
		char cServer[48] = {0};
		char cAccount[48] = {0};
		char cPassword[48] = {0};
		char cAddress[48] = {0};
		char cAddress1[48] = {0};
		char cAddress2[48] = {0};
		char cAddress3[48] = {0};
		char cSubject[48] = {0};
		g2u(smtpEx.smtpInfo.cSmtpServer, strlen(smtpEx.smtpInfo.cSmtpServer)+1, cServer, 48);
		g2u(smtpEx.smtpInfo.cEmailAccount, strlen(smtpEx.smtpInfo.cEmailAccount)+1, cAccount, 48);
		g2u(smtpEx.smtpInfo.cEmailPassword, strlen(smtpEx.smtpInfo.cEmailPassword)+1, cPassword, 48);
		g2u(smtpEx.smtpInfo.cEmailAddress, strlen(smtpEx.smtpInfo.cEmailAddress)+1, cAddress, 48);
		g2u(smtpEx.cMailAddr[0], strlen(smtpEx.cMailAddr[0])+1, cAddress1, 48);
		g2u(smtpEx.cMailAddr[1], strlen(smtpEx.cMailAddr[1])+1, cAddress2, 48);
		g2u(smtpEx.cMailAddr[2], strlen(smtpEx.cMailAddr[2])+1, cAddress3, 48);
		g2u(smtpEx.smtpInfo.cMailSubject, strlen(smtpEx.smtpInfo.cMailSubject)+1, cSubject, 48);

        fprintf(stderr, "NetClient_GetEmailAlarmEx is successful\n");
		fprintf(stderr, "smtpEx.cSmtpServer is %s\n", cServer);
		fprintf(stderr, "smtpEx.smtpInfo.wdSmtpPort is %d\n", smtpEx.smtpInfo.wdSmtpPort);
		fprintf(stderr, "smtpEx.smtpInfo.cEmailAccount is %s\n", cAccount);
        fprintf(stderr, "smtpEx.smtpInfo.cEmailPassword is %s\n", cPassword);
        fprintf(stderr, "smtpEx.smtpInfo.cEmailAddress is %s\n", cAddress);
        fprintf(stderr, "smtpEx.smtpInfo.cMailSubject is %s\n", cSubject);
        fprintf(stderr, "smtpEx.smtpInfo.iAuthtype is %d\n", smtpEx.smtpInfo.iAuthtype);
        if (0 == iGet)
        {
            fprintf(stderr, "smtpEx.smtpInfo.smtpEx.cMailAddr[0] is %s\n", cAddress1);
            fprintf(stderr, "smtpEx.smtpInfo.smtpEx.cMailAddr[1] is %s\n", cAddress2);
            fprintf(stderr, "smtpEx.smtpInfo.smtpEx.cMailAddr[2] is %s\n", cAddress3);
        }
    }
    else
    {
        fprintf(stderr, "GetEmailAlarmEx failed! return %d, errno = 0x%08x\n", iRet, errno);
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_SetFTPUploadConfig()
{
    fprintf(stderr, "You choose to test NetClient_SetFTPUploadConfig, number is 280\n");
    fprintf(stderr, "which function do you want to Exec:\n 0:FTP_CMD_SET_SNAPSHOT \n 1:FTP_CMD_SET_LINKSEND\n 2:FTP_CMD_SET_TIMEDSEND \n 3:FTP_CMD_SET_UPDATE \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iCmd = to_int_def(cTemp);

    void* lpCmdBuf = NULL;
    int   iBufSize = 0;
    FTP_SNAPSHOT snapshot = {0};
    FTP_LINKSEND LinkSend = {0};
    FTP_TIMEDSEND timeSend = {0};
    FTP_UPDATE update;
    memset(&update, 0, sizeof(update));
    switch (iCmd)
    {
        case 0:
            fprintf(stderr, "Please input snapshot.iChannel:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            snapshot.iChannel = to_int_def(cTemp);

            fprintf(stderr, "Please input snapshot.iEnable:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            snapshot.iEnable = to_int_def(cTemp);

            fprintf(stderr, "Please input snapshot.iInterval(iInterval >= 3):\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            snapshot.iInterval = to_int_def(cTemp);

            fprintf(stderr, "Please input snapshot.iQValue:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            snapshot.iQValue = to_int_def(cTemp);
            lpCmdBuf = (void*)(&snapshot);
            iBufSize = sizeof(FTP_SNAPSHOT);
            break;
        case 1:
            fprintf(stderr, "Please input LinkSend.iChannel:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            LinkSend.iChannel = to_int_def(cTemp);

            fprintf(stderr, "Please input LinkSend.iEnable:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            LinkSend.iEnable = to_int_def(cTemp);

            fprintf(stderr, "Please input LinkSend.iMethod:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            LinkSend.iMethod = to_int_def(cTemp);

            lpCmdBuf = (void*)(&LinkSend);
            iBufSize = sizeof(FTP_LINKSEND);
            break;
        case 2:
            fprintf(stderr, "Please input timeSend.iChannel:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            timeSend.iChannel = to_int_def(cTemp);

            fprintf(stderr, "Please input timeSend.iEnable:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            timeSend.iEnable = to_int_def(cTemp);

            fprintf(stderr, "Please input timeSend.iFileType:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            timeSend.iFileType = to_int_def(cTemp);

            fprintf(stderr, "Please input timeSend.iHour:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            timeSend.iHour = to_int_def(cTemp);

            fprintf(stderr, "Please input timeSend.iMinute:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            timeSend.iMinute = to_int_def(cTemp);

            fprintf(stderr, "Please input timeSend.iSecond:\n");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            timeSend.iSecond = to_int_def(cTemp);
            lpCmdBuf = (void*)(&timeSend);
            iBufSize = sizeof(FTP_TIMEDSEND);
            break;
        case 3:
            fprintf(stderr, "Please input update.cFtpAddr:");
            gets_s(update.cFtpAddr, 64);
            if(0 == strcasecmp("q", update.cFtpAddr))
                return -1;

            fprintf(stderr, "Please input update.cFileName:");
            gets_s(update.cFileName, 64);
            if(0 == strcasecmp("q", update.cFileName))
                return -1;

            fprintf(stderr, "Please input update.cUserName:");
            gets_s(update.cUserName, 64);
            if(0 == strcasecmp("q", update.cUserName))
                return -1;

            fprintf(stderr, "Please input update.cPassword:");
            gets_s(update.cPassword, 64);
            if(0 == strcasecmp("q", update.cPassword))
                return -1;

            fprintf(stderr, "Please input update.iPort:");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;

            update.iPort = to_int_def(cTemp);
            fprintf(stderr, "Please input update.iUsage:");
            memset(cTemp, 0, sizeof(cTemp));
            gets_s(cTemp, 16);
            if(0 == strcasecmp("q", cTemp))
                return -1;
            update.iUsage = to_int_def(cTemp);
            lpCmdBuf = (void*)(&update);
            iBufSize = sizeof(FTP_UPDATE);
            break;
        default:
            break;
    }
    if (NULL != lpCmdBuf && 0 != iBufSize)
    {            
        int iRet = NetClient_SetFTPUploadConfig(g_iLogonID, iCmd, lpCmdBuf, iBufSize);
        if(iRet < 0)
        {
            fprintf(stderr, "SetFTPUploadConfig failed! return %d, errno = 0x%08x\n", iRet, errno);
        }
        else
        {
            fprintf(stderr, "SetFTPUploadConfig success! Result\n");
        }
    }
    else
    {
        fprintf(stderr, "SetFTPUploadConfig failed ! param is error!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_GetFTPUploadConfig()
{
    fprintf(stderr, "You choose to test NetClient_GetFTPUploadConfig, number is 281\n");
    fprintf(stderr, "which function do you want to Exec:\n 0:FTP_CMD_GET_SNAPSHOT \n 1:FTP_CMD_GET_LINKSEND\n 2:FTP_CMD_GET_TIMEDSEND \n 3:FTP_CMD_GET_UPDATE \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iCmd = to_int_def(cTemp);
    fprintf(stderr, "please input the channel no:(for FTP_CMD_GET_SNAPSHOT,FTP_CMD_GET_LINKSEND and FTP_CMD_GET_TIMEDSEND)\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iChannel = to_int_def(cTemp);
    void* lpCmdBuf = NULL;
    int   iBufSize = 0;
    FTP_SNAPSHOT snapshot = {0};
    FTP_LINKSEND LinkSend = {0};
    FTP_TIMEDSEND timeSend = {0};
    FTP_UPDATE update = {{0}};
    int iRet = 0;
    switch (iCmd)
    {
        case 0:
            snapshot.iChannel = iChannel;
            lpCmdBuf = &snapshot; 
            iBufSize = sizeof(FTP_SNAPSHOT);
            break;
        case 1:
            LinkSend.iChannel = iChannel;
            lpCmdBuf = &LinkSend; 
            iBufSize = sizeof(FTP_LINKSEND);
            break;
        case 2:
            timeSend.iChannel = iChannel;
            lpCmdBuf = &timeSend; 
            iBufSize = sizeof(FTP_TIMEDSEND);
            break;
        case 3:
            lpCmdBuf = &update; 
            iBufSize = sizeof(FTP_UPDATE);
            break;
        default:
            snapshot.iChannel = iChannel;
            lpCmdBuf = &snapshot;
            iBufSize = sizeof(FTP_SNAPSHOT);
            break;
    }
    iRet = NetClient_GetFTPUploadConfig(g_iLogonID, iCmd + 4, lpCmdBuf, iBufSize);
    if (0 == iRet)
    {
        fprintf(stderr, "NetClient_GetFTPUploadConfig is successful\n");
        if (0 == iCmd)
        {
            //snapshot
            fprintf(stderr, "snapshot.iChannel is %d\n", snapshot.iChannel);
    		fprintf(stderr, "snapshot.iEnable is %d\n", snapshot.iEnable);
    		fprintf(stderr, "snapshot.iInterval is %d\n", snapshot.iInterval);
    		fprintf(stderr, "snapshot.iQValue is %d\n", snapshot.iQValue);
        }
        else if( 1 == iCmd)
        {
            //LinkSend
            fprintf(stderr, "LinkSend.iChannel is %d\n", LinkSend.iChannel);
    		fprintf(stderr, "LinkSend.iEnable is %d\n", LinkSend.iEnable);
    		fprintf(stderr, "LinkSend.iMethod is %d\n", LinkSend.iMethod);
        }
        else if (2 == iCmd)
        {
            //timeSend
            fprintf(stderr, "timeSend.iChannel is %d\n", timeSend.iChannel);
    		fprintf(stderr, "timeSend.iEnable is %d\n", timeSend.iEnable);
    		fprintf(stderr, "timeSend.iMethod is %d\n", timeSend.iFileType);
            fprintf(stderr, "timeSend.iChannel is %d\n", timeSend.iHour);
    		fprintf(stderr, "timeSend.iEnable is %d\n", timeSend.iMinute);
    		fprintf(stderr, "timeSend.iMethod is %d\n", timeSend.iSecond);
        }
        else if (3 == iCmd)
        {
            //update
            fprintf(stderr, "update.cFtpAddr is %s\n", update.cFtpAddr);
            fprintf(stderr, "update.cFileName is %s\n", update.cFileName);
            fprintf(stderr, "update.cUserName is %s\n", update.cUserName);
    		fprintf(stderr, "update.cPassword is %s\n", update.cPassword);
    		fprintf(stderr, "update.iPort is %d\n", update.iPort);
    		fprintf(stderr, "update.iUsage is %d\n", update.iUsage);
        }
    }
    else
    {
        fprintf(stderr, "NetClient_GetFTPUploadConfig failed! return %d, errno = 0x%08x\n", iRet, errno);
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_SetDigitalChannelConfig_ALL()
{
	fprintf(stderr, "NetClient_SetDigitalChannelConfig:DC_CMD_SET_ALL\n");
    TDigitalChannelParam digitalChannelInfo = {0};

    int iChannel = -1;
    fprintf(stderr, "Please input the channel no:");
    char cTemp[256] = {0};
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp);
    digitalChannelInfo.iChannel = iChannel;//to_int_def(cTemp);

    fprintf(stderr, "please input the Enable\n 0:no\n 1:yes \n ");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    digitalChannelInfo.iEnable = to_int_def(cTemp);

    fprintf(stderr, "please input the connect mode :\n 0:ip\n 1:DDNS\n 2:DSM\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    digitalChannelInfo.iConnectMode = to_int_def(cTemp);

    fprintf(stderr, "please input ip address :");
    gets_s(digitalChannelInfo.cIP, 31);
    if(0 == strcasecmp("q", digitalChannelInfo.cIP))
    {
        return -1;
    }

    fprintf(stderr, "please input ProxyIP :");
    gets_s(digitalChannelInfo.cProxyIP, 16);
    if(0 == strcasecmp("q", digitalChannelInfo.cProxyIP))
    {
        return -1;
    }

    fprintf(stderr, "please input the iDevChannel:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    digitalChannelInfo.iDevChannel = to_int_def(cTemp);

    fprintf(stderr, "please input the iDevPort:(80-65535)\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    digitalChannelInfo.iDevPort = to_int_def(cTemp);

    fprintf(stderr, "please input the iStreamType:\n 0:Main\n 1:Sub\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    digitalChannelInfo.iStreamType = to_int_def(cTemp);

    fprintf(stderr, "please input the iNetMode:\n only 1:TCP\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    digitalChannelInfo.iNetMode = to_int_def(cTemp);

    fprintf(stderr, "please input cPtzProtocolName :");
    gets_s(digitalChannelInfo.cPtzProtocolName, 16);
    if(0 == strcasecmp("q", digitalChannelInfo.cPtzProtocolName))
    {
        return -1;
    }

    fprintf(stderr, "please input the iPtzAddr:(0-255)\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    digitalChannelInfo.iPtzAddr = to_int_def(cTemp);

    fprintf(stderr, "please input cUserName (forbid setting NULL):");
    gets_s(digitalChannelInfo.cUserName, 16);
    if(0 == strcasecmp("q", digitalChannelInfo.cUserName))
    {
        return -1;
    }
	
    fprintf(stderr, "please input cPassword (forbid setting NULL):");
    gets_s(digitalChannelInfo.cPassword, 16);
    if(0 == strcasecmp("q", digitalChannelInfo.cPassword))
    {
        return -1;
    }

    fprintf(stderr, "please input cEncryptKey :");
    gets_s(digitalChannelInfo.cEncryptKey, 16);
    if(0 == strcasecmp("q", digitalChannelInfo.cEncryptKey))
    {
        return -1;
    }

	fprintf(stderr, "please input the iServerType:\n 0:Private\n 1:Onvif\n 2:Push Stream\n");	
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 16);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	digitalChannelInfo.iServerType = to_int_def(cTemp);
    int iRet = NetClient_SetDigitalChannelConfig(g_iLogonID, iChannel, DC_CMD_SET_ALL, &digitalChannelInfo, sizeof(TDigitalChannelParam));
    if(iRet < 0)
    {
        fprintf(stderr, "SetDigitalChannelConfig failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "SetDigitalChannelConfig success! Result\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_SetDigitalChannelConfig_IPCPnP()
{
	fprintf(stderr, "NetClient_SetDigitalChannelConfig:DC_CMD_SET_IPCPnP\n");

// 	fprintf(stderr, "Please input the channel no:");
// 	char cTemp[256] = {0};
// 	gets_s(cTemp, 16);
// 	if(0 == strcasecmp("q", cTemp))
// 	{
// 		return -1;
// 	}
// 	int iChannel = to_int_def(cTemp);
	int iChannel = -1;

	char cTemp[256] = {0};
	fprintf(stderr, "Please input IPCPnP:\n 0:Disable\n 1:Auto\n 2:Notice\n");
	gets_s(cTemp, 16);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iIPCPnP = to_int_def(cTemp);

	int iRet = NetClient_SetDigitalChannelConfig(g_iLogonID, iChannel, DC_CMD_SET_IPCPnP, (void *)&iIPCPnP, sizeof(int));
	if(iRet < 0)
	{
		fprintf(stderr, "SetDigitalChannelConfig failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "SetDigitalChannelConfig success! Result\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetDigitalChannelConfig()
{
	while(true)
	{
		fprintf(stderr, "You choose to test NetClient_SetDigitalChannelConfig, number is 282\n");
		fprintf(stderr, "Select command:\n");
		fprintf(stderr, "  0 - DC_CMD_SET_ALL\n");
		fprintf(stderr, "  1 - DC_CMD_SET_IPCPnP\n");
		fprintf(stderr, "  q - quit\n");

		char cTemp[256] = {0};
		gets_s(cTemp, 256);           
		if(0 == strcasecmp("0", cTemp))
		{
			Test_SetDigitalChannelConfig_ALL();
		}
		else if(0 == strcasecmp("1", cTemp))
		{
			Test_SetDigitalChannelConfig_IPCPnP();
		}
		else if(0 == strcasecmp("q", cTemp))
		{
			break;
		}			
	}
	return 0;
}

int Test_GetDigitalChannelConfig_ALL()
{
	fprintf(stderr, "NetClient_GetDigitalChannelConfig:DC_CMD_GET_ALL\n");
    TDigitalChannelParam digitalChannelInfo = {0};
    int iChannel = -1;
    //int iCmd = -1;
    fprintf(stderr, "Please input the channel no:");
    char cTemp[256] = {0};
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp);
    digitalChannelInfo.iChannel = iChannel;

    int iRet = NetClient_GetDigitalChannelConfig(g_iLogonID, iChannel, DC_CMD_GET_ALL, &digitalChannelInfo, sizeof(TDigitalChannelParam));
    if(iRet != 0)
    {
        fprintf(stderr, "GetDigitalChannelConfig failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "SetDigitalChannelConfig success! Result\n");
        fprintf(stderr, "digitalChannelInfo.iChannel is %d\n", digitalChannelInfo.iChannel);
        fprintf(stderr, "digitalChannelInfo.iEnable is %d\n", digitalChannelInfo.iEnable);
        fprintf(stderr, "digitalChannelInfo.iConnectMode is %d\n", digitalChannelInfo.iConnectMode);
        fprintf(stderr, "digitalChannelInfo.cIP is %s\n", digitalChannelInfo.cIP);
        fprintf(stderr, "digitalChannelInfo.cProxyIP is %s\n", digitalChannelInfo.cProxyIP);
        fprintf(stderr, "digitalChannelInfo.iDevChannel is %d\n", digitalChannelInfo.iDevChannel);
        fprintf(stderr, "digitalChannelInfo.iDevPort is %d\n", digitalChannelInfo.iDevPort);
        fprintf(stderr, "digitalChannelInfo.iStreamType is %d\n", digitalChannelInfo.iStreamType);
        fprintf(stderr, "digitalChannelInfo.iNetMode is %d\n", digitalChannelInfo.iNetMode);
        fprintf(stderr, "digitalChannelInfo.cPtzProtocolName is %s\n", digitalChannelInfo.cPtzProtocolName);
        fprintf(stderr, "digitalChannelInfo.iPtzAddr is %d\n", digitalChannelInfo.iPtzAddr);
        fprintf(stderr, "digitalChannelInfo.cUserName is %s\n", digitalChannelInfo.cUserName);
        fprintf(stderr, "digitalChannelInfo.cPassword is %s\n", digitalChannelInfo.cPassword);
        fprintf(stderr, "digitalChannelInfo.cEncryptKey is %s\n", digitalChannelInfo.cEncryptKey);
		fprintf(stderr, "digitalChannelInfo.iServerType is %d\n", digitalChannelInfo.iServerType);
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_GetDigitalChannelConfig_IPCPnP()
{
	fprintf(stderr, "NetClient_GetDigitalChannelConfig:DC_CMD_GET_IPCPnP\n");

// 	fprintf(stderr, "Please input the channel no:");
// 	char cTemp[256] = {0};
// 	gets_s(cTemp, 16);
// 	if(0 == strcasecmp("q", cTemp))
// 	{
// 		return -1;
// 	}
// 	int iChannel = to_int_def(cTemp);

	int iChannel = -1;
	int iIPCPnP = -1;
	int iRet = NetClient_GetDigitalChannelConfig(g_iLogonID, iChannel, DC_CMD_GET_IPCPnP, &iIPCPnP, sizeof(int));
	if(iRet < 0)
	{
		fprintf(stderr, "NetClient_GetDigitalChannelConfig failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		switch (iIPCPnP)
		{
		case 0:fprintf(stderr, "IPCPnP: Disable\n");
			break;
		case 1:fprintf(stderr, "IPCPnP: Auto\n");
			break;
		case 2:fprintf(stderr, "IPCPnP: Notice\n");
			break;
		}
		fprintf(stderr, "NetClient_GetDigitalChannelConfig success! Result\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetDigitalChannelConfig()
{
	while(true)
	{
		fprintf(stderr, "You choose to test NetClient_GetDigitalChannelConfig, number is 283\n");
		fprintf(stderr, "Select command:\n");
		fprintf(stderr, "  0 - DC_CMD_GET_ALL\n");
		fprintf(stderr, "  1 - DC_CMD_GET_IPCPnP\n");
		fprintf(stderr, "  q - quit\n");

		char cTemp[256] = {0};
		gets_s(cTemp, 256);           
		if(0 == strcasecmp("0", cTemp))
		{
			Test_GetDigitalChannelConfig_ALL();
		}
		else if(0 == strcasecmp("1", cTemp))
		{
			Test_GetDigitalChannelConfig_IPCPnP();
		}
		else if(0 == strcasecmp("q", cTemp))
		{
			break;
		}			
	}
	return 0;
}

int Test_DigitalChannelSend()
{
    fprintf(stderr, "You choose to test NetClient_DigitalChannelSend, number is 284\n");
    fprintf(stderr, "Please input the channel no:");
    char cTemp[256] = {0};
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iChannel = to_int_def(cTemp);
    fprintf(stderr, "Please input the infomation:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iRet = NetClient_DigitalChannelSend(g_iLogonID, iChannel, (unsigned char *)cTemp, strlen(cTemp));
    if(iRet != 0)
    {
        fprintf(stderr, "DigitalChannelSend failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "DigitalChannelSend success! Result\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_SetVideoNPModeEx()
{
    fprintf(stderr, "You choose to test NetClient_SetVideoNPModeEx, number is 285\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:");
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iChannel = to_int_def(cTemp);
    fprintf(stderr, "Please input the mode no: 0:PAL 1:NTSC \n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iMode = to_int_def(cTemp);
    VIDEO_NORM _iNPMode;
    if (iMode == 0)
    {
        _iNPMode = VIDEO_MODE_PAL; 
    }
    else if (iMode == 1)
    {
        _iNPMode = VIDEO_MODE_NTSC;
    }
    int iRet = NetClient_SetVideoNPModeEx(g_iLogonID, iChannel, _iNPMode);
    if(iRet != 0)
    {
        fprintf(stderr, "SetVideoNPModeEx failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "SetVideoNPModeEx success! Result\n");
        iRet = NetClient_Reboot(g_iLogonID);
        if(0 == iRet)
        {
            fprintf(stderr, "Sending command to server is OK!\n");
        }
        else
        {
            fprintf(stderr, "Sending command to server is failed!\n");
        }
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_GetVideoNPModeEx()
{
    fprintf(stderr, "You choose to test NetClient_GetVideoNPModeEx, number is 286\n");
    int iChannelNo = -1;
    VIDEO_NORM NPMode;
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the Channel No:\n");
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannelNo =  to_int_def(cTemp);
    int iRet = NetClient_GetVideoNPModeEx(g_iLogonID, iChannelNo, &NPMode);
    if(iRet != 0)
    {
        fprintf(stderr, "GetVideoNPModeEx failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "GetVideoNPModeEx success! Result\n");
        fprintf(stderr, "iChannel no: %d \n", iChannelNo);
        fprintf(stderr, "mode is:%d \n", NPMode);
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_GetDigitChannelCount()
{
    fprintf(stderr, "You choose to test NetClient_GetDigitChannelCount, number is 287\n");
    int iChannelCount = 0;
    int iRet = NetClient_GetDigitalChannelNum(g_iLogonID, &iChannelCount);
    if(iRet != 0)
    {
        fprintf(stderr, "GetDigitChannelCount failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "GetDigitChannelCount success! Result\n");
        fprintf(stderr, "iChannel Count: %d \n", iChannelCount);
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_GetChannelProperty()
{
    fprintf(stderr, "You choose to test NetClient_GetChannelProperty, number is 288\n");
//    int iType = -1;

    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iChannel =  to_int_def(cTemp);

    fprintf(stderr, "Please input the cmd:(must 1 now) :\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iCmd =  to_int_def(cTemp);
    
    int iChannelType = 0;
	fprintf(stderr, " 0:Main\n 1:Sub\n 2:Digital channel\n 3:Combine channel\n");
    int iRet = NetClient_GetChannelProperty(g_iLogonID,iChannel, iCmd, (void*)(&iChannelType), sizeof(iChannelType));
    if(iRet != 0)
    {
        fprintf(stderr, "GetChannelProperty failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "GetChannelProperty success! \n Result:\n");
		switch (iChannelType)
		{
		case 0:fprintf(stderr, "Channel type: Main \n" );
			break;
		case 1:fprintf(stderr, "Channel type: Sub \n" );
			break;
		case 2:fprintf(stderr, "Channel type: Digital \n" );
			break;
		case 3:fprintf(stderr, "Channel type: Combine \n" );
			break;
		}
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_SetDeviceTimerReboot()
{
    fprintf(stderr, "You choose to test NetClient_SetDeviceTimerReboot, number is 289\n");
    char cTemp[256] = {0};
    fprintf(stderr, 
            "Enable:\n"
            "0: Unable\n"
            "1: Enable\n");
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iEnable =  to_int_def(cTemp);
    fprintf(stderr, "Interval(day):\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iInterval =  to_int_def(cTemp);
    fprintf(stderr, "hour:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int ihour =  to_int_def(cTemp);

    int iRet = NetClient_SetDeviceTimerReboot(g_iLogonID, iEnable, iInterval, ihour);
    if(iRet != 0)
    {
        fprintf(stderr, "SetDeviceTimerReboot failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "SetDeviceTimerReboot success! Result\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_GetDeviceTimerReboot()
{
    fprintf(stderr, "You choose to test NetClient_GetDeviceTimerReboot, number is 290\n");
    int iEnable = 0;
    int iInterval = 0;
    int iHour = 0;
    int iRet = NetClient_GetDeviceTimerReboot(g_iLogonID, &iEnable, &iInterval, &iHour);
    if(iRet != 0)
    {
        fprintf(stderr, "GetDeviceTimerReboot failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "GetDeviceTimerReboot success! Result\n");
        fprintf(stderr, "Enable:%d\n", iEnable);
        fprintf(stderr, "Interval(day):%d\n", iInterval);
        fprintf(stderr, "Hour:%d\n", iHour);
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_SetVideoCoverSchedule()
{
    fprintf(stderr, "You choose to test NetClient_SetVideoCoverSchedule, number is 291\n");
    char cTemp[256] = {0};
    fprintf(stderr, 
            "Channel:\n");
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iChannel =  to_int_def(cTemp);
    fprintf(stderr, "WeekDay\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iWeekDay =  to_int_def(cTemp);

    NVS_SCHEDTIME timeSeg1,timeSeg2,timeSeg3,timeSeg4;
    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));
    
    fprintf(stderr, "timeSeg1.StartHour:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStartHour  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg1.StartMin:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStartMin  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg1.StopHour:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStopHour  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg1.StopMin:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iStopMin  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg1.iRecordMode:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg1.iRecordMode  =  to_int_def(cTemp);


    fprintf(stderr, "timeSeg2.StartHour:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStartHour  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg2.StartMin:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStartMin  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg2.StopHour:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStopHour  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg2.StopMin:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iStopMin  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg2.iRecordMode:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg2.iRecordMode  =  to_int_def(cTemp);


    fprintf(stderr, "timeSeg3.StartHour:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStartHour  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg3.StartMin:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStartMin  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg3.StopHour:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStopHour  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg3.StopMin:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iStopMin  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg3.iRecordMode:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg3.iRecordMode  =  to_int_def(cTemp);

    fprintf(stderr, "timeSeg4.StartHour:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStartHour  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg4.StartMin:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStartMin  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg4.StopHour:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStopHour  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg4.StopMin:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iStopMin  =  to_int_def(cTemp);
    fprintf(stderr, "timeSeg4.iRecordMode:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    timeSeg4.iRecordMode  =  to_int_def(cTemp);

    NVS_SCHEDTIME* schedule[] = {&timeSeg1,&timeSeg2,&timeSeg3,&timeSeg4};
    int iRet = NetClient_SetVideoCoverSchedule(g_iLogonID, iChannel, iWeekDay, schedule);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient_SetVideoCoverSchedule failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_SetVideoCoverSchedule success! Result\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_GetVideoCoverSchedule()
{
    fprintf(stderr, "You choose to test NetClient_GetDeviceTimerReboot, number is 292\n");
    
    char cTemp[256]={0};
	fprintf(stderr, "Channel:\n");
	gets_s(cTemp, 16);
	if (0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannel =  to_int_def(cTemp);

	fprintf(stderr,"Please input weekday:\n");
	fprintf(stderr,"0--Sunday;1--Monday;2--Tuesday;3--Wednesday;4--Thursday;5--Friday;6--Saturday.\n");
	gets_s(cTemp,256);
	if (0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
    int iWeekDay = to_int_def(cTemp, -1);

    NVS_SCHEDTIME timeseg1,timeseg2,timeseg3,timeseg4;
    memset(&timeseg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeseg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeseg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeseg4,0,sizeof(NVS_SCHEDTIME));
    NVS_SCHEDTIME *schedule[] = {&timeseg1,&timeseg2,&timeseg3,&timeseg4};
    int iRet = NetClient_GetVideoCoverSchedule(g_iLogonID, iChannel, iWeekDay, schedule);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient_GetVideoCoverSchedule failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_GetVideoCoverSchedule success! Result\n");
        fprintf(stderr, "channel info: %d\n", iChannel);
        fprintf(stderr, "weekday info: %d\n", iWeekDay);
        
        fprintf(stderr, "timeseg1.starttime:%d:%d\n", timeseg1.iStartHour, timeseg1.iStartMin);
        fprintf(stderr, "timeseg1.stoptime:%d:%d\n", timeseg1.iStopHour, timeseg1.iStopMin);
        fprintf(stderr, "timeseg1.iRecordMode:%d\n",  timeseg1.iRecordMode);
        fprintf(stderr, "timeseg2.starttime:%d:%d\n", timeseg2.iStartHour, timeseg2.iStartMin);
        fprintf(stderr, "timeseg2.stoptime:%d:%d\n", timeseg2.iStopHour, timeseg2.iStopMin);
        fprintf(stderr, "timeseg2.iRecordMode:%d\n",  timeseg2.iRecordMode);
        fprintf(stderr, "timeseg3.starttime:%d:%d\n", timeseg3.iStartHour, timeseg3.iStartMin);
        fprintf(stderr, "timeseg3.stoptime:%d:%d\n", timeseg3.iStopHour, timeseg3.iStopMin);
        fprintf(stderr, "timeseg3.iRecordMode:%d\n",  timeseg3.iRecordMode);
        fprintf(stderr, "timeseg4.starttime:%d:%d\n", timeseg4.iStartHour, timeseg4.iStartMin);
        fprintf(stderr, "timeseg4.stoptime:%d:%d\n", timeseg4.iStopHour, timeseg4.iStopMin);
        fprintf(stderr, "timeseg4.iRecordMode:%d\n",  timeseg4.iRecordMode);
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_SetCPUMEMAlarmThreshold()
{
    fprintf(stderr, "You choose to test NetClient_SetVideoCoverSchedule, number is 293\n");
    char cTemp[256] = {0};
    fprintf(stderr, 
            "CPUThreshold:\n");
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iCPUThreshold =  to_int_def(cTemp);
    fprintf(stderr, "MEMThreshold:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iMEMThreshold =  to_int_def(cTemp);
    int iRet = NetClient_SetCPUMEMAlarmThreshold(g_iLogonID, iCPUThreshold, iMEMThreshold);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient_SetCPUMEMAlarmThreshold failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_SetCPUMEMAlarmThreshold success! Result\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_GetCPUMEMAlarmThreshold()
{
    fprintf(stderr, "You choose to test NetClient_SetVideoCoverSchedule, number is 294\n");
    int iCPUThreshold = 0;
    int iMEMThreshold = 0;
    int iRet = NetClient_GetCPUMEMAlarmThreshold(g_iLogonID, &iCPUThreshold, &iMEMThreshold);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient_GetCPUMEMAlarmThreshold failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_GetCPUMEMAlarmThreshold success! Result\n");
        fprintf(stderr, "CPU:%d\n", iCPUThreshold);
        fprintf(stderr, "MEM:%d\n", iMEMThreshold);
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_SetDZInfo()
{
    fprintf(stderr, "You choose to test NetClient_SetDZInfo, number is 295\n");
    DZ_INFO_PARAM dzinfo = {{0}};
    fprintf(stderr, "dzinfo[1]:");
    gets_s(dzinfo.m_cParam1, 64);
    fprintf(stderr, "dzinfo[2]:");
    gets_s(dzinfo.m_cParam2, 64);
    fprintf(stderr, "dzinfo[3]:");
    gets_s(dzinfo.m_cParam3, 64);
    fprintf(stderr, "dzinfo[4]:");
    gets_s(dzinfo.m_cParam4, 64);
    fprintf(stderr, "dzinfo[5]:");
    gets_s(dzinfo.m_cParam5, 64);
    fprintf(stderr, "dzinfo[6]:");
    gets_s(dzinfo.m_cParam6, 64);
    fprintf(stderr, "dzinfo[7]:");
    gets_s(dzinfo.m_cParam7, 64);
    fprintf(stderr, "dzinfo[8]:");
    gets_s(dzinfo.m_cParam8, 64);
    fprintf(stderr, "dzinfo[9]:");
    gets_s(dzinfo.m_cParam9, 64);
    fprintf(stderr, "dzinfo[10]:");
    gets_s(dzinfo.m_cParam10, 64);

    fprintf(stderr, "dzinfo[11]:");
    gets_s(dzinfo.m_cParam11, 64);
    fprintf(stderr, "dzinfo[12]:");
    gets_s(dzinfo.m_cParam12, 64);
    fprintf(stderr, "dzinfo[13]:");
    gets_s(dzinfo.m_cParam13, 64);
    fprintf(stderr, "dzinfo[14]:");
    gets_s(dzinfo.m_cParam14, 64);
    fprintf(stderr, "dzinfo[15]:");
    gets_s(dzinfo.m_cParam15, 64);
    fprintf(stderr, "dzinfo[16]:");
    gets_s(dzinfo.m_cParam16, 64);
    fprintf(stderr, "dzinfo[17]:");
    gets_s(dzinfo.m_cParam17, 64);
    fprintf(stderr, "dzinfo[18]:");
    gets_s(dzinfo.m_cParam18, 64);
    fprintf(stderr, "dzinfo[19]:");
    gets_s(dzinfo.m_cParam19, 64);
    fprintf(stderr, "dzinfo[20]:");
    gets_s(dzinfo.m_cParam20, 64);


    int iRet = NetClient_SetDZInfo(g_iLogonID, &dzinfo);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient_SetDZInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_SetDZInfo success! Result\n");
    } 

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_GetDZInfo()
{
    fprintf(stderr, "You choose to test NetClient_GetDZInfo, number is 296\n");
    DZ_INFO_PARAM dzinfo = {{0}};
    int iRet = NetClient_GetDZInfo(g_iLogonID, &dzinfo);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient_GetDZInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_GetDZInfo success! Result\n");
        fprintf(stderr, "dzinfo[1]:%s\n", dzinfo.m_cParam1);
        fprintf(stderr, "dzinfo[2]:%s\n", dzinfo.m_cParam2);
        fprintf(stderr, "dzinfo[3]:%s\n", dzinfo.m_cParam3);
        fprintf(stderr, "dzinfo[4]:%s\n", dzinfo.m_cParam4);
        fprintf(stderr, "dzinfo[5]:%s\n", dzinfo.m_cParam5);  
        fprintf(stderr, "dzinfo[6]:%s\n", dzinfo.m_cParam6);
        fprintf(stderr, "dzinfo[7]:%s\n", dzinfo.m_cParam7);
        fprintf(stderr, "dzinfo[8]:%s\n", dzinfo.m_cParam8);
        fprintf(stderr, "dzinfo[9]:%s\n", dzinfo.m_cParam9);
        fprintf(stderr, "dzinfo[10]:%s\n", dzinfo.m_cParam10);
        fprintf(stderr, "dzinfo[11]:%s\n", dzinfo.m_cParam11);
        fprintf(stderr, "dzinfo[12]:%s\n", dzinfo.m_cParam12);
        fprintf(stderr, "dzinfo[13]:%s\n", dzinfo.m_cParam13);
        fprintf(stderr, "dzinfo[14]:%s\n", dzinfo.m_cParam14);
        fprintf(stderr, "dzinfo[15]:%s\n", dzinfo.m_cParam15);  
        fprintf(stderr, "dzinfo[16]:%s\n", dzinfo.m_cParam16);
        fprintf(stderr, "dzinfo[17]:%s\n", dzinfo.m_cParam17);
        fprintf(stderr, "dzinfo[18]:%s\n", dzinfo.m_cParam18);
        fprintf(stderr, "dzinfo[19]:%s\n", dzinfo.m_cParam19);
        fprintf(stderr, "dzinfo[20]:%s\n", dzinfo.m_cParam20);
    } 

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_SetPTZAutoBack()
{
    fprintf(stderr, "You choose to test NetClient__SetPTZAutoBack, number is 297\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Channel:\n");
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iChannel =  to_int_def(cTemp);
    fprintf(stderr, "Enable:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iEnable = to_int_def(cTemp);
    fprintf(stderr, "PresetIndex:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iPresetIndex = to_int_def(cTemp);
    fprintf(stderr, "IdleTime:\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iIdleTime = to_int_def(cTemp);
    int iRet = NetClient_SetPTZAutoBack(g_iLogonID, iChannel, iEnable, iPresetIndex, iIdleTime);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient__SetPTZAutoBack failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient__SetPTZAutoBack success! Result\n");
    } 

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_GetPTZAutoBack()
{
    fprintf(stderr, "You choose to test NetClient__GetPTZAutoBack, number is 298\n");
    int iChannel = 0;
    int iEnable = 0;
    int iPresetIndex = 0;
    int iIdleTime = 0;
    char cTemp[256] = {0};
    fprintf(stderr, "Channel:\n");
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel =  to_int_def(cTemp);
    int iRet = NetClient_GetPTZAutoBack(g_iLogonID, iChannel, &iEnable, &iPresetIndex, &iIdleTime);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient__GetPTZAutoBack failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient__GetPTZAutoBack success! Result\n");
        fprintf(stderr, "channel:%d\n", iChannel);
        fprintf(stderr, "enable:%d\n", iEnable);
        fprintf(stderr, "PresetIndex:%d\n", iPresetIndex);
        fprintf(stderr, "IdleTime:%d\n", iIdleTime);
    } 
    
    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_Set3GVPND()
{
    char cDialNumber[256] = {0};
    char cAccount[256] = {0};
    char cPassword[256] = {0};
    fprintf(stderr, "You choose to test NetClient_Set3GVPNDk, number is 299\n");
    fprintf(stderr, "DialNumber:\n");
    gets_s(cDialNumber, 32);
    if (0 == strcasecmp("q", cDialNumber))
    {
        return -1;
    }
    fprintf(stderr, "Account:\n");
    gets_s(cAccount, 32);
    if (0 == strcasecmp("q", cAccount))
    {
        return -1;
    }
    fprintf(stderr, "Password:\n");
    gets_s(cPassword, 32);
    if (0 == strcasecmp("q", cPassword))
    {
        return -1;
    }
    int iRet = NetClient_Set3GVPND(g_iLogonID, cDialNumber, cAccount, cPassword);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient_Set3GVPND failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_Set3GVPND success! Result\n");
    } 

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_Get3GVPND()
{
    char cDialNumber[256] = {0};
    char cAccount[256] = {0};
    char cPassword[256] = {0};
    fprintf(stderr, "You choose to test NetClient_Get3GVPNDk, number is 300\n");
    int iRet = NetClient_Get3GVPND(g_iLogonID, cDialNumber, cAccount, cPassword);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient_Get3GVPND failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_Get3GVPND success! Result\n");
        fprintf(stderr, "DialNumber:%s\n", cDialNumber);
        fprintf(stderr, "Account:%s\n", cAccount);
        fprintf(stderr, "Password:%s\n", cPassword);
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_SetHDCamerEx()
{
    fprintf(stderr, "You choose to test NetClient_SetHDCamerEx, number is 301\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Channel:\n");
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iChannel =  to_int_def(cTemp);
    fprintf(stderr, "FuncID:\n 6or7:Rect \n other:int\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iFuncID = to_int_def(cTemp);
    RECT rect = {0};
    int iBuf = 0;
    void *pBuff = NULL;
    int iBufferSize = 0;
    if (iFuncID == 6 || 7 == iFuncID)
    {
		fprintf(stderr, "point1 x:");
        memset(cTemp, 0, sizeof(cTemp));
        gets_s(cTemp, 16);
        if (0 == strcasecmp("q", cTemp))
        {
            return -1;
        }
        rect.left = to_int_def(cTemp);
        fprintf(stderr, "point1 y:");
        memset(cTemp, 0, sizeof(cTemp));
        gets_s(cTemp, 16);
        if (0 == strcasecmp("q", cTemp))
        {
            return -1;
        }
        rect.top = to_int_def(cTemp);
        fprintf(stderr, "point2 x:");
        memset(cTemp, 0, sizeof(cTemp));
        gets_s(cTemp, 16);
        if (0 == strcasecmp("q", cTemp))
        {
            return -1;
        }
        rect.right = to_int_def(cTemp);
        fprintf(stderr, "point2 y:");
        memset(cTemp, 0, sizeof(cTemp));
        gets_s(cTemp, 16);
        if (0 == strcasecmp("q", cTemp))
        {
            return -1;
        }
        rect.bottom = to_int_def(cTemp);
        pBuff = &rect;
        iBufferSize = sizeof(rect);
    }
    else
    {
        fprintf(stderr, "please input an integer:\n");
        memset(cTemp, 0, sizeof(cTemp));
        gets_s(cTemp, 16);
        if (0 == strcasecmp("q", cTemp))
        {
            return -1;
        }
        iBuf = to_int_def(cTemp);
        pBuff = &iBuf;
        iBufferSize = sizeof(int);
    }
    int iRet = NetClient_SetHDCamerEx(g_iLogonID, iChannel, iFuncID, pBuff, iBufferSize);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient_SetHDCamerEx failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_SetHDCamerEx success! Result\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int	Test_GetHDCamerEx()
{
    fprintf(stderr, "You choose to test NetClient_GetHDCamerEx, number is 302\n");
    int iChannel = 0;
    int iFuncID = 0;
    char cTemp[256] = {0};
    fprintf(stderr, "channel:");
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iChannel = to_int_def(cTemp);
    fprintf(stderr, "FuncID:\n 6or7:Rect \n other:int\n");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 16);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    iFuncID = to_int_def(cTemp);
    RECT rect = {0};
    int  iPara = 0;
    void *pPara = NULL;
    int iSize;
    if (6 == iFuncID || 7 == iFuncID)
    {
        pPara = &rect;
        iSize = sizeof(RECT);
    }
    else
    {
        pPara = &iPara;
        iSize = sizeof(int);
    }
    int iRet = NetClient_GetHDCamerEx(g_iLogonID, iChannel, iFuncID, pPara, iSize);
    if(iRet != 0)
    {
        fprintf(stderr, "NetClient_GetHDCamerEx failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_GetHDCamerEx success! Result\n");
        if (6 == iFuncID || 7 == iFuncID)
        {
            fprintf(stderr, "point1:(%d,%d),point2(%d,%d)\n", rect.left, rect.top,rect.right,rect.bottom);
        }
        else
        {
            fprintf(stderr, "param:%d\n", iPara);
        }
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_VCASetConfig()
{
    fprintf(stderr, "You choose to test NetClient_VCASetConfig, number is 303\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChan = to_int_def(cTemp);

    fprintf(stderr, "Please choose operation:\n0-set channel enable\n1-set videosize(VCA)\n2-set advance para\n3-set target para\n"
                    "4-clear alarm statistics\n5-set rule common para\n6-set tripwire\n7-set perimeter\n8-set alarm schedule\n"
                    "9-set alarmlink\n10-set alarm schedule enalbe\n11-set face rec\n12-set video detetion\n13-set abandum and object stolen\n"
                    "14-set crowd\n15-set fluxstatistic\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iCmd = to_int_def(cTemp);
    switch (iCmd)
    {
    case 0: T_SetVCAChanEnable(iChan);  break;
    case 1: T_SetVCAVideoSize(iChan);   break;
    case 2: T_SetVCAAdvPara(iChan);     break;
    case 3: T_SetVCATargetPara(iChan);  break;
    case 4: T_ClearAlarmStat(iChan);    break;
    case 5: T_SetVCARuleCommPara(iChan);break;
    case 6: T_SetVCATripWire(iChan);    break;
    case 7: T_SetVCAPerimeter(iChan);   break;
    case 8: T_SetVCAAlarmSchedule(iChan); break;
    case 9: T_SetVCAAlarmLink(iChan);   break;
    case 10: T_SetVCAScheduleEnable(iChan); break;
    case 11: T_SetVCAFaceRec(iChan);    break;
    case 12: T_SetVCAVideoDetection(iChan);    break;
    case 13: T_SetVCAAbandum(iChan);	break;
    case 14: T_SetVCACrowd(iChan);      break;
    case 15: T_SetVCAFlux(iChan);       break;
        default:
            {
                fprintf(stderr, "You input error cmd id(%d).\n", iCmd);
                break;
            }
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_VCAGetConfig()
{
    fprintf(stderr, "You choose to test NetClient_VCAGetConfig, number is 304\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChan = to_int_def(cTemp);

	fprintf(stderr, "Please choose operation:\n0-get channel enable\n1-get videosize(VCA)\n2-get advance para\n3-get target para\n"
					"4-clear alarm statistics\n5-get rule common para\n6-get tripwire\n7-get perimeter\n8-get alarm schedule\n"
					"9-get alarmlink\n10-get alarm schedule enalbe\n11-get face rec\n12-get video detetion\n13--get abandum and object stolen\n"
                    "14-get crowd\n15-get flux");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iCmd = to_int_def(cTemp);
    switch (iCmd)
    {
        case 0: T_GetVCAChanEnable(iChan); break;
        case 1: T_GetVCAVideoSize(iChan); break;
        case 2: T_GetVCAAdvPara(iChan); break;
        case 3: T_GetVCATargetPara(iChan); break;
        case 4: T_GetVCAAlarmStat(iChan); break;
        case 5: T_GetVCARuleCommPara(iChan); break;
        case 6: T_GetVCATripWire(iChan); break;
        case 7: T_GetVCAPerimeter(iChan); break;
        case 8: T_GetVCAAlarmSchedule(iChan); break;
        case 9: T_GetVCAAlarmLink(iChan); break;
        case 10: T_GetVCAScheduleEnable(iChan); break;
        case 11: T_GetVCAFaceRec(iChan);    break;
        case 12: T_GetVCAVideoDetection(iChan);    break;
        case 13: T_GetVCAAbandum(iChan);	break;
        case 14: T_GetVCACrowd(iChan);      break;
        case 15: T_GetVCAFlux(iChan);       break;
        default:
            {
                fprintf(stderr, "You input error cmd id(%d).\n", iCmd);
                break;
            }
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

//רVCAȫֱ  
/*************************/
//ºб-->**--0,1..У
//ʾӿڵVCAҪֵı
//ûעܲýӿʧ
//ע---ֱܷʡ߼ܽ硢ʱҪܿ
/*************************/
vca_TVCAParam g_vcaPara = {0};
int T_SetVCAChanEnable(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_SetVCAChanEnable] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;

    fprintf(stderr, "Please input enable option: 0-disable, 1-enable.\n");
    pVcaPara->iEnable = SafeGetInt();

    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_CHANNEL, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Set VCA channel enable failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set VCA channel enable success.\n");
    }
    
    return 0;
}

int T_SetVCAVideoSize(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_SetVCAVideoSize] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;

    fprintf(stderr, "Please input video size, 0-QCIF, 2-FCIF.\n");
    int iVideoSize = SafeGetInt();
    if(iVideoSize == 0)
    {
        pVcaPara->chnParam[_iChan].config.iVideoSize = 0;
    }
    else if(iVideoSize == 2)
    {
        pVcaPara->chnParam[_iChan].config.iVideoSize = 2;
    }
    else
    {
        fprintf(stderr, "[T_SetVCAVideoSize] Please input 0 or 2.\n");
        return 0;
    }

    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_VIDEOSIZE, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Set VCA channel videosize failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set VCA channel videosize success.\n");
        Test_VCARestart();
    }

    return 0;
}

int T_SetVCAAdvPara(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_SetVCAAdvPara] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;

    fprintf(stderr, "Please input advparam_enable:\n0-no,1-yes;\nsensitivity:0-low,1-mid,2-high;\nTarget minsize\nmaxsize;\nTarget minspeed\nmaxspeed\ne.g:1,0,10,20,30,60\n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;

    vca_TAdvParam &para = pVcaPara->chnParam[_iChan].advParam;
    sscanf(cTemp, "%d,%d,%d,%d,%d,%d", &para.iEnable, &para.iSensitivity, &para.iTargetMinSize, &para.iTargetMaxSize, &para.iTargetMinSpeed, &para.iTargetMaxSpeed);

	fprintf(stderr, "Please input param:\nmin width;\nmax width\nmin height\nmax height;\nmin WHRatio\nmax WHRatio\ne.g:10,20,10,20,10,20\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;

    sscanf(cTemp, "%d,%d,%d,%d,%d,%d", &para.iTargetMinWidth, &para.iTargetMaxWidth, &para.iTargetMinHeight, &para.iTargetMaxHeight, 
           &para.iTargetMinWHRatio, &para.iTargetMaxWHRatio); 

    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_ADVANCE_PARAM, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Set VCA advance param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set VCA advance param success.\n");
        Test_VCARestart();
    }

    return 0;
}

int T_SetVCATargetPara(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_SetVCATargetPara] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;

    vca_TConfig &config = pVcaPara->chnParam[_iChan].config;
    char cTemp[256] = {0};
    fprintf(stderr, "Please set target param, display target:0-no,1-yes; display trace:0-no,1-yes; target trace length(0~40). e.g:0,1,20.\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    sscanf(cTemp, "%d,%d,%d", &config.iDisplayTarget, &config.iDisplayTrace, &config.iTraceLength);

    fprintf(stderr, "Please input target color: 0-random, 1-red, 2-green, 3-yellow, 4-blue, 5-magenta, 6-cyan, 7-black, 8-white.\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    config.iTargetColor = to_int_def(cTemp);

    fprintf(stderr, "Please input alarm color: 0-default, 1-red, 2-green, 3-yellow, 4-blue, 5-magenta, 6-cyan, 7-black, 8-white.\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    config.iTargetAlarmColor = to_int_def(cTemp);
    
    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_TARGET_PARAM, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Set VCA target param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set VCA target param success.\n");
    }

    return 0;
}

int T_ClearAlarmStat(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_ClearAlarmStat] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;
    fprintf(stderr, "Please input rule id(0~7):\n");
    int iRuleID = SafeGetInt();
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;
    fprintf(stderr, "Please input event id:0-tripwire, 2-perimeter.\n");
    int iEventID = SafeGetInt();
    if(iEventID == 0)
    {
        pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_TRIPWIRE;
    }
    else if(iEventID == 2)
    {
        pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_PERIMETER;
    }
    else
    {
        fprintf(stderr, "[T_ClearAlarmStat]No support this event(%d).!\n", iEventID);
    }
    
    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_ALARM_STATISTIC, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Clear VCA alarm statistics failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Clear VCA alarm statistics success.\n");
    }

    return 0;
}

int T_SetVCARuleCommPara(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_SetVCARuleCommPara] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid

    vca_TRuleParam& rulePara = pVcaPara->chnParam[_iChan].rule[iRuleID];
    fprintf(stderr, "Please input rule name(len <= 16): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    strncpy(rulePara.cRuleName, cTemp, 16);  //Դ17ֽڵ  -->rulename
    
    fprintf(stderr, "Please input rule valid(0-no,1-yes): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iValid = to_int_def(cTemp);
	pVcaPara->chnParam[_iChan].rule[iRuleID].iValid = iValid;
    if(iValid == 0 || iValid == 1)
    {
        int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_RULE_COMMON, _iChan, pVcaPara, sizeof(vca_TVCAParam));
        if(iRet < 0)
        {
            fprintf(stderr, "Set VCA rule common param failed, return = %d, err = 0x%08x. \n", iRet, errno);
        }
        else
        {
            fprintf(stderr, "Set VCA rule common param success.\n");
        }
    }
    else
        fprintf(stderr, "Valid must be 0 or 1!\n");

    return 0;
}

int T_SetVCATripWire(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_SetVCATripWire] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_TRIPWIRE; //-->eventid--2

    vca_TRuleParam& rp = pVcaPara->chnParam[_iChan].rule[iRuleID];
    vca_TTripwire& tw = pVcaPara->chnParam[_iChan].rule[iRuleID].events.tripwire;
    fprintf(stderr, "Please input rule valid(0-no, 1-yes):\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    rp.iValid = to_int_def(cTemp);

    fprintf(stderr, "Enable two-way of tripwire(0-no, 1-yes):\n"); //-->to-way--3
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    tw.iType = to_int_def(cTemp);

    fprintf(stderr, "Display this rule(0-no, 1-yes), show alarm statistics(0-no, 1-yes), no alarm color(1~8), alarm color(0~8) e.g: 1,1,3,3: \n"); //-->display para--4
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    sscanf(cTemp, "%d,%d,%d,%d", &rp.stDisplayParam.iDisplayRule, &rp.stDisplayParam.iDisplayStat, &rp.stDisplayParam.iColor, &rp.stDisplayParam.iAlarmColor);

    fprintf(stderr, "Please input min-time, min-distance, direction(0~359), e.g:10, 30, 180: \n");  //other para--5
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    sscanf(cTemp, "%d,%d,%d", &tw.iMinTime, &tw.iMinDistance, &tw.iDirection);  

    fprintf(stderr, "Please input identify type \n"
                    "0-none\n"
                    "1-people\n"
                    "2-car\n"
                    "3-people and car\n");  //-->identify type--6
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    tw.iTargetTypeCheck = to_int_def(cTemp);

    fprintf(stderr, "Please input start point, e.g:50,100 \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    sscanf(cTemp, "%d,%d", &tw.stLine.stStart.iX, &tw.stLine.stStart.iY);

    fprintf(stderr, "Please input end point, e.g:100,200 \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    sscanf(cTemp, "%d,%d", &tw.stLine.stEnd.iX, &tw.stLine.stEnd.iY);

    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_RULE0_TRIPWIRE, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Set VCA tripwire param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set VCA tripwire param success.\n");
        //Test_VCARestart();
        Test_VCARestartEx();
    }

    return 0;
}

int T_SetVCAPerimeter(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_SetVCAPerimeter] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_PERIMETER; //-->eventid--2

    vca_TRuleParam& rp = pVcaPara->chnParam[_iChan].rule[iRuleID];
    vca_TPerimeter& pm = pVcaPara->chnParam[_iChan].rule[iRuleID].events.perimeter;
    fprintf(stderr, "Please input rule valid(0-no, 1-yes):\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    rp.iValid = to_int_def(cTemp);

    fprintf(stderr, "Enable direction limit(0-no, 1-yes):\n"); //-->dir limit--3
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    pm.iType = to_int_def(cTemp);

    fprintf(stderr, "Display this rule(0-no, 1-yes), show alarm statistics(0-no, 1-yes), no alarm color(0~8), alarm color(0~8) e.g: 1,1,3,3: \n"); //-->display para--4
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    sscanf(cTemp, "%d,%d,%d,%d", &rp.stDisplayParam.iDisplayRule, &rp.stDisplayParam.iDisplayStat, &rp.stDisplayParam.iColor, &rp.stDisplayParam.iAlarmColor);

    fprintf(stderr, "Please input min-time, min-distance, direction(0~359), e.g:10, 1000, 180: \n");  //other para--5
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    sscanf(cTemp, "%d,%d,%d", &pm.iMinTime, &pm.iMinDistance, &pm.iDirection);

    fprintf(stderr, "Please input identify type \n"
                    "0-none\n"
                    "1-people\n"
                    "2-car\n"
                    "3-people and car\n");  //-->identify type--6
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    pm.iTargetTypeCheck = to_int_def(cTemp);

    fprintf(stderr, "Please input detect mode:\n"
                    "0-intrusion\n"
                    "1-enter\n"
                    "2-leave\n");  //-->detect mode--7
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    pm.iMode = to_int_def(cTemp);

    fprintf(stderr, "Please input point num(n<=8):\n");
    gets_s(cTemp, 8);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iPointNum = to_int_def(cTemp);
    pm.stRegion.iPointNum = iPointNum;

    fprintf(stderr, "Please input the points, e.g:10,20 \n");
    for(int i=0; i<iPointNum; i++)
    {
        fprintf(stderr, "Point %d:", i);
        gets_s(cTemp, 16);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        sscanf(cTemp, "%d,%d", &pm.stRegion.stPoints[i].iX, &pm.stRegion.stPoints[i].iY);
    }
    
    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_RULE2_PERIMETER, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Set VCA Perimeter param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set VCA Perimeter param success.\n");
        //Test_VCARestart();
        Test_VCARestartEx();
    }

    return 0;
}

int T_SetVCAFaceRec(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_SetVCAFaceRec] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_FACEREC; //-->eventid--2

    vca_TRuleParam& rp = pVcaPara->chnParam[_iChan].rule[iRuleID];
    vca_TFaceRec& fr = pVcaPara->chnParam[_iChan].rule[iRuleID].events.m_stFaceRec;
    fprintf(stderr, "Please input rule valid(0-no, 1-yes):\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    rp.iValid = to_int_def(cTemp);

    fprintf(stderr, "Display this rule(0-no, 1-yes), show alarm statistics(0-no, 1-yes),  alarm color(0~8) e.g: 1,1,3: \n"); //-->display para--4
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    sscanf(cTemp, "%d,%d,%d", &rp.stDisplayParam.iDisplayRule, &rp.stDisplayParam.iDisplayStat, &rp.stDisplayParam.iAlarmColor);
    rp.stDisplayParam.iColor = 0;       //ʱûãĿǰ0ɡ

    fprintf(stderr, "Please input point num(n<=8):\n");
    gets_s(cTemp, 8);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iPointNum = to_int_def(cTemp);
    fr.stRegion.iPointNum = iPointNum;

    fprintf(stderr, "Please input the points, e.g:10,20 \n");
    for(int i=0; i<iPointNum; i++)
    {
        fprintf(stderr, "Point %d:", i);
        gets_s(cTemp, 16);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        sscanf(cTemp, "%d,%d", &fr.stRegion.stPoints[i].iX, &fr.stRegion.stPoints[i].iY);
    }
    
    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_RULE9_FACEREC, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Set VCA FaceRec param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set VCA FaceRec param success.\n");
        //Test_VCARestart();
        Test_VCARestartEx();
    }

    return 0;
}

int T_SetVCAVideoDetection(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_SetVCAVideoDetection] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    int iRuleID = 0;
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_VIDEODETECT; //-->eventid--2

    vca_TRuleParam& rp = pVcaPara->chnParam[_iChan].rule[iRuleID];
    vca_TVideoDetection& vd = pVcaPara->chnParam[_iChan].rule[iRuleID].events.m_stVideoDetection;
    fprintf(stderr, "Please input enable set : (bit0-bit8:\
					Noise, Clarity, Bright, Color, Freeze, Nosignal, Change\
					, Interfere, Ptz lost ctl\n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    rp.iValid = to_int_def(cTemp);

    rp.stDisplayParam.iDisplayStat = 1;

    fprintf(stderr, "Please input check time:\n");
    gets_s(cTemp, 8);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iCheckTime = to_int_def(cTemp);
    vd.m_iCheckTime = iCheckTime;
    
    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_RULE10_VIDEODETECT, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Set VCA VideoDetection param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set VCA VideoDetection param success.\n");
        //Test_VCARestart();
        Test_VCARestartEx();
    }

    return 0;
}

int T_SetVCAAlarmSchedule(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_VCASetAlarmSchedule] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1

    fprintf(stderr, "Please input Event ID(0~10): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iEventID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = iEventID; //-->eventid--2

    fprintf(stderr, "Please input weekday(0~6): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iWeekDay = to_int_def(cTemp);

    vca_TAlarmSchedule& as = pVcaPara->chnParam[_iChan].rule[iRuleID].alarmSchedule; //-->time segment---3
    as.iWeekday = iWeekDay;

    fprintf(stderr, "Please input four timesegment and enable state, e.g: (8:10~10:00, 1). \n");
    for(int i=0; i<4; i++)
    {
        fprintf(stderr, "Time segment %d:", i);
        gets_s(cTemp, 256);
        if(strlen(cTemp) == 0)
            continue;
        sscanf(cTemp, "%d:%d~%d:%d,%d", &as.timeSeg[iWeekDay][i].iStartHour, &as.timeSeg[iWeekDay][i].iStartMinute, 
               &as.timeSeg[iWeekDay][i].iStopHour, &as.timeSeg[iWeekDay][i].iStopMinute, &as.timeSeg[iWeekDay][i].iEnable);
    }
    
    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_ALARM_SCHEDULE, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Set VCA alarm shchedule failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set VCA alarm shchedule success.\n");
    }

    return 0;
}

int T_SetVCAAlarmLink(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_SetVCAAlarmLink] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1

    fprintf(stderr, "Please input Event ID(0~10): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iEventID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = iEventID; //-->eventid--2

    vca_TAlarmLink& al = pVcaPara->chnParam[_iChan].rule[iRuleID].alarmLink;

    fprintf(stderr, "Please choose alarm link type, 0-Audio, 1-Screen, 2-PortOut, 3-Record, 4-PTZ, 5-Snap: \n"); //-->link type--3
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iLinkType = to_int_def(cTemp);
    al.iLinkType = iLinkType;
    if(iLinkType == VCA_ARARMLINK_SCREEMSHOW || iLinkType == VCA_ALARMLINK_AUDIO || 
       iLinkType == VCA_ALARMLINK_OUTPORT || iLinkType == VCA_ALARMLINK_RECODER ||
       iLinkType == VCA_ALARMLINK_CAPTUREPIC)
    {
		
        fprintf(stderr, "Please input channel bits or enable:\n");  //-->channel bits--4
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        al.iLinkSet[iLinkType] = to_int_def(cTemp, -1);
    }
    else if(iLinkType == 4)
    {
        fprintf(stderr, "Please input the link channel no:\n"); //-->link channel no--5
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        al.iLinkChannel = to_int_def(cTemp);

        fprintf(stderr, "Please input link mode(0-no linkptz, 1-link preset(1~255), 2-link track(1), 3-link path(1~8)):\n"); //-->link no--6
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        int iLinkPTZType = to_int_def(cTemp);
        al.ptz[al.iLinkChannel].usType = iLinkPTZType;

        fprintf(stderr, "Please input link NO:\n");
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        int iLinkNO = to_int_def(cTemp);
        switch (iLinkPTZType)
        {
            case 1: al.ptz[al.iLinkChannel].usPresetNO = iLinkNO; break;
            case 2: al.ptz[al.iLinkChannel].usTrackNO = iLinkNO; break;
            case 3: al.ptz[al.iLinkChannel].usPathNO = iLinkNO; break;
            default: break;
        }
    }
    else
    {
        fprintf(stderr, "Please input 2(PortOut) or 4(PTZ).\n");
        return 0;
    }

    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_ALARM_LINK, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Set VCA alarm link failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set VCA alarm link success.\n");
    }

    return 0;
}

int T_SetVCAScheduleEnable(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_SetVCAScheduleEnable] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1

    fprintf(stderr, "Please input Event ID(0~10): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iEventID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = iEventID; //-->eventid--2
    vca_TScheduleEnable& te = pVcaPara->chnParam[_iChan].rule[iRuleID].scheduleEnable;
    
    fprintf(stderr, "Enable alarm schedule?(0-no, 1-yes):\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    te.iEnable = to_int_def(cTemp);  //-->enable--3
    te.iParam = 0;                  //-->para--4

    int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_SCHEDULE_ENABLE, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Set VCA alarm shchedule enable failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set VCA alarm shchedule enable success.\n");
    }

    return 0;
}

int T_SetVCAAbandum(int _iChan)
{
	vca_TVCAParam* pVcaPara = &g_vcaPara;
	if(pVcaPara == NULL)
	{
		fprintf(stderr, "[T_SetVCAAbandum] &g_vcaPara = NULL, will return.\n");
		return 0;
	}
	memset(pVcaPara, 0, sizeof(vca_TVCAParam));

	pVcaPara->iChannelID = _iChan;  //-->channel id--0

	fprintf(stderr, "Please input ruleID(0~7): \n");
	char cTemp[256] = {0};
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	int iRuleID = to_int_def(cTemp);
	pVcaPara->chnParam[_iChan].iRuleID = iRuleID;//-->ruleid--1 

	fprintf(stderr, "Please input Event ID(0~10): \n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
		return -1;
	int iEventID = to_int_def(cTemp);
	pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = iEventID; //-->eventid--2

	int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_RULE_COMMON, _iChan, pVcaPara, sizeof(vca_TVCAParam));
	vca_TRuleParam& tRuleParam = pVcaPara->chnParam[_iChan].rule[iRuleID];

	fprintf(stderr, "Please input rule valid(0-no, 1-yes):\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	tRuleParam.iValid = to_int_def(cTemp);

	fprintf(stderr, "Display this rule(0-no, 1-yes), show alarm statistics(0-no, 1-yes) e.g: 1,1: \n"); //-->display para--4
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	sscanf(cTemp, "%d,%d", &tRuleParam.stDisplayParam.iDisplayRule, &tRuleParam.stDisplayParam.iDisplayStat);

	vca_tOSC & tOSC = pVcaPara->chnParam[_iChan].rule[iRuleID].events.m_stOSC;

    fprintf(stderr,"No alarm color(1~8), alarm color(1~8) e.g:3,3\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	sscanf(cTemp, "%d,%d", &tOSC.iColor, &tOSC.iAlarmColor);
	
	fprintf(stderr, "Please input Mintime range:(0,30000 ms):\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	tOSC.iMinTime = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input Minsize:0~100,and Maxsize:100~40000. e.g:10,10000\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	sscanf(cTemp, "%d,%d", &tOSC.iMinSize, &tOSC.iMaxSize);

	fprintf(stderr, "Please input main region point num(<=16):\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	int iPointNum = to_int_def(cTemp, -1);
	tOSC.stMainRegion.iPointNum = iPointNum;

	fprintf(stderr, "Please input the points, e.g:10,20 \n");
	for(int i=0; i<iPointNum; i++)
	{
		fprintf(stderr, "Point %d:", i);
		gets_s(cTemp, 16);
		if(0 == strcasecmp(cTemp, "q"))
		{
			return -1;
		}
		sscanf(cTemp, "%d,%d", &tOSC.stMainRegion.stPoints[i].iX, &tOSC.stMainRegion.stPoints[i].iY);
	}
	
	fprintf(stderr, "Please input subRegion num(<=3):\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	int iSubRegionNum = to_int_def(cTemp, -1);
	tOSC.iSunRegionCount = iSubRegionNum;

	for(int i=0; i<iSubRegionNum; i++)
	{
		fprintf(stderr, "Please input SunRegion%d point num(<=16):\n", i+1);
		gets_s(cTemp, 256);
		if(0 == strcasecmp(cTemp, "q"))
		{
			return -1;
		}
		int iSunPointNum = to_int_def(cTemp, -1);
		tOSC.stSubRegion[i].iPointNum = iSunPointNum;

		fprintf(stderr, "Please input the points, e.g:10,20 \n");
		for(int j=0; j<iSunPointNum; j++)
		{
			fprintf(stderr, "Point %d:", j+1);
			gets_s(cTemp, 16);
			if(0 == strcasecmp(cTemp, "q"))
			{
				return -1;
			}
			sscanf(cTemp, "%d,%d", &tOSC.stSubRegion[i].stPoints[j].iX, &tOSC.stSubRegion[i].stPoints[j].iY);
		}
	}
	
	iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_RULE8_ABANDUM, _iChan, pVcaPara, sizeof(vca_TVCAParam)); 
	if (0==iRet)
	{
		fprintf(stderr, "set abandum and object stolen succeed!");
	}
	else
	{
		fprintf(stderr, "set abandum and object stolen failed!, return = %d, err = 0x%08x. \n", iRet, errno);
	}
	return 0;
}

int T_GetVCAAbandum(int _iChan)
{
	vca_TVCAParam* pVcaPara = &g_vcaPara;
	if(pVcaPara == NULL)
	{
		fprintf(stderr, "[T_GetVCAAbandum] &g_vcaPara = NULL, will return.\n");
		return 0;
	}
	memset(pVcaPara, 0, sizeof(vca_TVCAParam));

	pVcaPara->iChannelID = _iChan;  //-->channel id--0

	fprintf(stderr, "Please input ruleID(0~7): \n");
	char cTemp[256] = {0};
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	int iRuleID = to_int_def(cTemp);
	pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1

	fprintf(stderr, "Please input Event ID(0~10): \n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
		return -1;
	int iEventID = to_int_def(cTemp);
	pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = iEventID; //-->eventid--2

	int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_RULE8_ABANDUM, _iChan, pVcaPara, sizeof(vca_TVCAParam));
	if (0 == iRet)
	{
		vca_TRuleParam & tRuleParam = pVcaPara->chnParam[_iChan].rule[iRuleID];
		vca_tOSC & tOSC = pVcaPara->chnParam[_iChan].rule[iRuleID].events.m_stOSC;
		fprintf(stderr, "Get VCA and object stolen succeed!");

		fprintf(stderr, "iValid=%d,display rule=%d,display state=%d,alarm color=%d,no alarm color=%d,Min time=%d,Min size=%d,Max size=%d.\n",
						tRuleParam.iValid, tRuleParam.stDisplayParam.iDisplayRule, tRuleParam.stDisplayParam.iDisplayStat, tOSC.iColor, tOSC.iAlarmColor,
						tOSC.iMinTime, tOSC.iMinSize, tOSC.iMaxSize);
		
		fprintf(stderr,"Main point num = %d.\n", tOSC.stMainRegion.iPointNum);
		
		for(int i=0; i<tOSC.stMainRegion.iPointNum; i++)
		{
			fprintf(stderr, "main region point %d:", i+1);
			fprintf(stderr, "%d,%d\n", tOSC.stMainRegion.stPoints[i].iX, tOSC.stMainRegion.stPoints[i].iY);
		}
		
		fprintf(stderr, "Subregion num = %d.\n",tOSC.iSunRegionCount);

		for(int i=0; i<tOSC.iSunRegionCount; i++)
		{
			fprintf(stderr, "SunRegion%d:\n", i+1);
			fprintf(stderr, "Point num = %d", tOSC.stSubRegion[i].iPointNum);
			for(int j=0; j<tOSC.stSubRegion[i].iPointNum; j++)
			{
				fprintf(stderr, "Point %d:", j+1);
				fprintf(stderr, "%d,%d", tOSC.stSubRegion[i].stPoints[j].iX, tOSC.stSubRegion[i].stPoints[j].iY);
			}
		}
	}
	else
	{
		fprintf(stderr, "Get VCA and object stolene failed, return = %d, err = 0x%08x. \n", iRet, errno);
	}
	return 0;
}

int T_SetVCACrowd(int _iChan)
{	
	vca_TVCAParam* pVcaPara = &g_vcaPara;
	if(pVcaPara == NULL)
	{
		fprintf(stderr, "[T_SetVCACrowd] &g_vcaPara = NULL, will return.\n");
		return 0;
	}
	memset(pVcaPara, 0, sizeof(vca_TVCAParam));

	pVcaPara->iChannelID = _iChan;  //-->channel id--0

	fprintf(stderr, "Please input ruleID(0~7): \n");
	char cTemp[256] = {0};
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	int iRuleID = to_int_def(cTemp);
	pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1
	pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_CROWD; //-->eventid--2

	vca_TRuleParam& rp = pVcaPara->chnParam[_iChan].rule[iRuleID];
	vca_tCrowd& tCd = pVcaPara->chnParam[_iChan].rule[iRuleID].events.m_stCrowd;
	fprintf(stderr, "Please input rule valid(0-no, 1-yes):\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	rp.iValid = to_int_def(cTemp);

	fprintf(stderr, "Display this rule(0-no, 1-yes), show alarm statistics(0-no, 1-yes): \n"); //-->display para--4
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	sscanf(cTemp, "%d,%d", &rp.stDisplayParam.iDisplayRule, &rp.stDisplayParam.iDisplayStat);
	
	tCd.stRegion.iPointNum = 4;

	fprintf(stderr, "Please input the points,you only need to input two points to determine a rect,e.g:10,20 \n");
	for(int i=0; i<2; i++)
	{
		fprintf(stderr, "Point %d:", i);
		gets_s(cTemp, 16);
		if(0 == strcasecmp(cTemp, "q"))
		{
			return -1;
		}
		sscanf(cTemp, "%d,%d", &tCd.stRegion.stPoints[2*i].iX, &tCd.stRegion.stPoints[2*i].iY);
	}
	tCd.stRegion.stPoints[1].iX = tCd.stRegion.stPoints[2].iX;
	tCd.stRegion.stPoints[1].iY = tCd.stRegion.stPoints[0].iY;
	tCd.stRegion.stPoints[3].iX = tCd.stRegion.stPoints[0].iX;
	tCd.stRegion.stPoints[3].iY = tCd.stRegion.stPoints[2].iY;

	int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_RULE13_CROWD, _iChan, pVcaPara, sizeof(vca_TVCAParam));
	if(iRet < 0)
	{
		fprintf(stderr, "Set VCA crowd param failed, return = %d, err = 0x%08x. \n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Set VCA crowd param success.\n");
		//Test_VCARestart();
		Test_VCARestartEx();
	}

	return 0;	
}

int T_GetVCACrowd(int _iChan)
{
	vca_TVCAParam* pVcaPara = &g_vcaPara;
	if(pVcaPara == NULL)
	{
		fprintf(stderr, "[T_GetVCACrowd] &g_vcaPara = NULL, will return.\n");
		return 0;
	}
	memset(pVcaPara, 0, sizeof(vca_TVCAParam));

	pVcaPara->iChannelID = _iChan;  //-->channel id--0

	fprintf(stderr, "Please input ruleID(0~7): \n");
	char cTemp[256] = {0};
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	int iRuleID = to_int_def(cTemp);
	pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1

	pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_CROWD; //-->eventid--2

	int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_RULE13_CROWD, _iChan, pVcaPara, sizeof(vca_TVCAParam));
	if (0 == iRet)
	{
		vca_TRuleParam & tRuleParam = pVcaPara->chnParam[_iChan].rule[iRuleID];
		vca_tCrowd & tC = pVcaPara->chnParam[_iChan].rule[iRuleID].events.m_stCrowd;
		fprintf(stderr, "Get VCA and crowd succeed!");

		fprintf(stderr, "iValid=%d,display rule=%d,display state=%d.\n",
			tRuleParam.iValid, tRuleParam.stDisplayParam.iDisplayRule, tRuleParam.stDisplayParam.iDisplayStat);

		fprintf(stderr,"point num = %d.\n", tC.stRegion.iPointNum);
		for(int i=0; i<tC.stRegion.iPointNum; i++)
		{
			fprintf(stderr, "Point %d:", i+1);
			fprintf(stderr, "%d,%d", tC.stRegion.stPoints[i].iX, tC.stRegion.stPoints[i].iY);
		}
	}
	else
	{
		fprintf(stderr, "Get VCA crowd failed, return = %d, err = 0x%08x. \n", iRet, errno);
	}
	return 0;
}

int T_SetVCAFlux(int _iChan)
{	
	vca_TVCAParam* pVcaPara = &g_vcaPara;
	if(pVcaPara == NULL)
	{
		fprintf(stderr, "[T_SetVCAFlux] &g_vcaPara = NULL, will return.\n");
		return 0;
	}
	memset(pVcaPara, 0, sizeof(vca_TVCAParam));

	pVcaPara->iChannelID = _iChan;  //-->channel id--0

	fprintf(stderr, "Please input ruleID(0~7): \n");
	char cTemp[256] = {0};
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	int iRuleID = to_int_def(cTemp);
	pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1
	pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_FLUXSTATISTIC; //-->eventid--2

	vca_TRuleParam& rp = pVcaPara->chnParam[_iChan].rule[iRuleID];
	vca_tFluxStatistic& tFlux = pVcaPara->chnParam[_iChan].rule[iRuleID].events.m_stFluxStatic;
	fprintf(stderr, "Please input rule valid(0-no, 1-yes):\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	rp.iValid = to_int_def(cTemp);

	fprintf(stderr, "Display this rule(0-no, 1-yes), show alarm statistics(0-no, 1-yes): \n"); //-->display para--4
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	sscanf(cTemp, "%d,%d", &rp.stDisplayParam.iDisplayRule, &rp.stDisplayParam.iDisplayStat);

	tFlux.stRegion.iPointNum = 4;

	fprintf(stderr, "Please input the points,you only need to input two points to determine a rect,e.g:10,20 \n");
	for(int i=0; i<4; i++)
	{
		fprintf(stderr, "Point %d:", i);
		gets_s(cTemp, 16);
		if(0 == strcasecmp(cTemp, "q"))
		{
			return -1;
		}
		sscanf(cTemp, "%d,%d", &tFlux.stRegion.stPoints[i].iX, &tFlux.stRegion.stPoints[i].iY);
	}

	int iRet = NetClient_VCASetConfig(g_iLogonID, VCA_CMD_SET_RULE12_FLUXSTATISTIC, _iChan, pVcaPara, sizeof(vca_TVCAParam));
	if(iRet < 0)
	{
		fprintf(stderr, "Set VCA flux param failed, return = %d, err = 0x%08x. \n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Set VCA flux param success.\n");
		//Test_VCARestart();
		Test_VCARestartEx();
	}

	return 0;	
}

int T_GetVCAFlux(int _iChan)
{
	vca_TVCAParam* pVcaPara = &g_vcaPara;
	if(pVcaPara == NULL)
	{
		fprintf(stderr, "[T_GetVCAFlux] &g_vcaPara = NULL, will return.\n");
		return 0;
	}
	memset(pVcaPara, 0, sizeof(vca_TVCAParam));

	pVcaPara->iChannelID = _iChan;  //-->channel id--0

	fprintf(stderr, "Please input ruleID(0~7): \n");
	char cTemp[256] = {0};
	gets_s(cTemp, 256);
	if(0 == strcasecmp(cTemp, "q"))
	{
		return -1;
	}
	int iRuleID = to_int_def(cTemp);
	pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1

	pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_FLUXSTATISTIC; //-->eventid--2

	int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_RULE12_FLUXSTATISTIC, _iChan, pVcaPara, sizeof(vca_TVCAParam));
	if (0 == iRet)
	{
		vca_TRuleParam & tRuleParam = pVcaPara->chnParam[_iChan].rule[iRuleID];
		vca_tFluxStatistic & tFlux = pVcaPara->chnParam[_iChan].rule[iRuleID].events.m_stFluxStatic;
		fprintf(stderr, "Get VCA and flux succeed!");

		fprintf(stderr, "iValid=%d,display rule=%d,display state=%d.\n",
			tRuleParam.iValid, tRuleParam.stDisplayParam.iDisplayRule, tRuleParam.stDisplayParam.iDisplayStat);

		fprintf(stderr,"point num = %d.\n", tFlux.stRegion.iPointNum);
		for(int i=0; i<tFlux.stRegion.iPointNum; i++)
		{
			fprintf(stderr, "Point %d:", i+1);
			fprintf(stderr, "%d,%d", tFlux.stRegion.stPoints[i].iX, tFlux.stRegion.stPoints[i].iY);
		}
	}
	else
	{
		fprintf(stderr, "Get VCA flux failed, return = %d, err = 0x%08x. \n", iRet, errno);
	}
	return 0;
}

int T_GetVCAChanEnable(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCAChanEnable] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0
    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_CHANNEL, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA channel enable failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Get VCA channel enable success, enable = %d.\n", pVcaPara->chnParam[_iChan].iEnable);
    }

    return 0;
}

int T_GetVCAVideoSize(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCAVideoSize] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0
    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_VIDEOSIZE, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA videosize failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "SGet VCA videosize success, size = %d.\n", pVcaPara->chnParam[_iChan].config.iVideoSize);
    }

    return 0;
}

int T_GetVCAAdvPara(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCAAdvPara] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0
    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_ADVANCE_PARAM, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA advance param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        vca_TAdvParam& pAP = pVcaPara->chnParam[_iChan].advParam;
        fprintf(stderr, "Get VCA advance param success.\nMinsize=%d\nMaxSize=%d\nMinWidth=%d\nMaxWidth=%d\n"
                        "MinHeight=%d\nMaxHeight=%d\nMinWHRatio=%d\nMaxWHRatio=%d\nMinSpeed=%d\nMaxSpeed=%d\n"
                        "Enable=%d\nSensitivity=%d\n", pAP.iTargetMinSize, pAP.iTargetMaxSize, pAP.iTargetMinWidth, pAP.iTargetMaxWidth, 
                pAP.iTargetMinHeight, pAP.iTargetMaxHeight, pAP.iTargetMinWHRatio, pAP.iTargetMaxWHRatio, pAP.iTargetMinSpeed, pAP.iTargetMaxSpeed,
                pAP.iEnable, pAP.iSensitivity);
    }

    return 0;
}

int T_GetVCATargetPara(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCATargetPara] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0
    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_TARGET_PARAM, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA target param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        vca_TConfig &config = pVcaPara->chnParam[_iChan].config;
        fprintf(stderr, "Get VCA target param success. Enable show trace=%d, Enable show target=%d, target color=%d, alarm color=%d, trace len=%d\n"
                        , config.iDisplayTrace, config.iDisplayTarget, config.iTargetColor, config.iTargetAlarmColor, config.iTraceLength);
    }

    return 0;
}

int T_GetVCAAlarmStat(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCAAlarmStat] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0
    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1

    fprintf(stderr, "Please input event ID(0 or 2): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iEventID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = iEventID; //-->eventid--2

    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_ALARM_STATISTIC, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA alarm statistics failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Get VCA alarm statistics success, count = %d\n", 
                pVcaPara->chnParam[_iChan].rule[iRuleID].iAlarmCount);
        
    }

    return 0;
}

int T_GetVCARuleCommPara(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCARuleCommPara] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0
    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1

    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_RULE_COMMON, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA rule common param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
         fprintf(stderr, "Get VCA rule common param success, rule name=%s\nvalid=%d\n", 
                 pVcaPara->chnParam[_iChan].rule[iRuleID].cRuleName, pVcaPara->chnParam[_iChan].rule[iRuleID].iValid);
    }

    return 0;
}

int T_GetVCATripWire(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCATripWire] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_TRIPWIRE; //-->eventid--2

    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_RULE0_TRIPWIRE, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA event tripwire param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        vca_TRuleParam& rp = pVcaPara->chnParam[_iChan].rule[iRuleID]; 
        vca_TTripwire& tw = pVcaPara->chnParam[_iChan].rule[iRuleID].events.tripwire;
        fprintf(stderr, "Get VCA event tripwire param success,Valid=%d, MinTime=%d, MinDistance=%d, Direction=%d, TripwireType=%d, TargetTypeCheck=%d\n"
                        "DisplayRule=%d, DisplayStatistics=%d, noAlarmColor=%d, AlarmColor=%d, startpoint(%d,%d), endpoint(%d,%d)\n", 
                tw.iValid, tw.iMinTime, tw.iMinDistance, tw.iDirection, tw.iType, tw.iTargetTypeCheck, rp.stDisplayParam.iDisplayRule,
                rp.stDisplayParam.iDisplayStat, rp.stDisplayParam.iColor, rp.stDisplayParam.iAlarmColor, tw.stLine.stStart.iX, tw.stLine.stStart.iY, 
                tw.stLine.stEnd.iX, tw.stLine.stEnd.iY);
    }

    return 0;
}

int T_GetVCAPerimeter(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCAPerimeter] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;

    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_PERIMETER; //-->eventid--2

    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_RULE2_PERIMETER, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA event perimeter param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        vca_TRuleParam& rp = pVcaPara->chnParam[_iChan].rule[iRuleID];
        vca_TPerimeter& pm = pVcaPara->chnParam[_iChan].rule[iRuleID].events.perimeter;
        fprintf(stderr, "Get VCA event perimeter param success, Valid=%d, MinTime=%d, MinDistance=%d, Direction=%d, PerimeterType=%d,\n"
                        "TargetTypeCheck=%d, DisplayRule=%d, DisplayStatistics=%d, noAlarmColor=%d, AlarmColor=%d, Mode=%d, PointNum=%d\n",
                pm.iValid, pm.iMinTime, pm.iMinDistance, pm.iDirection, pm.iType, pm.iTargetTypeCheck, rp.stDisplayParam.iDisplayRule,
                rp.stDisplayParam.iDisplayStat, rp.stDisplayParam.iColor, rp.stDisplayParam.iAlarmColor, pm.iMode, pm.stRegion.iPointNum);
        fprintf(stderr, "Points list:");
        for(int i=0; i<pm.stRegion.iPointNum; i++)
        {
            fprintf(stderr, "(%d,%d)", pm.stRegion.stPoints[i].iX, pm.stRegion.stPoints[i].iY); 
        }
        fprintf(stderr, "\n");
    }

    return 0;
}

int T_GetVCAFaceRec(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCAFaceRec] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;

    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_FACEREC; //-->eventid--2

    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_RULE9_FACEREC, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA event face rec param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        vca_TRuleParam& rp = pVcaPara->chnParam[_iChan].rule[iRuleID];
        vca_TFaceRec& fr = pVcaPara->chnParam[_iChan].rule[iRuleID].events.m_stFaceRec;
        fprintf(stderr, "Get VCA event face rec param success, Valid=%d, \n"
                        "DisplayRule=%d, DisplayStatistics=%d,  AlarmColor=%d, PointNum=%d\n",
                fr.iValid, rp.stDisplayParam.iDisplayRule, rp.stDisplayParam.iDisplayStat, rp.stDisplayParam.iAlarmColor, fr.stRegion.iPointNum);
        fprintf(stderr, "Points list:");
        for(int i=0; i<fr.stRegion.iPointNum; i++)
        {
            fprintf(stderr, "(%d,%d)", fr.stRegion.stPoints[i].iX, fr.stRegion.stPoints[i].iY); 
        }
        fprintf(stderr, "\n");
    }

    return 0;
}

int T_GetVCAVideoDetection(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCAVideoDetection] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;

    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = VCA_EVENT_VIDEODETECT; //-->eventid--2

    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_RULE10_VIDEODETECT, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA event videodetetion param failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        vca_TVideoDetection& vd = pVcaPara->chnParam[_iChan].rule[iRuleID].events.m_stVideoDetection;
        fprintf(stderr, "Get VCA event videodetetion param success, Valid=%d, \n"
                        "Check time = %d\n",
                vd.iValid, vd.m_iCheckTime);
    }

    return 0;
}

int T_GetVCAAlarmSchedule(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCAAlarmSchedule] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1

    fprintf(stderr, "Please input Event ID(0~10): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iEventID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = iEventID; //-->eventid--2

    fprintf(stderr, "Please input weekday(0~6): \n"); //--weekday--3
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iWeekday = to_int_def(cTemp);

    vca_TAlarmSchedule& as = pVcaPara->chnParam[_iChan].rule[iRuleID].alarmSchedule;
    as.iWeekday = iWeekday;

    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_ALARM_SCHEDULE, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA alarm schedule failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {   
        for(int i=0; i<4; i++)
        {
            fprintf(stderr, "Time segment%d(%02d:%02d~%02d:%02d,enable(%d))\n", i+1, as.timeSeg[iWeekday][i].iStartHour, as.timeSeg[iWeekday][i].iStartMinute,
                    as.timeSeg[iWeekday][i].iStopHour, as.timeSeg[iWeekday][i].iStopMinute, as.timeSeg[iWeekday][i].iEnable);
        }
    }

    return 0;
}

int T_GetVCAAlarmLink(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCAAlarmLink] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1

    fprintf(stderr, "Please input Event ID(0~10): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iEventID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = iEventID; //-->eventid--2

    fprintf(stderr, "Please input LinkType(0~5): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iLinkType = to_int_def(cTemp);

    pVcaPara->chnParam[_iChan].rule[iRuleID].alarmLink.iLinkType = iLinkType;
    if (4 == iLinkType)
    {
        fprintf(stderr, "Please input link channel no(0 or 1):\n"); //-->link channel no--4
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
            return -1;
        int iLinkChannel = to_int_def(cTemp);
        pVcaPara->chnParam[_iChan].rule[iRuleID].alarmLink.iLinkChannel = iLinkChannel;
    }

    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_ALARM_LINK, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA alarm link failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        vca_TAlarmLink& al = pVcaPara->chnParam[_iChan].rule[iRuleID].alarmLink;
        fprintf(stderr, "Get VCA alarm link successful, link type = %d\n", al.iLinkType);
        
        if(al.iLinkType == 4)
        {
            fprintf(stderr, "Link PTZ, link channel=%d, link PTZ type=%d\n", al.iLinkChannel, al.ptz[al.iLinkChannel].usType);
            if(al.ptz[al.iLinkChannel].usType == 1)
            {
                fprintf(stderr, "Link NO = %d\n", al.ptz[al.iLinkChannel].usPresetNO);
            }
            else if(al.ptz[al.iLinkChannel].usType == 2)
            {
                fprintf(stderr, "Link NO = %d\n", al.ptz[al.iLinkChannel].usTrackNO);
            }
            else if(al.ptz[al.iLinkChannel].usType == 3)
            {
                fprintf(stderr, "Link NO = %d\n", al.ptz[al.iLinkChannel].usPathNO);
            }
        }
        else
        {
            fprintf(stderr, "Link type = %d, value = %d\n", al.iLinkType, al.iLinkSet[al.iLinkType]); 
        }
    }

    return 0;
}

int T_GetVCAScheduleEnable(int _iChan)
{
    vca_TVCAParam* pVcaPara = &g_vcaPara;
    if(pVcaPara == NULL)
    {
        fprintf(stderr, "[T_GetVCAScheduleEnable] &g_vcaPara = NULL, will return.\n");
        return 0;
    }
    memset(pVcaPara, 0, sizeof(vca_TVCAParam));

    pVcaPara->iChannelID = _iChan;  //-->channel id--0

    fprintf(stderr, "Please input ruleID(0~7): \n");
    char cTemp[256] = {0};
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iRuleID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].iRuleID = iRuleID;       //-->ruleid--1

    fprintf(stderr, "Please input Event ID(0~10): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;
    int iEventID = to_int_def(cTemp);
    pVcaPara->chnParam[_iChan].rule[iRuleID].iEventID = iEventID; //-->eventid--2

    int iRet = NetClient_VCAGetConfig(g_iLogonID, VCA_CMD_GET_SCHEDULE_ENABLE, _iChan, pVcaPara, sizeof(vca_TVCAParam));
    if(iRet < 0)
    {
        fprintf(stderr, "Get VCA schedule enable failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        vca_TScheduleEnable& te = pVcaPara->chnParam[_iChan].rule[iRuleID].scheduleEnable;
        fprintf(stderr, "Get VCA schedule enable successful, enable=%d, param=%d.\n", te.iEnable, te.iParam);
    }
    
    return 0;
}

int Test_VCARestart()
{
    fprintf(stderr, "You choose to test NetClient_VCARestart, number is 337\n");
    int iRet = NetClient_VCARestart(g_iLogonID);
    if(iRet < 0)
    {
        fprintf(stderr, "VCA restart failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "VCA restart successful. \n");
    }

    return 0;
}

int Test_VCARestartEx()
{
    fprintf(stderr, "You choose to test NetClient_VCARestart, number is 343\n");

    char cTemp[256] = {0};
    fprintf(stderr,"Please input channel NO:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
        return -1;

    int iChan = to_int_def(cTemp);
    int iRet = NetClient_VCARestartEx(g_iLogonID, iChan);
    if(iRet < 0)
    {
        fprintf(stderr, "Call NetClient_VCARestart failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Call NetClient_VCARestart successful. \n");
    }

    return 0;
}

int Test_SetChannelSipConfig()
{
    fprintf(stderr, "You choose to test NetClient_SetChannelSipConfig, number is 305\n");
    char cTemp[256] = {0};
	fprintf(stderr,"1:SIP_CMD_SET_VIDEOCHANNEL\n");
	fprintf(stderr,"2:SIP_CMD_SET_ALARMCHANNEL\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int Num = to_int_def(cTemp);
    if (Num == 1)
    {
        TSipVideoChannel svc = {0};
        fprintf(stderr,"Please input channel no :\n");
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        int iChan = to_int_def(cTemp);
        svc.iChannelNo = iChan;
        fprintf(stderr,"Please input channelID :\n");
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        strcpy(svc.cChannelID, cTemp);
        fprintf(stderr,"Please input channel level :\n");
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        svc.iLevel = to_int_def(cTemp);
        fprintf(stderr,"Please input channel ptztime :\n");
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        svc.iPtzTime = to_int_def(cTemp);
        int iRet = NetClient_SetChannelSipConfig(g_iLogonID, iChan, SIP_CMD_SET_VIDEOCHANNEL, &svc, sizeof(svc));
        if(iRet < 0)
        {
            fprintf(stderr, "SetChannelSipConfig failed!\n");
        }
        else
        {
            fprintf(stderr, "SetChannelSipConfig success!\n");
        }
        fprintf(stderr, "Please type a number to test corresponding interface:\n");
    
        return 0;
    }
    else if (Num == 2)
    {
        TSipAlarmChannel svc = {0};
        fprintf(stderr,"Please input channel no :\n");
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        int iChan = to_int_def(cTemp);
        svc.iChannelNo = iChan;
        fprintf(stderr,"Please input channelID :\n");
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        strcpy(svc.cChannelID, cTemp);
        fprintf(stderr,"Please input channel level :\n");
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        svc.iLevel = to_int_def(cTemp);
        int iRet = NetClient_SetChannelSipConfig(g_iLogonID, iChan, SIP_CMD_SET_ALARMCHANNEL, &svc, sizeof(svc));
        if(iRet < 0)
        {
            fprintf(stderr, "SetChannelSipConfig failed!\n");
        }
        else
        {
            fprintf(stderr, "SetChannelSipConfig success!\n");
        }
        fprintf(stderr, "Please type a number to test corresponding interface:\n");
        return 0;
    }

    return 0;
}

int Test_GetChannelSipConfig()
{
    fprintf(stderr, "You choose to test NetClient_GetChannelSipConfig, number is 306\n");
    char cTemp[256] = {0};
	fprintf(stderr,"1:SIP_CMD_SET_VIDEOCHANNEL\n");
	fprintf(stderr,"2:SIP_CMD_SET_ALARMCHANNEL\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int Num = to_int_def(cTemp);

    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr,"Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChannelNo = to_int_def(cTemp);

    if (1 == Num)
    {
        TSipVideoChannel svc = {0};
        //int iChan = svc.iChannelNo;
        svc.iChannelNo = iChannelNo;
        int iRet = NetClient_GetChannelSipConfig(g_iLogonID, iChannelNo, SIP_CMD_GET_VIDEOCHANNEL, &svc, sizeof(svc));
        if(iRet < 0)
        {
            fprintf(stderr, "GetChannelSipConfig failed!\n");
        }
        else
        {
            fprintf(stderr, "GetChannelSipConfig success!\n");
            fprintf(stderr, "Channel NO: %d,ChannelID: %s, Channel level: %d, Channel ptztime: %d\n", svc.iChannelNo,svc.cChannelID, svc.iLevel, svc.iPtzTime);
        }
        fprintf(stderr, "Please type a number to test corresponding interface:\n");    
        return 0;
    }
    else if (2 == Num)
    {
        TSipAlarmChannel svc = {0};
        //int iChan = svc.iChannelNo;
        svc.iChannelNo = iChannelNo;
        int iRet = NetClient_GetChannelSipConfig(g_iLogonID, iChannelNo, SIP_CMD_GET_ALARMCHANNEL, &svc, sizeof(svc));
        if(iRet < 0)
        {
            fprintf(stderr, "GetChannelSipConfig failed!\n");
        }
        else
        {
            fprintf(stderr, "GetChannelSipConfig success!\n");
            fprintf(stderr, "Channel NO: %d, ChannelID: %s, Channel level: %d\n", svc.iChannelNo, svc.cChannelID, svc.iLevel);
        }
        fprintf(stderr, "Please type a number to test corresponding interface:\n");    
        return 0;
    }

    return 0;
}

//add by cmz 20110309
int Test_GetMaxVideoSize()
{
    fprintf(stderr, "You choose to test NetClient_GetMaxVideoSize, number is 307\n");
    int iVideoSize = 0;
    int iRet = NetClient_GetMaxVideoSize(g_iLogonID, &iVideoSize);
    if(iRet < 0)
    {
        fprintf(stderr, "GetMaxVideoSize failed!\n");
    }
    else
    {
        fprintf(stderr, "GetMaxVideoSize success!\n");
        fprintf(stderr, "MaxVideoSize: %d\n", iVideoSize);
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");    
    return 0;
}

int Test_SetBitRatePercent()
{
    fprintf(stderr, "You choose to test NetClient_SetBitRatePercent, number is 308\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChan = to_int_def(cTemp);
    fprintf(stderr, "Please input Percent:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iPercent = to_int_def(cTemp);
    int iRet = NetClient_SetBitRatePercent(g_iLogonID, iChan, iPercent);
    if(iRet < 0)
    {
        fprintf(stderr, "SetBitRatePercent failed!\n");
    }
    else
    {
        fprintf(stderr, "SetBitRatePercent success!\n");
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");    
    return 0;

}

int Test_GetBitRatePercent()
{
    fprintf(stderr, "You choose to test NetClient_GetBitRatePercent, number is 309\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChan = to_int_def(cTemp);
    int iPercent = 0;
    int iRet = NetClient_GetBitRatePercent(g_iLogonID, iChan, &iPercent);
    if(iRet < 0)
    {
        fprintf(stderr, "SetBitRatePercent failed!\n");
    }
    else
    {
        fprintf(stderr, "SetBitRatePercent success!\n");
        fprintf(stderr, "iChan:%d,Percent: %d\n", iChan,iPercent);
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");    
    return 0;
}

int Test_SetFTPUsage()
{
    fprintf(stderr, "You choose to test NetClient_SetFTPUsage, number is 310\n");
    char cTemp[256] = {0};
    FTP_UPDATE FtpUpdate;
    memset(&FtpUpdate, 0, sizeof(FtpUpdate));
    fprintf(stderr, "Please input FtpAddr :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    strcpy(FtpUpdate.cFtpAddr, cTemp);
    fprintf(stderr, "Please input Port :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    FtpUpdate.iPort = to_int_def(cTemp);
    fprintf(stderr, "Please input FilePath :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    strcpy(FtpUpdate.cFileName,cTemp);
    fprintf(stderr, "Please input FtpUserName :\n");
    gets_s(cTemp, 256);
    strcpy(FtpUpdate.cUserName,cTemp);
    fprintf(stderr, "Please input FtpPassword :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    strcpy(FtpUpdate.cPassword,cTemp);
    fprintf(stderr, "Please input Usage :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    FtpUpdate.iUsage = to_int_def(cTemp);

    int iRet = NetClient_SetFTPUsage(g_iLogonID, FtpUpdate.cFtpAddr, FtpUpdate.iPort, FtpUpdate.cFileName, FtpUpdate.cUserName, FtpUpdate.cPassword, FtpUpdate.iUsage);
    if(iRet < 0)
    {
        fprintf(stderr, "SetFTPUsage failed!\n");
    }
    else
    {
        fprintf(stderr, "SetFTPUsage success!\n");
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");    
    return 0;

}
int Test_GetFTPUsage()
{
    fprintf(stderr, "You choose to test NetClient_GetFTPUsage, number is 311\n");
    FTP_UPDATE FtpUpdate;
    memset(&FtpUpdate, 0, sizeof(FtpUpdate));
    int iRet = NetClient_GetFTPUsage(g_iLogonID, FtpUpdate.cFtpAddr, &FtpUpdate.iPort, FtpUpdate.cFileName,
                                      FtpUpdate.cUserName, FtpUpdate.cPassword, &FtpUpdate.iUsage);
    if(iRet < 0)
    {
        fprintf(stderr, "GetFTPUsage failed!\n");
    }
    else
    {
        fprintf(stderr, "GetFTPUsage success!\n");
        fprintf(stderr, "FtpAddr:%s,Port: %d,FilePath:%s,FtpUserName:%s,FtpPassword:%s,Usage:%d\n", FtpUpdate.cFtpAddr,
                 FtpUpdate.iPort, FtpUpdate.cFileName, FtpUpdate.cUserName, FtpUpdate.cPassword, FtpUpdate.iUsage);
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");    
    return 0;
}

////GetVideoParam add by cmz 20110309
int Test_GetVideoParam()
{
    fprintf(stderr, "You choose to test NetClient_GetVideoParam, number is 312\n");
	fprintf(stderr, "Please connect video before use this interface\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChan = to_int_def(cTemp);

    fprintf(stderr,"Stream type:\n 0: MAIN_STREAM\n 1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iStreamType = to_int_def(cTemp, -1);

    int iWidth = 0;
    int iHeight = 0;
    int iFrameRate = 0;

    int iRet = NetClient_GetVideoParam(g_uiRecv[iChan+ iStreamType*g_iTotalChnlNum], &iWidth, &iHeight, &iFrameRate);
    if(iRet < 0)
    {
        fprintf(stderr, "GetVideoParam failed! err = 0x%08x\n", errno);
    }
    else
    {
        fprintf(stderr, "GetVideoParam success!\n");
        fprintf(stderr, "Width: %d,Height:%d,FrameRate:%d\n", iWidth, iHeight, iFrameRate);
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");    
    return 0;
}

//OSDAlpha
int Test_SetOSDAlpha()
{
    fprintf(stderr, "You choose to test NetClient_SetOSDAlpha, number is 313\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChan = to_int_def(cTemp);
    fprintf(stderr, "Please input Alpha no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iAlpha = to_int_def(cTemp);
    int iRet = NetClient_SetOSDAlpha(g_iLogonID, iChan, iAlpha);
    if(iRet < 0)
    {
        fprintf(stderr, "SetOSDAlpha failed!\n");
    }
    else
    {
        fprintf(stderr, "SetOSDAlpha success!\n");
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");    
    return 0;
}

int Test_GetOSDAlpha()
{
    fprintf(stderr, "You choose to test NetClient_GetOSDAlpha, number is 314\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChan = to_int_def(cTemp);
    int iAlpha = 0;
    int iRet = NetClient_GetOSDAlpha(g_iLogonID, iChan, &iAlpha);
    if(iRet < 0)
    {
        fprintf(stderr, "GetOSDAlpha failed!\n");
    }
    else
    {
        fprintf(stderr, "GetOSDAlpha success!\n");
        fprintf(stderr, "Channel: %d,Alpha:%d\n", iChan, iAlpha);
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");    
    return 0;
}

int Test_Set3GDVRConfig()
{
    fprintf(stderr, "You choose to test NetClient_Set3GConfig, number is 315\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please choose operation:\n0-set power delay\n1-set GPS overlay\n2-set GPS filter\n3-set ftp upload mode.\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iCmd = to_int_def(cTemp);

    switch(iCmd)
    {
        case 0: return T_SetPowerDelay();
        case 1: return T_SetGPSOverlay();
        case 2: return T_SetGPSFilter();
        case 3: return T_SetFtpUploadMode();
        default: 
            {
                fprintf(stderr, "You input error cmd id(%d).\n", iCmd);
                break;
            }
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

    return 0;
}

int Test_Get3GDVRConfig()
{
    fprintf(stderr, "You choose to test NetClient_Get3GConfig, number is 316\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please choose operation: 0-get power delay, 1-get sim num, 2-get GPS overlay, 3-get GPS filter, 4-get ftp upload mode.\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iCmd = to_int_def(cTemp);

    switch(iCmd)
    {
        case 0: return T_GetPowerDelay();
        case 1: return T_GetSimNum();
        case 2: return T_GetGPSOverlay();
        case 3: return T_GetGPSFilter();
        case 4: return T_GetFtpUploadMode();
        default: 
            {
                fprintf(stderr, "You input error cmd id(%d).\n", iCmd);
                break;
            }
    }
    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int T_SetPowerDelay()
{
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChanNo = to_int_def(cTemp);

    fprintf(stderr, "Please input the delaytime of power on:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iTimeOn = to_int_def(cTemp);

    fprintf(stderr, "Please input the delaytime of power off:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iTimeOff = to_int_def(cTemp);

    TDVR3GInfo info = {0};
    info.iPowerDelayOnTime = iTimeOn;
    info.iPowerDelayOffTime = iTimeOff;

    int iRet = NetClient_Set3GConfig(g_iLogonID,  DVR3G_CMD_SET_POWERDELAY, iChanNo, &info, sizeof(TDVR3GInfo));
    if(iRet < 0)
    {
        fprintf(stderr, "Set power delay failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set power delay successful.\n");
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int T_SetGPSOverlay()
{
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChanNo = to_int_def(cTemp);

    fprintf(stderr, "Please input the dis/enable of overlay:(0-disbale, 1-enable): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iEnable = to_int_def(cTemp);

    TDVR3GInfo info = {0};
    info.iGpsOverlay[iChanNo] = iEnable;

    int iRet = NetClient_Set3GConfig(g_iLogonID,  DVR3G_CMD_SET_GPSOVERLAY, iChanNo, &info, sizeof(TDVR3GInfo));
    if(iRet < 0)
    {
        fprintf(stderr, "Set gps overlay failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set gps overlay successful.\n");
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int T_SetGPSFilter()
{
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChanNo = to_int_def(cTemp);

    fprintf(stderr, "Please input the filter no(GGA, RMC, VTG, GLL, GSA, GSV).\n"
                    "e.g:0,1,0,1,1,0 ==>0-no filter,1-filter.\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iTempBit[6] = {0};
    sscanf(cTemp, "%d,%d,%d,%d,%d,%d", &iTempBit[0], &iTempBit[1], &iTempBit[2], &iTempBit[3],
           &iTempBit[4], &iTempBit[5]);
    int iBitSet[6] = {0x1, 0x2, 0x4, 0x8, 0x10, 0x20};

    int iFilter = 0;
    for(int i=0; i<6; i++)
    {
        if(iTempBit[i] == 1)
        {
            iFilter |= (iBitSet[i]);
        }
        else
        {
            iFilter &= ~(iBitSet[i]);
        }
        
    }

    TDVR3GInfo info = {0};
    info.iGpsFilter = iFilter;
    int iRet = NetClient_Set3GConfig(g_iLogonID, DVR3G_CMD_SET_GPSFILTER, iChanNo, &info, sizeof(TDVR3GInfo));
    if(iRet < 0)
    {
        fprintf(stderr, "Set gps filter failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set gps filter successful.\n");
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int T_SetFtpUploadMode()
{
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChanNo = to_int_def(cTemp);

    fprintf(stderr, "Please input the mode of ftp upload:(0-auto, 1-manual): \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iMode = to_int_def(cTemp);

    TDVR3GInfoEx infoEx;
    memset(&infoEx, 0, sizeof(infoEx));
    infoEx.iFtpUploadMode = iMode;
    int iRet = NetClient_Set3GConfig(g_iLogonID,  DVR3G_CMD_SET_FTPUPLOAD_MODE, iChanNo, &infoEx, sizeof(TDVR3GInfoEx));
    if(iRet < 0)
    {
        fprintf(stderr, "Set ftp upload failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Set ftp upload successful.\n");
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int T_GetPowerDelay()
{
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChanNo = to_int_def(cTemp);

    TDVR3GInfo info = {0};
    int iRet = NetClient_Get3GConfig(g_iLogonID,  DVR3G_CMD_GET_GPSOVERLAY,iChanNo, &info, sizeof(TDVR3GInfo));
    if(iRet < 0)
    {
        fprintf(stderr, "get gps power delay failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "get gps power delay successful.\n");
        fprintf(stderr, "Power on delay time = %d, off time = %d\n", info.iPowerDelayOnTime, info.iPowerDelayOffTime);
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int T_GetSimNum()
{
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChanNo = to_int_def(cTemp); 

    TDVR3GInfo info = {0};
    int iRet = NetClient_Get3GConfig(g_iLogonID,  DVR3G_CMD_GET_SIMNUM,iChanNo, &info,  sizeof(TDVR3GInfo));
    if(iRet < 0)
    {
        fprintf(stderr, "get sim number failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "get sim number successful.\n");
        fprintf(stderr, "Sim number = %s.\n", info.cSimNum);
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int T_GetGPSOverlay()
{
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChanNo = to_int_def(cTemp);

    TDVR3GInfo info = {0};
    int iRet = NetClient_Get3GConfig(g_iLogonID, DVR3G_CMD_GET_GPSOVERLAY,iChanNo, &info, sizeof(TDVR3GInfo));
    if(iRet < 0)
    {
        fprintf(stderr, "Get GPS overlay enable failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Get GPS overlay enable successful.\n");
        fprintf(stderr, "GPS overlay enable = %i.\n", info.iGpsOverlay[iChanNo]);
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int T_GetGPSFilter()
{
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChanNo = to_int_def(cTemp);

    TDVR3GInfo info = {0};
    int iRet = NetClient_Get3GConfig(g_iLogonID, DVR3G_CMD_GET_GPSFILTER, iChanNo,  &info, sizeof(TDVR3GInfo));
    if(iRet < 0)
    {
        fprintf(stderr, "Get GPS filter failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Get GPS filter successful.\n");
        int iBitSet[6] = {0x1, 0x2, 0x4, 0x8, 0x10, 0x20};
        //                GGA, RMC, VTG, GLL, GSA,  GSV
        char* strFilter[] = {"GGA", "RMC", "VTG", "GLL", "GSA", "GSV"};
        for(int i=0; i<6; i++)
        {
            if(iBitSet[i] == (info.iGpsFilter & iBitSet[i]))
            {
                fprintf(stderr, "%s is to be filtered!\n", strFilter[i]);
            }
        }
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;   
}

int T_GetFtpUploadMode()
{
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChanNo = to_int_def(cTemp);
    TDVR3GInfoEx infoEx;
    memset(&infoEx, 0, sizeof(infoEx));
    int iRet = NetClient_Get3GConfig(g_iLogonID, DVR3G_CMD_GET_FTPUPLOAD_MODE, iChanNo, &infoEx, sizeof(TDVR3GInfoEx));
    if(iRet < 0)
    {
        fprintf(stderr, "Get ftp upload mode failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "Get ftp upload mode successful.\n");
        fprintf(stderr, "Ftp upload mode  = %i.\n", infoEx.iFtpUploadMode);
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetColorToGray()
{
    fprintf(stderr, "You choose to test NetClient_SetColorToGray, number is 317\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChannelNo = to_int_def(cTemp);
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the enable no:\n 0:Disable \n 1:Gray \n 2:Color \n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iEnable = to_int_def(cTemp);
    int iRet = NetClient_SetColorToGray(g_iLogonID, iChannelNo, iEnable);
    if(iRet < 0)
    {
        fprintf(stderr, "NetClient_SetColorToGray failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_SetColorToGray is successful.\n");
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetColorToGray()
{
    fprintf(stderr, "You choose to test NetClient_GetColorToGray, number is 318\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChannelNo = to_int_def(cTemp);
    int iEnable = -1;
    int iRet = NetClient_GetColorToGray(g_iLogonID, iChannelNo, &iEnable);
    if(iRet < 0)
    {
        fprintf(stderr, "NetClient_GetColorToGray failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_GetColorToGray is successful.\n");
        fprintf(stderr, "Channel no: %d , enable  = %d.\n", iChannelNo, iEnable);
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetExceptionMsg()
{
    fprintf(stderr, "You choose to test NetClient_GetExceptionMsg, number is 319\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the exception type:\n");
	fprintf(stderr, " 0:Disk Full\n 1:No Disk\n 2:Disk I/O Error\n 3:No Allow Access\n 4:IP Collision\n 5:Network Interrupt\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iExceptionType = to_int_def(cTemp);
    int iState = -1;
    int iRet = NetClient_GetExceptionMsg(g_iLogonID, iExceptionType, &iState);
    if(iRet < 0)
    {
        fprintf(stderr, "NetClient_GetExceptionMsg failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_GetExceptionMsg is successful.\n");
        fprintf(stderr, "Exception Type: %d , State = %d.\n", iExceptionType, iState);
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetCHNPTZFormat()
{
    fprintf(stderr, "You choose to test NetClient_SetCHNPTZFormat, number is 320\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChannelNo = to_int_def(cTemp);

    char cFormat[256] = {0};
    fprintf(stderr, "Plsase input com format(e.g: 9600,n,8,1):\n");
    gets_s(cFormat, 256);
    if(0 == strcasecmp("q", cFormat))
    {
        return -1;
    }
    int iRet = NetClient_SetCHNPTZFormat(g_iLogonID,iChannelNo,cFormat);
    if (iRet != 0)
    {
        fprintf(stderr, "NetClient_SetCHNPTZFormat failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_SetCHNPTZFormat is successful.\n");
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetCHNPTZFormat()
{
    fprintf(stderr, "You choose to test NetClient_GetCHNPTZFormat, number is 321\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChannelNo = to_int_def(cTemp);
    char cFormat[256] = {0};
    int iRet = NetClient_GetCHNPTZFormat(g_iLogonID, iChannelNo, cFormat);
    if (iRet != 0)
    {
        fprintf(stderr, "NetClient_GetCHNPTZFormat failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_GetCHNPTZFormat is successful.\n");
        fprintf(stderr, "Channel no: %d , com format  = %s.\n", iChannelNo, cFormat);
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetProtocolList()
{
    fprintf(stderr, "You choose to test NetClient_GetProtocolList, number is 322\n");
    st_NVSProtocol nvsProtocol = {0};
    int iRet = NetClient_GetProtocolList(g_iLogonID, &nvsProtocol);
    if (iRet != 0)
    {
        fprintf(stderr, "NetClient_GetProtocolList failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_GetProtocolList  is successful.\n");
        fprintf(stderr, "Type is(0:support by the device 1:using):%d.\n",  nvsProtocol.iType);
        for (int i = 0; i < nvsProtocol.iCount; i++)
        {
            fprintf(stderr, "nvsProtocol.cProtocol[%d]: %s\n", i, nvsProtocol.cProtocol[i]);
        }
//      fprintf(stderr, "nvsProtocol.cProtocol: %s, nvsProtocol.iCount: %d, nvsProtocol.iType: %d \n", nvsProtocol.cProtocol, nvsProtocol.iCount, nvsProtocol.iType);
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetCHNPTZCRUISE()
{
    fprintf(stderr, "You choose to test NetClient_SetCHNPTZCRUISE, number is 323\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChannelNo = to_int_def(cTemp);
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the cruise no(0-7):\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iCruiseNo = to_int_def(cTemp);
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the cruise Enbale(0:disable 1:enable):\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iEnbale = to_int_def(cTemp);
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the cruise number:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iCruiseNum = to_int_def(cTemp);

    st_PTZCruise stPTZCruise;
    memset(&stPTZCruise,0,sizeof(stPTZCruise));
    for (int i = 0; i < 4; i++)
    {
        memset(cTemp, 0, sizeof(cTemp));
        fprintf(stderr, "Please input the Preset(%d):\n", i+1);
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        stPTZCruise.iPreset[i]  = to_int_def(cTemp);
        memset(cTemp, 0, sizeof(cTemp));
        fprintf(stderr, "Please input the StayTime(%d):\n", i+1);
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        stPTZCruise.iStayTime[i]= to_int_def(cTemp);
        memset(cTemp, 0, sizeof(cTemp));
        fprintf(stderr, "Please input the Speed(%d):\n", i+1);
        gets_s(cTemp, 256);
        if(0 == strcasecmp(cTemp, "q"))
        {
            return -1;
        }
        stPTZCruise.iSpeed[i]   = to_int_def(cTemp);
    }
    int iRet = NetClient_SetCHNPTZCRUISE(g_iLogonID, iChannelNo, iCruiseNo, iEnbale, iCruiseNum, &stPTZCruise);
    if (iRet != 0)
    {
        fprintf(stderr, "NetClient_SetCHNPTZCRUISE failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_SetCHNPTZCRUISE  is successful.\n");
    }
    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetCHNPTZCRUISE()
{
    fprintf(stderr, "You choose to test NetClient_GetCHNPTZCRUISE, number is 324\n");
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the channel no:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iChannelNo = to_int_def(cTemp);
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the Cruise No:\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
    int iCruiseNo = to_int_def(cTemp);

    
    int iEnable = 0;
    int iCruiseNum = 0;
    st_PTZCruise stPTZCruise = {{0}};

    int iRet = NetClient_GetCHNPTZCRUISE(g_iLogonID, iChannelNo, iCruiseNo, &iEnable, &iCruiseNum, &stPTZCruise);
    if (iRet != 0)
    {
        fprintf(stderr, "NetClient_GetCHNPTZCRUISE failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_GetCHNPTZCRUISE  is successful.\n");
        fprintf(stderr, "Channel no:%d Cruise no:%d Enable:%d Cruise Number:%d.\n",iChannelNo, iCruiseNo, iEnable, iCruiseNum);
        for (int i = 0;i < 4; i++)
        {
            fprintf(stderr, "Preset(%d):%d StayTime(%d):%d Speed(%d):%d\n", i+1, stPTZCruise.iPreset[i], i+1, stPTZCruise.iStayTime[i], i+1, stPTZCruise.iSpeed[i]);
        }
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SetFTPUpdate()
{
    fprintf(stderr, "You choose to test NetClient_SetFTPUpdate, number is 325\n");
    char cFtpAddress[256] = {0};
    char cFilePath[256] = {0};
    char cUserName[256] = {0};
    char cPassWord[256] = {0};
    char cTemp[256] = {0};
    fprintf(stderr, "Please input the ftp address:\n");
    gets_s(cFtpAddress, 256);
    if(0 == strcasecmp(cFtpAddress, "q"))
    {
        return -1;
    }
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the file path:\n");
    gets_s(cFilePath, 256);
    if(0 == strcasecmp(cFilePath, "q"))
    {
        return -1;
    }
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the user name:\n");
    gets_s(cUserName, 256);
    if(0 == strcasecmp(cUserName, "q"))
    {
        return -1;
    }
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the password:\n");
    gets_s(cPassWord, 256);
    if(0 == strcasecmp(cPassWord, "q"))
    {
        return -1;
    }
    int iRet = NetClient_SetFTPUpdate(g_iLogonID, cFtpAddress, cFilePath, cUserName, cPassWord);
    if (iRet != 0)
    {
        fprintf(stderr, "NetClient_SetFTPUpdate failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_SetFTPUpdate  is successful.\n");
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetFTPUpdate()
{
    fprintf(stderr, "You choose to test NetClient_GetFTPUpdate, number is 326\n");
    char cFtpAddress[256] = {0};
    char cFilePath[256] = {0};
    char cUserName[256] = {0};
    char cPassWord[256] = {0};
    int iRet = NetClient_GetFTPUpdate(g_iLogonID, cFtpAddress, cFilePath, cUserName, cPassWord);
    if (iRet != 0)
    {
        fprintf(stderr, "NetClient_GetFTPUpdate failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "NetClient_GetFTPUpdate  is successful.\n");
        fprintf(stderr, "ftp address:%s.\n",cFtpAddress);
        fprintf(stderr, "file path  :%s.\n",cFilePath);
        fprintf(stderr, "user name  :%s.\n",cUserName);
        fprintf(stderr, "password   :%s.\n",cPassWord);
    }
	fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_ChangeSvrIPEx()
{
    fprintf(stderr, "You choose to test NetClient_ChangeSvrIPEx, number is 327\n"); 
       
    char cNewSvrIP[16] = {0};
    char cMask[16] = {0};
    char cGateway[16] = {0};
    char cDNS[16] = {0};
    char cBackDNS[16] = {0};

    fprintf(stderr, "Please input new server ip:");
    gets_s(cNewSvrIP, 16);
    if(0 == strcasecmp("q", cNewSvrIP))
    {
        return -1;
    }

    fprintf(stderr, "Please input mask:");
    gets_s(cMask, 16);
    if(0 == strcasecmp("q", cMask))
    {
        return -1;
    }

    fprintf(stderr, "Please input gateway:");
    gets_s(cGateway, 16);
    if(0 == strcasecmp("q", cGateway))
    {
        return -1;
    }

    fprintf(stderr, "Please input DNS:");
    gets_s(cDNS, 16);
    if(0 == strcasecmp("q", cDNS))
    {
        return -1;
    }

    fprintf(stderr, "Please input Back DNS:");
    gets_s(cBackDNS, 16);
    if(0 == strcasecmp("q", cBackDNS))
    {
        return -1;
    }

    int iRet = NetClient_ChangeSvrIPEx(g_iLogonID, cNewSvrIP, cMask, cGateway, cDNS, cBackDNS);
    if(0 == iRet)
    {
		if (0 == NetClient_Reboot(g_iLogonID)) 
		{
			fprintf(stderr, "ChangeSvrIPEx is OK!\n");
		}
		else
		{
			fprintf(stderr, "ChangeSvrIPEx failed, Reboot failed!!\n");
		}	   
    }
    else
    {
        fprintf(stderr, "ChangeSvrIPEx is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_GetIpPropertyEx()
{
    fprintf(stderr, "You choose to test NetClient_GetIpPropertyEx, number is 328\n");

    char cMAC[32] = {0};
	char cMask[16] = {0};
	char cGateway[16] = {0};
	char cDNS[16] = {0};
    char cBackDNS[16] = {0};

    int iRet = NetClient_GetIpPropertyEx(g_iLogonID, cMAC, cMask, cGateway, cDNS, cBackDNS);
    if(0 == iRet)
    {
        fprintf(stderr, "GetIpProperty is OK!\n");

		fprintf(stderr, "MAC is %s\n", cMAC);
		fprintf(stderr, "Mask is %s\n", cMask);
		fprintf(stderr, "Gateway is %s\n", cGateway);
		fprintf(stderr, "DNS is %s\n", cDNS);
        fprintf(stderr, "Back DNS is %s\n", cBackDNS);
    }
    else
    {
        fprintf(stderr, "GetIpPropertyEx is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");
    return 0;
}

int Test_SendStringToServerEx()
{
    fprintf(stderr, "You choose to test NetClient_SendStringToServerEx, number is 329\n");
    fprintf(stderr, "please input the msg info:\n");
    char cMsg[1025] = {0};
    gets_s(cMsg, 1025);
    if(0 == strcasecmp(cMsg, "q"))
    {
        return -1;
    }
    fprintf(stderr, "please input the flag(0:CMD 1:DATA):\n");
    char cTemp[1025] = {0};
    gets_s(cTemp, 1025);
    if(0 == strcasecmp(cTemp, "q"))
    {
        return -1;
    }
	
    int iFlag = to_int_def(cTemp);
	if (SEND_STRING_CMD == iFlag)
	{
		u2g(cMsg,strlen(cMsg)+1,cTemp,sizeof(cTemp));
		memcpy(cMsg,cTemp,sizeof(cMsg));
		cTemp[1024] = '\0';
	}
    int iRet = NetClient_SendStringToServerEx(g_iLogonID, cMsg, strlen(cMsg), iFlag);
    if (iRet != 0)
    {
        fprintf(stderr, "NetClient_SendStringToServerEx failed, return = %d, err = 0x%08x. \n", iRet, errno);
    }
    else
    {
	fprintf(stderr, "string len(%d)\n",strlen(cMsg));
        fprintf(stderr, "NetClient_SendStringToServerEx  is successful.\n");	
    }
    return 0;
}

//add by cmz 20110412
int Test_SetOSDTypeColor()
{
    //                    {black, green, gray, red, lime, yellow, blue, white}
    //int iColorValue[8] = {0, 32768, 8421504, 255, 65280, 65535, 16711680, 16777215};
    int iChannel = 0;
    int iOSDType = 0;
    int iColor = 0;
	bool bReverse = false; 
	bool bBkDisplay = false;

    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_SetOSDTypeColor, number is 330\n");

	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input OSDType:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iOSDType = to_int_def(cTemp, -1);
    
    //fprintf(stderr, "Please input Color(0-black, 1-green, 2-gray, 3-red, 4-lime, 5-yellow, 6-blue, 7-white): \n");
    fprintf(stderr, "Please input Color(0-black, 32768-green, 8421504-gray, 255-red, 65280-lime"
                    ", 65535-yellow, 16711680-blue, 16777215-white:\n");
	gets_s(cTemp, 16);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iColor = to_int_def(cTemp, -1);


	fprintf(stderr, "OSD color reverse?[y/n]\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	bReverse = to_boolean_def(cTemp, false);
	if(bReverse)
		iColor = 0x01000000 | iColor;

	fprintf(stderr, "OSD display background?[y/n]\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	bBkDisplay = to_boolean_def(cTemp, false);
	if(bBkDisplay)
		iColor = 0x02000000 | iColor;

    int iRet = NetClient_SetOSDTypeColor(g_iLogonID, iChannel, iOSDType, iColor/*iColorValue[iColor]*/);
    if(iRet < 0)
    {
        fprintf(stderr, "Set OSDTypeColor is failed\n");
    }
    else
    {
        fprintf(stderr, "Set OSDTypeColor is OK\n");
    }

    return 0;
}

int Test_GetOSDTypeColor()
{
    int iChannel = 0;
    int iOSDType = 0;
    int iColor = 0;
    char cTemp[8] = {0};
    fprintf(stderr, "You choose to test NetClient_GetOSDTypeColor, number is 331\n");

	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input OSDType:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	iOSDType = to_int_def(cTemp, -1);

    int iRet = NetClient_GetOSDTypeColor(g_iLogonID, iChannel, iOSDType-1, &iColor);
    if(0 == iRet)
    {
        fprintf(stderr, "GetOSDTypeColor is OK!\n");
		fprintf(stderr, "The OSDType is %d\n", iOSDType);
        fprintf(stderr, "The Color is %d\n", 0x00ffffff&iColor);
		fprintf(stderr, "Color reverse is %s\n", iColor&0x01000000?"true":"false");
		fprintf(stderr, "Color background display is %s\n", iColor&0x02000000?"true":"false");
    }
    else
    {
        fprintf(stderr, "GetMotionDecLinkRec is failed!\n");
    }

    fprintf(stderr, "Please type interface to test:");

    return 0;
}

int Test_GetServerVersionEx()
{
    fprintf(stderr, "You choose to test NetClient_GetServerVersionEx, number is 332\n");
    char cVersion[32]={0};
    char cUIVersion[32]={0};
    char cSlaveVersion[32]={0};
    int iRet =  NetClient_GetServerVersionEx(g_iLogonID,cVersion,cUIVersion,cSlaveVersion);
    if (0 == iRet)
    {
        fprintf(stderr, "GetServerVersionEx is succeed!\n");
        fprintf(stderr, " Version:%s \n UIVersion:%s \n SlaveVersion:%s \n",cVersion,cUIVersion,cSlaveVersion);
    }
    else
    {
        fprintf(stderr, "GetServerVersionEx is failed! iRet = %d,err = 0x%08x\n",iRet,errno);
    }
    return 0;
}

//int Test_NetLogGetLogfile()
//{
//    fprintf(stderr, "You choose to test NetClient_NetLogGetLogfile, number is 333\n");
//    NVS_LOG_DATA logInfo = {0};
//    fprintf(stderr, "Please input the count:\n");
//    char cTemp[8] = {0};
//    gets_s(cTemp, 8);
//    if(0 == strcasecmp("q", cTemp))
//    {
//        return -1;
//    }
//    int iCount = to_int_def(cTemp, -1);
//    int iRet = NetClient_NetLogGetLogfile(g_iLogonID, iCount, &logInfo);
//    if (0 == iRet)
//    {
//        fprintf(stderr, "NetClient_NetLogGetLogfile is succeed!\n");
//        fprintf(stderr, "loginfo.iChannel:%d(240 is system log)\n loginfo.Type:%d\n", logInfo.iChannel, logInfo.iLogType);
//        fprintf(stderr, "loginfo.content:%d\n",logInfo.szLogContent);
//        fprintf(stderr, "loginfo.starttime is %04d/%02d/%02d-%02d:%02d:%02d\n", logInfo.struStartTime.iYear, logInfo.struStartTime.iMonth, logInfo.struStartTime.iDay, logInfo.struStartTime.iHour, logInfo.struStartTime.iMinute, logInfo.struStartTime.iSecond);
//        fprintf(stderr, "loginfo.stoptime is %04d/%02d/%02d-%02d:%02d:%02d\n", logInfo.struStoptime.iYear, logInfo.struStoptime.iMonth, logInfo.struStoptime.iDay, logInfo.struStoptime.iHour, logInfo.struStoptime.iMinute, logInfo.struStoptime.iSecond);
//    }
//    else
//    {
//        fprintf(stderr, "NetClient_NetLogGetLogfile is failed!ret = :%d, err = 0x%08x\n", iRet, errno);
//    }
//    return 0;
//}

int Test_DrawRectOnLocalVideo()
{
    fprintf(stderr, "You choose to test NetClient_DrawRectOnLocalVideo, number is 334\n");
	fprintf(stderr, "Please connect video before use this interface\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iChan = to_int_def(cTemp);

    fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iStreamNo = to_int_def(cTemp, -1);

    RECT tmpRect = {0};
    fprintf(stderr, "Please input the left:\n");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
    tmpRect.left = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input the right:\n");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
    tmpRect.right = to_int_def(cTemp, -1);
    fprintf(stderr, "Please input the top:\n");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
    tmpRect.top = to_int_def(cTemp, -1);
    fprintf(stderr, "Please input the bottom:\n");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
    tmpRect.bottom = to_int_def(cTemp, -1);
    int iRet = NetClient_DrawRectOnLocalVideo(g_uiRecv[iChan+iStreamNo*g_iTotalChnlNum], &tmpRect, 1);
    if (0 == iRet)
    {
        fprintf(stderr, "NetClient_DrawRectOnLocalVideo is succeed!\n");
    }
    else
    {
        fprintf(stderr, "NetClient_DrawRectOnLocalVideo is failed!ret = :%d, err = 0x%08x\n", iRet, errno);
    }

    return 0;
}

int Test_DrawPolyOnLocalVideo()
{
    fprintf(stderr, "You choose to test NetClient_DrawPolyOnLocalVideo, number is 335\n");
	fprintf(stderr, "Please connect video before use this interface\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no :\n");
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iChan = to_int_def(cTemp);

    fprintf(stderr, 
            "Stream type:\n"
            "0: MAIN_STREAM\n"
            "1: SUB_STREAM\n");
    fprintf(stderr, "Please select number to set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
        return -1;
    int iStreamNo = to_int_def(cTemp, -1);

    POINT pt[2] = {{0}};
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the start x coordinate:\n");
    gets_s(cTemp, 256);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    pt[0].x = to_int_def(cTemp, -1);
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the start y coordinate:\n");
    gets_s(cTemp, 256);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    pt[0].y = to_int_def(cTemp, -1);
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the end x coordinate:\n");
    gets_s(cTemp, 256);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    pt[1].x = to_int_def(cTemp, -1);
    memset(cTemp, 0, sizeof(cTemp));
    fprintf(stderr, "Please input the end y coordinate:\n");
    gets_s(cTemp, 256);
    if (0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    pt[1].y = to_int_def(cTemp, -1);
    int iRet = NetClient_DrawPolyOnLocalVideo(g_uiRecv[iChan+iStreamNo*g_iTotalChnlNum], pt, sizeof(pt)/sizeof(POINT), 0);
    if (0 == iRet)
    {
        fprintf(stderr, "NetClient_DrawPolyOnLocalVideo is succeed!\n");
    }
    else
    {
        fprintf(stderr, "NetClient_DrawPolyOnLocalVideo is failed!ret = :%d, err = 0x%08x\n", iRet, errno);
    }
    return 0;
}

int Test_NetFileQueryEx()
{
    fprintf(stderr, "You choose to test NetClient_NetFileQueryEx, number is 336\n");
    char cTemp[256] = {0};
    NVS_FILE_QUERY fileQuery;
    memset(&fileQuery, 0, sizeof(fileQuery)); 

	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	fileQuery.iChannel = to_int_def(cTemp, -1);

    fprintf(stderr,
        "Set file type:\n"
        "0: All\n"
        "1: AVstream\n"
        "2: picture\n"
        "Please choose a number to be set:");
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	fileQuery.iFiletype = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input page number:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	fileQuery.iPageNo = to_int_def(cTemp, -1);
	fileQuery.iPageSize = 20;

    fprintf(stderr, "Please input start time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	unsigned short iYear = 0;   
    unsigned short iMonth = 0;  
    unsigned short iDay = 0;    
    unsigned short iHour = 0;   
    unsigned short iMinute = 0; 
    unsigned short iSecond = 0;

	
	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		   &iYear,
		   &iMonth,
		   &iDay,
		   &iHour,
		   &iMinute,
		   &iSecond);

	fileQuery.struStartTime.iYear = iYear;
	fileQuery.struStartTime.iMonth = iMonth;
	fileQuery.struStartTime.iDay = iDay;
	fileQuery.struStartTime.iHour = iHour;
	fileQuery.struStartTime.iMinute = iMinute;
	fileQuery.struStartTime.iSecond = iSecond;
	

    fprintf(stderr, "Please input stop time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	iYear = 0;   
    iMonth = 0;  
    iDay = 0;    
    iHour = 0;   
    iMinute = 0; 
    iSecond = 0;

	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		   &iYear,
		   &iMonth,
		   &iDay,
		   &iHour,
		   &iMinute,
		   &iSecond);

	fileQuery.struStopTime.iYear = iYear;
	fileQuery.struStopTime.iMonth = iMonth;
	fileQuery.struStopTime.iDay = iDay;
	fileQuery.struStopTime.iHour = iHour;
	fileQuery.struStopTime.iMinute = iMinute;
	fileQuery.struStopTime.iSecond = iSecond;

	fprintf(stderr,
        "Set record type:\n"
        "255: All\n"
        "1: Manual record\n"
        "2: Schedule record\n"
        "3: Alarm record\n"
        "Please choose a number to be set:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 8);
    if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	fileQuery.iType = to_int_def(cTemp, -1);
    NVS_FILE_QUERY_EX fileQueryEx = {{0}};
	fileQueryEx.iTriggerType = 0x7FFFFFFF;
    fileQueryEx.fileQuery = fileQuery;
    fprintf(stderr, "Please input the osd text:\n");
    gets_s(fileQueryEx.cOtherQuery, 65);
    if(0 == strcasecmp("q", fileQueryEx.cOtherQuery))
	{
	    return -1;
	}
    int iRet = NetClient_NetFileQueryEx(g_iLogonID, (PNVS_FILE_QUERY)&fileQueryEx, sizeof(fileQueryEx));
    if (0 == iRet)
    {
        fprintf(stderr, "NetClient_NetFileQueryEx is succeed!\n");
    }
    else
    {
        fprintf(stderr, "NetClient_NetFileQueryEx is failed!ret = :%d, err = 0x%08x\n", iRet, errno);
    }

    return 0;
}

int Test_ComSend()
{
    fprintf(stderr, "You choose to test NetClient_ComSend, number is 338\n");
    fprintf(stderr, "Please input the com no:");
    char cTemp[256] = {0};
    gets_s(cTemp, 16);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iComNo = to_int_def(cTemp);

    fprintf(stderr, "Please input the infomation:");
    memset(cTemp, 0, sizeof(cTemp));
    gets_s(cTemp, 256);
    if(0 == strcasecmp("q", cTemp))
    {
        return -1;
    }
    int iRet = NetClient_ComSend(g_iLogonID, (unsigned char *)cTemp, strlen(cTemp), iComNo);
    if(iRet != 0)
    {
        fprintf(stderr, "ComSend failed! return %d, errno = 0x%08x\n", iRet, errno);
    }
    else
    {
        fprintf(stderr, "ComSend success!\n");
    }

    fprintf(stderr, "Please type a number to test corresponding interface:\n");
    return 0;
}

int Test_SetCustomChannelName()
{
    fprintf(stderr, "You choose to test NetClient_SetCustomChannelName, number is 339\n");
        
    char cTemp[256] = {0};
    fprintf(stderr,
        "Select channel type\n"
        "0: Video Channel\n"
        "1: AlarmInput\n"
        "2: AlarmOutput\n"
        "Please choose a number to be set:\n");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	int iChanType = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input channel number:(Refer to channel type!)\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	int iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input custom name:\n");
    gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
    char cName[256] = {0};
    strcpy(cName, cTemp);

    int iRet = -1;
    iRet = NetClient_SetCustomChannelName(g_iLogonID, iChannel, iChanType, cName);
    if(iRet < 0)
        fprintf(stderr, "SetCustomChannelName failed!\n");
    else 
        fprintf(stderr, "SetCustomChannelName successful!\n");

    return 0;
}

int Test_GetCustomChannelName()
{
    fprintf(stderr, "You choose to test NetClient_GetCustomChannelName, number is 340\n");
        
    char cTemp[256] = {0};
    fprintf(stderr,
        "Select channel type\n"
        "0: Video Channel\n"
        "1: AlarmInput\n"
        "2: AlarmOutput\n"
        "Please choose a number to be set:");
    memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	int iChanType = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input channel number:(Refer to channel type!)");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	int iChannel = to_int_def(cTemp, -1);

    char cName[256] = {0};
    int iRet = -1;
    iRet = NetClient_GetCustomChannelName(g_iLogonID, iChannel, iChanType, cName);
    if(iRet < 0)
        fprintf(stderr, "GetCustomChannelName failed!\n");
    else 
        fprintf(stderr, "GetCustomChannelName successful, name = %s\n", cName);

    return 0;
}

int Test_SetCustomRecType()
{
    fprintf(stderr, "You choose to test NetClient_SetCustomRecType, number is 341\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input rec type:(0~31)\n");
    gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	int iRecType = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input rec name:\n");
    gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
    char cName[256] = {0};
    strcpy(cName, cTemp);
    
    int iRet = -1;
    iRet = NetClient_SetCustomRecType(g_iLogonID, iRecType, cName);
    if(iRet < 0)
        fprintf(stderr, "SetCustomRecType failed!\n");
    else 
        fprintf(stderr, "SetCustomRecType successful, name = %s\n", cName);

    return 0;
}

int Test_GetCustomRecType()
{
    fprintf(stderr, "You choose to test NetClient_GetCustomRecType, number is 342\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input rec type:(0~31)\n");
    gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
	int iRecType = to_int_def(cTemp, -1);

    char cName[256] = {0};
    
    int iRet = -1;
    iRet = NetClient_GetCustomRecType(g_iLogonID, iRecType, cName);
    if(iRet < 0)
        fprintf(stderr, "GetCustomRecType failed!\n");
    else 
        fprintf(stderr, "GetCustomRecType successful, name = %s\n", cName);

    return 0;
}

int Test_SetDecCallBackEx()
{
    fprintf(stderr, "You choose to test NetClient_SetDecCallBackEx, number is 344\n");
	fprintf(stderr, "Please connect video before use this interface\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input channel no:\n");
    gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	    return -1;
	int iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input stream no:\n");
    gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	    return -1;
	int iStreamNo = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input user data:\n");
    gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	    return -1;
	int iUserData = to_int_def(cTemp, -1);

    int iRet = -1;
    iRet = NetClient_SetDecCallBackEx(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum], Notify_DecYUV, (void*)iUserData);
    if(iRet < 0)
        fprintf(stderr, "SetDecCallBackEx failed!\n");
    else 
        fprintf(stderr, "SetDecCallBackEx successful, Notify_DecYUV(%p)\n", (void*)Notify_DecYUV);

    return 0;
}

void GetStream(unsigned int _ulID, unsigned char* _ucData, int _iSize, int _Flag, void* _pContext)
{
    fwrite(_ucData, sizeof(char), _iSize, file);
}

int Test_GetDownloadStream()
{
    fprintf(stderr, "You choose to test NetClient_SetNetFileDownloadFileCallBack, number is 345\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input rec name:\n");
    gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
	    return -1;
	}
    char cName[256] = {0};
    strcpy(cName, cTemp);

    file = fopen(cName, "wb");
    Test_NetFileDownloadByTimeSpanEx();
    int iRet = -1;
    iRet = NetClient_SetNetFileDownloadFileCallBack(g_uiNetFileID, GetStream, 0);
    if(iRet < 0)
        fprintf(stderr, "GetDownloadStream failed!\n");
    else 
        fprintf(stderr, "GetDownloadStream successful\n");

    return 0;
}

void GetRawAudio(unsigned int _ulID, unsigned char* _cData, int _iLen, int Type, void* _pvUserData)
{

}
FILE* fpPS = NULL;
void GetPSStream(unsigned int _ulID, unsigned char* _cData, int _iLen, int Type, void* _pvUserData)
{
    if(NULL == fpPS)
        fpPS  = fopen("1.ps", "wb");

    if(fpPS)
    {
        fwrite(_cData, _iLen, 1, fpPS);
    }
}

int Test_SetDataPackCallBack()
{
    fprintf(stderr, "You choose to test NetClient_SetDataPackCallBack, number is 346\n");
	fprintf(stderr, "Please connect video before use this interface\n");

    char cTemp[256] = {0};
    fprintf(stderr, "Please input callback type:\n"
                    "0:MP_H264\n"
                    "1:RAW_AUDIO\n"
                    "2:PS Stream\n");
    gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	    return -1;
    int iCBType = to_int_def(cTemp);

    fprintf(stderr, "Please input channel no:\n");
    gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	    return -1;
	int iChannel = to_int_def(cTemp, -1);

    fprintf(stderr, "Please input stream no:\n");
    gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	    return -1;
	int iStreamNo = to_int_def(cTemp, -1);

    int iRet = -1;
    void* cbk = NULL;
    switch(iCBType)
    {
        case DTYPE_H264_MP:
            break;
        case DTYPE_RAW_AUDIO:
            cbk = (void*)GetRawAudio;
            break;
        case DTYPE_PS:
            cbk = (void*)GetPSStream;
            break;
        default:
            break;
    }
    iRet = NetClient_SetDataPackCallBack(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum], iCBType, cbk, NULL);

    if(iRet < 0)
        fprintf(stderr, "SetDataPackCallBack failed!\n");
    else 
        fprintf(stderr, "SetDataPackCallBack successful\n");

    return 0;
}

int Test_NetFileSetChannelParam()
{
	fprintf(stderr, "You choose to test NetClient_NetFileSetChannelParam, number is 347\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plsase input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannel = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Cmd(0):");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);

	STORAGE_RULE sr = {0};
	sr.iSize = sizeof(sr);
	
	fprintf(stderr, "Please input storage rule type:\n"
					"0-STORAGE_RULE_RECORD_AUDIO\n"
					"1-STORAGE_RULE_STORAGE_TIME\n"
					"2-STORAGE_RULE_EXTRACT_FRAME\n"
					"3-STORAGE_RULE_REDUNDANCE_RECORD\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	sr.iType = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input storage rule value:\n"
					"type=0 (0,1)\n"
					"type=1 [0,60]\n"
					"type=2 (0,1)\n"
					"type=3 (0,1)\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	sr.iValue = to_int_def(cTemp, 0);

	int iRet = -1;
	iRet = NetClient_NetFileSetChannelParam(g_iLogonID, iChannel, iCmd, (void*)&sr);
	if(iRet != 0)
		fprintf(stderr, "NetClient_NetFileSetChannelParam failed!\n");
	else 
		fprintf(stderr, "NetClient_NetFileSetChannelParam successful!\n");

	return 0;
}

int Test_NetFileGetChannelParam()
{
	fprintf(stderr, "You choose to test NetClient_NetFileGetChannelParam, number is 348\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plsase input channel number:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannel = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Cmd:(0-STORAGE_CMD_STORAGE_RULE)\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);

	STORAGE_RULE sr = {0};
	sr.iSize = sizeof(sr);

	fprintf(stderr, "Please input storage rule type:\n"
		"0-STORAGE_RULE_RECORD_AUDIO\n"
		"1-STORAGE_RULE_STORAGE_TIME\n"
		"2-STORAGE_RULE_EXTRACT_FRAME\n"
		"3-STORAGE_RULE_REDUNDANCE_RECORD\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	sr.iType = to_int_def(cTemp, 0);

	int iRet = -1;
	iRet = NetClient_NetFileGetChannelParam(g_iLogonID, iChannel, iCmd, (void*)&sr);
	if(iRet != 0)
		fprintf(stderr, "NetClient_NetFileGetChannelParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	else 
	{
		fprintf(stderr, "NetClient_NetFileGetChannelParam successful:\n");
		fprintf(stderr, "STORAGE_RULE.iType:%d\n", sr.iType);
		fprintf(stderr, "STORAGE_RULE.iValue:%d\n", sr.iValue);
	}

	return 0;
}


int Test_ShutDownDev()
{
	fprintf(stderr, "You choose to test NetClient_ShutDownDev, number is 349\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input iFlag(0-shutdown):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iFlag = to_int_def(cTemp, 0);

	int iRet = NetClient_ShutDownDev(g_iLogonID, iFlag);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_ShutDownDev failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_ShutDownDev successful:\n");
	}

	return 0;
}

int Test_BackupImage()
{
	fprintf(stderr, "You choose to test NetClient_BackupImage, number is 350\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input iType(0-backup all):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iType = to_int_def(cTemp, 0);

	int iRet = NetClient_BackupImage(g_iLogonID, iType);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_BackupImage failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_BackupImage successful:\n");
	}

	return 0;
}


int Test_LaneParam_GetLanNum()
{
	fprintf(stderr, "You choose to test NetClient_GetLanParam:LAN_CMD_GET_LANNUM\n");

	int iLanNum = 0;
	int iRet = NetClient_GetLanParam(g_iLogonID, LAN_CMD_GET_LANNUM, (void*)&iLanNum);
	if(iRet!=0)
		fprintf(stderr, "Test_LaneParam_GetLanNum failed! return %d, errno = 0x%08x\n", iRet, errno);
	else
		fprintf(stderr, "Test_LaneParam_GetLanNum successful,lan num is %d\n", iLanNum);
	return 0;
}

int Test_LaneParam_GetIPV4()
{
	fprintf(stderr, "You choose to test NetClient_GetLanParam:LAN_CMD_GET_IPV4\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input lan no(0-1):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iLanNo = to_int_def(cTemp, 0);

	LANPARAM_IPV4 ip4 = {0};
	ip4.iSize = sizeof(ip4);
	ip4.iLanNo = iLanNo;
	int iRet = NetClient_GetLanParam(g_iLogonID, LAN_CMD_GET_IPV4, (void*)&ip4);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_GetIPV4 failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_GetIPV4 successful\n");
		fprintf(stderr, "LANPARAM_IPV4.iSize:%d\n", ip4.iSize);
		fprintf(stderr, "LANPARAM_IPV4.iLanNo:%d\n", ip4.iLanNo);
		fprintf(stderr, "LANPARAM_IPV4.iLanType:%d\n", ip4.iLanType);
		fprintf(stderr, "LANPARAM_IPV4.cIP:%s\n", ip4.cIP);
		fprintf(stderr, "LANPARAM_IPV4.cMask:%s\n", ip4.cMask);
		fprintf(stderr, "LANPARAM_IPV4.cGateway:%s\n", ip4.cGateway);
		fprintf(stderr, "LANPARAM_IPV4.cDNS:%s\n", ip4.cDNS);
		fprintf(stderr, "LANPARAM_IPV4.cBackDNS:%s\n", ip4.cBackDNS);
	}


	return 0;
}

int Test_LaneParam_SetIPV4()
{
	fprintf(stderr, "You choose to test NetClient_SetLanParam:LAN_CMD_SET_IPV4\n");

	char cTemp[256] = {0};

	LANPARAM_IPV4 ip4 = {0};
	ip4.iSize = sizeof(ip4);

	fprintf(stderr, "Please input lan no(0-1):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	ip4.iLanNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input lan type(0):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	ip4.iLanType = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input lan IP:");
	gets_s(cTemp, 32);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(ip4.cIP, cTemp);

	fprintf(stderr, "Please input lan mask:");
	gets_s(cTemp, 32);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(ip4.cMask, cTemp);

	fprintf(stderr, "Please input lan gateway:");
	gets_s(cTemp, 32);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(ip4.cGateway, cTemp);

	fprintf(stderr, "Please input lan DNS:");
	gets_s(cTemp, 32);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(ip4.cDNS, cTemp);

	fprintf(stderr, "Please input lan BackDNS:");
	gets_s(cTemp, 32);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(ip4.cBackDNS, cTemp);
	
	int iRet = NetClient_SetLanParam(g_iLogonID, LAN_CMD_SET_IPV4, (void*)&ip4);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_SetIPV4 failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_SetIPV4 successful\n");
	}
	return 0;
}

int Test_LaneParam_GetIPV6()
{
	fprintf(stderr, "You choose to test NetClient_GetLanParam:LAN_CMD_GET_IPV6\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input lan no(0-1):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iLanNo = to_int_def(cTemp, 0);

	LANPARAM_IPV6 ip6 = {0};
	ip6.iSize = sizeof(ip6);
	ip6.iLanNo = iLanNo;
	int iRet = NetClient_GetLanParam(g_iLogonID, LAN_CMD_GET_IPV6, (void*)&ip6);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_GetIPV6 failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_GetIPV6 successful\n");
		fprintf(stderr, "LANPARAM_IPV6.iSize:%d\n", ip6.iSize);
		fprintf(stderr, "LANPARAM_IPV6.iLanNo:%d\n", ip6.iLanNo);
		fprintf(stderr, "LANPARAM_IPV6.iPrefixLen:%d\n", ip6.iPrefixLen);
		fprintf(stderr, "LANPARAM_IPV6.cIP:%s\n", ip6.cIP);
		fprintf(stderr, "LANPARAM_IPV6.cGateway:%s\n", ip6.cGateway);
		fprintf(stderr, "LANPARAM_IPV6.cDNS:%s\n", ip6.cDNS);
		fprintf(stderr, "LANPARAM_IPV6.cBackDNS:%s\n", ip6.cBackDNS);
	}
	return 0;
}

int Test_LaneParam_SetIPV6()
{
	fprintf(stderr, "You choose to test NetClient_SetLanParam:LAN_CMD_SET_IPV6\n");

	char cTemp[256] = {0};

	LANPARAM_IPV6 ip6 = {0};
	ip6.iSize = sizeof(ip6);

	fprintf(stderr, "Please input lan no(0-1):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	ip6.iLanNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input lan iPrefixLen(0):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	ip6.iPrefixLen = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input lan IP:");
	gets_s(cTemp, 32);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(ip6.cIP, cTemp);


	fprintf(stderr, "Please input lan gateway:");
	gets_s(cTemp, 32);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(ip6.cGateway, cTemp);

	fprintf(stderr, "Please input lan DNS:");
	gets_s(cTemp, 32);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(ip6.cDNS, cTemp);

	fprintf(stderr, "Please input lan BackDNS:");
	gets_s(cTemp, 32);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(ip6.cBackDNS, cTemp);

	int iRet = NetClient_SetLanParam(g_iLogonID, LAN_CMD_SET_IPV6, (void*)&ip6);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_SetIPV6 failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_SetIPV6 successful\n");
	}
	return 0;
}

int Test_LaneParam_GetWorkMode()
{
	fprintf(stderr, "You choose to test NetClient_GetLanParam:LAN_CMD_GET_WORKMODE\n");

	LANPARAM_WORKMODE wm = {0};
	wm.iSize = sizeof(wm);

	int iRet = NetClient_GetLanParam(g_iLogonID, LAN_CMD_GET_WORKMODE, (void*)&wm);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_GetWorkMode failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_GetWorkMode successful\n");
		fprintf(stderr, "LANPARAM_WORKMODE.iSize:%d\n", wm.iSize);
		fprintf(stderr, "LANPARAM_WORKMODE.iWorkMode:%d\n", wm.iWorkMode);
		fprintf(stderr, "LANPARAM_WORKMODE.iMainLanNo:%d\n", wm.iMainLanNo);
	}

	return 0;
	
}

int Test_LaneParam_SetWorkMode()
{
	fprintf(stderr, "You choose to test NetClient_SetLanParam:LAN_CMD_SET_WORKMODE\n");

	char cTemp[256] = {0};

	LANPARAM_WORKMODE wm = {0};
	wm.iSize = sizeof(wm);

	fprintf(stderr, "Please input main lan no(0-1):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	wm.iMainLanNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input work mode(0:ؾ 1:ݴ 2:ַ趨):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	wm.iWorkMode = to_int_def(cTemp, 0);

	int iRet = NetClient_SetLanParam(g_iLogonID, LAN_CMD_SET_WORKMODE, (void*)&wm);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_SetWorkMode failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_SetWorkMode successful\n");
	}

	return 0;
}
int Test_LaneParam_GetDHCP()
{
	fprintf(stderr, "You choose to test NetClient_GetLanParam:LAN_CMD_GET_DHCP\n");

	char cTemp[256] = {0};

	LANPARAM_DHCP dhcp = {0};
	dhcp.iSize = sizeof(LANPARAM_DHCP);

	fprintf(stderr, "Please input lan no(0-1):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	dhcp.iLanNo = to_int_def(cTemp, 0);

	int iRet = NetClient_GetLanParam(g_iLogonID, LAN_CMD_GET_DHCP, (void*)&dhcp);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_GetDHCP failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_GetDHCP successful\n");
		fprintf(stderr, "LANPARAM_DHCP.iSize:%d\n", dhcp.iSize);
		fprintf(stderr, "LANPARAM_DHCP.iLanNo:%d\n", dhcp.iLanNo);
		fprintf(stderr, "LANPARAM_DHCP.iEnable:%d\n", dhcp.iEnable);
	}

	return 0;
}

int Test_LaneParam_SetDHCP()
{
	fprintf(stderr, "You choose to test NetClient_SetLanParam:LAN_CMD_SET_DHCP\n");

	char cTemp[256] = {0};

	LANPARAM_DHCP dhcp = {0};
	dhcp.iSize = sizeof(dhcp);

	fprintf(stderr, "Please input lan no(0-1):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	dhcp.iLanNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input dhcp iEnable(0:disable 1:enable):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	dhcp.iEnable = to_int_def(cTemp, 0);


	int iRet = NetClient_SetLanParam(g_iLogonID, LAN_CMD_SET_DHCP, (void*)&dhcp);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_SetDHCP failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_SetDHCP successful\n");
	}
	return 0;
}

int Test_LaneParam_GetWifiDHCP()
{
	fprintf(stderr, "You choose to test NetClient_GetLanParam:LAN_CMD_GET_WIFIDHCPMODE\n");

	WIFIPARAM_DHCP WifiParaDHCP = {0};
	WifiParaDHCP.iSize = sizeof(WifiParaDHCP);
    
	for(int iDHCPMode = 0; iDHCPMode < 2; iDHCPMode++)
	{
		WifiParaDHCP.iWifiDHCPMode = iDHCPMode;
		int iRet = NetClient_GetLanParam(g_iLogonID, LAN_CMD_GET_WIFIDHCPMODE, &WifiParaDHCP);
        if(0 == iRet)
        {
            if(1 == WifiParaDHCP.iEnable)
            {
               	fprintf(stderr, "Test_LaneParam_GetWifiDHCP successful\n"); // only one wifinetcard but have two mode
				fprintf(stderr, "WIFIPARAM_DHCP.iSize:%d\n", WifiParaDHCP.iSize);
				fprintf(stderr, "WIFIPARAM_DHCP.iWifiDHCPMode:%d\n", WifiParaDHCP.iWifiDHCPMode);
            }
			else
			{
				fprintf(stderr, "Test_LaneParam_GetWifiDHCP is not enable\n"); 
			}
        }
        else
        {
             fprintf(stderr, "Test_LaneParam_GetWorkMode failed! return %d, errno = 0x%08x\n", iRet, errno);
        }
	}
	return 0;
}

int Test_LaneParam_SetWifiDHCP()
{
	fprintf(stderr, "You choose to test NetClient_SetLanParam:LAN_CMD_SET_WIFIDHCPMODE\n");

	char cTemp[256] = {0};

	WIFIPARAM_DHCP WifiParaDHCP = {0};
	WifiParaDHCP.iSize = sizeof(WifiParaDHCP);

	fprintf(stderr, "Please input WifiDHCPMode(0:Wifi DHCP Enable 1:Wifi AP DHCP Enable 2:All Disable):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	WifiParaDHCP.iWifiDHCPMode = to_int_def(cTemp, 0);
    WifiParaDHCP.iEnable = true;

	int iRet = NetClient_SetLanParam(g_iLogonID, LAN_CMD_SET_WIFIDHCPMODE, (void*)&WifiParaDHCP);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_SetWifiDHCP failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_SetWifiDHCP successful\n");
	}

	return 0;
}

int Test_LaneParam_GetWifiWorkMode()
{
	fprintf(stderr, "You choose to test NetClient_GetLanParam:LAN_CMD_GET_WIFIWORKMODE\n");

    int iWifiWorkMode = -1;
	int iRet = NetClient_GetLanParam(g_iLogonID, LAN_CMD_GET_WIFIWORKMODE, &iWifiWorkMode);
	if(0 == iRet)
	{
		//m_iWifiWorkMode = iWifiWorkMode;
		fprintf(stderr, "Test_LaneParam_GetWifiWorkMode successful\n");   //only one wifinetcard but have two mode
		fprintf(stderr, "iWifiWorkMode:%d\n", iWifiWorkMode);
	}
	else
	{
		 fprintf(stderr, "Test_LaneParam_GetWorkMode failed! return %d, errno = 0x%08x\n", iRet, errno);
	}

	return 0;
}

int Test_LaneParam_SetWifiWorkMode()
{
	fprintf(stderr, "You choose to test NetClient_SetLanParam:LAN_CMD_SET_WIFIWORKMODE\n");

	char cTemp[256] = {0};

	fprintf(stderr, "Please input iWifiWorkMode(0:unonline 1:sta wifi 2:ap wifi):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iWifiWorkMode = to_int_def(cTemp, 0);

	int iRet = NetClient_SetLanParam(g_iLogonID, LAN_CMD_SET_WIFIWORKMODE, (void*)&iWifiWorkMode);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_SetWifiWorkMode failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_SetWifiWorkMode successful\n");
	}
	return 0;
}

int Test_LaneParam_GetWifiApDHCPPara()
{
	fprintf(stderr, "You choose to test NetClient_GetLanParam:LAN_CMD_GET_WIFIAPDHCPPARA\n");

	WIFIAPDHCPPARA_DHCP WifiApDHCPPara = {0};
	WifiApDHCPPara.iSize = sizeof(WifiApDHCPPara);
    

	int iRet = NetClient_GetLanParam(g_iLogonID, LAN_CMD_GET_WIFIAPDHCPPARA, &WifiApDHCPPara);
	if(0 == iRet)
	{
		fprintf(stderr, "Test_LaneParam_GetWifiApDHCPPara successful\n"); // only one wifinetcard but have two mode
		fprintf(stderr, "WifiApDHCPPara.iSize:%d\n", WifiApDHCPPara.iSize);
		fprintf(stderr, "WifiApDHCPPara.iDHCPStart:%d\n", WifiApDHCPPara.iDHCPStart);
		fprintf(stderr, "WifiApDHCPPara.iDHCPEnd:%d\n", WifiApDHCPPara.iDHCPEnd);
		fprintf(stderr, "WifiApDHCPPara.iDHCPLease:%d\n", WifiApDHCPPara.iDHCPLease);
	}
	else
	{
		 fprintf(stderr, "Test_LaneParam_GetWorkMode failed! return %d, errno = 0x%08x\n", iRet, errno);
	}

	return 0;
}

int Test_LaneParam_SetWifiApDHCPPara()
{
	fprintf(stderr, "You choose to test NetClient_SetLanParam:LAN_CMD_SET_WIFIAPDHCPPARA\n");

	char cTemp[256] = {0};

    WIFIAPDHCPPARA_DHCP  WifiApDHCPPara = {0};
    WifiApDHCPPara.iSize = sizeof(WIFIAPDHCPPARA_DHCP);

	fprintf(stderr, "Please input DHCPStart(0~255&bigger than current IP):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	WifiApDHCPPara.iDHCPStart = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input DHCPEnd(0~255&bigger than DHCPStart&bigger than current IP):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	WifiApDHCPPara.iDHCPEnd = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input DHCPLease(>0):");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	WifiApDHCPPara.iDHCPLease = to_int_def(cTemp, 0);

	int iRet = NetClient_SetLanParam(g_iLogonID, LAN_CMD_SET_WIFIAPDHCPPARA, (void*)&WifiApDHCPPara);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_SetWifiApDHCPPara failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_SetWifiApDHCPPara successful\n");
	}

	return 0;
}

int Test_LaneParam_GetWifiApParam()
{
	fprintf(stderr, "You choose to test NetClient_GetLanParam:LAN_CMD_GET_WIFIAPPARA\n");
   
	NVS_WIFI_PARAM wifiapPara;
    memset(&wifiapPara,0,sizeof(NVS_WIFI_PARAM));
    
	int iRet = NetClient_GetLanParam(g_iLogonID, LAN_CMD_GET_WIFIAPPARA, &wifiapPara);
	if(0 == iRet)
	{
		fprintf(stderr, "Test_LaneParam_GetWifiApParam successful\n"); // only one wifinetcard but have two mode
		fprintf(stderr, "wifiapPara.cWifiSvrIP:%s\n", wifiapPara.cWifiSvrIP);
		fprintf(stderr, "wifiapPara.cWifiMask:%s\n", wifiapPara.cWifiMask);
		fprintf(stderr, "wifiapPara.cWifiGateway:%s\n", wifiapPara.cWifiGateway);
		fprintf(stderr, "wifiapPara.cWifiDNS:%s\n", wifiapPara.cWifiDNS);
		fprintf(stderr, "wifiapPara.cESSID:%s\n", wifiapPara.cESSID);
		fprintf(stderr, "wifiapPara.cWifiKeyType:%s\n", wifiapPara.cWifiKeyType);
		fprintf(stderr, "wifiapPara.cWifiPassword:%s\n", wifiapPara.cWifiPassword);
		fprintf(stderr, "wifiapPara.cEncryption:%s\n", wifiapPara.cEncryption);
		fprintf(stderr, "wifiapPara.cWifiKeyNum:%s\n", wifiapPara.cWifiKeyNum);
		fprintf(stderr, "wifiapPara.iHaveCard:%d\n", wifiapPara.iHaveCard);
		fprintf(stderr, "wifiapPara.iCardOnline:%d\n", wifiapPara.iCardOnline);

		if(0 == wifiapPara.iHaveCard)
        {
            fprintf(stderr, "Do not have wifi(ap) card\n");
        }
        else if(1 == wifiapPara.iHaveCard)
        {
            fprintf(stderr, "Have wifi(ap) card\n");
        }

        if(0 == wifiapPara.iCardOnline)
        {
            fprintf(stderr, "Wifiap state is offline\n");
        }
        else if(1 == wifiapPara.iCardOnline)
        {
            fprintf(stderr, "Wifiap state is online\n");
        }
	}
	else
	{
		 fprintf(stderr, "Test_LaneParam_GetWifiApParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}

	return 0;
}

int Test_LaneParam_SetWifiApParam()
{
	//PARASET*WIFIAP*pcIP*pcMask*pcGateWay*pcDNS*pcESSID*pcENCRYPTION*pcWifiKeyType*pcWifiPassword*iWifiKeyNum for wifiap
	fprintf(stderr, "You choose to test NetClient_SetLanParam:LAN_CMD_SET_WIFIAPPARA\n");

	NVS_WIFI_PARAM wifiapParam;
	memset(&wifiapParam,0,sizeof(NVS_WIFI_PARAM));

	fprintf(stderr, "Plsase input wifiap server ip:");
    gets_s(wifiapParam.cWifiSvrIP, 16);
    if(0 == strcasecmp("q", wifiapParam.cWifiSvrIP))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifiap mask ip:");
    gets_s(wifiapParam.cWifiMask, 16);
    if(0 == strcasecmp("q", wifiapParam.cWifiMask))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifiap gateway:");
    gets_s(wifiapParam.cWifiGateway, 16);
    if(0 == strcasecmp("q", wifiapParam.cWifiGateway))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifiap DNS:");
    gets_s(wifiapParam.cWifiDNS, 16);
    if(0 == strcasecmp("q", wifiapParam.cWifiDNS))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifiap ESSID:");
    gets_s(wifiapParam.cESSID, 33);
    if(0 == strcasecmp("q", wifiapParam.cESSID))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifiap key type[ascii or hex]:");
    gets_s(wifiapParam.cWifiKeyType, 16);
    if(0 == strcasecmp("q", wifiapParam.cWifiKeyType))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifiap password:");
    gets_s(wifiapParam.cWifiPassword, 32);
    if(0 == strcasecmp("q", wifiapParam.cWifiPassword))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifiap encryption:");
    gets_s(wifiapParam.cEncryption, 16);
    if(0 == strcasecmp("q", wifiapParam.cEncryption))
    {
        return -1;
    }

    fprintf(stderr, "Plsase input wifiap key number [1-4]:");
    gets_s(wifiapParam.cWifiKeyNum, 2);
    if(0 == strcasecmp("q", wifiapParam.cWifiKeyNum))
    {
        return -1;
    }

	int iRet = NetClient_SetLanParam(g_iLogonID, LAN_CMD_SET_WIFIAPPARA, (void*)&wifiapParam);
	if(iRet!=0)
	{
		fprintf(stderr, "Test_LaneParam_SetWifiApParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Test_LaneParam_SetWifiApParam successful\n");
	}

	return 0;
}
//add wifiap test@120807
int Test_LaneParam()
{
	fprintf(stderr, "\nYou choose to test NetClient_Get/SetLanParam, number is 351\n");
	char cTemp[256] = {0};
	while(true)
	{
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			break;
		}
		else if(0 == strcasecmp("1", cTemp))
		{
			Test_LaneParam_GetLanNum();
		}
		else if(0 == strcasecmp("2", cTemp))
		{
			Test_LaneParam_GetIPV4();
		}
		else if(0 == strcasecmp("3", cTemp))
		{
			Test_LaneParam_SetIPV4();
		}
		else if(0 == strcasecmp("4", cTemp))
		{
			Test_LaneParam_GetIPV6();
		}
		else if(0 == strcasecmp("5", cTemp))
		{
			Test_LaneParam_SetIPV6();
		}
		else if(0 == strcasecmp("6", cTemp))
		{
			Test_LaneParam_GetWorkMode();
		}
		else if(0 == strcasecmp("7", cTemp))
		{
			Test_LaneParam_SetWorkMode();
		}
		else if(0 == strcasecmp("8", cTemp))
		{
			Test_LaneParam_GetDHCP();
		}
		else if(0 == strcasecmp("9", cTemp))
		{
			Test_LaneParam_SetDHCP();
		}
		else if(0 == strcasecmp("10", cTemp))
		{
			Test_LaneParam_GetWifiDHCP();
		}
		else if(0 == strcasecmp("11", cTemp))
		{
			Test_LaneParam_SetWifiDHCP();
		}
		else if(0 == strcasecmp("12", cTemp))
		{
			Test_LaneParam_GetWifiWorkMode();
		}
		else if(0 == strcasecmp("13", cTemp))
		{
			Test_LaneParam_SetWifiWorkMode();
		}
		else if(0 == strcasecmp("14", cTemp))
		{
			Test_LaneParam_GetWifiApDHCPPara();
		}
		else if(0 == strcasecmp("15", cTemp))
		{
			Test_LaneParam_SetWifiApDHCPPara();
		}
		else if(0 == strcasecmp("16", cTemp))
		{
			Test_LaneParam_GetWifiApParam();
		}
		else if(0 == strcasecmp("17", cTemp))
		{
			Test_LaneParam_SetWifiApParam();
		}
		else if (0 == strcasecmp("18", cTemp))
		{
			break;
		}
		else
		{
			fprintf(stderr, "Please select lan test number:\n");
			fprintf(stderr, "1 - LAN_CMD_GET_LANNUM\n");
			fprintf(stderr, "2 - LAN_CMD_GET_IPV4		3 - LAN_CMD_SET_IPV4\n");
			fprintf(stderr, "4 - LAN_CMD_GET_IPV6		5 - LAN_CMD_SET_IPV6\n");
			fprintf(stderr, "6 - LAN_CMD_GET_WORKMODE	7 - LAN_CMD_SET_WORKMODE\n");
			fprintf(stderr, "8 - LAN_CMD_GET_DHCP		9 - LAN_CMD_SET_DHCP\n");
            //for wifiap@120807
			fprintf(stderr, "10 - LAN_CMD_GET_WIFIDHCPMODE		11 - LAN_CMD_SET_WIFIDHCPMODE\n");
			fprintf(stderr, "12 - LAN_CMD_GET_WIFIWORKMODE		13 - LAN_CMD_SET_WIFIWORKMODE\n");
			fprintf(stderr, "14 - LAN_CMD_GET_WIFIAPDHCPPARA	15 - LAN_CMD_SET_WIFIAPDHCPPARA\n");
			fprintf(stderr, "16 - LAN_CMD_GET_WIFIAPPARA		17 - LAN_CMD_SET_WIFIAPPARA\n");
			fprintf(stderr, "18 - quit\n");
		}
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}


int Test_SetAlarmConfig_Schedule()
{
	fprintf(stderr, "Test NetClient_SetAlarmConfig:CMD_SET_ALARMSCHEDULE\n");	
	
	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel no:\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iChannel = to_int_def(cTemp, -1);
	
	char cAlarmType[256] = {0};
	fprintf(stderr, "please input alarm type:\n");
	fprintf(stderr, "0-Video Lost Schedule\n");
	fprintf(stderr, "1-Port Alarm Schedule\n");
	fprintf(stderr, "2-Motion Detect Schedule\n");
	fprintf(stderr, "3-Video Cover Schedule\n");
	fprintf(stderr, "4-VCA Schedule\n");
	fprintf(stderr, "5-Audio Lost Schedule\n");
	fprintf(stderr, "6-Temperature and Humidity Schedule\n");
	gets_s(cAlarmType, 256);
	if(0 == strcasecmp("q", cAlarmType))
		return -1;
	int iAlarmType = to_int_def(cAlarmType, -1);

	fprintf(stderr, "please input weekday:\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iWeekday = to_int_def(cTemp, -1);

	int iParam1 = 0;
	int iParam2 = 0;
	if (iAlarmType == 4)
	{
		fprintf(stderr, "please input RuleID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam1 = to_int_def(cTemp, -1);

		fprintf(stderr, "please input EventID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam2 = to_int_def(cTemp, -1);
	}
	//Ϊȡʱ
	NVS_SCHEDTIME timeSeg[4];
	int iTimeSegNo;
	for(iTimeSegNo = 0; iTimeSegNo < 4; iTimeSegNo++)
	{
		memset(&timeSeg[iTimeSegNo],0,sizeof(NVS_SCHEDTIME));
	}
	for(iTimeSegNo = 0; iTimeSegNo < 4; iTimeSegNo++)
	{
		timeSeg[iTimeSegNo].iRecordMode = true; //true1
		char cStartHour[8] = {0};
		fprintf(stderr, "please input (%d)StartHour:\n",iTimeSegNo+1);
		gets_s(cStartHour, 8);
		if(0 == strcasecmp("q", cStartHour))
			return -1;
		timeSeg[iTimeSegNo].iStartHour = to_int_def(cStartHour, -1);

		char cStartMin[8] = {0};
		fprintf(stderr, "please input (%d)StartMin :\n",iTimeSegNo+1);
		gets_s(cStartMin, 8);
		if(0 == strcasecmp("q", cStartMin))
			return -1;
		timeSeg[iTimeSegNo].iStartMin = to_int_def(cStartMin, -1);

		char cStopHour[8] = {0};
		fprintf(stderr, "please input (%d)StopHour :\n",iTimeSegNo+1);
		gets_s(cStopHour, 8);
		if(0 == strcasecmp("q", cStopHour))
			return -1;
		timeSeg[iTimeSegNo].iStopHour = to_int_def(cStopHour, -1);

		char cStopMin[8] = {0};
		fprintf(stderr, "please input (%d)StopMin :\n",iTimeSegNo+1);
		gets_s(cStopMin, 8);
		if(0 == strcasecmp("q", cStopMin))
			return -1;
		timeSeg[iTimeSegNo].iStopMin = to_int_def(cStopMin, -1);

		char cEnable[8] = {0};
		fprintf(stderr, "please input (%d)enable :\n",iTimeSegNo+1);
		gets_s(cEnable, 8);
		if(0 == strcasecmp("q", cEnable))
			return -1;
		timeSeg[iTimeSegNo].iRecordMode = to_int_def(cEnable, -1);
	}
	TAlarmScheduleParam alarmParam = {0};
	alarmParam.iBuffSize = sizeof(TAlarmScheduleParam);
	alarmParam.iWeekday = iWeekday;
	alarmParam.iParam1 = iParam1;
	alarmParam.iParam2 = iParam2;
	for(int i = 0; i < MAX_TIMESEGMENT; i++)
		alarmParam.timeSeg[iWeekday][i] = timeSeg[i];   

	int iRet = -1;
	iRet = NetClient_SetAlarmConfig(g_iLogonID, iChannel, iAlarmType, CMD_SET_ALARMSCHEDULE, &alarmParam);
	if(iRet < 0)
		fprintf(stderr, "SetAlarmConfig failed!\n");
	else 
		fprintf(stderr, "SetAlarmConfig successful\n");
	return 0;

}

int Test_SetAlarmConfig_Link()
{
	fprintf(stderr, "Test NetClient_SetAlarmConfig:CMD_SET_ALARMLINK\n");	
	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel no:\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iChannel = to_int_def(cTemp, -1);

	TAlarmLinkParam tAlarmLinkParam = {0};
	tAlarmLinkParam.iBuffSize = sizeof(tAlarmLinkParam);

	char cAlarmType[256] = {0};
	fprintf(stderr, "please input alarm type:\n");
	fprintf(stderr, "0-Video Lost Link\n");
	fprintf(stderr, "1-Port Alarm Link\n");
	fprintf(stderr, "2-Motion Detect Link\n");
	fprintf(stderr, "3-Video Cover Link\n");
	fprintf(stderr, "4-VCA Link\n");
	fprintf(stderr, "5-Audio Lost Link\n");
	fprintf(stderr, "6-Temperature and Humidity Link\n");
	gets_s(cAlarmType, 256);
	if(0 == strcasecmp("q", cAlarmType))
		return -1;
	int iAlarmType = to_int_def(cAlarmType, -1);
	int iParam1 = 0;
	int iParam2 = 0;
	if (iAlarmType == 4)
	{
		fprintf(stderr, "please input RuleID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam1 = to_int_def(cTemp, -1);

		fprintf(stderr, "please input EventID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam2 = to_int_def(cTemp, -1);
		tAlarmLinkParam.iAlarmTypeParam = iParam1;
		tAlarmLinkParam.iReserved = iParam2;
	}

	char cLinkType[256] = {0};
	fprintf(stderr, "please input alarm link type:\n");
	fprintf(stderr, "0-Sound link \n");
	fprintf(stderr, "1-Display link\n");
	fprintf(stderr, "2-Output port link\n");
	fprintf(stderr, "3-Record link\n");
	fprintf(stderr, "4-PTZ link\n");
	fprintf(stderr, "5-Snap link\n");
	gets_s(cLinkType, 256);
	if(0 == strcasecmp("q", cLinkType))
		return -1;
	int iLinkType = to_int_def(cLinkType, -1);
	tAlarmLinkParam.iLinkType = iLinkType;
	if (iLinkType == 0 || iLinkType == 1)
	{
		if (iLinkType == 0)
		{
			fprintf(stderr, "Please input sound link enable(0:disable,1:enable):\n");
		}
		else
		{
			fprintf(stderr, "Please input display link enable(0:disable,1:enable):\n");
		}
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		int iEnable = to_int_def(cTemp, -1);
		tAlarmLinkParam.stLinkContent.iLinkSet[iLinkType] = iEnable;
	}
	else if (iLinkType == 2||iLinkType == 3||iLinkType == 5)
	{
		int iBitEnable[2] = {0};
		for (int i=0; i<32; i++)
		{
			fprintf(stderr, "Please input bit[%d]:",i);
			gets_s(cTemp, 256);
			if(0 == strcasecmp("q", cTemp))
				return -1;
			int iEnable = to_int_def(cTemp, -1);
			iBitEnable[0] |= iEnable<<i;
		}
		tAlarmLinkParam.stLinkContent.iLinkSet[iLinkType] = iBitEnable[0];
	}
	else if (iLinkType == 4)
	{
		fprintf(stderr, "Please input link channel No:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		int iLinkChannelNo = to_int_def(cTemp, -1);
		tAlarmLinkParam.stLinkContent.iLinkSet[iLinkType] = iLinkChannelNo;

		fprintf(stderr, "Please input PTZ type:\n");
		fprintf(stderr, "0-No link\n");
		fprintf(stderr, "1-Preset\n");
		fprintf(stderr, "2-Track\n");
		fprintf(stderr, "3-Path\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		int iPtzType = to_int_def(cTemp, -1);
		tAlarmLinkParam.stLinkContent.ptz[iLinkChannelNo].usType = iPtzType;

		fprintf(stderr, "Please input PTZ No:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		int iPtzNo = to_int_def(cTemp, -1);
		if (iPtzType == 1)
		{
			tAlarmLinkParam.stLinkContent.ptz[iLinkChannelNo].usPresetNO = iPtzNo;
		}
		else if (iPtzType == 2)
		{
			tAlarmLinkParam.stLinkContent.ptz[iLinkChannelNo].usTrackNO = iPtzNo;
		}
		else if (iPtzType == 3)
		{
			tAlarmLinkParam.stLinkContent.ptz[iLinkChannelNo].usPathNO = iPtzNo;
		}
	}
	
	int iRet = -1;
	iRet = NetClient_SetAlarmConfig(g_iLogonID, iChannel, iAlarmType, CMD_SET_ALARMLINK, &tAlarmLinkParam);
	if(iRet < 0)
		fprintf(stderr, "SetAlarmConfig failed!\n");
	else 
		fprintf(stderr, "SetAlarmConfig successful\n");
	return 0;
}

int Test_SetAlarmConfig_ScheduleEnable()
{
	fprintf(stderr, "Test NetClient_SetAlarmConfig:CMD_SET_ALARMSCH_ENABLE\n");	

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel no:\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iChannel = to_int_def(cTemp, -1);

	char cAlarmType[256] = {0};
	fprintf(stderr, "please input alarm type:\n");
	fprintf(stderr, "0-Video Lost Schedule Enable\n");
	fprintf(stderr, "1-Port Alarm Schedule Enable\n");
	fprintf(stderr, "2-Motion Detect Schedule Enable\n");
	fprintf(stderr, "3-Video Cover Schedule Enable\n");
	fprintf(stderr, "4-VCA Schedule Enable\n");
	fprintf(stderr, "5-Audio Lost Schedule Enable\n");
	fprintf(stderr, "6-Temperature and Humidity Schedule Enable\n");
	gets_s(cAlarmType, 256);
	if(0 == strcasecmp("q", cAlarmType))
		return -1;
	int iAlarmType = to_int_def(cAlarmType, -1);

	TAlarmScheEnableParam tAlarmScheEnableParam = {0};
	tAlarmScheEnableParam.iBuffSize = sizeof(tAlarmScheEnableParam);

	fprintf(stderr, "please input alarm parameter enable(0:disable, 1:enable):\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	tAlarmScheEnableParam.iEnable = to_int_def(cTemp, -1);

	int iParam1 = 0;
	int iParam2 = 0;
	if (iAlarmType == 4)
	{
		fprintf(stderr, "please input RuleID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam1 = to_int_def(cTemp, -1);

		fprintf(stderr, "please input EventID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam2 = to_int_def(cTemp, -1);
		tAlarmScheEnableParam.iParam1 = iParam1;
		tAlarmScheEnableParam.iParam2 = iParam2;
	}
	else
	{
		fprintf(stderr, "please input alarm parameter .iParam1:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		tAlarmScheEnableParam.iParam1 = to_int_def(cTemp, -1);

		fprintf(stderr, "please input alarm parameter .iParam2:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		tAlarmScheEnableParam.iParam2 = to_int_def(cTemp, -1);

		fprintf(stderr, "please input alarm parameter .iParam3:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		tAlarmScheEnableParam.iParam3 = to_int_def(cTemp, -1);
	}

	int iRet = NetClient_SetAlarmConfig(g_iLogonID, iChannel, iAlarmType, CMD_SET_ALARMSCH_ENABLE, &tAlarmScheEnableParam);

	if(iRet < 0)
		fprintf(stderr, "SetAlarmConfig failed!\n");
	else 
		fprintf(stderr, "SetAlarmConfig successful\n");

	return 0;
	
}

int Test_SetAlarmConfig_Trigger()
{
	fprintf(stderr, "Test NetClient_SetAlarmConfig:CMD_SET_ALARMTRIGGER\n");	

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel no:\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iChannel = to_int_def(cTemp, -1);

	char cAlarmType[256] = {0};
	fprintf(stderr, "please input alarm type:\n");
	fprintf(stderr, "0-Video Lost\n");
	fprintf(stderr, "1-Port Alarm\n");
	fprintf(stderr, "2-Motion Detect \n");
	fprintf(stderr, "3-Video Cover\n");
	fprintf(stderr, "4-VCA \n");
	fprintf(stderr, "5-Audio Lost\n");
	fprintf(stderr, "6-Temperature and Humidity\n");
	gets_s(cAlarmType, 256);
	if(0 == strcasecmp("q", cAlarmType))
		return -1;
	int iAlarmType = to_int_def(cAlarmType, -1);

	char cID[256] = {0};
	fprintf(stderr, "please input alarm parameter ID:\n");
	gets_s(cID, 256);
	if(0 == strcasecmp("q", cID))
		return -1;
	int iID = to_int_def(cID, -1);

	char cValue[256] = {0};
	fprintf(stderr, "please input alarm parameter value:\n");
	gets_s(cValue, 256);
	if(0 == strcasecmp("q", cValue))
		return -1;
	int iValue = to_int_def(cValue, -1);

	TAlarmTriggerParam triParam = {0};
	triParam.iBuffSize = sizeof(triParam);
	triParam.iType = iAlarmType;
	triParam.iID = iID;
	triParam.iValue = iValue;
	int iRet = NetClient_SetAlarmConfig(g_iLogonID, iChannel, iAlarmType, CMD_SET_ALARMTRIGGER, &triParam);

	if(iRet < 0)
		fprintf(stderr, "SetAlarmConfig failed!\n");
	else 
		fprintf(stderr, "SetAlarmConfig successful\n");
		
	return 0;
}

int Test_SetAlarmConfig()
{
    while(true)
	{
		fprintf(stderr, "You choose to test NetClient_SetAlarmConfig, number is 352\n");
		fprintf(stderr, "Select command:\n");
		fprintf(stderr, "  0 - CMD_SET_ALARMSCHEDULE\n");
		fprintf(stderr, "  1 - CMD_SET_ALARMLINK\n");
		fprintf(stderr, "  2 - CMD_SET_ALARMSCH_ENABLE\n");
		fprintf(stderr, "  3 - CMD_SET_ALARMTRIGGER\n");
		fprintf(stderr, "  q - quit\n");

		char cTemp[256] = {0};
		gets_s(cTemp, 256);           
		if(0 == strcasecmp("0", cTemp))
		{
			Test_SetAlarmConfig_Schedule();
		}
		else if(0 == strcasecmp("1", cTemp))
		{
			Test_SetAlarmConfig_Link();
		}
		else if(0 == strcasecmp("2", cTemp))
		{
			Test_SetAlarmConfig_ScheduleEnable();
		}
		else if(0 == strcasecmp("3", cTemp))
		{
			Test_SetAlarmConfig_Trigger();
		}
		else if(0 == strcasecmp("q", cTemp))
		{
			break;
		}			
    }
    return 0;
}

int Test_GetAlarmConfig_Schedule()
{
	fprintf(stderr, "Test NetClient_GetAlarmConfig:CMD_GET_ALARMSCHEDULE\n");	

	char cTemp[8] = {0};
	fprintf(stderr, "Please input channel no:\n");
	gets_s(cTemp, 8);           //
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iChannel = to_int_def(cTemp, -1);

	//fprintf(stderr, "please input the connect mode :\n 0:CMD_SET_ALARMSCHEDULE\n 1:CMD_SET_ALARMLINK\n 2:CMD_SET_ALARMSCH_ENABLE\n");  //choose
	//memset(cTemp, 0, sizeof(cTemp));
	//gets_s(cTemp, 8);
	char cAlarmType[256] = {0};
	fprintf(stderr, "please input alarm type:\n");
	fprintf(stderr, "0-Video Lost Schedule\n");
	fprintf(stderr, "1-Port Alarm Schedule\n");
	fprintf(stderr, "2-Motion Detect Schedule\n");
	fprintf(stderr, "3-Video Cover Schedule\n");
	fprintf(stderr, "4-VCA Schedule\n");
	fprintf(stderr, "5-Audio Lost Schedule\n");
	fprintf(stderr, "6-Temperature and Humidity Schedule\n");

	gets_s(cAlarmType, 256);
	if(0 == strcasecmp("q", cAlarmType))
		return -1;
	int iAlarmType = to_int_def(cAlarmType, -1);

	char cWeekDay[8] = {0};
	fprintf(stderr, "please input iWeekDay :\n");
	gets_s(cWeekDay, 8);
	if(0 == strcasecmp("q", cWeekDay))
		return -1;
	int iWeekday = to_int_def(cWeekDay, -1);
	
	int iParam1 = 0;
	int iParam2 = 0;

	if (iAlarmType == 4)
	{
		fprintf(stderr, "please input RuleID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam1 = to_int_def(cTemp, -1);

		fprintf(stderr, "please input EventID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam2 = to_int_def(cTemp, -1);
	}
	NVS_SCHEDTIME schedule[4];

	TAlarmScheduleParam alarmParam = {0};
	alarmParam.iBuffSize = sizeof(TAlarmScheduleParam);    
	alarmParam.iWeekday = iWeekday; //120704
	alarmParam.iParam1 = iParam1;
	alarmParam.iParam2 = iParam2;

	int iRet = -1;
	iRet = NetClient_GetAlarmConfig(g_iLogonID, iChannel, iAlarmType, CMD_GET_ALARMSCHEDULE, &alarmParam);
	if(iRet < 0)
		fprintf(stderr, "GetAlarmScheduleConfig failed!\n");
	else 
	{
		for(int i = 0; i < MAX_TIMESEGMENT; i++)
		{
			schedule[i] = alarmParam.timeSeg[iWeekday][i];
			printf("iStartHour(%d) = %d\n", i+1, schedule[i].iStartHour);
			printf("iStartMin(%d) = %d\n", i+1, schedule[i].iStartMin);
			printf("iStopHour(%d) = %d\n", i+1, schedule[i].iStopHour);
			printf("iStopMin(%d) = %d\n", i+1, schedule[i].iStopMin);
			printf("iRecordMode(%d) = %d\n", i+1, schedule[i].iRecordMode);
		}
		fprintf(stderr, "GetAlarmScheduleConfig successful\n");
	}

	return 0;

}

int Test_GetAlarmConfig_Link()
{
	fprintf(stderr, "Test NetClient_GetAlarmConfig:CMD_GET_ALARMLINK\n");	

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel no:\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iChannel = to_int_def(cTemp, -1);

	TAlarmLinkParam tAlarmLinkParam = {0};
	tAlarmLinkParam.iBuffSize = sizeof(tAlarmLinkParam);

	char cAlarmType[256] = {0};
	fprintf(stderr, "please input alarm type:\n");
	fprintf(stderr, "0-Video Lost Link\n");
	fprintf(stderr, "1-Port Alarm Link\n");
	fprintf(stderr, "2-Motion Detect Link\n");
	fprintf(stderr, "3-Video Cover Link\n");
	fprintf(stderr, "4-VCA Link\n");
	fprintf(stderr, "5-Audio Lost Link\n");
	fprintf(stderr, "6-Temperature and Humidity Link\n");
	gets_s(cAlarmType, 256);
	if(0 == strcasecmp("q", cAlarmType))
		return -1;
	int iAlarmType = to_int_def(cAlarmType, -1);
	int iParam1 = 0;
	int iParam2 = 0;
	if (iAlarmType == 4)
	{
		fprintf(stderr, "please input RuleID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam1 = to_int_def(cTemp, -1);

		fprintf(stderr, "please input EventID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam2 = to_int_def(cTemp, -1);
		tAlarmLinkParam.iAlarmTypeParam = iParam1;
		tAlarmLinkParam.iReserved = iParam2;
	}

	char cLinkType[256] = {0};
	fprintf(stderr, "please input alarm link type:\n");
	fprintf(stderr, "0-Sound link \n");
	fprintf(stderr, "1-Display link\n");
	fprintf(stderr, "2-Output port link\n");
	fprintf(stderr, "3-Record link\n");
	fprintf(stderr, "4-PTZ link\n");
	fprintf(stderr, "5-Snap link\n");
	gets_s(cLinkType, 256);
	if(0 == strcasecmp("q", cLinkType))
		return -1;
	int iLinkType = to_int_def(cLinkType, -1);
	tAlarmLinkParam.iLinkType = iLinkType;
	int iRet = NetClient_GetAlarmConfig(g_iLogonID, iChannel, iAlarmType, CMD_GET_ALARMLINK, &tAlarmLinkParam);
	if(iRet < 0)
		fprintf(stderr, "GetAlarmConfig failed!\n");
	else 
	{
		if (iLinkType == 0 || iLinkType == 1)
		{
			int iEnable = tAlarmLinkParam.stLinkContent.iLinkSet[iLinkType];
			if (iLinkType == 0)
			{
				fprintf(stderr, "Sound link enable(0:disable,1:enable):%d\n", iEnable);
			}
			else
			{
				fprintf(stderr, "Display link enable(0:disable,1:enable):%d\n", iEnable);
			}
		}
		else if (iLinkType == 2 || iLinkType == 3 || iLinkType == 5)
		{
			int iBitEnable[2] = {0};
			iBitEnable[0] = tAlarmLinkParam.stLinkContent.iLinkSet[iLinkType];
			for (int i=0; i<32; i++)
			{
				int iEnable = (iBitEnable[0]>>i) & 1;
				fprintf(stderr, "Bit[%d]:%d\n",i, iEnable);
			}
		}
		else if (iLinkType == 4)
		{
			fprintf(stderr, "Please input link channel No:");
			gets_s(cTemp, 256);
			if(0 == strcasecmp("q", cTemp))
				return -1;
			int iLinkChannelNo = to_int_def(cTemp, -1);

			int iPtzType = tAlarmLinkParam.stLinkContent.ptz[iLinkChannelNo].usType;
			fprintf(stderr, "PTZ type(0-No link,1-Preset,2-Track,3-Path):%d\n", iPtzType);
			int iPtzNo = 0;
			if (iPtzType == 1)
			{
				iPtzNo = tAlarmLinkParam.stLinkContent.ptz[iLinkChannelNo].usPresetNO;
			}
			else if (iPtzType == 2)
			{
				iPtzNo = tAlarmLinkParam.stLinkContent.ptz[iLinkChannelNo].usTrackNO;
			}
			else if (iPtzType == 3)
			{
				iPtzNo = tAlarmLinkParam.stLinkContent.ptz[iLinkChannelNo].usPathNO;
			}
			fprintf(stderr, "PTZ No:%d\n", iPtzNo);
		}
		fprintf(stderr, "GetAlarmConfig successful\n");
	}

	return 0;
}

int Test_GetAlarmConfig_ScheduleEnable()
{
	fprintf(stderr, "Test NetClient_GetAlarmConfig:CMD_GET_ALARMSCH_ENABLE\n");	

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel no:\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iChannel = to_int_def(cTemp, -1);

	char cAlarmType[256] = {0};
	fprintf(stderr, "please input alarm type:\n");
	fprintf(stderr, "0-Video Lost Schedule Enable\n");
	fprintf(stderr, "1-Port Alarm Schedule Enable\n");
	fprintf(stderr, "2-Motion Detect Schedule Enable\n");
	fprintf(stderr, "3-Video Cover Schedule Enable\n");
	fprintf(stderr, "4-VCA Schedule Enable\n");
	fprintf(stderr, "5-Audio Lost Schedule Enable\n");
	fprintf(stderr, "6-Temperature and Humidity Schedule Enable\n");
	gets_s(cAlarmType, 256);
	if(0 == strcasecmp("q", cAlarmType))
		return -1;
	int iAlarmType = to_int_def(cAlarmType, -1);

	TAlarmScheEnableParam tAlarmScheEnableParam = {0};
	tAlarmScheEnableParam.iBuffSize = sizeof(tAlarmScheEnableParam);

	int iParam1 = 0;
	int iParam2 = 0;
	if (iAlarmType == 4)
	{
		fprintf(stderr, "please input RuleID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam1 = to_int_def(cTemp, -1);

		fprintf(stderr, "please input EventID:\n");
		gets_s(cTemp, 256);
		if(0 == strcasecmp("q", cTemp))
			return -1;
		iParam2 = to_int_def(cTemp, -1);
		tAlarmScheEnableParam.iParam1 = iParam1;
		tAlarmScheEnableParam.iParam2 = iParam2;
	}
	int iRet = NetClient_GetAlarmConfig(g_iLogonID, iChannel, iAlarmType, CMD_GET_ALARMSCH_ENABLE, &tAlarmScheEnableParam);
	if(iRet < 0)
		fprintf(stderr, "GetAlarmConfig failed!\n");
	else 
	{
		fprintf(stderr, "Current alarm schedule enable(0:disable,1:enable):%d\n", tAlarmScheEnableParam.iEnable);
		fprintf(stderr, "GetAlarmConfig successful\n");
	}

	return 0;
}

int Test_GetAlarmConfig_Trigger()
{
	fprintf(stderr, "Test NetClient_GetAlarmConfig:CMD_GET_ALARMTRIGGER\n");	

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel no:\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iChannel = to_int_def(cTemp, -1);

	char cAlarmType[256] = {0};
	fprintf(stderr, "please input alarm type:\n");
	fprintf(stderr, "0-Video Lost\n");
	fprintf(stderr, "1-Port Alarm\n");
	fprintf(stderr, "2-Motion Detect \n");
	fprintf(stderr, "3-Video Cover\n");
	fprintf(stderr, "4-VCA \n");
	fprintf(stderr, "5-Audio Lost\n");
	fprintf(stderr, "6-Temperature and Humidity\n");
	gets_s(cAlarmType, 256);
	if(0 == strcasecmp("q", cAlarmType))
		return -1;
	int iAlarmType = to_int_def(cAlarmType, -1);

	char cID[256] = {0};
	fprintf(stderr, "please input alarm parameter ID:\n");
	gets_s(cID, 256);
	if(0 == strcasecmp("q", cID))
		return -1;
	int iID = to_int_def(cID, -1);

	TAlarmTriggerParam triParam = {0};
	triParam.iBuffSize = sizeof(triParam);
	triParam.iType = iAlarmType;
	triParam.iID = iID;
	int iRet = NetClient_GetAlarmConfig(g_iLogonID, iChannel, iAlarmType, CMD_GET_ALARMTRIGGER, &triParam);

	if(iRet < 0)
		fprintf(stderr, "GetAlarmConfig failed!\n");
	else 
	{
		fprintf(stderr, "GetAlarmConfig successful, parameter value is %d\n", triParam.iValue);
	}

	return 0;
}


int Test_GetAlarmConfig()
{
	while(true)
	{
		fprintf(stderr, "You choose to test NetClient_GetAlarmConfig, number is 353\n");
		fprintf(stderr, "Select command:\n");
		fprintf(stderr, "  0 - CMD_GET_ALARMSCHEDULE\n");
		fprintf(stderr, "  1 - CMD_GET_ALARMLINK\n");
		fprintf(stderr, "  2 - CMD_GET_ALARMSCH_ENABLE\n");
		fprintf(stderr, "  3 - CMD_GET_ALARMTRIGGER\n");
		fprintf(stderr, "  q - quit\n");

		char cTemp[256] = {0};
		gets_s(cTemp, 256);           
		if(0 == strcasecmp("0", cTemp))
		{
			Test_GetAlarmConfig_Schedule();
		}
		else if(0 == strcasecmp("1", cTemp))
		{
			Test_GetAlarmConfig_Link();
		}
		else if(0 == strcasecmp("2", cTemp))
		{
			Test_GetAlarmConfig_ScheduleEnable();
		}
		else if(0 == strcasecmp("3", cTemp))
		{
			Test_GetAlarmConfig_Trigger();
		}
		else if(0 == strcasecmp("q", cTemp))
		{
			break;
		}			
	}
	return 0;
  
}

int Test_GetVideoSzList()
{
	 fprintf(stderr, "You choose to test NetClient_GetVideoSzList, number is 357\n");
	 char cTemp[8] = {0};
	 fprintf(stderr, "Please input channel no:\n");
	 gets_s(cTemp, 8);           //
	 if(0 == strcasecmp("q", cTemp))
		 return -1;
	 int iChannelNo = to_int_def(cTemp, -1);

	 fprintf(stderr, "Please input stream type:\n");
	 gets_s(cTemp, 8);           //
	 if(0 == strcasecmp("q", cTemp))
		 return -1;
	 int iStreamNo = to_int_def(cTemp, -1);

	 int iCount = 0;
	 int iRet = NetClient_GetVideoSzList(g_iLogonID,iChannelNo,iStreamNo,NULL,&iCount);
	 if (iRet >= 0)
	 {
			int* piData = (int*)malloc(iCount*sizeof(int));
			int iRet = NetClient_GetVideoSzList(g_iLogonID,iChannelNo,iStreamNo,piData,&iCount);
			if (iRet >= 0)
			{
				fprintf(stderr, "Channel(%d),Stream(%d),Count(%d),",iChannelNo,iStreamNo,iCount);
				for(int i = 0; i < iCount; ++i)
				{
					fprintf(stderr, "VideoSize %d(%d),",i+1,piData[i]);
				}
				fprintf(stderr, "\nNetClient_GetVideoSzList sucessed!\n");
			}
			else
			{
				fprintf(stderr, "NetClient_GetVideoSzList failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			free(piData);
			piData = NULL;
	 }
	 else
	 {
			fprintf(stderr, "NetClient_GetVideoSzList failed! return %d, errno = 0x%08x\n", iRet, errno);
	 }

	 fprintf(stderr, "Please type a number to test corresponding interface:\n");
	 return 0;
}

int Test_SetPictureCallBack()
{
	 fprintf(stderr, "You choose to test Test_SetPictureCallBack, number is 358\n");
	 fprintf(stderr, "Please connect video before use this interface\n");

	 unsigned int _uiConID = 0;
	 void (*cbkDataNotify)(unsigned int _uiRecvID, unsigned char* _ucData, int _iLen, void* _iUserData); 
	 cbkDataNotify = NVSDATA_Notify ;
	 int lpUserData = 0xF000;


	 int iRet = 0;
	CLIENTINFO cltInfo;
	memset(&cltInfo, 0, sizeof(CLIENTINFO));
    
	if(cbkDataNotify == NULL)
	{
		return -1;
	}

	//CreateDirectory("D:\\Demo_PicStream\\", NULL);          //洢ļ
	//system( "D:\\Demo_PicStream\\");
	//mkdir Demo_PicStream;
	//strcpy(cltInfo.m_cRemoteIP, server->GetDeviceIP()); ??
    //const char* filename = "/mnt/hgfs/Demo_PicStream";
	const char* filename = "./Demo_PicStream";
	//const char* filename = "D:\\Demo_PicStream";
    mkdir(filename, S_IRWXU|S_IRGRP|S_IXGRP|S_IROTH);
	cltInfo.m_iNetMode = NETMODE_TCP;
	cltInfo.m_iTimeout = 2000;
	cltInfo.m_iTTL = 32;
	cltInfo.m_iBufferCount = 10;
	cltInfo.m_iDelayNum = 1;
	cltInfo.m_iServerID = g_iLogonID;       //logonID 
	cltInfo.m_iStreamNO = CHANNEL_PICTURE;
	cltInfo.m_iChannelNo = 0; 
    
	iRet = NetClient_StartRecv(&_uiConID, &cltInfo, *cbkDataNotify, (void*)lpUserData);
	//&g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum]
	//_uiConID = 64;  //ʱд  windows㷨 
	printf("_uiConID is %d\n", _uiConID);
	iRet = NetClient_StartCaptureData(_uiConID);
    printf("iRet is %d\n", iRet);

	return iRet;

}

int Test_SetTimeZone()
{
	fprintf(stderr, "You choose to test NetClient_SetTimeZone, number is 406\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input TimeZone[-12,13]:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iTimeZone = to_int_def(cTemp, 0);

	int iRet = NetClient_SetTimeZone(g_iLogonID, iTimeZone);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetTimeZone failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetTimeZone successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetTimeZone()
{
	fprintf(stderr, "You choose to test NetClient_GetTimeZone, number is 407\n");
	int iTimeZone = -14;
	int iRet = NetClient_GetTimeZone(g_iLogonID, &iTimeZone);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetTimeZone failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "The Timezone is %d\n", iTimeZone);
		fprintf(stderr, "NetClient_GetTimeZone successful:\n");
	}
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetCurLanguage()
{
	fprintf(stderr, "You choose to test NetClient_SetCurLanguage, number is 408\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input Language(Chinese-China;Chinese-Taiwan;Spanish-Ecuador;Korean;Italian-Italy;English-United States):");
	gets_s(cTemp, 64);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	int iRet = NetClient_SetCurLanguage(g_iLogonID, cTemp);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetCurLanguage failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetCurLanguage successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetCurLanguage()
{
	fprintf(stderr, "You choose to test NetClient_GetCurLanguage, number is 409\n");
    char cLanguage[256] = {0};
	int iRet = NetClient_GetCurLanguage(g_iLogonID, cLanguage);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetCurLanguage failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "The current language is %s\n", cLanguage);
		fprintf(stderr, "NetClient_GetCurLanguage successful:\n");
	}
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetLanguageList()
{
	fprintf(stderr, "You choose to test NetClient_GetLanguageList, number is 410\n");
	st_NVSLanguageList stLanguageList = {0};
	int iRet = NetClient_GetLanguageList(g_iLogonID, &stLanguageList);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetLanguageList failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "This Device has %d language!\n", stLanguageList.iCount);
		for (int i = 0; i < stLanguageList.iCount; i++) {
			fprintf(stderr, "Language[%d] is %s.\n", i, stLanguageList.cLanguage[i]);
		}
		fprintf(stderr, "NetClient_GetLanguageList successful:\n");
	}
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetChannelEncodeProfile()
{
	fprintf(stderr, "You choose to test NetClient_SetChannelEncodeProfile, number is 411\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);
	
	fprintf(stderr, "Please input stream type(0:Main 1:substream):\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iStreamNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input profile level(0-baseline 1-main 2-high):\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int _iLevel = to_int_def(cTemp, 0);

	int iRet = NetClient_SetChannelEncodeProfile(g_iLogonID, iChannelNo, iStreamNo, _iLevel);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetChannelEncodeProfile failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetChannelEncodeProfile successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetChannelEncodeProfile()
{
	fprintf(stderr, "You choose to test NetClient_GetChannelEncodeProfile, number is 412\n");
	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);
	
	fprintf(stderr, "Please input stream type(0:Main 1:substream):\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iStreamNo = to_int_def(cTemp, 0);
	int iLevel = -1;
	int iRet = NetClient_GetChannelEncodeProfile(g_iLogonID, iChannelNo, iStreamNo, &iLevel);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetChannelEncodeProfile failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
        fprintf(stderr, "The profile level is %d(channel:%d  stream:%d)\n", iLevel, iChannelNo, iStreamNo);
		fprintf(stderr, "NetClient_GetChannelEncodeProfile successful:\n");
	}
    fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetAlarmClear()
{
	fprintf(stderr, "You choose to test NetClient_SetAlarmClear, number is 413\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31](255 stand for all channels or ports):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);
	
	fprintf(stderr, "Please input clear type: \n");
	fprintf(stderr, "    0:Videolost           \n");
    fprintf(stderr, "    1:PortAlarm           \n");
	fprintf(stderr, "    2:MotionAlarm         \n");
	fprintf(stderr, "    3:VideoCover          \n");
	fprintf(stderr, "    4:VCAAlarm            \n");
	fprintf(stderr, "    5:AudioLost           \n");
	fprintf(stderr, "    6:Temperature         \n");
	fprintf(stderr, "    100:ExceptionAlarm    \n");
	fprintf(stderr, "    255:All               \n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iClearType = to_int_def(cTemp, 0);

	int iRet = NetClient_SetAlarmClear(g_iLogonID, iChannelNo, iClearType);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetAlarmClear failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetAlarmClear successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetExceptionHandleParam()
{
	fprintf(stderr, "You choose to test NetClient_SetExceptionHandleParam, number is 414\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input Exception Type:\n");
	fprintf(stderr, "    0:             \n");
	fprintf(stderr, "    1:޴             \n");
	fprintf(stderr, "    2:̶д       \n");
	fprintf(stderr, "    3:Ƿ           \n");
	fprintf(stderr, "    4:IPͻ             \n");
	fprintf(stderr, "    5:ж           \n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iExceptionType = to_int_def(cTemp, 0);
	
	int iFlag = 0;
	fprintf(stderr, "Please input flag1Ƿʹܣ[0,1]:\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iBit = to_int_def(cTemp, 0);
	iFlag |= (iBit<<0);

	fprintf(stderr, "Please input flag2(Ƿ񵯳ʾԻ)[0,1]:\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iBit = to_int_def(cTemp, 0);
	iFlag |= (iBit<<1);
	
	fprintf(stderr, "Please input flag3(Ƿ)[0,1]:\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iBit = to_int_def(cTemp, 0);
	iFlag |= (iBit<<2);

	fprintf(stderr, "Please input flag4(Ƿ֪ͨͻ)[0,1]:\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iBit = to_int_def(cTemp, 0);
	iFlag |= (iBit<<3);

	int iRet = NetClient_SetExceptionHandleParam(g_iLogonID, iExceptionType, iFlag);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetExceptionHandleParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetExceptionHandleParam successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetExceptionHandleParam()
{
	fprintf(stderr, "You choose to test NetClient_GetExceptionHandleParam, number is 415\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input Exception Type:\n");
	fprintf(stderr, "    0:             \n");
	fprintf(stderr, "    1:޴             \n");
	fprintf(stderr, "    2:̶д       \n");
	fprintf(stderr, "    3:Ƿ           \n");
	fprintf(stderr, "    4:IPͻ             \n");
	fprintf(stderr, "    5:ж           \n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iExceptionType = to_int_def(cTemp, 0);

	int iFlag = 0;
	int iRet = NetClient_GetExceptionHandleParam(g_iLogonID, iExceptionType, &iFlag);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetExceptionHandleParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		int iBit[4] = {0};
		for (int i=0; i<4; i++)
		{
			iBit[i] = (iFlag>>i) & 1;
		}
		fprintf(stderr, "bit0:%d bit1:%d bit2:%d bit3:%d\n", iBit[0], iBit[1], iBit[2], iBit[3]);
		fprintf(stderr, "NetClient_GetExceptionHandleParam successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetAlarmLink_V1()
{
	fprintf(stderr, "You choose to test NetClient_SetAlarmLink_V1, number is 416\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input 0:video lost link record:\n");
	fprintf(stderr, "Please input 1:video lost link snap:\n");
	fprintf(stderr, "Please input 3:video lost outport:\n");
	fprintf(stderr, "Please input 4:motion detect link record:\n");
	fprintf(stderr, "Please input 5:motion detect link snap:\n");
	fprintf(stderr, "Please input 6:motion detect link outport:\n");
	fprintf(stderr, "Please input 7:port alarm link record:\n");
	fprintf(stderr, "Please input 8:port alarm link snap:\n");
	fprintf(stderr, "Please input 9:port alarm link outport:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iAlarmLinkType = to_int_def(cTemp, 0);
	
	int iAlarmInPortNum = 1;
	int iAlarmOutPortNum = 1;
	int iRet = NetClient_GetAlarmPortNum(g_iLogonID, &iAlarmInPortNum, &iAlarmOutPortNum);
	
	int iParam[2] = {0};
	if (iAlarmLinkType == ALARMLINKTYPE_PORTALARM_LINKRECORD || iAlarmLinkType == ALARMLINKTYPE_PORTALARM_LINKSNAP ||
		iAlarmLinkType == ALARMLINKTYPE_PORTALARM_LINKOUTPORT)
	{
		fprintf(stderr, "Please input portno[0,%d]:\n", iAlarmInPortNum - 1);
	}
	else
	{
		fprintf(stderr, "Please input channelno[0,%d]:\n",g_iTotalChnlNum - 1);
	}

		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		int iChannelNo = to_int_def(cTemp, 0);

	int iCount = 1;
	if(iAlarmLinkType == ALARMLINKTYPE_VIDEOLOST_LINKOUTPORT || iAlarmLinkType == ALARMLINKTYPE_MOTIONDETECT_LINKOUTPORT
	   || iAlarmLinkType == ALARMLINKTYPE_PORTALARM_LINKOUTPORT)
		{
		iCount = iAlarmOutPortNum ;
	}
	else
			{
		iCount = g_iTotalChnlNum;
		}
	if(iCount < 32)
		{
		for (int i=0; i<iCount; i++)
			{
			fprintf(stderr, "Please input enable [%d]:\n", i);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				int iChannel = to_int_def(cTemp, 0);
			iChannel &= 0x01;

			iParam[0] |= iChannel<<i;
			}
		}
	else
	{
		for (int i=0; i<32; i++)
		{
			fprintf(stderr, "Please input enable [%d]:\n", i);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iChannel = to_int_def(cTemp, 0);
			iChannel &= 0x01;
			iParam[0] |= iChannel<<i;
		}

			for (int i=0; i<iCount - 32; i++)
		{
				fprintf(stderr, "Please input enable =[%d]=:\n", i + 32);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
				int iChannel = to_int_def(cTemp, 0);
				iChannel &= 0x01;
				iParam[1] |= iChannel<<i;
		}

	}


		
	iRet = NetClient_SetAlarmLink_V1(g_iLogonID,iChannelNo, iAlarmLinkType, iParam, sizeof(iParam));

	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetAlarmLink_V1 failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetAlarmLink_V1 successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetAlarmLink_V1()
{
	fprintf(stderr, "You choose to test NetClient_GetAlarmLink_V1, number is 417\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input 0:video lost link record:\n");
	fprintf(stderr, "Please input 1:video lost link snap:\n");
	fprintf(stderr, "Please input 3:video lost outport:\n");
	fprintf(stderr, "Please input 4:motion detect link record:\n");
	fprintf(stderr, "Please input 5:motion detect link snap:\n");
	fprintf(stderr, "Please input 6:motion detect link outport:\n");
	fprintf(stderr, "Please input 7:port alarm link record:\n");
	fprintf(stderr, "Please input 8:port alarm link snap:\n");
	fprintf(stderr, "Please input 9:port alarm link outport:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iAlarmLinkType = to_int_def(cTemp, 0);

	int iRet;
	unsigned int iParam[2] = {0};
	if (iAlarmLinkType < 6)
	{
		fprintf(stderr, "Please input channelno[0,%d]:\n",g_iTotalChnlNum - 1);
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		int iChannelNo = to_int_def(cTemp, 0);
		iRet = NetClient_GetAlarmLink_V1(g_iLogonID, iChannelNo, iAlarmLinkType, iParam, sizeof(iParam));
	}
	else
	{
		fprintf(stderr, "Please input portno[0,31]:\n");
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		int iPortNo = to_int_def(cTemp, 0);
		iRet = NetClient_GetAlarmLink_V1(g_iLogonID, iPortNo, iAlarmLinkType, iParam, sizeof(iParam));
	}
	int iNo[64];
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetAlarmLink_V1 failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		for (int i=0; i<2; i++)
		{
			for (int j=0; j<32; j++)
			{
				iNo[i*32+j] = (iParam[i]>>j) & 1;
				fprintf(stderr, "channel/port [%d] is %d\n", i*32+j,iNo[i*32+j]);
			}
		}
		//fprintf(stderr, "channel param is %u\n", iParam[0]);
		fprintf(stderr, "NetClient_GetAlarmLink_V1 successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetITSBlock()
{
	fprintf(stderr, "You choose to test NetClient_SetITSBlock, number is 418\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input blockID:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iBlockID = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input X:\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iX = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Y:\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iY = to_int_def(cTemp, 0);
	int iRet = NetClient_SetITSBlock(g_iLogonID, iBlockID, iX, iY);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetITSBlock failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetITSBlock successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	
	return 0;
}

int Test_GetITSBlock()
{
	fprintf(stderr, "You choose to test NetClient_GetITSBlock, number is 419\n");
	char cTemp[256] = {0};
	fprintf(stderr, "Please input blockID:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iBlockID = to_int_def(cTemp, 0);

	int iX = 0;
	int iY = 0;
	int iRet = NetClient_GetITSBlock(g_iLogonID, iBlockID, &iX, &iY);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetITSBlock failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "The BlockID is %d(X:%d  Y:%d)\n", iBlockID, iX, iY);
		fprintf(stderr, "NetClient_GetITSBlock successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetHDTimeRangeParam()
{
	fprintf(stderr, "You choose to test NetClient_SetHDTimeRangeParam, number is 420\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input index[0,7]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iIndex = to_int_def(cTemp, 0);

	ITS_TTimeRangeParam itsTimeRangeParam = {0};
	fprintf(stderr, "Please input param type :\n");
	fprintf(stderr, "    0:Ȧ				\n");
	fprintf(stderr, "    1:̬				\n");
	fprintf(stderr, "    2:ⲹ				\n");
	fprintf(stderr, "    3:عʱ				\n");
	fprintf(stderr, "    4:ŵ				\n");
	fprintf(stderr, "    5:				\n");
	fprintf(stderr, "    6:gamma			\n");
	fprintf(stderr, "    7:ȵ				\n");
	fprintf(stderr, "    8:				\n");
	fprintf(stderr, "    9:ع				\n");
	fprintf(stderr, "    10:ⲹ		\n");
	fprintf(stderr, "    11:AF			\n");
	fprintf(stderr, "    12:Ŀȵ		\n");
	fprintf(stderr, "    13:ƽ			\n");
	fprintf(stderr, "    14:jpegͼ		\n");
	fprintf(stderr, "    15:lutʹ				\n");
	fprintf(stderr, "    16:Զȵʹ	\n");
	fprintf(stderr, "    17:ǿƹ		\n");
	fprintf(stderr, "    18:Զعģʽ		\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	itsTimeRangeParam.iType = to_int_def(cTemp, 0);

	if (itsTimeRangeParam.iType == 8)
	{
		fprintf(stderr, "Please input auto enable(0ֶ1Զͨģʽ2Զרģʽ):\n");
	}
	else
	{
		fprintf(stderr, "Please input auto enable(0ֶ1Զ):\n");
	}
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	itsTimeRangeParam.iAutoEnable[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
	switch (itsTimeRangeParam.iType)
	{
	case 0:
		{
			if (itsTimeRangeParam.iAutoEnable[itsTimeRangeParam.iType] == 0)
			{
				fprintf(stderr, "Please input param:\n");
			}
			else
			{
				fprintf(stderr, "Please input param(0:Ȧ1:رչȦ):\n");				
			}
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);				
		}
		break;
	case 1:
		{
			fprintf(stderr, "Please input param(1:0:ر):\n");				
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);				
		}
		break;
	case 2:
		{
			fprintf(stderr, "Please input param(1:0:ر):\n");				
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);							
		}
		break;
	case 3:
	case 4:
	case 5:
	case 6:
	case 7:
		{
			for (int i=0; i<3; i++)
			{
				if (itsTimeRangeParam.iAutoEnable[itsTimeRangeParam.iType] == 0)
				{
					fprintf(stderr, "Please input param:\n");
					gets_s(cTemp, 8);
					if(0 == strcasecmp("q", cTemp))
					{
						return -1;
					}
					itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
					break;
				}
				else
				{
					if (i == 0)
					{
						fprintf(stderr, "Please input param(ֵ):\n");	
						gets_s(cTemp, 8);
						if(0 == strcasecmp("q", cTemp))
						{
							return -1;
						}
						itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
					}
					else if (i == 1)
					{
						fprintf(stderr, "Please input param(ֵ):\n");
						gets_s(cTemp, 8);
						if(0 == strcasecmp("q", cTemp))
						{
							return -1;
						}
						itsTimeRangeParam.iParam2[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
					}
					else if (i == 2)
					{
						fprintf(stderr, "Please input param(ֵ):\n");
						gets_s(cTemp, 8);
						if(0 == strcasecmp("q", cTemp))
						{
							return -1;
						}
						itsTimeRangeParam.iParam3[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
					}
				}
			}
		}
		break;
	case 8:
		{
			for (int i=0; i<2; i++)
			{
				if (itsTimeRangeParam.iAutoEnable[itsTimeRangeParam.iType] == 0)
				{
					fprintf(stderr, "Please input param:\n");
					gets_s(cTemp, 8);
					if(0 == strcasecmp("q", cTemp))
					{
						return -1;
					}
					itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
					break;
				}
				else if (itsTimeRangeParam.iAutoEnable[itsTimeRangeParam.iType] == 1)
				{
					fprintf(stderr, "Please input param(ֵ):\n");	
					gets_s(cTemp, 8);
					if(0 == strcasecmp("q", cTemp))
					{
						return -1;
					}
					itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
					break;
				}
				else if (itsTimeRangeParam.iAutoEnable[itsTimeRangeParam.iType] == 2)
				{
					if (i == 0)
					{
						fprintf(stderr, "Please input param(2Dֵ):\n");
						gets_s(cTemp, 8);
						if(0 == strcasecmp("q", cTemp))
						{
							return -1;
						}
						itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
					}
					else if (i == 1)
					{
						fprintf(stderr, "Please input param(3Dֵ):\n");
						gets_s(cTemp, 8);
						if(0 == strcasecmp("q", cTemp))
						{
							return -1;
						}
						itsTimeRangeParam.iParam2[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
					}
				}
			}
		}
		break;
	case 9:
	case 10:
	case 11:
		{
			fprintf(stderr, "Please input param(ϽX):\n");	
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
			fprintf(stderr, "Please input param(ϽY):\n");	
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam2[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
			fprintf(stderr, "Please input param(½X):\n");	
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam3[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
			fprintf(stderr, "Please input param(½Y):\n");	
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam4[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
		}
		break;
	case 12:
		{
			fprintf(stderr, "Please input param(1):\n");	
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
			fprintf(stderr, "Please input param(2):\n");	
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam2[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
			fprintf(stderr, "Please input param(3):\n");	
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam3[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
		}
		break;
	case 13:
		{
			if (itsTimeRangeParam.iAutoEnable[itsTimeRangeParam.iType] == 0)
			{
				fprintf(stderr, "Please input param(R)[0255]:\n");	
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
				fprintf(stderr, "Please input param(G)[0255]:\n");	
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				itsTimeRangeParam.iParam2[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
				fprintf(stderr, "Please input param(B)[0255]:\n");	
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				itsTimeRangeParam.iParam3[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
			}
			else if (itsTimeRangeParam.iAutoEnable[itsTimeRangeParam.iType] == 1)
			{
				fprintf(stderr, "Please input param(RУϵ)[100200]:\n");	
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
				fprintf(stderr, "Please input param(GУϵ)[100200]:\n");	
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				itsTimeRangeParam.iParam2[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
				fprintf(stderr, "Please input param(BУϵ)[100200]:\n");	
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				itsTimeRangeParam.iParam3[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
			}
		}
		break;
	case 14:
		{
			fprintf(stderr, "Please input param[0100]:\n");	
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
		}
		break;
	case 15:
	case 16:
	case 17:
		{
			fprintf(stderr, "Please input param(1:0:ر):\n");	
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);
		}
		break;
	case 18:
		{
			fprintf(stderr, "Please input param(0:ȣ1:֡ȣ2:):\n");	
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			itsTimeRangeParam.iParam1[itsTimeRangeParam.iType] = to_int_def(cTemp, 0);		
		}
		break;
	}
	int iRet = NetClient_SetHDTimeRangeParam(g_iLogonID, iChannelNo, iIndex, &itsTimeRangeParam, sizeof(ITS_TTimeRangeParam));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetHDTimeRangeParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetHDTimeRangeParam successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetHDTimeRangeParam()
{
	fprintf(stderr, "You choose to test NetClient_GetHDTimeRangeParam, number is 421\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input index[0,7]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iIndex = to_int_def(cTemp, 0);

	ITS_TTimeRangeParam itsTimeRangeParam = {0};
	int iBufferSize = sizeof(ITS_TTimeRangeParam);
	int iRet = NetClient_GetHDTimeRangeParam(g_iLogonID, iChannelNo, iIndex, &itsTimeRangeParam, iBufferSize);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetHDTimeRangeParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		for (int i=0;i<=18; i++)
		{
			fprintf(stderr, "Type is %d\n", i);
			if (i == 8)
			{
				fprintf(stderr, "auto enable(0:ֶ1:Զͨģʽ2:Զרģʽ) is %d\n",
					itsTimeRangeParam.iAutoEnable[i]);
			}
			else
			{
				fprintf(stderr, "Auto enable(0:ֶ1:Զ) is %d\n", 
					itsTimeRangeParam.iAutoEnable[i]);
			}
			fprintf(stderr, "Param1 = %d\n", itsTimeRangeParam.iParam1[i]);
			fprintf(stderr, "Param2 = %d\n", itsTimeRangeParam.iParam2[i]);
			fprintf(stderr, "Param3 = %d\n", itsTimeRangeParam.iParam3[i]);
			fprintf(stderr, "Param4 = %d\n\n", itsTimeRangeParam.iParam4[i]);
		}
		fprintf(stderr, "NetClient_GetHDTimeRangeParam successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetHDTemplateName()
{
	fprintf(stderr, "You choose to test NetClient_SetHDTemplateName, number is 422\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input templateID[0,7]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iTemplateID = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input templateName (the length of char is 32):\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 32);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	char cTemplateName[32] = {0};
	//memcpy(cTemplateName, cTemp, 32);
	u2g(cTemp,strlen(cTemp),cTemplateName,sizeof(cTemplateName));
	int iRet = NetClient_SetHDTemplateName(g_iLogonID, iTemplateID, cTemplateName);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetHDTemplateName failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetHDTemplateName successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetHDTemplateName()
{
	fprintf(stderr, "You choose to test NetClient_GetHDTemplateName, number is 423\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input templateID[0,7]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iTemplateID = to_int_def(cTemp, 0);

	char cTemplateName[32] = {0};
	int iRet = NetClient_GetHDTemplateName(g_iLogonID, iTemplateID, cTemplateName);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetHDTemplateName failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		g2u(cTemplateName,strlen(cTemplateName),cTemp,sizeof(cTemp));
		fprintf(stderr, "The templateName is %s\n", cTemp);
		fprintf(stderr, "NetClient_GetHDTemplateName successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetHDTemplateMap()
{
	fprintf(stderr, "You choose to test NetClient_SetHDTemplateMap, number is 424\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input templatemap num:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iTemplateMapNum = to_int_def(cTemp, 0);

	ITS_TOTAL_TTemplateMap itsTotalTemplateMap;
	memset(&itsTotalTemplateMap,0,sizeof(ITS_TOTAL_TTemplateMap));
	for (int i=0; i<iTemplateMapNum; i++)
	{
		fprintf(stderr, "Please input templatemap templateID:\n");
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		itsTotalTemplateMap.templatemap[i].iTemplateID = to_int_def(cTemp, 0);

// 		fprintf(stderr, "Please input templatemap templatename:\n");
// 		gets_s(cTemp, 64);
// 		if(0 == strcasecmp("q", cTemp))
// 		{
// 			return -1;
// 		}
// 		u2g(cTemp,strlen(cTemp)+1,itsTotalTemplateMap.templatemap[i].cTemplateName,sizeof(itsTotalTemplateMap.templatemap[i].cTemplateName));
		//memcpy(itsTotalTemplateMap.templatemap[i].cTemplateName, cTemp, 64);

	}
	int iRet = NetClient_SetHDTemplateMap(g_iLogonID, iChannelNo, &itsTotalTemplateMap, sizeof(ITS_TOTAL_TTemplateMap));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetHDTemplateMap failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetHDTemplateMap successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetHDTemplateMap()
{
	fprintf(stderr, "You choose to test NetClient_GetHDTemplateMap, number is 425\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	ITS_TOTAL_TTemplateMap itsTotalTemplateMap;
	memset(&itsTotalTemplateMap,0,sizeof(ITS_TOTAL_TTemplateMap));
	int iRet = NetClient_GetHDTemplateMap(g_iLogonID, iChannelNo, &itsTotalTemplateMap, sizeof(ITS_TOTAL_TTemplateMap));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetHDTemplateMap failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
// 		char cTemplateName[96] = {0};	
// 		for (int i=0; i<8; i++)
// 		{
// 			g2u(itsTotalTemplateMap.templatemap[i].cTemplateName,strlen(itsTotalTemplateMap.templatemap[i].cTemplateName)+1,cTemplateName,sizeof(cTemplateName));
// 			fprintf(stderr, "The itsTemplateMap is %d(%d,%s)\n", i,
// 				itsTotalTemplateMap.templatemap[i].iTemplateID,
// 				cTemplateName);
// 		}
		for (int i=0; i<8; i++)
		{
			fprintf(stderr, "The itsTemplateMap is %d(%d)\n", i,
				itsTotalTemplateMap.templatemap[i].iTemplateID);
		}
		fprintf(stderr, "NetClient_GetHDTemplateMap successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetITSTimeRangeEnable()
{
	fprintf(stderr, "You choose to test NetClient_SetITSTimeRangeEnable, number is 426\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input index:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iIndex = to_int_def(cTemp, 0);

	ITS_TTimeRange itsTimeRange = {0};
	fprintf(stderr, "Please input time range enable:(1:able 2:disable)\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	itsTimeRange.iEnable = to_int_def(cTemp, 0);
	
	fprintf(stderr, "Please input time range start hour:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iStartHour = to_int_def(cTemp, 0);
	itsTimeRange.iTimeRange |= iStartHour<<24;

	fprintf(stderr, "Please input time range start minute:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iStartMinute = to_int_def(cTemp, 0);
	itsTimeRange.iTimeRange |= iStartMinute<<16;

	fprintf(stderr, "Please input time range end hour:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iEndHour = to_int_def(cTemp, 0);
	itsTimeRange.iTimeRange |= iEndHour<<8;

	fprintf(stderr, "Please input time range end minute:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iEndMinute = to_int_def(cTemp, 0);
	itsTimeRange.iTimeRange |= iEndMinute<<0;
	int iRet = NetClient_SetITSTimeRangeEnable(g_iLogonID, iChannelNo, iIndex, &itsTimeRange, sizeof(ITS_TTimeRange));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetITSTimeRangeEnable failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetITSTimeRangeEnable successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetITSTimeRangeEnable()
{
	fprintf(stderr, "You choose to test NetClient_GetITSTimeRangeEnable, number is 427\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input index:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iIndex = to_int_def(cTemp, 0);

	ITS_TTimeRange itsTimeRange = {0};
	int iRet = NetClient_GetITSTimeRangeEnable(g_iLogonID, iChannelNo, iIndex, &itsTimeRange, sizeof(ITS_TTimeRange));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetITSTimeRangeEnable failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		int iEndMinute= (itsTimeRange.iTimeRange>>0 & 0xFF);
		int iEndHour= (itsTimeRange.iTimeRange>>8) & 0xFF;
		int iStartMinute= (itsTimeRange.iTimeRange>>16) & 0xFF;
		int iStartHour= (itsTimeRange.iTimeRange>>24) & 0xFF;
		fprintf(stderr, "The time range is (%d:%d-%d:%d)\n", iStartHour,iStartMinute,iEndHour,iEndMinute);
		fprintf(stderr, "NetClient_GetITSTimeRangeEnable successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetITSDetectMode()
{
	fprintf(stderr, "You choose to test NetClient_SetITSDetectMode, number is 428\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input detect mode:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iDetectMode = to_int_def(cTemp, 0);

	int iRet = NetClient_SetITSDetectMode(g_iLogonID, iDetectMode);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetITSDetectMode failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetITSDetectMode successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetITSDetectMode()
{
	fprintf(stderr, "You choose to test NetClient_GetITSDetectMode, number is 429\n");
	
	int iDetectMode = 0;
	int iRet = NetClient_GetITSDetectMode(g_iLogonID, &iDetectMode);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetITSDetectMode failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "The detect mode is %d\n", iDetectMode);
		fprintf(stderr, "NetClient_GetITSDetectMode successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetCharSet()
{
	fprintf(stderr, "You choose to test NetClient_GetCharSet, number is 430\n");

	char cCharSet[10] = {0};
	int iRet = NetClient_GetCharSet(g_iLogonID, cCharSet);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetCharSet failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "The CharSet is %s\n", cCharSet);
		fprintf(stderr, "NetClient_GetCharSet successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_CheckDeviceState()
{
	fprintf(stderr, "You choose to test NetClient_CheckDeviceState, number is 431\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input type(0: brightness  1: sharpness):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iType = to_int_def(cTemp, 0);

	int iRet = NetClient_CheckDeviceState(g_iLogonID, iChannelNo, iType);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_CheckDeviceState failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_CheckDeviceState successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetDeviceState()
{
	fprintf(stderr, "You choose to test NetClient_GetDeviceState, number is 432\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input type(0: brightness  1: sharpness):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iType = to_int_def(cTemp, 0);

	int iValue = 0;
	int iRet = NetClient_GetDeviceState(g_iLogonID, iChannelNo, iType, &iValue);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetDeviceState failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Type is %d (0:brightness  1:sharpness)\n", iType);
		fprintf(stderr, "The value is %d\n", iValue);
		fprintf(stderr, "NetClient_GetDeviceState successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_CheckCamera()
{
	fprintf(stderr, "You choose to test NetClient_CheckCamera, number is 433\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input type(0:bad pixel  1:Iris check):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iType = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input enable:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iEnable = to_int_def(cTemp, 0);

	int iRet = NetClient_CheckCamera(g_iLogonID, iChannelNo, iType, iEnable);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_CheckCamera failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_CheckCamera successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetCameraCheckInfo()
{
	fprintf(stderr, "You choose to test NetClient_CheckCamera, number is 434\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input type(0:bad pixel  1:Iris check):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iType = to_int_def(cTemp, 0);

	int iState = 0;
	int iRet = NetClient_GetCameraCheckInfo(g_iLogonID, iChannelNo, iType, &iState);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetCameraCheckInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "The type is %d (0:bad pixel  1:Iris checks)\n", iType);
		fprintf(stderr, "The state is %d\n", iState);
		fprintf(stderr, "NetClient_GetCameraCheckInfo successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetCameraParam()
{
	fprintf(stderr, "You choose to test NetClient_SetCameraParam, number is 435\n");

	TCameraParam tCameraParam = {0};
	char cTemp[256] = {0};
	fprintf(stderr, "Please input param type(0:quality of picture 1:LUT reserved):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tCameraParam.iParamType = to_int_def(cTemp, 0);

	if (tCameraParam.iParamType == 0)
	{
		fprintf(stderr, "Please input param value[0,100]:\n");
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		tCameraParam.iParamValue = to_int_def(cTemp, 0);
	}
	else if (tCameraParam.iParamType == 1)
	{
		fprintf(stderr, "Please input param value(0:No using;1:Using):\n");
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		tCameraParam.iParamValue = to_int_def(cTemp, 0);
	}
	int iRet = NetClient_SetCameraParam(g_iLogonID, &tCameraParam, sizeof(tCameraParam));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetCameraParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetCameraParam successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetCameraParam()
{
	fprintf(stderr, "You choose to test NetClient_GetCameraParam, number is 436\n");

	TCameraParam tCameraParam = {0};
	char cTemp[256] = {0};
	fprintf(stderr, "Please input param type(0:quality of picture, 1:LUT reserved):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tCameraParam.iParamType = to_int_def(cTemp, 0);

	int iRet = NetClient_GetCameraParam(g_iLogonID, &tCameraParam, sizeof(tCameraParam));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetCameraParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "the camera param type is %d (0:quality of picture, 1:LUT reserved)\n",tCameraParam.iParamType);
		if (1 == tCameraParam.iParamType)
		{
			fprintf(stderr, "value is %d (0:No using;1:Using)\n",tCameraParam.iParamValue);
		}
		else
		{
			fprintf(stderr, "value is %d\n",tCameraParam.iParamValue);
		}
		fprintf(stderr, "NetClient_GetCameraParam successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetColorParam()
{
	fprintf(stderr, "You choose to test NetClient_SetColorParam, number is 437\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Color To Grad Enable(0:inner syn,1:Black or white,2:color,3:out syn, 4:alarm syn):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iColorToGradEnable = to_int_def(cTemp, 0);
	
	fprintf(stderr, "Please input day range:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iDayRange = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input night range:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iNightRange = to_int_def(cTemp, 0);
	int iRet = NetClient_SetColorParam(g_iLogonID, iChannelNo, iColorToGradEnable, iDayRange, iNightRange);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetColorParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetColorParam successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetColorParam()
{
	fprintf(stderr, "You choose to test NetClient_SetColorParam, number is 438\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	int iColorToGradEnable = 0;
	int iDayRange = 0;
	int iNightRange = 0;
	int iRet = NetClient_GetColorParam(g_iLogonID, iChannelNo, &iColorToGradEnable, &iDayRange, &iNightRange);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetColorParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "the Color To Grad Enable is %d:\n", iColorToGradEnable);
		fprintf(stderr, "the day range is %d:\n", iDayRange);
		fprintf(stderr, "the night range is %d:\n", iNightRange);
		fprintf(stderr, "NetClient_GetColorParam successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetJPEGQuality()
{
	fprintf(stderr, "You choose to test NetClient_SetJPEGQuality, number is 439\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input JPEGQuality:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iJpegQuality = to_int_def(cTemp, 0);
	int iRet = NetClient_SetJPEGQuality(g_iLogonID, iJpegQuality);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetJPEGQuality failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetJPEGQuality successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;	
}

int Test_GetJPEGQuality()
{
	fprintf(stderr, "You choose to test NetClient_GetJPEGQuality, number is 440\n");

	int iJpegQuality = 0;
	int iRet = NetClient_GetJPEGQuality(g_iLogonID, &iJpegQuality);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetJPEGQuality failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "the JPEG quality is %d:\n",iJpegQuality);
		fprintf(stderr, "NetClient_GetJPEGQuality successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;	
}

int Test_SetPlatformApp()
{
	fprintf(stderr, "You choose to test NetClient_SetPlatformApp, number is 441\n");

	char cTemp[256] = {0};
	TPlatformApp tApp;
	memset(&tApp,0,sizeof(TPlatformApp));
	for(int i = 0; i < MAX_PLATFORM_COUNT; ++i)
	{
		fprintf(stderr, "Please input Name %d:\n",i+1);
		gets_s(cTemp, 32);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		strcpy(tApp.cName[i],cTemp);

		fprintf(stderr, "Please input State %d:\n",i+1);
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		tApp.iState[i] = to_int_def(cTemp, 0);
	}
	int iRet = NetClient_SetPlatformApp(g_iLogonID,PLATFORM_CMD_SET_RUN, &tApp,sizeof(TPlatformApp));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetPlatformApp failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetPlatformApp successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;	
}

int Test_GetPlatformApp()
{
	fprintf(stderr, "You choose to test NetClient_GetPlatformApp, number is 442\n");

	TPlatformApp tApp;
	memset(&tApp,0,sizeof(TPlatformApp));
	int iRet = NetClient_GetPlatformApp(g_iLogonID,PLATFORM_CMD_GET_LIST, &tApp,sizeof(TPlatformApp));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetPlatformApp failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		for(int i = 0; i < MAX_PLATFORM_COUNT; ++i)
		{
			fprintf(stderr, "platform %d Name(%s),State(%d)\n",i+1,tApp.cName[i],tApp.iState[i]);
		}
		
		fprintf(stderr, "\nNetClient_GetPlatformApp successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetOSDTypeFontSize()
{
	fprintf(stderr, "You choose to test NetClient_SetOSDTypeFontSize, number is 371\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,%d]:\n",g_iTotalChnlNum-1);
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input OSD type(1:datetime 2:channel name 3:logo color 4:OSD text 5:industrial applications):\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iType = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input OSD size[1,5]:\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iSize = to_int_def(cTemp, 0);

	int iRet = NetClient_SetOSDTypeFontSize(g_iLogonID, iChannelNo, iType, iSize);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetOSDTypeFontSize failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetOSDTypeFontSize successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetOSDTypeFontSize()
{
	fprintf(stderr, "You choose to test NetClient_GetOSDTypeFontSize, number is 372\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,%d]:\n",g_iTotalChnlNum-1);
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input OSD type(1:datetime 2:channel name 3:logo color 4:OSD text 5:industrial applications):\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iType = to_int_def(cTemp, 0);
	int iSize = 0;
	int iRet = NetClient_GetOSDTypeFontSize(g_iLogonID, iChannelNo, iType, &iSize);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetOSDTypeFontSize failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "font size is %d(channel no:%d,osd type:%d)\n",iSize,iChannelNo,iType);
		fprintf(stderr, "NetClient_GetOSDTypeFontSize successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetMuted()
{
	fprintf(stderr, "You choose to test NetClient_SetMuted, number is 373\n");
	fprintf(stderr, "Please connect video before use this interface\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,%d]:\n",g_iTotalChnlNum-1);
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input stream type(0:Main 1:substream):\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iStreamNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input mute type(0:false 1:true):\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iMuted = to_int_def(cTemp, 0);

	if(0xFFFFFFFF == g_uiRecv[iChannelNo+iStreamNo*g_iTotalChnlNum])
	{
		fprintf(stderr, "Please first call NetClient_StartRecv, then call Test_SetMuted\n");
		fprintf(stderr, "Please type interface to test:");
		return 0;
	}

	int iRet = NetClient_SetMuted(g_uiRecv[iChannelNo+iStreamNo*g_iTotalChnlNum],iMuted);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetMuted failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetMuted successful:\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetPWMValue()
{
	fprintf(stderr, "You choose to test NetClient_SetPWMValue, number is 374\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,%d]:\n",g_iTotalChnlNum-1);
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input PWM value[0,10]:\n");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iValue = to_int_def(cTemp, 0);

	int iRet = NetClient_SetPWMValue(g_iLogonID, iChannelNo, iValue);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetPWMValue failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetPWMValue successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetPWMValue()
{
	fprintf(stderr, "You choose to test NetClient_GetPWMValue, number is 375\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,%d]:\n",g_iTotalChnlNum-1);
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	int iValue = 0;
	int iRet = NetClient_GetPWMValue(g_iLogonID, iChannelNo, &iValue);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetPWMValue failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "PWM value is %d(channel:%d)\n", iValue, iChannelNo);
		fprintf(stderr, "NetClient_GetPWMValue successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetImgDisposal()
{
	fprintf(stderr, "You choose to test NetClient_SetImgDisposal, number is 376\n");

	TImgDisposal tImgDisposal = {0};
	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel ID[0,3]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tImgDisposal.iChannelID = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input disposal start up(0:disable 1:enable):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tImgDisposal.iStartUp = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input quality[0,100]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tImgDisposal.iQuality = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input saturation[0,255]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tImgDisposal.iSaturation = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input brighten[0,255]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tImgDisposal.iBrighten = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input contrast[0,255]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tImgDisposal.iContrast = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input gamma[0,50]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tImgDisposal.iGamma = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input acutance[0,255]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tImgDisposal.iAcutance = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input enhance level[0,3]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tImgDisposal.iImgEnhanceLevel = to_int_def(cTemp, 0);

	int iRet = NetClient_SetImgDisposal(g_iLogonID, &tImgDisposal, sizeof(TImgDisposal));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetImgDisposal failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetImgDisposal successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetImgDisposal()
{
	fprintf(stderr, "You choose to test NetClient_GetImgDisposal, number is 377\n");

	TImgDisposal tImgDisposal = {0};
	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel ID[0,3]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tImgDisposal.iChannelID = to_int_def(cTemp, 0);

	int iRet = NetClient_GetImgDisposal(g_iLogonID, &tImgDisposal, sizeof(TImgDisposal));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetImgDisposal failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, 
			"ChannelID:%d\n StartUp:%d(0:No using 1:Using)\n Quality:%d\n Saturation:%d \
			\n Brighten:%d\n Contrast:%d\n Gamma:%d\n Acutance:%d\n EnhanceLevel:%d\n"
			,tImgDisposal.iChannelID,tImgDisposal.iStartUp,tImgDisposal.iQuality,tImgDisposal.iSaturation
			,tImgDisposal.iBrighten,tImgDisposal.iContrast,tImgDisposal.iGamma,tImgDisposal.iAcutance
			,tImgDisposal.iImgEnhanceLevel);
		fprintf(stderr, "NetClient_GetImgDisposal successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetSystemType()
{
	fprintf(stderr, "You choose to test NetClient_SetSystemType, number is 378\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input system type\n 0:debug mode\n 1:normal mode\n 2:safe mode\n 3:toll-gate\n 4:ECOP\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iType = to_int_def(cTemp, 0);

	int iRet = NetClient_SetSystemType(g_iLogonID, iType);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetSystemType failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetSystemType successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetSystemType()
{
	fprintf(stderr, "You choose to test NetClient_GetSystemType, number is 379\n");

	int iType = 0;
	int iRet = NetClient_GetSystemType(g_iLogonID, &iType);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetSystemType failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "system type is %d\n",iType);
		fprintf(stderr, "NetClient_GetSystemType successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetITSLoopMode()
{
	fprintf(stderr, "You choose to test NetClient_SetITSLoopMode, number is 380\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input loop mode(0:single loop 1:double loop):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iMode = to_int_def(cTemp, 0);

	int iRet = NetClient_SetITSLoopMode(g_iLogonID, iMode);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetITSLoopMode failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetITSLoopMode successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetITSLoopMode()
{
	fprintf(stderr, "You choose to test NetClient_GetITSLoopMode, number is 381\n");

	int iMode = 0;
	int iRet = NetClient_GetITSLoopMode(g_iLogonID, &iMode);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetITSLoopMode failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "loop mode is %d\n",iMode);
		fprintf(stderr, "NetClient_GetITSLoopMode successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetITSDeviceType()
{
	fprintf(stderr, "You choose to test NetClient_SetITSDeviceType, number is 382\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input device type[0,4]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iType = to_int_def(cTemp, 0);

	int iRet = NetClient_SetITSDeviceType(g_iLogonID, iType);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetITSDeviceType failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetITSDeviceType successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetITSDeviceType()
{
	fprintf(stderr, "You choose to test NetClient_GetITSDeviceType, number is 383\n");

	int iType = 0;
	int iRet = NetClient_GetITSDeviceType(g_iLogonID, &iType);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetITSDeviceType failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "ITS device type is %d\n",iType);
		fprintf(stderr, "NetClient_GetITSDeviceType successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetITSRoadwayParam()
{
	fprintf(stderr, "You choose to test NetClient_SetITSRoadwayParam, number is 384\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input cmd code\n(\n\t0:SetITSRoadwayEnable \n\t1:SetITSRoadwayLoop \n\t2:SetITSRoadwayTime \
					\n\t3:SetITSRoadwaySpeed \n\t4:SetITSRoadwayReco \n\t5:SetITSRoadwayVloop \n\t6:SetITSRoadwayLight \
					\n\t7:SetITSRoadwayCapture \n\t8:SetITSReferencLines\n):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);
	switch(iCmd)
	{
	case ITS_ROADWAY_CMD_SET_ENABLE:
		{
			TITSRoadwayInfo tRoadwayInfo = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayInfo.iRoadwayID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input roadway enable(0:disable 1:enable):\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayInfo.iEnable = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input channel name:\n");
			gets_s(cTemp, 31);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			//strcpy(tRoadwayInfo.cChannelName,cTemp);
			u2g(cTemp,strlen(cTemp)+1,tRoadwayInfo.cChannelName,sizeof(tRoadwayInfo.cChannelName));

			fprintf(stderr, "Please input channel dir:\n");
			gets_s(cTemp, 31);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			//strcpy(tRoadwayInfo.cChannelDir,cTemp);
			u2g(cTemp,strlen(cTemp)+1,tRoadwayInfo.cChannelDir,sizeof(tRoadwayInfo.cChannelDir));

			int iRet = NetClient_SetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_SET_ENABLE,&tRoadwayInfo,sizeof(TITSRoadwayInfo));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_SET_LOOP:
		{
			TITSRoadWayLoop tRoadwayLoop = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayLoop.iRoadwayID = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input com port:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayLoop.iComportNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input capture loop No:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayLoop.iCaptureLoopNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input seed loop No:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayLoop.iSpeedLoopNo = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_SET_LOOP,&tRoadwayLoop,sizeof(TITSRoadWayLoop));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_SET_TIME: 
		{
			TITSRoadwayTime tRoadwayTime = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayTime.iRoadwayID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input min time:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayTime.iLoopMinTime = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input max time:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayTime.iLoopMaxTime = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input delay time:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayTime.iLoopDelayTime = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_SET_TIME,&tRoadwayTime,sizeof(TITSRoadwayTime));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_SET_SPEED:
		{
			TITSRoadwaySpeed tRoadwaySpeed = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwaySpeed.iRoadwayID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input loop distance:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwaySpeed.iLoopDistance = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input seed limit:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwaySpeed.iSpeedLimit = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input seed modify:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwaySpeed.iSpeedModify = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_SET_SPEED,&tRoadwaySpeed,sizeof(TITSRoadwaySpeed));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_SET_RECO:
		{
			TITSRoadwayReco tRoadwayReco = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayReco.iRoadwayID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input left[0,100]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iLeftEdge = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input top[0,100]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iUpEdge = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input right[0,100]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iRightEdge = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input bottom[0,100]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iDownEdge = to_int_def(cTemp, 0);

			if (iLeftEdge < 0 || iLeftEdge > 100 || iUpEdge < 0 || iUpEdge > 100
				|| iRightEdge < 0 || iRightEdge > 100 || iDownEdge < 0 || iDownEdge > 100)
			{
				return -1;
			}
			tRoadwayReco.iRoadwayRange = (iLeftEdge << 24) | (iUpEdge << 16) | (iRightEdge << 8) | (iDownEdge);

			int iRet = NetClient_SetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_SET_RECO,&tRoadwayReco,sizeof(TITSRoadwayReco));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_SET_VLOOP:
		{
			TITSRoadwayVLoop tRoadwayVLoop = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayVLoop.iRoadwayID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input loop id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayVLoop.iLoopID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input day night mode(0:night 1:day):\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayVLoop.iDayNight = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input point 1 X:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iPoint1X = to_int_def(cTemp, 0); 

			fprintf(stderr, "Please input point 1 Y:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iPoint1Y = to_int_def(cTemp, 0); 
			tRoadwayVLoop.iPoint1[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iRoadwayID] = (iPoint1X & 0xFFFF) | ((iPoint1Y  & 0xFFFF)<< 16);

			fprintf(stderr, "Please input point 2 X:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iPoint2X = to_int_def(cTemp, 0); 

			fprintf(stderr, "Please input point 2 Y:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iPoint2Y = to_int_def(cTemp, 0); 
			tRoadwayVLoop.iPoint2[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iRoadwayID] = (iPoint2X & 0xFFFF) | ((iPoint2Y  & 0xFFFF)<< 16);

			fprintf(stderr, "Please input point 3 X:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iPoint3X = to_int_def(cTemp, 0); 

			fprintf(stderr, "Please input point 3 Y:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iPoint3Y = to_int_def(cTemp, 0); 
			tRoadwayVLoop.iPoint3[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iRoadwayID] = (iPoint3X & 0xFFFF) | ((iPoint3Y  & 0xFFFF)<< 16);

			fprintf(stderr, "Please input point 4 X:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iPoint4X = to_int_def(cTemp, 0); 

			fprintf(stderr, "Please input point 4 Y:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iPoint4Y = to_int_def(cTemp, 0); 
			tRoadwayVLoop.iPoint4[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iRoadwayID] = (iPoint4X & 0xFFFF) | ((iPoint4Y  & 0xFFFF)<< 16);

			int iRet = NetClient_SetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_SET_VLOOP,&tRoadwayVLoop,sizeof(TITSRoadwayVLoop));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_SET_LIGHT: 
		{
			TITSRoadwayLight_V1 tRoadwayLight;
			memset(&tRoadwayLight,0,sizeof(TITSRoadwayLight_V1));
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayLight.m_stLight.iRoadwayID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input com port[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayLight.m_stLight.iComNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input Light ID:\n");
			gets_s(cTemp, 31);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			strcpy(tRoadwayLight.m_stLight.cLightID,cTemp);
			
			fprintf(stderr, "Please input flood id:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayLight.m_stLight.iFloodID = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input compel red light(0:no 1:yes):\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayLight.m_iCompelRedlight = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_SET_LIGHT,&tRoadwayLight,sizeof(TITSRoadwayLight_V1));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_SET_CAPTURE: 
		{
			TITSRoadwayCapture tRoadwayCapture = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayCapture.iRoadwayID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input capture type:\n");
			gets_s(cTemp, 9);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayCapture.iType = to_int_def(cTemp, 0);

			for (int i = 0; i < 3; ++i)
			{
				fprintf(stderr, "Please input capture place %d:\n",i+1);
				gets_s(cTemp, 63);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				u2g(cTemp,strlen(cTemp)+1,tRoadwayCapture.cPlace[i],sizeof(tRoadwayCapture.cPlace[i]));
			}

// 			fprintf(stderr, "Please input capture place 1:\n");
// 			gets_s(cTemp, 63);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			strcpy(tRoadwayCapture.cPlace[0],cTemp);
// 
// 			fprintf(stderr, "Please input capture place 2:\n");
// 			gets_s(cTemp, 63);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			strcpy(tRoadwayCapture.cPlace[1],cTemp);
// 
// 			fprintf(stderr, "Please input capture place 3:\n");
// 			gets_s(cTemp, 63);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			strcpy(tRoadwayCapture.cPlace[2],cTemp);

			fprintf(stderr, "Please input channel type:\n");
			gets_s(cTemp, 9);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayCapture.iChannelTpye = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input recognize place:\n");
			gets_s(cTemp, 9);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayCapture.iRecognizePlace = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_SET_CAPTURE,&tRoadwayCapture,sizeof(TITSRoadwayCapture));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_SET_REFERENCELINE:	
		{
			TITS_RefLineAarry tLine = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tLine.m_iRoadwayID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input LineNum [0,%d):\n",MAX_ITS_REFLINE_NUM);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tLine.m_iLineNum = to_int_def(cTemp, 0);

			for (int i = 0; i < tLine.m_iLineNum; ++i)
			{
				tLine.m_stLines[i].m_iLineID = i;
				fprintf(stderr, "Please input Line %d Enable:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tLine.m_stLines[i].m_iEnable = to_int_def(cTemp, 0);

				fprintf(stderr, "Please input Line %d LineType:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tLine.m_stLines[i].m_iLineType = to_int_def(cTemp, 0);

// 				fprintf(stderr, "Please input Line %d Start X:\n",i+1);
// 				gets_s(cTemp, 8);
// 				if(0 == strcasecmp("q", cTemp))
// 				{
// 					return -1;
// 				}
// 				tLine.m_stLines[i].m_stLine1.stStart.iX = to_int_def(cTemp, 0);
// 
// 				fprintf(stderr, "Please input Line %d Start Y:\n",i+1);
// 				gets_s(cTemp, 8);
// 				if(0 == strcasecmp("q", cTemp))
// 				{
// 					return -1;
// 				}
// 				tLine.m_stLines[i].m_stLine1.stStart.iY = to_int_def(cTemp, 0);
// 
// 				fprintf(stderr, "Please input Line %d Start X:\n",i+1);
// 				gets_s(cTemp, 8);
// 				if(0 == strcasecmp("q", cTemp))
// 				{
// 					return -1;
// 				}
// 				tLine.m_stLines[i].m_stLine2.stStart.iX = to_int_def(cTemp, 0);
// 
// 				fprintf(stderr, "Please input Line %d Start Y:\n",i+1);
// 				gets_s(cTemp, 8);
// 				if(0 == strcasecmp("q", cTemp))
// 				{
// 					return -1;
// 				}
// 				tLine.m_stLines[i].m_stLine2.stStart.iY = to_int_def(cTemp, 0);

				fprintf(stderr, "Please input Line %d first line (Start X,Start Y,End X,End Y):\n",i+1);
				gets_s(cTemp, 50);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				sscanf(cTemp,"%d,%d,%d,%d"
					,&tLine.m_stLines[i].m_stLine1.stStart.iX
					,&tLine.m_stLines[i].m_stLine1.stStart.iY
					,&tLine.m_stLines[i].m_stLine1.stEnd.iX
					,&tLine.m_stLines[i].m_stLine1.stEnd.iY
					);

				fprintf(stderr, "Please input Line %d second line(Start X,Start Y,End X,End Y):\n",i+1);
				gets_s(cTemp, 50);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				sscanf(cTemp,"%d,%d,%d,%d"
					,&tLine.m_stLines[i].m_stLine2.stStart.iX
					,&tLine.m_stLines[i].m_stLine2.stStart.iY
					,&tLine.m_stLines[i].m_stLine2.stEnd.iX
					,&tLine.m_stLines[i].m_stLine2.stEnd.iY
					);

				fprintf(stderr, "Please input Line %d Distance:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tLine.m_stLines[i].m_iDistance = to_int_def(cTemp, 0);
			}
			int iRet = NetClient_SetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_SET_REFERENCELINE,&tLine,sizeof(TITS_RefLineAarry));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSRoadwayParam successful\n");
			}
		}
		break;
	default:break;
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_GetITSRoadwayParam()
{
	fprintf(stderr, "You choose to test NetClient_GetITSRoadwayParam, number is 385\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input cmd code\n(\n\t0:GetITSRoadwayEnable \n\t1:GetITSRoadwayLoop \n\t2:GetITSRoadwayTime \
					\n\t3:GetITSRoadwaySpeed \n\t4:GetITSRoadwayReco \n\t5:GetITSRoadwayVloop \n\t6:GetITSRoadwayLight \
					\n\t7:GetITSRoadwayCapture \n\t8:GetITSReferencLines\n):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);
	switch(iCmd)
	{
	case ITS_ROADWAY_CMD_GET_ENABLE:
		{
			TITSRoadwayInfo tRoadwayInfo = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayInfo.iRoadwayID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_GET_ENABLE,&tRoadwayInfo,sizeof(TITSRoadwayInfo));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				char cChannelName[48] = {0};
				char cChannelDir[48] = {0};
				g2u(tRoadwayInfo.cChannelName, strlen(tRoadwayInfo.cChannelName)+1, cChannelName, 48);
				g2u(tRoadwayInfo.cChannelDir, strlen(tRoadwayInfo.cChannelDir)+1, cChannelDir, 48);

				fprintf(stderr, "RoadwayID(%d),Enable(%d),ChannelName(%s),ChannelDir(%s)\n"
					,tRoadwayInfo.iRoadwayID,tRoadwayInfo.iEnable,cChannelName
					,cChannelDir);
				fprintf(stderr, "NetClient_GetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_GET_LOOP:
		{
			TITSRoadWayLoop tRoadwayLoop = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayLoop.iRoadwayID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_GET_LOOP,&tRoadwayLoop,sizeof(TITSRoadWayLoop));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "RoadwayID(%d),ComportNo(%d),CaptureLoopNo(%d),SpeedLoopNo(%d)\n"
					,tRoadwayLoop.iRoadwayID,tRoadwayLoop.iComportNo,tRoadwayLoop.iCaptureLoopNo
					,tRoadwayLoop.iSpeedLoopNo);
				fprintf(stderr, "NetClient_GetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_GET_TIME: 
		{
			TITSRoadwayTime tRoadwayTime = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayTime.iRoadwayID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_GET_TIME,&tRoadwayTime,sizeof(TITSRoadwayTime));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "RoadwayID(%d),LoopMinTime(%d),LoopMaxTime(%d),LoopDelayTime(%d)\n"
					,tRoadwayTime.iRoadwayID,tRoadwayTime.iLoopMinTime,tRoadwayTime.iLoopMaxTime
					,tRoadwayTime.iLoopDelayTime);
				fprintf(stderr, "NetClient_GetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_GET_SPEED:
		{
			TITSRoadwaySpeed tRoadwaySpeed = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwaySpeed.iRoadwayID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_GET_SPEED,&tRoadwaySpeed,sizeof(TITSRoadwaySpeed));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "RoadwayID(%d),LoopDistance(%d),SpeedLimit(%d),SpeedModify(%d)\n"
					,tRoadwaySpeed.iRoadwayID,tRoadwaySpeed.iLoopDistance,tRoadwaySpeed.iSpeedLimit
					,tRoadwaySpeed.iSpeedModify);
				fprintf(stderr, "NetClient_GetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_GET_RECO:
		{
			TITSRoadwayReco tRoadwayReco = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayReco.iRoadwayID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_GET_RECO,&tRoadwayReco,sizeof(TITSRoadwayReco));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "RoadwayID(%d),RoadwayRange(%d,%d,%d,%d)\n"
					,tRoadwayReco.iRoadwayID
					,(tRoadwayReco.iRoadwayRange >> 24) & 0xFF
					,(tRoadwayReco.iRoadwayRange >> 16) & 0xFF
					,(tRoadwayReco.iRoadwayRange >> 8) & 0xFF
					,(tRoadwayReco.iRoadwayRange) & 0xFF);
				fprintf(stderr, "NetClient_GetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_GET_VLOOP:
		{
			TITSRoadwayVLoop tRoadwayVLoop = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayVLoop.iRoadwayID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_GET_VLOOP,&tRoadwayVLoop,sizeof(TITSRoadwayVLoop));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "RoadwayID(%d),DayNight(%d),LoopID(%d),Point1(%d,%d),Point2(%d,%d),Point3(%d,%d),Point4(%d,%d)\n"
					,tRoadwayVLoop.iRoadwayID,tRoadwayVLoop.iDayNight,tRoadwayVLoop.iLoopID
					,tRoadwayVLoop.iPoint1[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iLoopID] & 0xFFFF
					,(tRoadwayVLoop.iPoint1[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iLoopID] >> 16) & 0xFFFF
					,tRoadwayVLoop.iPoint2[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iLoopID] & 0xFFFF
					,(tRoadwayVLoop.iPoint2[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iLoopID] >> 16) & 0xFFFF
					,tRoadwayVLoop.iPoint3[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iLoopID] & 0xFFFF
					,(tRoadwayVLoop.iPoint3[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iLoopID] >> 16) & 0xFFFF
					,tRoadwayVLoop.iPoint4[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iLoopID] & 0xFFFF
					,(tRoadwayVLoop.iPoint4[tRoadwayVLoop.iDayNight][tRoadwayVLoop.iLoopID] >> 16) & 0xFFFF
					);
				fprintf(stderr, "NetClient_GetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_GET_LIGHT: 
		{
			TITSRoadwayLight_V1 tRoadwayLight;
			memset(&tRoadwayLight,0,sizeof(TITSRoadwayLight_V1));
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayLight.m_stLight.iRoadwayID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_GET_LIGHT,&tRoadwayLight,sizeof(TITSRoadwayLight_V1));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "RoadwayID(%d),LightID(%s),ComNo(%d),FloodID(%d),CompelRedlight(%d)\n"
					,tRoadwayLight.m_stLight.iRoadwayID,tRoadwayLight.m_stLight.cLightID
					,tRoadwayLight.m_stLight.iComNo,tRoadwayLight.m_stLight.iFloodID
					,tRoadwayLight.m_iCompelRedlight);
				fprintf(stderr, "NetClient_GetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_GET_CAPTURE: 
		{
			TITSRoadwayCapture tRoadwayCapture = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayCapture.iRoadwayID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_GET_CAPTURE,&tRoadwayCapture,sizeof(TITSRoadwayCapture));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				char cPlace[3][96];
				memset(cPlace,0,sizeof(cPlace));
				for (int i = 0; i < 3; ++i)
				{
					g2u(tRoadwayCapture.cPlace[i], strlen(tRoadwayCapture.cPlace[i])+1, cPlace[i], 48);
				}

				fprintf(stderr, "RoadwayID(%d),Cap type(%d),ChannelTpye(%d),RecognizePlace(%d),Place 1(%s),Place 2(%s),Place 3(%s)\n"
					,tRoadwayCapture.iRoadwayID,tRoadwayCapture.iType,tRoadwayCapture.iChannelTpye
					,tRoadwayCapture.iRecognizePlace,cPlace[0],cPlace[1]
					,cPlace[2]);
				fprintf(stderr, "NetClient_GetITSRoadwayParam successful\n");
			}
		}
		break;
	case ITS_ROADWAY_CMD_GET_REFERENCELINE:	
		{
			TITS_RefLineAarry tLine = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tLine.m_iRoadwayID = to_int_def(cTemp, 0);
			
			int iRet = NetClient_GetITSRoadwayParam(g_iLogonID,ITS_ROADWAY_CMD_GET_REFERENCELINE,&tLine,sizeof(TITS_RefLineAarry));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSRoadwayParam failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "RoadwayID(%d),LineNum(%d),",tLine.m_iRoadwayID,tLine.m_iLineNum);
				for (int i = 0; i < tLine.m_iLineNum; ++i)
				{
					fprintf(stderr, "LineID(%d),Enable(%d),LineType(%d),Distance(%d),Line1(%d,%d,%d,%d),Line2(%d,%d,%d,%d)"
						,tLine.m_stLines[i].m_iLineID,tLine.m_stLines[i].m_iEnable,tLine.m_stLines[i].m_iLineType
						,tLine.m_stLines[i].m_iDistance,tLine.m_stLines[i].m_stLine1.stStart.iX,tLine.m_stLines[i].m_stLine1.stStart.iY
						,tLine.m_stLines[i].m_stLine1.stEnd.iX,tLine.m_stLines[i].m_stLine1.stEnd.iY
						,tLine.m_stLines[i].m_stLine2.stStart.iX,tLine.m_stLines[i].m_stLine2.stStart.iY
						,tLine.m_stLines[i].m_stLine2.stEnd.iX,tLine.m_stLines[i].m_stLine2.stEnd.iY);
				}
				fprintf(stderr, "\nNetClient_GetITSRoadwayParam successful\n");
			}
		}
		break;
	default:break;
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");

	return 0;
}

int Test_SetITSLicensePlateOptimize()
{
	fprintf(stderr, "You choose to test NetClient_SetITSLicensePlateOptimize, number is 386\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input cmd code\n(\n\t0:SetFirstCharacter \n\t1:SetNoPlateEnbale \n\t2:SetOther\n):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);
	switch(iCmd)
	{
	case ITS_LICENSEPLATE_OPTIMIZE_CMD_SET_FIRST_HZ:
		{
			TITSLicensePlateOptimizeFirstHZInfo tFirstHZInfo;
			memset(&tFirstHZInfo,0,sizeof(TITSLicensePlateOptimizeFirstHZInfo));
			fprintf(stderr, "Please input first chinese characters  to optimize:\n");
			gets_s(cTemp, 4);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			u2g(cTemp,strlen(cTemp),tFirstHZInfo.cModifyChar,sizeof(tFirstHZInfo.cModifyChar)-1);
			//strcpy(tFirstHZInfo.cModifyChar,cTemp);

			fprintf(stderr, "Please input min confide of first chinese characters:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tFirstHZInfo.iMinCharConfid = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input first letter to optimize:\n");
			gets_s(cTemp, 9);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			u2g(cTemp,strlen(cTemp),tFirstHZInfo.cModifyAlpha,sizeof(tFirstHZInfo.cModifyAlpha)-1);
			//strcpy(tFirstHZInfo.cModifyAlpha,cTemp);

			fprintf(stderr, "Please input min confide of first letter:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tFirstHZInfo.iMinAlphaConfig = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSLicensePlateOptimize(g_iLogonID,ITS_LICENSEPLATE_OPTIMIZE_CMD_SET_FIRST_HZ,&tFirstHZInfo,sizeof(TITSLicensePlateOptimizeFirstHZInfo));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSLicensePlateOptimize failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSLicensePlateOptimize successful\n");
			}
		}
		break;
	case ITS_LICENSEPLATE_OPTIMIZE_CMD_SET_NOPLATE_ENABLE:
		{
			fprintf(stderr, "allow no plate(0:no 1:yes):\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iEnable = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSLicensePlateOptimize(g_iLogonID,ITS_LICENSEPLATE_OPTIMIZE_CMD_SET_NOPLATE_ENABLE,&iEnable,sizeof(int));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSLicensePlateOptimize failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSLicensePlateOptimize successful\n");
			}
		}
		break;
	case ITS_LICENSEPLATE_OPTIMIZE_CMD_SET_OTHER:
		{
			TITSLicesePlateOptimizeOther tOtherOpt = {0};
			fprintf(stderr, "Please input chinese characters type(0:wait for retrieval 1:distrustful):\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tOtherOpt.iType = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input chinese characters count[0,4]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tOtherOpt.iCount = to_int_def(cTemp, 0);
			if (tOtherOpt.iCount < 0)
			{
				tOtherOpt.iCount = 0;
			}
			if (tOtherOpt.iCount > 4)
			{
				tOtherOpt.iCount = 4;
			}

			for (int i = 0; i < tOtherOpt.iCount; ++i)
			{
				fprintf(stderr, "Please input chinese characters %d:\n",i+1);
				gets_s(cTemp, 4);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				u2g(cTemp,strlen(cTemp),tOtherOpt.cModifyChar[i],sizeof(tOtherOpt.cModifyChar[i])-1);
				//strcpy(tOtherOpt.cModifyChar[i],cTemp);
			}

			int iRet = NetClient_SetITSLicensePlateOptimize(g_iLogonID,ITS_LICENSEPLATE_OPTIMIZE_CMD_SET_OTHER,&tOtherOpt,sizeof(TITSLicesePlateOptimizeOther));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSLicensePlateOptimize failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSLicensePlateOptimize successful\n");
			}
		}
		break;
	default:break;
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetITSLicensePlateOptimize()
{
	fprintf(stderr, "You choose to test NetClient_GetITSLicensePlateOptimize, number is 387\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input cmd code\n(\n\t0:GetFirstCharacter \n\t1:GetNoPlateEnbale \n\t2:GetOther\n):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);
	switch(iCmd)
	{
	case ITS_LICENSEPLATE_OPTIMIZE_CMD_GET_FIRST_CHARACTER:
		{
			TITSLicensePlateOptimizeFirstHZInfo tFirstHZInfo;
			memset(&tFirstHZInfo,0,sizeof(TITSLicensePlateOptimizeFirstHZInfo));
			int iRet = NetClient_GetITSLicensePlateOptimize(g_iLogonID,ITS_LICENSEPLATE_OPTIMIZE_CMD_GET_FIRST_CHARACTER,&tFirstHZInfo,sizeof(TITSLicensePlateOptimizeFirstHZInfo));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSLicensePlateOptimize failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				char cModifyChar[6] = {0};
				char cModifyAlpha[20] = {0};
				g2u(tFirstHZInfo.cModifyChar,strlen(tFirstHZInfo.cModifyChar),cModifyChar,sizeof(cModifyChar)-1);
				g2u(tFirstHZInfo.cModifyAlpha,strlen(tFirstHZInfo.cModifyAlpha),cModifyAlpha,sizeof(cModifyAlpha)-1);
				fprintf(stderr, "ModifyChar(%s),MinCharConfid(%d),ModifyAlpha(%s),MinAlphaConfig(%d) \n"
					,cModifyChar,tFirstHZInfo.iMinCharConfid
					,cModifyAlpha,tFirstHZInfo.iMinAlphaConfig);
				fprintf(stderr, "NetClient_GetITSLicensePlateOptimize successful\n");
			}
		}
		break;
	case ITS_LICENSEPLATE_OPTIMIZE_CMD_GET_NOPLATE_ENABLE:
		{
			int iEnable = 0;
			int iRet = NetClient_GetITSLicensePlateOptimize(g_iLogonID,ITS_LICENSEPLATE_OPTIMIZE_CMD_GET_NOPLATE_ENABLE,&iEnable,sizeof(int));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSLicensePlateOptimize failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "no plate enable is %d\n",iEnable);
				fprintf(stderr, "NetClient_GetITSLicensePlateOptimize successful\n");
			}
		}
		break;
	case ITS_LICENSEPLATE_OPTIMIZE_CMD_GET_OTHER:
		{
			TITSLicesePlateOptimizeOther tOtherOpt = {0};
			int iRet = NetClient_GetITSLicensePlateOptimize(g_iLogonID,ITS_LICENSEPLATE_OPTIMIZE_CMD_SET_OTHER,&tOtherOpt,sizeof(TITSLicesePlateOptimizeOther));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSLicensePlateOptimize failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				char cModifyChar[4][6];
				memset(cModifyChar,0,sizeof(cModifyChar));
				for (int i = 0; i < 4; ++i)
				{
					g2u(tOtherOpt.cModifyChar[i],strlen(tOtherOpt.cModifyChar[i]),cModifyChar[i],sizeof(cModifyChar[i])-1);
				}
				
				fprintf(stderr, "Type(%d),Count(%d),ModifyChar1(%s),ModifyChar2(%s),ModifyChar3(%s),ModifyChar4(%s)\n"
					,tOtherOpt.iType,tOtherOpt.iCount,cModifyChar[0],cModifyChar[1]
					,cModifyChar[2],cModifyChar[3]);
				fprintf(stderr, "NetClient_GetITSLicensePlateOptimize successful\n");
			}
		}
		break;
	default:break;
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetITSExtraInfo()
{
	fprintf(stderr, "You choose to test NetClient_SetITSExtraInfo, number is 388\n");

	int iChannelNo = -1;
	char cTemp[256] = {0};
	fprintf(stderr, "Please input cmd code\n(\n\t0:SetIllegalPark \n\t1:SetIllegalParkParm \n\t2:SetLicenseOptimizeOther \
		\n\t3:SetLicensePlateOptimizeFirstCharacter \n\t4:SetRecoParam \n\t5:SetRoadwayEnable \
		\n\t6:SetCamLocation \n\t7:SetExatConfirm \n\t8:SetVideoDetectParam \
		\n\t10:SetDetectArea \n\t11:SetRecoType \n\t12:SetRedLightDetectArea \
		\n\t13:SetEnable \n\t14:SetITSDayNight \n\t15:SetITSWorkMode \
		\n\t16:SetLightInfo \n):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);
	switch(iCmd)
	{
	case ITS_ILLEGALPARK_CMD_SET:
		{
			ITS_IllegalPark tIllegalPark = {0};
			fprintf(stderr, "Please input PresetNo[0,7]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tIllegalPark.iPresetNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input AreaNo[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tIllegalPark.iAreaNo = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input IllegalParkTime:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tIllegalPark.iIllegalParkTime = to_int_def(cTemp, 0);

			for (int i = 0; i < 4; ++i)
			{
				fprintf(stderr, "Please input TimeRange %d:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tIllegalPark.iTimeRange[i] = to_int_def(cTemp, 0);
			}

			for (int i = 0; i < 4; ++i)
			{
				fprintf(stderr, "Please input Area point %d X:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tIllegalPark.arrPTArea[i].x = to_int_def(cTemp, 0);

				fprintf(stderr, "Please input Area point %d Y:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tIllegalPark.arrPTArea[i].y = to_int_def(cTemp, 0);
			}
			
			fprintf(stderr, "Please input CheckParkTime:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tIllegalPark.iCheckParkTime = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input Sensitivity:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tIllegalPark.iSensitivity = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_ILLEGALPARK_CMD_SET,iChannelNo,&tIllegalPark,sizeof(ITS_IllegalPark));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_ILLEGALPARKPARM_CMD_SET:
		{
			ITS_IllegalParkParm tParam = {0};
			fprintf(stderr, "Please input PresetNo[0,7]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tParam.iPresetNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input AreaNo[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tParam.iAreaNo = to_int_def(cTemp, 0);

			for (int i = 0; i < 4; ++i)
			{
				fprintf(stderr, "Please input Param point %d X:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tParam.arrPTParam[i][0].x = to_int_def(cTemp, 0);

				fprintf(stderr, "Please input Param point %d Y:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tParam.arrPTParam[i][0].y = to_int_def(cTemp, 0);

				fprintf(stderr, "Please input Param point %d X:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tParam.arrPTParam[i][1].x = to_int_def(cTemp, 0);

				fprintf(stderr, "Please input Param point %d Y:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tParam.arrPTParam[i][1].y = to_int_def(cTemp, 0);
			}

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_ILLEGALPARKPARM_CMD_SET,iChannelNo,&tParam,sizeof(ITS_IllegalParkParm));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_LICENSEOPTIMIZEOTHER_CMD_SET:
		{
			ITS_LicenseOptimizeOther tOtherOpt = {0};
			fprintf(stderr, "Please input chinese characters type(0:wait for retrieval 1:distrustful):\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tOtherOpt.iType = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input chinese characters count[0,8]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tOtherOpt.iCount = to_int_def(cTemp, 0);

			if (tOtherOpt.iCount < 0)
			{
				tOtherOpt.iCount = 0;
			}
			if (tOtherOpt.iCount > 8)
			{
				tOtherOpt.iCount = 8;
			}

			//char cModifyChar[10] = {0};
			for (int i = 0; i < tOtherOpt.iCount; ++i)
			{
				fprintf(stderr, "Please input chinese characters %d:\n",i+1);
				gets_s(cTemp, 4);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				u2g(cTemp,strlen(cTemp),tOtherOpt.cModifyChar[i],sizeof(tOtherOpt.cModifyChar[i]));
				//strcpy(tOtherOpt.cModifyChar[i],cTemp);
			}

			for (int i = 0; i < tOtherOpt.iCount; ++i)
			{
				fprintf(stderr, "Please input OtherCharWeight %d:\n",i+1);
				gets_s(cTemp, 3);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tOtherOpt.iOtherCharWeight[i] = to_int_def(cTemp, 0);
			}

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_LICENSEOPTIMIZEOTHER_CMD_SET,iChannelNo,&tOtherOpt,sizeof(ITS_LicenseOptimizeOther));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_OPTIM_CMD_SET:
		{
			TITSLicensePlateOptimizeFirstHZInfo tFirstHZInfo;
			memset(&tFirstHZInfo,0,sizeof(TITSLicensePlateOptimizeFirstHZInfo));
			fprintf(stderr, "Please input first chinese characters  to optimize:\n");
			gets_s(cTemp, 4);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			u2g(cTemp,strlen(cTemp),tFirstHZInfo.cModifyChar,sizeof(tFirstHZInfo.cModifyChar));
			//strcpy(tFirstHZInfo.cModifyChar,cTemp);

			fprintf(stderr, "Please input min confide of first chinese characters:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tFirstHZInfo.iMinCharConfid = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input first letter to optimize:\n");
			gets_s(cTemp, 9);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			u2g(cTemp,strlen(cTemp),tFirstHZInfo.cModifyAlpha,sizeof(tFirstHZInfo.cModifyAlpha));
			//strcpy(tFirstHZInfo.cModifyAlpha,cTemp);

			fprintf(stderr, "Please input min confide of first letter:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tFirstHZInfo.iMinAlphaConfig = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_OPTIM_CMD_SET,iChannelNo,&tFirstHZInfo,sizeof(TITSLicensePlateOptimizeFirstHZInfo));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_RECOPARAM_CMD_SET:
		{
			ITS_RecoParamEx tRecoParamEx;
			memset(&tRecoParamEx,0,sizeof(ITS_RecoParamEx));
			fprintf(stderr, "Please input RoadwayID[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iRoadwayID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input MaxPlateNO:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iMaxPlateNO = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input MaxPlateWidth:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iMaxPlateWidth = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input MinPlateWidth:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iMinPlateWidth = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input Enable:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iEnable = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input EngineNum:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iEngineNum = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input AreaType:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iAreaType = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input PlateType:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iPlateType = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input Speed[1,10]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iSpeed = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input MaxSkip:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iMaxSkip = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input MinValid:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iMinValid = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input FramePercent:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iFramePercent = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input MinCapDiff:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iMinCapDiff = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input CaliInfo:\n");
			gets_s(cTemp, 75);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			//strcpy(tRecoParamEx.cCaliInfo,cTemp);
			u2g(cTemp,strlen(cTemp)+1,tRecoParamEx.cCaliInfo,sizeof(tRecoParamEx.cCaliInfo));
			
			fprintf(stderr, "Please input PlateCharType:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iPlateCharType = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input Confid:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iConfid = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_RECOPARAM_CMD_SET,iChannelNo,&tRecoParamEx,sizeof(ITS_RecoParamEx));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_ROADWAYENABLE_CMD_SET:
		{
			TITSRoadwayInfo tRoadwayInfo = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayInfo.iRoadwayID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input roadway enable(0:disable 1:enable):\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayInfo.iEnable = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input channel name:\n");
			gets_s(cTemp, 31);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			u2g(cTemp,strlen(cTemp),tRoadwayInfo.cChannelName,sizeof(tRoadwayInfo.cChannelName));
			//strcpy(tRoadwayInfo.cChannelName,cTemp);

			fprintf(stderr, "Please input channel dir:\n");
			gets_s(cTemp, 31);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			u2g(cTemp,strlen(cTemp),tRoadwayInfo.cChannelDir,sizeof(tRoadwayInfo.cChannelDir));
			//strcpy(tRoadwayInfo.cChannelDir,cTemp);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_ROADWAYENABLE_CMD_SET,iChannelNo,&tRoadwayInfo,sizeof(TITSRoadwayInfo));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_CAMLOCATION_CMD_SET:
		{
			ITS_CamLocation tLocation;
			memset(&tLocation,0,sizeof(ITS_CamLocation));
			fprintf(stderr, "Please input DeviceVode:\n");
			gets_s(cTemp, 63);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			u2g(cTemp,strlen(cTemp),tLocation.cDeviceVode,sizeof(tLocation.cDeviceVode));
			//strcpy(tLocation.cDeviceVode,cTemp);

			fprintf(stderr, "Please input RoadName:\n");
			gets_s(cTemp, 63);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			u2g(cTemp,strlen(cTemp),tLocation.cRoadName,sizeof(tLocation.cRoadName));
			//strcpy(tLocation.cRoadName,cTemp);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_CAMLOCATION_CMD_SET,iChannelNo,&tLocation,sizeof(ITS_CamLocation));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_EXACTCONFIRM_CMD_SET:
		{
			ITS_ExactConfirm tConfirm = {0};
			fprintf(stderr, "Please input PresetNo[0,7]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tConfirm.iPresetNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input AreaNo[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tConfirm.iAreaNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input LocalPos1[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tConfirm.iLocalPos1 = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_EXACTCONFIRM_CMD_SET,iChannelNo,&tConfirm,sizeof(ITS_ExactConfirm));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_VIDEODECTECT_CMD_SET:
		{
			TITS_VDetect tVDetect = {0};
			fprintf(stderr, "Please input channel no[0,%d]:\n",g_iTotalChnlNum-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iChannelNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input EngineType(1:T130T 2:T130G 3:T110G):\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_iEngineType = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input Enable:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_iEnable = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input VedioType:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_iVedioType = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input VedioWidth:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_iVedioWidth = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input VedioHeight:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_iVedioHeight = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input VehicleMinSize:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_iVehicleMinSize = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input VehicleMaxSize:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_iVehicleMaxSize = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input ModelType:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_iModelType = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input FrameRateCount:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_iFrameRateCount = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input ZoomRate:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_stParmas130T.m_iZoomRate = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input VehicleWidth:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_stParmas130T.m_iVehicleWidth = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input ConfidenceValve:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_stParmas130T.m_iConfidenceValve = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input Proportion:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tVDetect.m_stParmas130T.m_iProportion = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_VIDEODECTECT_CMD_SET,iChannelNo,&tVDetect,sizeof(TITS_VDetect));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_DETECTAREA_CMD_SET:
		{
			TITS_DetectArea tDetectArea = {0};
			fprintf(stderr, "Please input channel no[0,%d]:\n",g_iTotalChnlNum-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iChannelNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input RegionID[0,%d):\n",MAX_ITS_DETECTAREA_NUM);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.m_iRegionID = to_int_def(cTemp, 0);
			if (tDetectArea.m_iRegionID < 0)
			{
				tDetectArea.m_iRegionID = 0;
			}
			if (tDetectArea.m_iRegionID >= MAX_ITS_DETECTAREA_NUM)
			{
				tDetectArea.m_iRegionID = MAX_ITS_DETECTAREA_NUM-1;
			}
			
			fprintf(stderr, "Please input Enabled:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.m_iEnabled = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input PointCount[0,%d):\n",MAX_ITS_AREA_POINTNUM);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.m_iPointCount = to_int_def(cTemp, 0);
			if (tDetectArea.m_iPointCount < 0)
			{
				tDetectArea.m_iPointCount = 0;
			}
			if (tDetectArea.m_iPointCount >= MAX_ITS_AREA_POINTNUM)
			{
				tDetectArea.m_iPointCount = MAX_ITS_AREA_POINTNUM-1;
			}

			for (int i = 0; i < tDetectArea.m_iPointCount; ++i)
			{
				fprintf(stderr, "Please input Point %d X:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tDetectArea.m_arrPoint[i].iX = to_int_def(cTemp, 0);

				fprintf(stderr, "Please input Point %d Y:\n",i+1);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				tDetectArea.m_arrPoint[i].iY = to_int_def(cTemp, 0);
			}

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_DETECTAREA_CMD_SET,iChannelNo,&tDetectArea,sizeof(TITS_DetectArea));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_RECOTYPE_CMD_SET:
		{
			fprintf(stderr, "Please input channel no[0,%d]:\n",g_iTotalChnlNum-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iChannelNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input type:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iType = to_int_def(cTemp, 0);
			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_RECOTYPE_CMD_SET,iChannelNo,&iType,sizeof(int));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_ENABLE_CMD_SET:
		{
			ITS_EnalbeParam tEnableParam = {0};
			fprintf(stderr, "Please input type:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tEnableParam.iType = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input enable:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tEnableParam.iEnable = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_ENABLE_CMD_SET,iChannelNo,&tEnableParam,sizeof(ITS_EnalbeParam));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_REDLIGHTDETECTAREA_CMD_SET:
		{
			ITS_RedLightDetectArea tDetectArea = {0};
			fprintf(stderr, "Please input channel no[0,%d]:\n",g_iTotalChnlNum-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iChannelNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input RegionID[0,%d):\n",MAX_ITS_REDLIGHT_DETECTAREA_NUM);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.iRegionID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input Enabled:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.iEnabled = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input StandardArea left:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.rcStandardArea.left = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input StandardArea top:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.rcStandardArea.top = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input StandardArea right:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.rcStandardArea.right = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input StandardArea bottom:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.rcStandardArea.bottom = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input ReviseArea left:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.rcReviseArea.left = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input ReviseArea top:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.rcReviseArea.top = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input ReviseArea right:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.rcReviseArea.right = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input ReviseArea bottom:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.rcReviseArea.bottom = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_REDLIGHTDETECTAREA_CMD_SET,iChannelNo,&tDetectArea,sizeof(ITS_RedLightDetectArea));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_DAYNIGHT_CMD_SET:
		{
			fprintf(stderr, "Please input DayNight:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iDayNight = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_DAYNIGHT_CMD_SET,iChannelNo,&iDayNight,sizeof(int));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_WORKMODE_CMD_SET:
		{
			ITS_CamWorkMode tWorkMode = {0};
			fprintf(stderr, "Please input WorkMode:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tWorkMode.iWorkMode = to_int_def(cTemp, 0);
			
			fprintf(stderr, "Please input Interval:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tWorkMode.iInterval = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_WORKMODE_CMD_SET,iChannelNo,&tWorkMode,sizeof(ITS_CamWorkMode));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_LIGHTINFO_CMD_SET:
		{
			TITSLightInfo tLightInfo = {0};
			fprintf(stderr, "Please input LightID[0,%d]:\n",LIGHT_COUNT-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tLightInfo.iLightID = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input TimeInterval:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tLightInfo.iTimeInterval = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input TimeAcceptDiff:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tLightInfo.iTimeAcceptDiff = to_int_def(cTemp, 0);

			int iRet = NetClient_SetITSExtraInfo(g_iLogonID,ITS_LIGHTINFO_CMD_SET,iChannelNo,&tLightInfo,sizeof(TITSLightInfo));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_SetITSExtraInfo successful\n");
			}
		}
		break;
	default:break;
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetITSExtraInfo()
{
	fprintf(stderr, "You choose to test NetClient_GetITSExtraInfo, number is 389\n");

	int iChannelNo = -1;
	char cTemp[256] = {0};
	fprintf(stderr, "Please input cmd code\n(\n\t0:GetIllegalPark \n\t1:GetIllegalParkParm \n\t2:GetLicenseOptimizeOther \
					\n\t3:GetLicensePlateOptimizeFirstCharacter \n\t4:GetRecoParam \n\t5:GetRoadwayEnable \
					\n\t6:GetCamLocation \n\t7:GetVideoDetectParam \n\t9:GetDetectArea\
					\n\t10:GetRecoType \n\t11:GetCamraType \n\t12:GetRedLightDetectArea\
					\n\t13:GetEnable \n\t14:GetVersionPro  \n\t15:GetDayNight\
					\n\t16:GetWorkMode \n\t17:GetLightInfo \n):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);
	switch(iCmd)
	{
	case ITS_ILLEGALPARK_CMD_GET:
		{
			ITS_IllegalPark tIllegalPark = {0};
			fprintf(stderr, "Please input PresetNo[0,7]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tIllegalPark.iPresetNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input AreaNo[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tIllegalPark.iAreaNo = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_ILLEGALPARK_CMD_GET,iChannelNo,&tIllegalPark,sizeof(ITS_IllegalPark));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "PresetNo(%d),AreaNo(%d),IllegalParkTime(%d),TimeRange1(%d),TimeRange2(%d)\
					,TimeRange3(%d),TimeRange4(%d),PTArea1(%d,%d),PTArea2(%d,%d),PTArea3(%d,%d),PTArea4(%d,%d)\
					CheckParkTime(%d),Sensitivity(%d)\n",tIllegalPark.iPresetNo,tIllegalPark.iAreaNo,tIllegalPark.iIllegalParkTime
					,tIllegalPark.iTimeRange[0],tIllegalPark.iTimeRange[1],tIllegalPark.iTimeRange[2],tIllegalPark.iTimeRange[3]
				,tIllegalPark.arrPTArea[0].x,tIllegalPark.arrPTArea[0].y,tIllegalPark.arrPTArea[1].x,tIllegalPark.arrPTArea[1].y
					,tIllegalPark.arrPTArea[2].x,tIllegalPark.arrPTArea[2].y,tIllegalPark.arrPTArea[3].x,tIllegalPark.arrPTArea[3].y
					,tIllegalPark.iCheckParkTime,tIllegalPark.iSensitivity);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_ILLEGALPARKPARM_CMD_GET:
		{
			ITS_IllegalParkParm tParam = {0};
			fprintf(stderr, "Please input PresetNo[0,7]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tParam.iPresetNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input AreaNo[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tParam.iAreaNo = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_ILLEGALPARKPARM_CMD_GET,iChannelNo,&tParam,sizeof(ITS_IllegalParkParm));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "PresetNo(%d),AreaNo(%d),A1(%d,%d):A2(%d,%d),B1(%d,%d):B2(%d,%d),C1(%d,%d):C2(%d,%d),D1(%d,%d):D2(%d,%d)\n"
					,tParam.iPresetNo,tParam.iAreaNo
					,tParam.arrPTParam[0][0].x,tParam.arrPTParam[0][0].y,tParam.arrPTParam[0][1].x,tParam.arrPTParam[0][1].y
					,tParam.arrPTParam[1][0].x,tParam.arrPTParam[1][0].y,tParam.arrPTParam[1][1].x,tParam.arrPTParam[1][1].y
					,tParam.arrPTParam[2][0].x,tParam.arrPTParam[2][0].y,tParam.arrPTParam[2][1].x,tParam.arrPTParam[2][1].y
					,tParam.arrPTParam[3][0].x,tParam.arrPTParam[3][0].y,tParam.arrPTParam[3][1].x,tParam.arrPTParam[3][1].y);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_LICENSEOPTIMIZEOTHER_CMD_GET:
		{
			ITS_LicenseOptimizeOther tOtherOpt = {0};
			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_LICENSEOPTIMIZEOTHER_CMD_GET,iChannelNo,&tOtherOpt,sizeof(ITS_LicenseOptimizeOther));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "Type(%d),Count(%d)\n",tOtherOpt.iType,tOtherOpt.iCount);
				char cModifyChar[10] = {0};
				for (int i = 0; i < tOtherOpt.iCount; ++i)
				{
					g2u(tOtherOpt.cModifyChar[i],strlen(tOtherOpt.cModifyChar[i]),cModifyChar,sizeof(cModifyChar));
					fprintf(stderr, ",ModifyChar(%s)",cModifyChar);
				}
				for (int i = 0; i < tOtherOpt.iCount; ++i)
				{
					fprintf(stderr, ",OtherCharWeight(%d)",tOtherOpt.iOtherCharWeight[i]);
				}
				fprintf(stderr, "\nNetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_OPTIM_CMD_GET:
		{
			TITSLicensePlateOptimizeFirstHZInfo tFirstHZInfo;
			memset(&tFirstHZInfo,0,sizeof(TITSLicensePlateOptimizeFirstHZInfo));
			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_OPTIM_CMD_GET,iChannelNo,&tFirstHZInfo,sizeof(TITSLicensePlateOptimizeFirstHZInfo));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				char cModifyChar[6] = {0};
				g2u(tFirstHZInfo.cModifyChar,strlen(tFirstHZInfo.cModifyChar),cModifyChar,sizeof(cModifyChar));
				char cModifyAlpha[6] = {0};
				g2u(tFirstHZInfo.cModifyAlpha,strlen(tFirstHZInfo.cModifyAlpha),cModifyAlpha,sizeof(cModifyAlpha));
				fprintf(stderr, "ModifyChar(%s),MinCharConfid(%d),ModifyAlpha(%s),MinAlphaConfig(%d)\n"
					,cModifyChar,tFirstHZInfo.iMinCharConfid,cModifyAlpha
					,tFirstHZInfo.iMinAlphaConfig);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_RECOPARAM_CMD_GET:
		{
			ITS_RecoParamEx tRecoParamEx;
			memset(&tRecoParamEx,0,sizeof(ITS_RecoParamEx));
			fprintf(stderr, "Please input RoadwayID[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRecoParamEx.iRoadwayID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_RECOPARAM_CMD_GET,iChannelNo,&tRecoParamEx,sizeof(ITS_RecoParamEx));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				char cCaliInfo[114] = {0};
				g2u(tRecoParamEx.cCaliInfo,strlen(tRecoParamEx.cCaliInfo),cCaliInfo,sizeof(cCaliInfo));

				fprintf(stderr, "RoadwayID(%d),MaxPlateNO(%d),MaxPlateWidth(%d),MinPlateWidth(%d),Enable(%d),AreaType(%d)\
								,PlateType(%d),Speed(%d),MaxSkip(%d),MinValid(%d),FramePercent(%d),MinCapDiff(%d),CaliInfo(%s)\
								,PlateCharType(%d),Confid(%d)\n"
					,tRecoParamEx.iRoadwayID,tRecoParamEx.iMaxPlateNO,tRecoParamEx.iMaxPlateWidth
					,tRecoParamEx.iMinPlateWidth,tRecoParamEx.iEnable,tRecoParamEx.iAreaType
					,tRecoParamEx.iPlateType,tRecoParamEx.iSpeed,tRecoParamEx.iMaxSkip,tRecoParamEx.iMinValid
					,tRecoParamEx.iFramePercent,tRecoParamEx.iMinCapDiff,cCaliInfo
					,tRecoParamEx.iPlateCharType,tRecoParamEx.iConfid);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_ROADWAYENABLE_CMD_GET:
		{
			TITSRoadwayInfo tRoadwayInfo = {0};
			fprintf(stderr, "Please input roadway id[0,3]:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tRoadwayInfo.iRoadwayID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_ROADWAYENABLE_CMD_GET,iChannelNo,&tRoadwayInfo,sizeof(TITSRoadwayInfo));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				char cChannelName[64] = {0};
				char cChannelDir[64] = {0};
				g2u(tRoadwayInfo.cChannelName,strlen(tRoadwayInfo.cChannelName),cChannelName,sizeof(cChannelName));
				g2u(tRoadwayInfo.cChannelDir,strlen(tRoadwayInfo.cChannelDir),cChannelDir,sizeof(cChannelDir));
				fprintf(stderr, "RoadwayID(%d),Enable(%d),ChannelName(%s),ChannelDir(%s)\n"
								,tRoadwayInfo.iRoadwayID,tRoadwayInfo.iEnable,cChannelName,cChannelDir);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_CAMLOCATION_CMD_GET:
		{
			ITS_CamLocation tLocation;
			memset(&tLocation,0,sizeof(ITS_CamLocation));
			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_CAMLOCATION_CMD_GET,iChannelNo,&tLocation,sizeof(ITS_CamLocation));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				char cRoadName[128] = {0};
				char cDeviceVode[128] = {0};
				g2u(tLocation.cRoadName,strlen(tLocation.cRoadName),cRoadName,sizeof(cRoadName));
				g2u(tLocation.cDeviceVode,strlen(tLocation.cDeviceVode),cDeviceVode,sizeof(cDeviceVode));
				fprintf(stderr, "RoadName(%s),DeviceVode(%s)\n",cRoadName,cDeviceVode);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_VIDEODECTECT_CMD_GET:
		{
			TITS_VDetect tVDetect = {0};
			fprintf(stderr, "Please input channel no[0,%d]:\n",g_iTotalChnlNum-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			iChannelNo = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_VIDEODECTECT_CMD_GET,iChannelNo,&tVDetect,sizeof(TITS_VDetect));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "EngineType(%d),Enable(%d),VedioType(%d),VedioWidth(%d),VedioHeight(%d),VehicleMinSize(%d)\
								,VehicleMaxSize(%d),ModelType(%d),FrameRateCount(%d),ConfidenceValve(%d),Proportion(%d)\
								,VehicleWidth(%d),ZoomRate(%d)\n"
					,tVDetect.m_iEngineType,tVDetect.m_iEnable,tVDetect.m_iVedioType,tVDetect.m_iVedioWidth
					,tVDetect.m_iVedioHeight,tVDetect.m_iVehicleMinSize,tVDetect.m_iVehicleMaxSize
					,tVDetect.m_iModelType,tVDetect.m_iFrameRateCount,tVDetect.m_stParmas130T.m_iConfidenceValve
					,tVDetect.m_stParmas130T.m_iProportion,tVDetect.m_stParmas130T.m_iVehicleWidth
					,tVDetect.m_stParmas130T.m_iZoomRate);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_DETECTAREA_CMD_GET:
		{
			TITS_DetectArea tDetectArea = {0};
			fprintf(stderr, "Please input channel no[0,%d]:\n",g_iTotalChnlNum-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			iChannelNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input RegionID[0,%d):\n",MAX_ITS_DETECTAREA_NUM);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.m_iRegionID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_DETECTAREA_CMD_GET,iChannelNo,&tDetectArea,sizeof(TITS_DetectArea));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "RegionID(%d),Enabled(%d),PointCount(%d)",tDetectArea.m_iRegionID,tDetectArea.m_iEnabled,tDetectArea.m_iPointCount);
				for (int i = 0; i < tDetectArea.m_iPointCount; ++i)
				{
					fprintf(stderr, "Point %d(%d,%d)",i,tDetectArea.m_arrPoint[i].iX,tDetectArea.m_arrPoint[i].iY);
				}
				fprintf(stderr, "\nNetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_RECOTYPE_CMD_GET:
		{
			fprintf(stderr, "Please input channel no[0,%d]:\n",g_iTotalChnlNum-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			iChannelNo = to_int_def(cTemp, 0);
			int iType = 0;

			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_RECOTYPE_CMD_GET,iChannelNo,&iType,sizeof(int));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "Type(%d)\n",iType);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_CAMRATYPE_CMD_GET:
		{
			int iType = 0;
			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_CAMRATYPE_CMD_GET,iChannelNo,&iType,sizeof(int));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "CamraType(%d)\n",iType);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_ENABLE_CMD_GET:
		{
			ITS_EnalbeParam tEnableParam = {0};
			fprintf(stderr, "Please input type:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tEnableParam.iType = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_ENABLE_CMD_GET,iChannelNo,&tEnableParam,sizeof(ITS_EnalbeParam));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "Type(%d),Enable(%d)\n",tEnableParam.iType,tEnableParam.iEnable);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_VERSIONPRO_CMD_GET:
		{
			char m_strITSVersionPro[1024] = {0};	
			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_VERSIONPRO_CMD_GET,iChannelNo,m_strITSVersionPro,sizeof(m_strITSVersionPro));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				char cITSVersionPro[1536] = {0};
				g2u(m_strITSVersionPro,strlen(m_strITSVersionPro),cITSVersionPro,sizeof(cITSVersionPro));

				fprintf(stderr, "VersionPro(%s)\n",cITSVersionPro);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}

		}
		break;
	case ITS_REDLIGHTDETECTAREA_CMD_GET:
		{
			ITS_RedLightDetectArea tDetectArea = {0};
			fprintf(stderr, "Please input channel no[0,%d]:\n",g_iTotalChnlNum-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			iChannelNo = to_int_def(cTemp, 0);

			fprintf(stderr, "Please input RegionID[0,%d):\n",MAX_ITS_REDLIGHT_DETECTAREA_NUM);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tDetectArea.iRegionID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_REDLIGHTDETECTAREA_CMD_GET,iChannelNo,&tDetectArea,sizeof(ITS_RedLightDetectArea));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "RegionID(%d),Enable(%d),StandardArea(%d,%d,%d,%d),ReviseArea(%d,%d,%d,%d)\n"
					,tDetectArea.iRegionID,tDetectArea.iEnabled,tDetectArea.rcStandardArea.left,tDetectArea.rcStandardArea.top
					,tDetectArea.rcStandardArea.right,tDetectArea.rcStandardArea.bottom,tDetectArea.rcReviseArea.left
					,tDetectArea.rcReviseArea.top,tDetectArea.rcReviseArea.right,tDetectArea.rcReviseArea.bottom);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_DAYNIGHT_CMD_GET:
		{
			int iDayNight = 0;

			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_DAYNIGHT_CMD_GET,iChannelNo,&iDayNight,sizeof(int));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "DayNight(%d)\n",iDayNight);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_WORKMODE_CMD_GET:
		{
			ITS_CamWorkMode tWorkMode = {0};
			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_WORKMODE_CMD_GET,iChannelNo,&tWorkMode,sizeof(ITS_CamWorkMode));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "WorkMode(%d),Interval(%d)\n",tWorkMode.iWorkMode,tWorkMode.iInterval);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	case ITS_LIGHTINFO_CMD_GET:
		{
			TITSLightInfo tLightInfo = {0};
			fprintf(stderr, "Please input LightID[0,%d]:\n",LIGHT_COUNT-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			tLightInfo.iLightID = to_int_def(cTemp, 0);

			int iRet = NetClient_GetITSExtraInfo(g_iLogonID,ITS_LIGHTINFO_CMD_GET,iChannelNo,&tLightInfo,sizeof(TITSLightInfo));
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetITSExtraInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "LightID(%d),TimeAcceptDiff(%d),TimeInterval(%d)\n"
					,tLightInfo.iLightID,tLightInfo.iTimeAcceptDiff,tLightInfo.iTimeInterval);
				fprintf(stderr, "NetClient_GetITSExtraInfo successful\n");
			}
		}
		break;
	default:break;
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}
int Test_SetATMConfig()
{
	fprintf(stderr, "You choose to test NetClient_SetATMConfig, number is 443\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input cmd:\n");
	fprintf(stderr, "0-ATM info:\n");
	fprintf(stderr, "1-ATM OSD:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);

	int iRet;
	if (iCmd == ATM_CONFIG_CMD_ATM_INFO)
	{
		ATM_INFO atmInfo = {0};
		atmInfo.iSize = sizeof(ATM_INFO);
		fprintf(stderr, "input inform way(0:COM,1:UDP):\n");
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		atmInfo.iInformWay = to_int_def(cTemp, 0);

		fprintf(stderr, "input protocol name(32 char):\n");
		gets_s(cTemp, 31);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		strcpy(atmInfo.cProtocolName, cTemp);

		fprintf(stderr, "input atm IP(16 char):\n");
		gets_s(cTemp, 16);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		strcpy(atmInfo.cSrcIP, cTemp);

		fprintf(stderr, "input atm port:\n");
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		atmInfo.iSrcPort = to_int_def(cTemp, 0);

		fprintf(stderr, "input device IP(16 char):\n");
		gets_s(cTemp, 16);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		strcpy(atmInfo.cDestIP, cTemp);

		fprintf(stderr, "input device port:\n");
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		atmInfo.iDestPort = to_int_def(cTemp, 0);

		iRet = NetClient_SetATMConfig(g_iLogonID,iCmd,&atmInfo);
	}
	else if (iCmd ==ATM_CONFIG_CMD_OSD_INFO)
	{
		ATM_OSD_INFO atmOSDInfo = {0};
		atmOSDInfo.iSize = sizeof(ATM_OSD_INFO);
		fprintf(stderr, "input x:\n");
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		atmOSDInfo.iX = to_int_def(cTemp, 0);

		fprintf(stderr, "input y:\n");
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		atmOSDInfo.iY = to_int_def(cTemp, 0);

		fprintf(stderr, "input enable:\n");
		gets_s(cTemp, 10);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		atmOSDInfo.uEnable = to_int_def(cTemp, 0);
		iRet = NetClient_SetATMConfig(g_iLogonID,iCmd,&atmOSDInfo);
	}
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetATMConfig failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetATMConfig successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetATMConfig()
{
	fprintf(stderr, "You choose to test NetClient_GetATMConfig, number is 444\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input cmd:\n");
	fprintf(stderr, "0-ATM info:\n");
	fprintf(stderr, "1-ATM OSD:\n");
	fprintf(stderr, "2-Protocol count:\n");
	fprintf(stderr, "3-Protocol:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);
	int iRet;
	switch (iCmd)
	{
	case ATM_CONFIG_CMD_ATM_INFO:
		{
			ATM_INFO atmInfo = {0};
			atmInfo.iSize = sizeof(ATM_INFO);
			iRet = NetClient_GetATMConfig(g_iLogonID,iCmd,&atmInfo);
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetATMConfig failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "InformWay:%d, ProtocolName:%s, ATM IP:%s, ATM Port:%d, device IP:%s, device port:%d\n",
					atmInfo.iInformWay,atmInfo.cProtocolName,atmInfo.cSrcIP,atmInfo.iSrcPort,atmInfo.cDestIP,atmInfo.iDestPort);
				fprintf(stderr, "NetClient_GetATMConfig successful\n");
			}
		}
		break;
	case ATM_CONFIG_CMD_OSD_INFO:
		{
			ATM_OSD_INFO atmOSDInfo = {0};
			atmOSDInfo.iSize = sizeof(ATM_OSD_INFO);
			iRet = NetClient_GetATMConfig(g_iLogonID,iCmd,&atmOSDInfo);
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetATMConfig failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "x:%d, y:%d, enable:%d\n",atmOSDInfo.iX, atmOSDInfo.iY, atmOSDInfo.uEnable);
				fprintf(stderr, "NetClient_GetATMConfig successful\n");
			}
		}
		break;
	case ATM_CONFIG_CMD_PROTOCOL_COUNT:
		{
			int iCount;
			iRet = NetClient_GetATMConfig(g_iLogonID,iCmd,&iCount);
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetATMConfig failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "atm protocol number:%d\n",iCount);
				fprintf(stderr, "NetClient_GetATMConfig successful\n");
			}
		}
		break;
	case ATM_CONFIG_CMD_PROTOCOL_NAME:
		{
			ATM_PROTOCOL_NAME atmProtocol = {0};
			atmProtocol.iSize = sizeof(ATM_PROTOCOL_NAME);
			iRet = NetClient_GetATMConfig(g_iLogonID,iCmd,&atmProtocol);
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetATMConfig failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "Index:%d, ProtocolName:%s\n",
					atmProtocol.iIndex, atmProtocol.cName);
				fprintf(stderr, "NetClient_GetATMConfig successful\n");
			}
		}
		break;
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_ATMQueryFile()
{
	fprintf(stderr, "You choose to test NetClient_ATMQueryFile, number is 445\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input cmd:\n");
	fprintf(stderr, "0-field query:\n");
	fprintf(stderr, "1-card query:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);

	switch (iCmd)
	{
	case ATM_QUERY_CMD_FIELD:
		{
			ATM_FIELD_QUERY atmFieldQuery = {0};
			atmFieldQuery.iSize = sizeof(ATM_FIELD_QUERY);
			atmFieldQuery.iType = 0xFF;
// 			fprintf(stderr, "input Type(34:ATM):\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.iType = to_int_def(cTemp, 0);

			fprintf(stderr, "input Channel([0,%d] 255:all):\n",g_iTotalChnlNum-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			atmFieldQuery.iChannel = to_int_def(cTemp, 0);

			fprintf(stderr, "input start time(yyyy-MM-dd HH:mm:ss):\n");
			gets_s(cTemp, 20);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			sscanf(cTemp,"%hd-%hd-%hd %hd:%hd:%hd",&atmFieldQuery.struStartTime.iYear,&atmFieldQuery.struStartTime.iMonth
				,&atmFieldQuery.struStartTime.iDay,&atmFieldQuery.struStartTime.iHour,&atmFieldQuery.struStartTime.iMinute
				,&atmFieldQuery.struStartTime.iSecond);

			fprintf(stderr, "input stop time(yyyy-MM-dd HH:mm:ss):\n");
			gets_s(cTemp, 20);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			sscanf(cTemp,"%hd-%hd-%hd %hd:%hd:%hd",&atmFieldQuery.struStopTime.iYear,&atmFieldQuery.struStopTime.iMonth
				,&atmFieldQuery.struStopTime.iDay,&atmFieldQuery.struStopTime.iHour,&atmFieldQuery.struStopTime.iMinute
				,&atmFieldQuery.struStopTime.iSecond);
// 			fprintf(stderr, "input start time year:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStartTime.iYear = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input start time month:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStartTime.iMonth = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input start time day:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStartTime.iDay = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input start time hour:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStartTime.iHour = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input start time Minute:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStartTime.iMinute = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input start time second:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStartTime.iSecond = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time year:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStopTime.iYear = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time month:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStopTime.iMonth = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time day:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStopTime.iDay = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time hour:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStopTime.iHour = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time Minute:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStopTime.iMinute = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time second:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.struStopTime.iSecond = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input page size:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.iPageSize = to_int_def(cTemp, 0);
			atmFieldQuery.iPageSize = 20;

			fprintf(stderr, "input page no:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			atmFieldQuery.iPageNo = to_int_def(cTemp, 0);

// 			fprintf(stderr, "input file type(0:all,1:video,2:picture):\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.iFiletype = to_int_def(cTemp, 0);

// 			fprintf(stderr, "input device type(0:,1:Ƶ,2:,255:all):\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.iDevType = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input other query:\n");
// 			gets_s(cTemp, 64);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			strcpy(atmFieldQuery.cOtherQuery, cTemp);
// 
// 			fprintf(stderr, "input trigger type(3:˿ڱ,4:ƶ,5:Ƶʧ,0x7FFFFFFF:Ч):\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.iTriggerType = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input trigger:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmFieldQuery.iTrigger = to_int_def(cTemp, 0);
			atmFieldQuery.iTriggerType = 0x7fffffff;

			for (int i=0; i<5; i++)
			{
				fprintf(stderr, "input field(%d)[0,32]:\n",i);
				gets_s(cTemp, 8);
				if(0 == strcasecmp("q", cTemp))
				{
					return -1;
				}
				strcpy(atmFieldQuery.cField[i], cTemp);
			}
			int iRet = NetClient_ATMQueryFile(g_iLogonID,iCmd,&atmFieldQuery);
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_ATMQueryFile failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_ATMQueryFile successful\n");
			}
		}
		break;
	case ATM_QUERY_CMD_CARD:
		{
			ATM_CARD_QUERY atmCardQuery = {0};
			atmCardQuery.iSize = sizeof(ATM_CARD_QUERY);
// 			fprintf(stderr, "input Type(34:ATM):\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.iType = to_int_def(cTemp, 0);
			atmCardQuery.iType = 255/*34*/;

			fprintf(stderr, "input Channel([0,%d] 255:all):\n",g_iTotalChnlNum-1);
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			atmCardQuery.iChannel = to_int_def(cTemp, 0);

// 			fprintf(stderr, "input start time year:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStartTime.iYear = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input start time month:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStartTime.iMonth = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input start time day:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStartTime.iDay = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input start time hour:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStartTime.iHour = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input start time Minute:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStartTime.iMinute = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input start time second:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStartTime.iSecond = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time year:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStopTime.iYear = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time month:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStopTime.iMonth = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time day:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStopTime.iDay = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time hour:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStopTime.iHour = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time Minute:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStopTime.iMinute = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input stop time second:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.struStopTime.iSecond = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input page size:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.iPageSize = to_int_def(cTemp, 0);
			

			fprintf(stderr, "input start time(yyyy-MM-dd HH:mm:ss):\n");
			gets_s(cTemp, 20);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			sscanf(cTemp,"%hd-%hd-%hd %hd:%hd:%hd",&atmCardQuery.struStartTime.iYear,&atmCardQuery.struStartTime.iMonth
				   ,&atmCardQuery.struStartTime.iDay,&atmCardQuery.struStartTime.iHour,&atmCardQuery.struStartTime.iMinute
				   ,&atmCardQuery.struStartTime.iSecond);

			fprintf(stderr, "input stop time(yyyy-MM-dd HH:mm:ss):\n");
			gets_s(cTemp, 20);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			sscanf(cTemp,"%hd-%hd-%hd %hd:%hd:%hd",&atmCardQuery.struStopTime.iYear,&atmCardQuery.struStopTime.iMonth
				,&atmCardQuery.struStopTime.iDay,&atmCardQuery.struStopTime.iHour,&atmCardQuery.struStopTime.iMinute
				,&atmCardQuery.struStopTime.iSecond);

			atmCardQuery.iPageSize = 20;

			fprintf(stderr, "input page no:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			atmCardQuery.iPageNo = to_int_def(cTemp, 0);

// 			fprintf(stderr, "input file type(0:all,1:video,2:picture):\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.iFiletype = to_int_def(cTemp, 0);

// 			fprintf(stderr, "input device type(0:,1:Ƶ,2:,255:all):\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.iDevType = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input other query:\n");
// 			gets_s(cTemp, 64);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			strcpy(atmCardQuery.cOtherQuery, cTemp);
// 
// 			fprintf(stderr, "input trigger type(3:˿ڱ,4:ƶ,5:Ƶʧ,0x7FFFFFFF:Ч):\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.iTriggerType = to_int_def(cTemp, 0);
// 
// 			fprintf(stderr, "input trigger:\n");
// 			gets_s(cTemp, 8);
// 			if(0 == strcasecmp("q", cTemp))
// 			{
// 				return -1;
// 			}
// 			atmCardQuery.iTrigger = to_int_def(cTemp, 0);
			atmCardQuery.iTriggerType = 0x7fffffff;

			fprintf(stderr, "input ID(32 char):\n");
			gets_s(cTemp, ATM_CARD_ID_LEN);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			strcpy(atmCardQuery.cID, cTemp);

			fprintf(stderr, "input operate(0:all 1:Query 2:Withdrawn 3:Change password 4:Transfer 5:Deposit 6:Query without cards 7:Deposit without cards 8:Other 9:Insert 10:Draw 11:No operation):\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			atmCardQuery.iOperate = to_int_def(cTemp, 0);

			fprintf(stderr, "input quantity:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			if (strlen(cTemp) <= 0)
			{
				atmCardQuery.iQuantity = 0x7FFFFFFF;
			}
			else
			{
				atmCardQuery.iQuantity = to_int_def(cTemp, 0);
			}

			fprintf(stderr, "input abnormity(0:All 1:Card swallowed 2:Money swallowed 255:No exception):\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			atmCardQuery.iAbnormity = to_int_def(cTemp, 0);
			int iRet = NetClient_ATMQueryFile(g_iLogonID,iCmd,&atmCardQuery);
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_ATMQueryFile failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "NetClient_ATMQueryFile successful\n");
			}
		}
		break;
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_ATMGetQueryFile()
{
	fprintf(stderr, "You choose to test NetClient_ATMGetQueryFile, number is 446\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input file index:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iFileIndex = to_int_def(cTemp, 0);

	ATM_FILE_DATA atmFileData = {0};
	atmFileData.iSize = sizeof(ATM_FILE_DATA);
	int iRet = NetClient_ATMGetQueryFile(g_iLogonID,iFileIndex, &atmFileData);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_ATMGetQueryFile failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "atm type:%d, channel:%d, file name:%s, start time:%d-%d-%d %d:%d:%d,\
			stop time:%d-%d-%d %d:%d:%d, file size:%d, operate:%d, operate time:%d-%d-%d %d:%d:%d\n",atmFileData.iType,
			atmFileData.iChannel, atmFileData.cFileName, atmFileData.struStartTime.iYear, atmFileData.struStartTime.iMonth,
			atmFileData.struStartTime.iDay, atmFileData.struStartTime.iHour, atmFileData.struStartTime.iMonth,
			atmFileData.struStartTime.iSecond,atmFileData.struStoptime.iYear, atmFileData.struStoptime.iMonth,
			atmFileData.struStoptime.iDay, atmFileData.struStoptime.iHour, atmFileData.struStoptime.iMonth,
			atmFileData.struStoptime.iSecond,atmFileData.iFileSize,atmFileData.iOperate,atmFileData.struOperateTime.iYear, 
			atmFileData.struOperateTime.iMonth,atmFileData.struOperateTime.iDay, atmFileData.struOperateTime.iHour, 
			atmFileData.struOperateTime.iMonth,atmFileData.struOperateTime.iSecond);
		fprintf(stderr, "NetClient_ATMGetQueryFile successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetAudioSample()
{
	fprintf(stderr, "You choose to test NetClient_SetAudioSample, number is 447\n");
	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

// 	fprintf(stderr, "Plesase input cmd:\n");
// 	gets_s(cTemp, 8);
// 	if(0 == strcasecmp("q", cTemp))
// 	{
// 		return -1;
// 	}
// 	int iCmd = to_int_def(cTemp, 0);
	int iRet = -1;
	int iCmd = AUDIO_SAMPLE_CMD_SAMPLE;
	//if (iCmd == AUDIO_SAMPLE_CMD_SAMPLE)
	{
		fprintf(stderr, "Plesase input sample:\n");
		gets_s(cTemp, 8);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		int iSample = to_int_def(cTemp, 0);
		iRet = NetClient_SetAudioSample(g_iLogonID,iChannelNo,iCmd, &iSample);
	}
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetAudioSample failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetAudioSample successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetAudioSample()
{
	fprintf(stderr, "You choose to test NetClient_GetAudioSample, number is 448\n");
	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Plesase input cmd(0:current sample 1:sample count 2:sample list):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);
	int iRet;
	switch (iCmd)
	{
	case AUDIO_SAMPLE_CMD_SAMPLE:
		{
			int iSample;
			iRet = NetClient_GetAudioSample(g_iLogonID,iChannelNo,iCmd, &iSample);
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetAudioSample failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "sample:%d \n",iSample);
				fprintf(stderr, "NetClient_GetAudioSample successful\n");
			}
		}
		break;
	case AUDIO_SAMPLE_CMD_SAMPLE_COUNT:
		{
			int iSampleCount;
			iRet = NetClient_GetAudioSample(g_iLogonID,iChannelNo,iCmd, &iSampleCount);
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetAudioSample failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "sample count:%d \n",iSampleCount);
				fprintf(stderr, "NetClient_GetAudioSample successful\n");
			}
		}
		break;
	case AUDIO_SAMPLE_CMD_SAMPLE_LIST:
		{
			fprintf(stderr, "Plesase input sample index:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iIndex = to_int_def(cTemp, 0);

			AUDIO_SAMPLE audioSample = {0};
			audioSample.iSize = sizeof(AUDIO_SAMPLE);
			audioSample.iIndex = iIndex;
			iRet = NetClient_GetAudioSample(g_iLogonID,iChannelNo,iCmd, &audioSample);
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetAudioSample failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "index:%d sample:%d\n",audioSample.iIndex, audioSample.iSample);
				fprintf(stderr, "NetClient_GetAudioSample successful\n");
			}
		}
		break;
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetSystemTypeEx()
{
	fprintf(stderr, "You choose to test NetClient_SetSystemTypeEx, number is 449\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input cmd(0:SystemType 1:DeviceProducter):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);
	int iRet;
	switch (iCmd)
	{
	case SYSTEMTYPE_WORKMODE:
		{
			fprintf(stderr, "Plesase input system type(0:debug mode 1:normal mode 2:safe mode 3:gate 4:ECOP):\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iType = to_int_def(cTemp, 0);
			iRet = NetClient_SetSystemTypeEx(g_iLogonID, iCmd, &iType);
		}
		break;
	case SYSTEMTYPE_DEVPROD:
		{
			fprintf(stderr, "Plesase input device producter:\n");
			gets_s(cTemp, 8);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			int iProducter = to_int_def(cTemp, 0);
			iRet = NetClient_SetSystemTypeEx(g_iLogonID, iCmd, &iProducter);
		}
		break;
	}
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetSystemTypeEx failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetSystemTypeEx successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetSystemTypeEx()
{
	fprintf(stderr, "You choose to test NetClient_GetSystemTypeEx, number is 450\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input cmd(0:SystemType 1:DeviceProducter):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCmd = to_int_def(cTemp, 0);
	int iRet;
	switch (iCmd)
	{
	case SYSTEMTYPE_WORKMODE:
		{
			int iType = 0;
			iRet = NetClient_GetSystemTypeEx(g_iLogonID, iCmd, &iType);
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetSystemTypeEx failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "system type:%d\n",iType);
				fprintf(stderr, "NetClient_GetSystemTypeEx successful\n");
			}
		}
		break;
	case SYSTEMTYPE_DEVPROD:
		{		
			int iProductor = 0;
			iRet = NetClient_GetSystemTypeEx(g_iLogonID, iCmd, &iProductor);
			if(iRet!=0)
			{
				fprintf(stderr, "NetClient_GetSystemTypeEx failed! return %d, errno = 0x%08x\n", iRet, errno);
			}
			else
			{
				fprintf(stderr, "device productor:%d\n",iProductor);
				fprintf(stderr, "NetClient_GetSystemTypeEx successful\n");
			}
		}
		break;
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetEncryptSN()
{
	fprintf(stderr, "You choose to test NetClient_SetEncryptSN, number is 451\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input type(0ʶ㷨ͣ1):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iType = to_int_def(cTemp, 0);

	char cSN[256] = {0};
	fprintf(stderr, "Plesase input type(0ʶ㷨ͣ1):\n");
	gets_s(cTemp, 255);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(cSN, cTemp);
	int iRet = NetClient_SetEncryptSN(g_iLogonID, iType, cSN);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetEncryptSN failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetEncryptSN successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetSNReg()
{
	fprintf(stderr, "You choose to test NetClient_GetSNReg, number is 452\n");
	
	int iLockRet = 0;
	int iRet = NetClient_GetSNReg(g_iLogonID, &iLockRet);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetSNReg failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		int iBit0 = iLockRet & 1;
		int iBit1 = iLockRet>>1 & 1;
		fprintf(stderr, "ʶ:%d, ܹܽͨ:%d\n", iBit0, iBit1);
		fprintf(stderr, "NetClient_GetSNReg successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetComFormat_V1()
{
	fprintf(stderr, "You choose to test NetClient_GetComFormat_V1, number is 453\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input com port:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iComPort = to_int_def(cTemp, 0);

	char cDeviceType[32] = {0};
	char cCommFormat[32] = {0};
	int iWorkMode;
	int iRet = NetClient_GetComFormat_V1(g_iLogonID, iComPort, cDeviceType, cCommFormat, &iWorkMode);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetComFormat_V1 failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "device type:%s, com format:%s, work mode:%d(1:Э;2:͸ͨ;3:ҵԤ)\n", 
			cDeviceType, cCommFormat, iWorkMode);
		fprintf(stderr, "NetClient_GetComFormat_V1 successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetComFormat_V2()
{
	fprintf(stderr, "You choose to test NetClient_SetComFormat_V2, number is 454\n");

	COMFORMAT comformat = {0};
	comformat.iSize = sizeof(COMFORMAT);
	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input com no:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	comformat.iComNo = to_int_def(cTemp, 0);
	
	fprintf(stderr, "Plesase input device name:\n");
	gets_s(cTemp, 31);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(comformat.cDeviceName, cTemp);

	fprintf(stderr, "Plesase input com format:\n");
	gets_s(cTemp, 31);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(comformat.cComFormat, cTemp);

	fprintf(stderr, "Plesase input work mode(1:Э,2:͸ͨ,3:ҵԤ,4:7601Bб,5:485):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	comformat.iWorkMode = to_int_def(cTemp, 0);

	fprintf(stderr, "Plesase input com type(0:485,1:232,2:422):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	comformat.iComType = to_int_def(cTemp, 0);

	int iRet = NetClient_SetComFormat_V2(g_iLogonID, &comformat);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetComFormat_V2 failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetComFormat_V2 successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetComFormat_V2()
{
	fprintf(stderr, "You choose to test NetClient_GetComFormat_V2, number is 455\n");

	COMFORMAT comformat = {0};
	comformat.iSize = sizeof(COMFORMAT);
	
	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input com no:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	comformat.iComNo = to_int_def(cTemp, 0);	

	int iRet = NetClient_GetComFormat_V2(g_iLogonID, &comformat);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetComFormat_V2 failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "com no:%d, device name:%s, com format:%s, work mode:%d, com type:%d\n", 
			comformat.iComNo, comformat.cDeviceName, comformat.cComFormat, comformat.iWorkMode, comformat.iComType);
		fprintf(stderr, "NetClient_GetComFormat_V2 successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetServerVersion_V1()
{
	fprintf(stderr, "You choose to test NetClient_GetServerVersion_V1, number is 456\n");

	SERVER_VERSION serverVersion = {0};
	serverVersion.m_iStructSize = sizeof(SERVER_VERSION);	
	int iRet = NetClient_GetServerVersion_V1(g_iLogonID, &serverVersion);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetServerVersion_V1 failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "version:%s, ui version:%s, slave version:%s, plug in version:%s\n", 
			serverVersion.m_cVersion,serverVersion.m_cUIVersion,serverVersion.m_cSlaveVersion,serverVersion.m_cPlugInVersion);
		fprintf(stderr, "NetClient_GetServerVersion_V1 successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_InputTalkingdataEx()
{
	fprintf(stderr, "You choose to test NetClient_InputTalkingdataEx, number is 457\n");

	char cTemp[640] = {0};
	fprintf(stderr, "Plesase input talking data:\n");
	gets_s(cTemp, 639);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	unsigned char ucData[640] = {0};
	strcpy((char *)ucData, cTemp);

	int iLen = strlen((char*)ucData);
	int iRet = NetClient_InputTalkingdataEx(g_iLogonID, ucData, iLen);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_InputTalkingdataEx failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_InputTalkingdataEx successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetVerticalSync()
{
	fprintf(stderr, "You choose to test NetClient_SetVerticalSync, number is 458\n");
	fprintf(stderr, "Please connect video before use this interface\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Plesase input stream no(0:,1:):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iStreamNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Plesase input volume:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iVolume = to_int_def(cTemp, 0);

	int iRet = NetClient_SetVerticalSync(g_uiRecv[iChannelNo+iStreamNo*g_iTotalChnlNum], iVolume);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetVerticalSync failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetVerticalSync successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetVerticalSync()
{
	fprintf(stderr, "You choose to test NetClient_GetVerticalSync, number is 459\n");
	fprintf(stderr, "Please connect video before use this interface\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Plesase input stream no(0:,1:):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iStreamNo = to_int_def(cTemp, 0);

	int iFlag;
	int iRet = NetClient_GetVerticalSync(g_uiRecv[iChannelNo+iStreamNo*g_iTotalChnlNum], &iFlag);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetVerticalSync failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "sync flag:%d(0:ر,1:)\n", iFlag);
		fprintf(stderr, "NetClient_GetVerticalSync successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetLocalAudioVolumeEx()
{
	fprintf(stderr, "You choose to test NetClient_SetLocalAudioVolumeEx, number is 457\n");
	fprintf(stderr, "Please connect video before use this interface\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Plesase input stream no(0:,1:):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iStreamNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Plesase input volume:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iVolume = to_int_def(cTemp, 0);

	int iRet = NetClient_SetLocalAudioVolumeEx(g_uiRecv[iChannelNo+iStreamNo*g_iTotalChnlNum], iVolume);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetLocalAudioVolumeEx failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetLocalAudioVolumeEx successful\n");
	}
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetLocalAudioVolumeEx()
{
	fprintf(stderr, "You choose to test NetClient_GetLocalAudioVolumeEx, number is 458\n");
	fprintf(stderr, "Please connect video before use this interface\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Plesase input stream no(0:,1:):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iStreamNo = to_int_def(cTemp, 0);

	int iVolume;
	int iRet = NetClient_GetLocalAudioVolumeEx(g_uiRecv[iChannelNo+iStreamNo*g_iTotalChnlNum], &iVolume);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetLocalAudioVolumeEx failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "volume:%d\n", iVolume);
		fprintf(stderr, "NetClient_GetLocalAudioVolumeEx successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_ClearPolyLocalVideo()
{
	fprintf(stderr, "You choose to test NetClient_ClearPolyLocalVideo, number is 466\n");
	fprintf(stderr, "Please connect video before use this interface\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Plesase input channelno[0,31]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Plesase input stream no(0:main,1:sub):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iStreamNo = to_int_def(cTemp, 0);	
	
	fprintf(stderr, "Plesase input Polygon Index:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iPolygonIndex = to_int_def(cTemp, 0);

	int iRet = NetClient_ClearPolyLocalVideo(g_uiRecv[iChannelNo+iStreamNo*g_iTotalChnlNum], iPolygonIndex);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_ClearPolyLocalVideo failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_ClearPolyLocalVideo successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

///???
int Test_SetITSSwitchTime()
{
	fprintf(stderr, "You choose to test NetClient_SetITSSwitchTime, number is 390\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input SwitchTime(s):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iSwitchTime = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input DelayTime(ms):\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iDelayTime = to_int_def(cTemp, 0);

	int iRet = NetClient_SetITSSwitchTime(g_iLogonID,iSwitchTime,iDelayTime);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetITSSwitchTime failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "SwitchTime(%d),DelayTime(%d)\n",iSwitchTime,iDelayTime);
		fprintf(stderr, "NetClient_SetITSSwitchTime successful\n");
	}
	
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetITSSwitchTime()
{
	fprintf(stderr, "You choose to test NetClient_GetITSSwitchTime, number is 391\n");

	int iSwitchTime = 0;
	int iDelayTime = 0;
	int iRet = NetClient_GetITSSwitchTime(g_iLogonID,&iSwitchTime,&iDelayTime);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetITSSwitchTime failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "SwitchTime(%d),DelayTime(%d)\n",iSwitchTime,iDelayTime);
		fprintf(stderr, "NetClient_GetITSSwitchTime successful\n");
	}
	
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetITSRecoParam()
{
	fprintf(stderr, "You choose to test NetClient_SetITSRecoParam, number is 392\n");

	char cTemp[256] = {0};
	ITS_RecoParamEx tRecoParamEx;
	memset(&tRecoParamEx,0,sizeof(ITS_RecoParamEx));
	fprintf(stderr, "Please input RoadwayID[0,3]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iRoadwayID = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input MaxPlateNO:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iMaxPlateNO = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input MaxPlateWidth:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iMaxPlateWidth = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input MinPlateWidth:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iMinPlateWidth = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Enable:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iEnable = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input EngineNum:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iEngineNum = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input AreaType:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iAreaType = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input PlateType:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iPlateType = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Speed[1,10]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iSpeed = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input MaxSkip:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iMaxSkip = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input MinValid:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iMinValid = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input FramePercent:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iFramePercent = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input MinCapDiff:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iMinCapDiff = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input CaliInfo:\n");
	gets_s(cTemp, 75);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strcpy(tRecoParamEx.cCaliInfo,cTemp);

	fprintf(stderr, "Please input PlateCharType:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iPlateCharType = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Confid:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iConfid = to_int_def(cTemp, 0);

	int iRet = NetClient_SetITSRecoParam(g_iLogonID,&tRecoParamEx,sizeof(ITS_RecoParamEx));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetITSRecoParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetITSRecoParam successful\n");
	}
	
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetITSRecoParam()
{
	fprintf(stderr, "You choose to test NetClient_GetITSRecoParam, number is 393\n");

	char cTemp[256] = {0};
	ITS_RecoParamEx tRecoParamEx;
	memset(&tRecoParamEx,0,sizeof(ITS_RecoParamEx));
	fprintf(stderr, "Please input RoadwayID[0,3]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tRecoParamEx.iRoadwayID = to_int_def(cTemp, 0);

	int iRet = NetClient_GetITSRecoParam(g_iLogonID,&tRecoParamEx,sizeof(ITS_RecoParamEx));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetITSRecoParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "RoadwayID(%d),MaxPlateNO(%d),MaxPlateWidth(%d),MinPlateWidth(%d),Enable(%d),AreaType(%d)\
						,PlateType(%d),Speed(%d),MaxSkip(%d),MinValid(%d),FramePercent(%d),MinCapDiff(%d),CaliInfo(%s)\
						,PlateCharType(%d),Confid(%d)\n"
						,tRecoParamEx.iRoadwayID,tRecoParamEx.iMaxPlateNO,tRecoParamEx.iMaxPlateWidth
						,tRecoParamEx.iMinPlateWidth,tRecoParamEx.iEnable,tRecoParamEx.iAreaType
						,tRecoParamEx.iPlateType,tRecoParamEx.iSpeed,tRecoParamEx.iMaxSkip,tRecoParamEx.iMinValid
						,tRecoParamEx.iFramePercent,tRecoParamEx.iMinCapDiff,tRecoParamEx.cCaliInfo
						,tRecoParamEx.iPlateCharType,tRecoParamEx.iConfid);
		fprintf(stderr, "NetClient_GetITSRecoParam successful\n");
	}
	
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetITSDayNight()
{
	fprintf(stderr, "You choose to test NetClient_SetITSDayNight, number is 394\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input TimeSegment:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iDayNight = to_int_def(cTemp, 0);

	int iRet = NetClient_SetITSDayNight(g_iLogonID,iDayNight);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetITSDayNight failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetITSDayNight successful\n");
	}
	
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetITSDayNight()
{
	fprintf(stderr, "You choose to test NetClient_GetITSDayNight, number is 395\n");

	int iDayNight = 0;
	int iRet = NetClient_GetITSDayNight(g_iLogonID,&iDayNight);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetITSDayNight failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "DayNight(%d)\n",iDayNight);
		fprintf(stderr, "NetClient_GetITSDayNight successful\n");
	}
	
	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetITSCamLocation()
{
	fprintf(stderr, "You choose to test NetClient_SetITSCamLocation, number is 396\n");

	char cTemp[256] = {0};
	ITS_CamLocation tLocation;
	memset(&tLocation,0,sizeof(ITS_CamLocation));
	fprintf(stderr, "Please input DeviceVode:\n");
	gets_s(cTemp, 63);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	u2g(cTemp,strlen(cTemp),tLocation.cDeviceVode,sizeof(tLocation.cDeviceVode));
	//strcpy(tLocation.cDeviceVode,cTemp);

	fprintf(stderr, "Please input RoadName:\n");
	gets_s(cTemp, 63);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	u2g(cTemp,strlen(cTemp),tLocation.cRoadName,sizeof(tLocation.cRoadName));
	//strcpy(tLocation.cRoadName,cTemp);

	int iRet = NetClient_SetITSCamLocation(g_iLogonID,&tLocation,sizeof(ITS_CamLocation));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetITSCamLocation failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetITSCamLocation successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetITSCamLocation()
{
	fprintf(stderr, "You choose to test NetClient_GetITSCamLocation, number is 397\n");

	//char cTemp[256] = {0};
	ITS_CamLocation tLocation;
	memset(&tLocation,0,sizeof(ITS_CamLocation));

	int iRet = NetClient_GetITSCamLocation(g_iLogonID,&tLocation,sizeof(ITS_CamLocation));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetITSCamLocation failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		char cRoadName[128] = {0};
		char cDeviceVode[128] = {0};
		g2u(tLocation.cRoadName,strlen(tLocation.cRoadName),cRoadName,sizeof(cRoadName));
		g2u(tLocation.cDeviceVode,strlen(tLocation.cDeviceVode),cDeviceVode,sizeof(cDeviceVode));
		fprintf(stderr, "DeviceVode(%s),RoadName(%s)\n"
						,cDeviceVode,cRoadName);
		fprintf(stderr, "NetClient_GetITSCamLocation successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetITSWorkMode()
{
	fprintf(stderr, "You choose to test NetClient_SetITSWorkMode, number is 398\n");

	char cTemp[256] = {0};
	ITS_CamWorkMode tWorkMode = {0};
	fprintf(stderr, "Please input WorkMode:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tWorkMode.iWorkMode = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Interval:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tWorkMode.iInterval = to_int_def(cTemp, 0);

	int iRet = NetClient_SetITSWorkMode(g_iLogonID,&tWorkMode,sizeof(ITS_CamWorkMode));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetITSWorkMode failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetITSWorkMode successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetITSWorkMode()
{
	fprintf(stderr, "You choose to test NetClient_GetITSWorkMode, number is 399\n");

	ITS_CamWorkMode tWorkMode = {0};
	int iRet = NetClient_GetITSWorkMode(g_iLogonID,&tWorkMode,sizeof(ITS_CamWorkMode));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetITSWorkMode failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "WorkMode(%d,%d)\n",tWorkMode.iWorkMode,tWorkMode.iInterval);
		fprintf(stderr, "NetClient_GetITSWorkMode successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetWaterMarkEnable()
{
	fprintf(stderr, "You choose to test NetClient_SetWaterMarkEnable, number is 400\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,%d):\n",g_iTotalChnlNum);
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Enable:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iEnable = to_int_def(cTemp, 0);
	int iRet = NetClient_SetWaterMarkEnable(g_iLogonID,iChannelNo,iEnable);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetWaterMarkEnable failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetWaterMarkEnable successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetWaterMarkEnable()
{
	fprintf(stderr, "You choose to test NetClient_GetWaterMarkEnable, number is 401\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channelno[0,%d):\n",g_iTotalChnlNum);
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannelNo = to_int_def(cTemp, 0);

	int iEnable = 0;
	int iRet = NetClient_GetWaterMarkEnable(g_iLogonID,iChannelNo,&iEnable);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetWaterMarkEnable failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "ChannelNo(%d),Enable(%d)\n",iChannelNo,iEnable);
		fprintf(stderr, "NetClient_GetWaterMarkEnable successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetITSLightInfo()
{
	fprintf(stderr, "You choose to test NetClient_SetITSLightInfo, number is 402\n");

	char cTemp[256] = {0};
	TITSLightInfo tLightInfo = {0};
	fprintf(stderr, "Please input LightID[0,%d]:\n",LIGHT_COUNT-1);
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tLightInfo.iLightID = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input TimeInterval:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tLightInfo.iTimeInterval = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input TimeAcceptDiff:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tLightInfo.iTimeAcceptDiff = to_int_def(cTemp, 0);

	int iRet = NetClient_SetITSLightInfo(g_iLogonID,&tLightInfo,sizeof(TITSLightInfo));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetITSLightInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetITSLightInfo successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetITSLightInfo()
{
	fprintf(stderr, "You choose to test NetClient_GetITSLightInfo, number is 403\n");

	char cTemp[256] = {0};
	TITSLightInfo tLightInfo = {0};
	fprintf(stderr, "Please input LightID[0,%d]:\n",LIGHT_COUNT-1);
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tLightInfo.iLightID = to_int_def(cTemp, 0);

	int iRet = NetClient_GetITSLightInfo(g_iLogonID,&tLightInfo,sizeof(TITSLightInfo));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetITSLightInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "LightID(%d),TimeAcceptDiff(%d),TimeInterval(%d)\n"
			,tLightInfo.iLightID,tLightInfo.iTimeAcceptDiff,tLightInfo.iTimeInterval);
		fprintf(stderr, "NetClient_GetITSLightInfo successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetHardWareParam()
{
	fprintf(stderr, "You choose to test NetClient_SetHardWareParam, number is 404\n");

	char cTemp[256] = {0};
	HardWare_Param tParam = {0};
	fprintf(stderr, "Please input Type[0,%d):\n",3);
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tParam.iType = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Mold:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tParam.iMold = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Value:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tParam.fValue = to_int_def(cTemp, 0);

	int iRet = NetClient_SetHardWareParam(g_iLogonID,IPC_CMD_SENSOR_VOLTAGE,&tParam,sizeof(HardWare_Param));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetHardWareParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetHardWareParam successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetHardWareParam()
{
	fprintf(stderr, "You choose to test NetClient_GetHardWareParam, number is 405\n");

	char cTemp[256] = {0};
	HardWare_Param tParam = {0};
	fprintf(stderr, "Please input Type[0,%d):\n",3 );
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tParam.iType = to_int_def(cTemp, 0);

	fprintf(stderr, "Please input Mold:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tParam.iMold = to_int_def(cTemp, 0);

	int iRet = NetClient_GetHardWareParam(g_iLogonID,IPC_CMD_SENSOR_VOLTAGE,&tParam,sizeof(HardWare_Param));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetHardWareParam failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Value(%f)\n",tParam.fValue);
		fprintf(stderr, "NetClient_GetHardWareParam successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}


int Test_GetBitrateOnVideo_V4()
{
	fprintf(stderr, "You choose to Test NetClient_GetBitrateOnVideo_V4, number is 459\n");
	
	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel no :\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iChan = to_int_def(cTemp);

	fprintf(stderr, 
		"Stream type:\n"
		"0: MAIN_STREAM\n"
		"1: SUB_STREAM\n");
	fprintf(stderr, "Please select number to set:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iStreamNo = to_int_def(cTemp, -1);
	
	int iX = 0;
	int iY = 0;
	int iEnable = 0;
	char cInfo[256] = {0};
		
	int iRet = NetClient_GetBitrateOnVideo_V4(g_uiRecv[iChan+iStreamNo*g_iTotalChnlNum], &iX, &iY, &iEnable, cInfo);
	if (0 == iRet)
	{
		fprintf(stderr, "NetClient_GetBitrateOnVideo_V4 is succeed!\n");
		fprintf(stderr, "X=%d, Y=%d, Enable=%d, Info=%s", iX, iY, iEnable, cInfo);
	}
	else
	{
		fprintf(stderr, "NetClient_GetBitrateOnVideo_V4 is failed!ret = :%d, err = 0x%08x\n", iRet, errno);
	}
	return 0;	
}

int Test_NetFileDownloadByTimeSpan()
{
	int iChannel = 0; 
	char cTemp[256] = {0};
	NVS_FILE_TIME timeBegin;
	memset(&timeBegin, 0, sizeof(timeBegin));
	NVS_FILE_TIME timeEnd;   
	memset(&timeEnd, 0, sizeof(timeEnd));

	fprintf(stderr, "You choose to test Test_NetFileDownloadByTimeSpan, number is 460\n");

	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input start time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	unsigned short iYear = 0;   
	unsigned short iMonth = 0;  
	unsigned short iDay = 0;    
	unsigned short iHour = 0;   
	unsigned short iMinute = 0; 
	unsigned short iSecond = 0;


	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		&iYear,
		&iMonth,
		&iDay,
		&iHour,
		&iMinute,
		&iSecond);

	timeBegin.iYear = iYear;
	timeBegin.iMonth = iMonth;
	timeBegin.iDay = iDay;
	timeBegin.iHour = iHour;
	timeBegin.iMinute = iMinute;
	timeBegin.iSecond = iSecond;


	fprintf(stderr, "Please input stop time (year-month-day hour:minute:second):");

	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}

	iYear = 0;   
	iMonth = 0;  
	iDay = 0;    
	iHour = 0;   
	iMinute = 0; 
	iSecond = 0;

	sscanf(cTemp, "%hd-%hd-%hd %hd:%hd:%hd", 
		&iYear,
		&iMonth,
		&iDay,
		&iHour,
		&iMinute,
		&iSecond);

	timeEnd.iYear = iYear;
	timeEnd.iMonth = iMonth;
	timeEnd.iDay = iDay;
	timeEnd.iHour = iHour;
	timeEnd.iMinute = iMinute;
	timeEnd.iSecond = iSecond;


	tm tm_Begin = {0}, tm_End = {0};
	tm_Begin.tm_year = timeBegin.iYear - 1900;
	tm_Begin.tm_mon  = timeBegin.iMonth - 1;
	tm_Begin.tm_mday = timeBegin.iDay;
	tm_Begin.tm_hour = timeBegin.iHour;
	tm_Begin.tm_min  = timeBegin.iMinute;
	tm_Begin.tm_sec  = timeBegin.iSecond;

	tm_End.tm_year = timeEnd.iYear - 1900;
	tm_End.tm_mon  = timeEnd.iMonth - 1;
	tm_End.tm_mday = timeEnd.iDay;
	tm_End.tm_hour = timeEnd.iHour;
	tm_End.tm_min  = timeEnd.iMinute;
	tm_End.tm_sec  = timeEnd.iSecond;

	time_t timenow, timeSpace;
	struct tm timeg;
	time(&timenow);
	gmtime_r(&timenow, &timeg);
	timeSpace = timenow - mktime(&timeg);

	time_t begin = mktime(&tm_Begin) + timeSpace;
	time_t end   = mktime(&tm_End) + timeSpace;
	const unsigned int uiFrom = (const unsigned int)begin;
	const unsigned int uiTo   = (const unsigned int)end;
	
	unsigned int iRecvContext = 0xFFFFFFFF;
	char cLocal[512] = {0};
	sprintf(cLocal,"/root/download_by_time_span.sdv");
	int iRet = NetClient_NetFileDownloadByTimeSpan(&iRecvContext,
													g_iLogonID,
													cLocal,
													iChannel,
													uiFrom,
													uiTo,
													0,
													-1,
													1);


	if(0 == iRet)
		fprintf(stderr, "NetFileDownloadByTimeSpan is successful\n");
	else
		fprintf(stderr, "NetFileDownloadByTimeSpan is fail\n");

	fprintf(stderr, "Please type other interface to test:");
	g_uiNetFileID = iRecvContext;
	return 0;

}

int Test_ControlDeviceRecord()
{
	fprintf(stderr, "You choose to test NetClient_ControlDeviceRecord, number is 461 \n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannel = to_int_def(cTemp, -1);
	
	fprintf(stderr, "Please input action (0-stop, 1-start, 2-package):");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iAction = to_int_def(cTemp, -1);


	fprintf(stderr, "Please input record type:\naction=0/1,type[32,63]\naction=2,type[0,63]\n");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iRecordType = to_int_def(cTemp, -1);

	int iRet = NetClient_ControlDeviceRecord(g_iLogonID, iChannel, iRecordType, iAction);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_ControlDeviceRecord failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_ControlDeviceRecord successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
	
	
}

int Test_SetVideoModeMethod()
{
	fprintf(stderr, "You choose to test NetClient_SetVideoModeMethod, number is 462 \n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannel = to_int_def(cTemp, -1);


	fprintf(stderr, "Please input video mode method:\n");
	fprintf(stderr, "	0 - VIDEO_MODE_HAND\n");
	fprintf(stderr, "	1 - VIDEO_MODE_AUT\n");
	
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iMode = to_int_def(cTemp, -1);

	int iRet = NetClient_SetVideoModeMethod(g_iLogonID, iChannel, iMode);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetVideoModeMethod failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetVideoModeMethod successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_GetVideoModeMethod()
{
	fprintf(stderr, "You choose to test NetClient_GetVideoModeMethod, number is 463 \n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannel = to_int_def(cTemp, -1);

	int iMode = 0;

	int iRet = NetClient_GetVideoModeMethod(g_iLogonID, iChannel, &iMode);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetVideoModeMethod failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "video mode method: %d \n", iMode);
		fprintf(stderr, "NetClient_GetVideoModeMethod successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

void PsPackCallBack(unsigned long _ulID, unsigned char* _ucData, int _iSize, PSPACK_INFO* _pPsPackInfo, void* _pContext)
{
	printf("Callback PsPackCallBack is called, %lu\n", _ulID);
	return ;
}

int Test_SetPsPackCallBack()
{
	fprintf(stderr, "You choose to test NetClient_SetPsPackCallBack, number is 464 \n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input channel number:");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannel = to_int_def(cTemp, -1);

	fprintf(stderr, 
		"Stream type:\n"
		"0: MAIN_STREAM\n"
		"1: SUB_STREAM\n");
	fprintf(stderr, "Please select number to set:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
		return -1;
	int iStreamNo = to_int_def(cTemp, -1);


	fprintf(stderr, "Please input callback :\n");
	fprintf(stderr, "	0 - Enable\n");
	fprintf(stderr, "	1 - Disable\n");

	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	bool bEnable = to_int_def(cTemp, 1)==0;

	int iRet = 0;//NetClient_SetPsPackCallBack(g_uiRecv[iChannel+iStreamNo*g_iTotalChnlNum], bEnable?PsPackCallBack:NULL, NULL);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetPsPackCallBack failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetPsPackCallBack successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;

}

void COMRECV_NOTIFY_V4_Callback(int _ulLogonID, char *_buf, int _length,int _iComNo,void* _iUser)
{
	char cCmd[1024] = {0};
    unsigned char tmp = 0;
    for(int i=0; i<_length; i++)
    {
        tmp = *(_buf+i);
        sprintf(&cCmd[i*3], " %02x", tmp);
    }

    printf("Com Recv Nodify: LogonID = %d | Buf = %s | Length = %d | ComNO = %d\n", _ulLogonID, cCmd, _length, _iComNo);
	return ;
}


int Test_SetComRecvNotify_V4()
{
	fprintf(stderr, "You choose to test NetClient_SetComRecvNotify_V4, number is 465 \n");

	char cTemp[256] = {0};


	fprintf(stderr, "Please input callback :\n");
	fprintf(stderr, "	0 - Enable\n");
	fprintf(stderr, "	1 - Disable\n");

	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	bool bEnable = to_int_def(cTemp, 1)==0;

	int iRet = NetClient_SetComRecvNotify_V4(bEnable?COMRECV_NOTIFY_V4_Callback:NULL);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetComRecvNotify_V4 failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetComRecvNotify_V4 successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
	
}

int Test_VCAGetAlarmInfo()
{
	fprintf(stderr, "You choose to test NetClient_VCAGetAlarmInfo, number is 467\n");

	char cTemp[256] = {0};
	fprintf(stderr, "Please input alram index[0,49]:\n");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iAlarmIndex = to_int_def(cTemp, 0);

	vca_TAlarmInfo tInfo = {0};
	int iRet = NetClient_VCAGetAlarmInfo(g_iLogonID,iAlarmIndex,&tInfo,sizeof(vca_TAlarmInfo));
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_VCAGetAlarmInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "ID(%d),Channel(%d),State(%d),EventType(%d),RuleID(%d),TargetID(%u),TargetType(%d)\
						,TargetRect(%d,%d,%d,%d),TargetDirection(%d),TargetSpeed(%d)\n"
			,tInfo.iID,tInfo.iChannel,tInfo.iState,tInfo.iEventType,tInfo.iRuleID,tInfo.uiTargetID
			,tInfo.iTargetType,tInfo.rctTarget.left,tInfo.rctTarget.top,tInfo.rctTarget.right,tInfo.rctTarget.bottom
			,tInfo.iTargetDirection,tInfo.iTargetSpeed);
		fprintf(stderr, "NetClient_VCAGetAlarmInfo successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;
}

int Test_SetManagerServersInfo()
{
	fprintf(stderr, "You choose to test NetClient_SetManagerServersInfo, number is 468 \n");

	char cTemp[256] = {0};
	
	char cRegSvrIP[256]={0};
	fprintf(stderr, "Please input register server IP:");
	gets_s(cRegSvrIP, 256);
	if(0 == strcasecmp("q", cRegSvrIP))
	{
		return -1;
	}

	fprintf(stderr, "Please input the monitor port of the register server:");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	unsigned short wdRegPort = (unsigned short)to_int_def(cTemp, 0);


	char cHeartSvrIP[256]={0};
	fprintf(stderr, "Please input Heartbeat server IP:");
	gets_s(cHeartSvrIP, 256);
	if(0 == strcasecmp("q", cHeartSvrIP))
	{
		return -1;
	}

	fprintf(stderr, "Please input the monitor port of the heartbeat server:");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	unsigned short wdHeartPort = (unsigned short)to_int_def(cTemp, 0);

	char cAlarmSvrIP[256]={0};
	fprintf(stderr, "Please input Alarm server IP:");
	gets_s(cAlarmSvrIP, 256);
	if(0 == strcasecmp("q", cAlarmSvrIP))
	{
		return -1;
	}

	fprintf(stderr, "Please input the monitor port of the alarm server:");
	gets_s(cTemp, 256);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	unsigned short wdAlarmPort = (unsigned short)to_int_def(cTemp, 0);

	int iRet = NetClient_SetManagerServersInfo(g_iLogonID, cRegSvrIP, wdRegPort, cHeartSvrIP, wdHeartPort, cAlarmSvrIP, wdAlarmPort);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_SetManagerServersInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_SetManagerServersInfo successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;

}

int Test_GetManagerServersInfo()
{
	fprintf(stderr, "You choose to test NetClient_GetManagerServersInfo, number is 469 \n");

	//char cTemp[256] = {0};

	char cRegSvrIP[256]={0};
	unsigned short wdRegPort = 0;

	char cHeartSvrIP[256]={0};
	unsigned short wdHeartPort = 0;

	char cAlarmSvrIP[256]={0};
	unsigned short wdAlarmPort = 0;

	int iRet = NetClient_GetManagerServersInfo(g_iLogonID, cRegSvrIP, &wdRegPort, cHeartSvrIP, &wdHeartPort, cAlarmSvrIP, &wdAlarmPort);
	if(iRet!=0)
	{
		fprintf(stderr, "NetClient_GetVideoModeMethod failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "Register server IP: %s \n", cRegSvrIP);
		fprintf(stderr, "The monitor port of the register server: %u \n", wdRegPort);
		fprintf(stderr, "Heartbeat server IP: %s \n", cHeartSvrIP);
		fprintf(stderr, "The monitor port of the register server: %u \n", wdHeartPort);
		fprintf(stderr, "Register server IP: %s \n", cAlarmSvrIP);
		fprintf(stderr, "The monitor port of the register server: %u \n", wdAlarmPort);
		fprintf(stderr, "NetClient_GetVideoModeMethod successful\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:\n");
	return 0;

}

int Test_BindInterface()
{
	fprintf(stderr, "You choose to test NetClient_BindInterface, number is 470 \n");

	char cTemp[256] = {0};

	fprintf(stderr, "Please input net connect ID:");
	gets_s(cTemp, 256);

	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iNetConnectID = to_int_def(cTemp, -1);
	int iRet = NetClient_BindInterface(iNetConnectID);
	if (iRet!=0)
	{
		fprintf(stderr, "NetClient_BindInterface failed! return %d, errno = 0x%08x\n", iRet, errno);
	}
	else
	{
		fprintf(stderr, "NetClient_BindInterface succeed!\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:");
	return 0;
}

int Test_GetNetInterface()
{
	fprintf(stderr, "You choose to test NetClient_GetNetInterface, number is 471 \n");

	char cTemp[256] = {0};

	fprintf(stderr, "Please input net connect ID:");
	gets_s(cTemp, 256);

	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iNetConnectID = to_int_def(cTemp, -1);
	
	char* pcRet = NULL;
	pcRet = new char[16];
	pcRet = NetClient_GetNetInterface(iNetConnectID);
	if ( pcRet == NULL)
	{
		fprintf(stderr, "There isn't this Interface!\n");
	}
	else
	{
		fprintf(stderr, "the IP related to the ID is:%s\n", pcRet);
		fprintf(stderr, "NetClient_GetNetInterface succeed!\n");
	}

	fprintf(stderr, "Please type a number to test corresponding interface:");
	return 0;
}

int Test_NetLogGetLogCount()
{
	fprintf(stderr, "You choose to test NetClient_NetLogGetLogCount, number is 472\n");

	//char cTmp[256] = {0};
	int iTotalCount = 0;
	int iCurrentCount = 0;

	int iRet = NetClient_NetLogGetLogCount(g_iLogonID, &iTotalCount, &iCurrentCount);
	if (0 == iRet)
	{
		fprintf(stderr, "The total number of log is:%d\n", iTotalCount);
		fprintf(stderr, "The current number of log is:%d\n", iCurrentCount);
		fprintf(stderr, "Test NetClient_NetLogGetLogCount succeed!\n");
	}
	else
		fprintf(stderr, "Test NetClient_NetLogGetLogCount failed!");
	
	fprintf(stderr, "Please type a number to test corresponding interface:");
	return 0;
}

int Test_SetDomainParsePara_V4()
{
	int iInterval = 0;
	char cUserID[256] = {0};
	char cPassword[256] = {0};
	char cHost[256] = {0};
	char cDomain1[256] = {0};
	char cDomain2[256] = {0};
	int iPort1 = 0;
	int iPort2 = 0;
	char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_SetDomainParsePara_V4, number is 473\n");

	fprintf(stderr, "Please input domain register interval:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iInterval = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input domain register account:");
	gets_s(cUserID, 256);
	if(0 == strcasecmp("q", cUserID))
	{
		return -1;
	}

	fprintf(stderr, "Please input domain register password:");
	gets_s(cPassword, 256);
	if(0 == strcasecmp("q", cPassword))
	{
		return -1;
	}

	fprintf(stderr, "Please input domain register host name:");
	gets_s(cHost, 256);
	if(0 == strcasecmp("q", cHost))
	{
		return -1;
	}

	fprintf(stderr, "Please input domain register center IP:");
	gets_s(cDomain1, 256);
	if(0 == strcasecmp("q", cDomain1))
	{
		return -1;
	}

	fprintf(stderr, "Please input domain register center IP for backup:");
	gets_s(cDomain2, 256);
	if(0 == strcasecmp("q", cDomain2))
	{
		return -1;
	}

	fprintf(stderr, "Please input domain register center port:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iPort1 = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input domain register center port for backup:");
	memset(cTemp, 0, sizeof(cTemp));
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iPort2 = to_int_def(cTemp, -1);

	int iRet = NetClient_SetDomainParsePara_V4(g_iLogonID,
		iInterval,
		cUserID,
		cPassword,
		cHost,
		cDomain1,
		cDomain2,
		iPort1,
		iPort2);
	if(0 == iRet)
	{
		fprintf(stderr, "Sending command to server is OK!\n");
	}
	else
	{
		fprintf(stderr, "Sending command to server is failed!\n");
	}

	fprintf(stderr, "Please type interface to test:");
	return 0;

}

int Test_GetDomainParsePara_V4()
{
	int iInterval = 0;
	char cUserID[256] = {0};
	char cPassword[256] = {0};
	char cHost[256] = {0};
	char cDomain1[256] = {0};
	char cDomain2[256] = {0};
	int iPort1 = 0;
	int iPort2 = 0;


	fprintf(stderr, "You choose to test NetClient_GetDomainParsePara_V4, number is 474\n");

	int iRet = NetClient_GetDomainParsePara(g_iLogonID,
		&iInterval,
		cUserID,
		cPassword,
		cHost,
		cDomain1,
		cDomain2,
		&iPort1,
		&iPort2);
	if(0 == iRet)
	{
		fprintf(stderr, "GetDomainParsePara_V4 is OK!\n");
		fprintf(stderr, "Register interval is %d\n", iInterval);
		fprintf(stderr, "Register account is %s\n", cUserID);
		fprintf(stderr, "Register password is %s\n", cPassword);
		fprintf(stderr, "Register host name is %s\n", cHost);
		fprintf(stderr, "Register center IP is %s\n", cDomain1);
		fprintf(stderr, "Register center IP for backup is %s\n", cDomain2);
		fprintf(stderr, "Register center port is %d\n", iPort1);
		fprintf(stderr, "Register center port for backup is %d\n", iPort2);
	}
	else
	{
		fprintf(stderr, "GetDomainParsePara_V4 is failed!\n");
	}

	fprintf(stderr, "Please type interface to test:");
	return 0;
}

int Test_SetHTTPPort_V4()
{
	int iPort = 0;
	char cTemp[8] = {0};

	fprintf(stderr, "You choose to test NetClient_SetHTTPPort_V4, number is 475\n");

	fprintf(stderr, "Please input http port:");
	gets_s(cTemp, 8);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	iPort = to_int_def(cTemp, -1);

	int iRet = NetClient_SetHTTPPort_V4(g_iLogonID, iPort);
	if(0 == iRet)
	{
		fprintf(stderr, "Sending command to server is OK!\n");
	}
	else
	{
		fprintf(stderr, "Sending command to server is failed!\n");
	}

	fprintf(stderr, "Please type interface to test:");
	return 0;
}

int Test_GetHTTPPort_V4()
{
	int iPort = 0;

	fprintf(stderr, "You choose to test NetClient_GetHTTPPort_V4, number is 476\n");


	int iRet = NetClient_GetHTTPPort_V4(g_iLogonID, &iPort);
	if(0 == iRet)
	{
		fprintf(stderr, "GetHTTPPort_V4 is OK!\n");
		fprintf(stderr, "Http port is %d\n", iPort);
	}
	else
	{
		fprintf(stderr, "GetHTTPPort_V4 failed!\n");
	}

	fprintf(stderr, "Please type interface to test:");
	return 0;
}

int Test_GetConnectInfo()
{
	fprintf(stderr, "You choose to test NetClient_GetConnectInfo, number is 477\n");
	TTotalConnectInfo strChannelConnectInfo;
	memset(&strChannelConnectInfo,0,sizeof(TTotalConnectInfo));
	int iChannelNum = 0;
	int iRet = NetClient_GetChannelNum(g_iLogonID, &iChannelNum);

	iRet = NetClient_GetConnectInfo(g_iLogonID, &strChannelConnectInfo,sizeof(TTotalConnectInfo));
	if (0 == iRet)
	{
		fprintf(stderr, "Logon Information:\n");
		for (int i=0;i<MAX_CONNECT_COUNT;i++)
		{
			if (strcmp(strChannelConnectInfo.connInfo[i].cClientIP, "") == 0 || strChannelConnectInfo.connInfo[i].iChannelType == 1)
			{
				continue;
			}
			fprintf(stderr, "Client IP is %s\n", strChannelConnectInfo.connInfo[i].cClientIP);
			fprintf(stderr, "User name is %s\n", strChannelConnectInfo.connInfo[i].cUserName);
			fprintf(stderr, "\n\n");
		}
		
		fprintf(stderr, "Connect Information:\n");
		for (int i=0;i<MAX_CONNECT_COUNT;i++)
		{
			if (strcmp(strChannelConnectInfo.connInfo[i].cClientIP, "") == 0 || strChannelConnectInfo.connInfo[i].iChannelType == 0)
			{
				continue;
			}
			fprintf(stderr,"channel ID is: %d\n", strChannelConnectInfo.connInfo[i].iChannelID);
			fprintf(stderr, "Client IP is %s\n", strChannelConnectInfo.connInfo[i].cClientIP);
			fprintf(stderr, "Channel Type is %d(0--command channel;1--data channel;2---innertalk;4----pictrue;other----download)\n", strChannelConnectInfo.connInfo[i].iChannelType);
			fprintf(stderr, "Net mode is %d(1--TCP;2--UDP;3--Multicast;4--Automatic mode)\n", strChannelConnectInfo.connInfo[i].iNetMode);
			fprintf(stderr, "User name is %s\n", strChannelConnectInfo.connInfo[i].cUserName);
			fprintf(stderr, "\n\n\n\n");
		}
		fprintf(stderr, "NetClient_GetConnectInfo succeed!\n");

	}
	else if (iRet!=0)
	{
		fprintf(stderr, "NetClient_GetConnectInfo failed! return %d, errno = 0x%08x\n", iRet, errno);
	}

	fprintf(stderr, "Please type interface to test:");
	return 0;

}

int Test_SetHXListenPortInfo()
{
	char cTemp[20] = {0};
	fprintf(stderr, "You choose to test NetClient_SetHXListenPortInfo, number is 478\n");
	fprintf(stderr, "Please input video port:");
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iVideoPort = to_int_def(cTemp, -1);

	fprintf(stderr, "Please input talk port:");
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iTalkPort = to_int_def(cTemp, -1);	
	
	fprintf(stderr, "Please input msg port:");
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iMsgPort = to_int_def(cTemp, -1);
	
	int iRet = NetClient_SetHXListenPortInfo(g_iLogonID, iVideoPort,iTalkPort,iMsgPort);
	if(0 == iRet)
	{
		fprintf(stderr, "SetHXListenPortInfo success!\n");
		fprintf(stderr, "video port(%d),talk port(%d),msg port(%d)\n", iVideoPort,iTalkPort,iMsgPort);
	}
	else
	{
		fprintf(stderr, "SetHXListenPortInfo failed!\n");
	}

	fprintf(stderr, "Please type interface to test:");
	return 0;
	
}

int Test_GetHXListenPortInfo()
{
	fprintf(stderr, "You choose to test NetClient_GetHXListenPortInfo, number is 479\n");

	int iVideoPort = 0;
	int iTalkPort = 0;	
	int iMsgPort = 0;
	int iRet = NetClient_GetHXListenPortInfo(g_iLogonID, &iVideoPort,&iTalkPort,&iMsgPort);
	if(0 == iRet)
	{
		fprintf(stderr, "GetHXListenPortInfo success!\n");
		fprintf(stderr, "video port(%d),talk port(%d),msg port(%d)\n", iVideoPort,iTalkPort,iMsgPort);
	}
	else
	{
		fprintf(stderr, "GetHXListenPortInfo failed!\n");
	}

	fprintf(stderr, "Please type interface to test:");
	return 0;
}

int Test_NetFileLockFile()
{
	char cTemp[8] = {0};
	char cFilename[256] = {0};
	fprintf(stderr, "You choose to test NetClient_NetFileLockFile!\n");
	fprintf(stderr, "Before you test this interface,you should test NetClient_NetFileQueryEx to get the file name!\n");

	fprintf(stderr, "Please input file name:\n");
	gets_s(cFilename,255);
	if(0 == strcasecmp("q", cFilename))
	{
		return -1;
	}

	fprintf(stderr, "Please input new lock state\n");
	fprintf(stderr, "unlock--0; lock--1.\n");
	gets_s(cTemp, 8);
	if (0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iLock = to_int_def(cTemp, -1);
	int iRet = NetClient_NetFileLockFile(g_iLogonID, cFilename, iLock);
	if (0 == iRet)
	{
		fprintf(stderr, "NetClient_NetFileLockFile test succeed!");
	}
	else
		fprintf(stderr, "NetClient_NetFileLockFile test filed!");
	return 0;
}

int Test_GetGroupAuthority()
{
	fprintf(stderr, "You choose to test NetClient_GetGroupAuthority, number is 481\n");
	fprintf(stderr, "Please choose group authority :\n");
	fprintf(stderr, "1:General User\n");
	fprintf(stderr, "2:Prerogative User\n");
	fprintf(stderr, "3:Super User\n");
	fprintf(stderr, "4:Administrator\n");

	char cTemp[8] = {0};
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iGroupAuthority = to_int_def(cTemp, -1);

	GROUP_AUTHORITY strGroupAut = {0};
	strGroupAut.iSize = sizeof(GROUP_AUTHORITY);
	strGroupAut.iGroupNO = iGroupAuthority;
	int iBufSize = sizeof(GROUP_AUTHORITY);
	int iRet = NetClient_GetGroupAuthority(g_iLogonID, &strGroupAut, iBufSize);
	if (0 == iRet)
	{
		fprintf(stderr, "NetClient_GetGroupAuthority test succeed!");
		fprintf(stderr, "Group Authority[%d] is %d\n", iGroupAuthority, strGroupAut.uiList[0]);
	}
	else
	{
		fprintf(stderr, "NetClient_GetGroupAuthority test filed!");
	}

	return 0;
}

int Test_ModifyUserAuthority()
{
	fprintf(stderr, "You choose to test NetClient_ModifyUserAuthority, number is 482\n");
	fprintf(stderr, "please input user name:\n");
	char cUserName[20] = {0};
	gets_s(cUserName, 18);
	if(0 == strcasecmp("q", cUserName))
	{
		return -1;
	}

	if (0 == strcasecmp(cUserName, "Admin"))
	{
		fprintf(stderr, "Modify 'Admin' authority is forbidden\n");
		return -1;
	}

	fprintf(stderr, "Please input modify authority's num[1-10]:\n");
	char cTemp[8] = {0};
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iCount = to_int_def(cTemp, -1);
	USER_AUTHORITY strUserAut = {0};
	int iUserAutSize = sizeof(USER_AUTHORITY);
	strUserAut.iNeedSize = sizeof(AUTHORITY_INFO)*iCount+4;

	for (int i=0; i<iCount; i++)
	{
		fprintf(stderr, "Please input authority NO[0-24]:\n");
		fprintf(stderr, "0:Local PTZ\n");
		fprintf(stderr, "1:Local Playback\n");
		fprintf(stderr, "2:Remote PTZ\n");
		fprintf(stderr, "3:Remote Playback\n");
		fprintf(stderr, "4:Remote Preview\n");
		fprintf(stderr, "5:Local Hand Operate\n");
		fprintf(stderr, "6:Remote Hand Operate\n");
		fprintf(stderr, "7:Local Hand Clear Alarm \n");
		fprintf(stderr, "8:Local Record and Playback \n");
		fprintf(stderr, "9:Local Log Search \n");
		fprintf(stderr, "10:Local Alarm Setting \n");
		fprintf(stderr, "11:Local Channel Management \n");
		fprintf(stderr, "12:Local Param Setting \n");
		fprintf(stderr, "13:Local System Setting \n");
		fprintf(stderr, "14:Local User Management \n");
		fprintf(stderr, "15:Remote Hand Clear Alarm \n");
		fprintf(stderr, "16:Remote Shutdown and Reboot\n");
		fprintf(stderr, "17:Remote Record\n");
		fprintf(stderr, "18:Remote Log Search\n");
		fprintf(stderr, "19:Remote Alarm Setting \n");
		fprintf(stderr, "20:Remote Channel Management\n");
		fprintf(stderr, "21:Remote Param Setting\n");
		fprintf(stderr, "22:Remote System Setting\n");
		fprintf(stderr, "23:Remote User Management\n");
		fprintf(stderr, "24:Talkback\n");

		gets_s(cTemp, 11);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		strUserAut.strAutInfo[i].iLevel = to_int_def(cTemp, -1);
		if (strUserAut.strAutInfo[i].iLevel < 7)
		{
			fprintf(stderr, "the authority is channel authority, please input channel list:\n");
			gets_s(cTemp, 20);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			strUserAut.strAutInfo[i].uiList[0] = to_int_def(cTemp, -1);
		}
		else
		{
			fprintf(stderr, "please input channel list(yes:1,no:0):\n");
			gets_s(cTemp, 11);
			if(0 == strcasecmp("q", cTemp))
			{
				return -1;
			}
			strUserAut.strAutInfo[i].uiList[0] = to_int_def(cTemp, -1);
		}
	}

	int iRet = NetClient_ModifyUserAuthority(g_iLogonID, cUserName, &strUserAut, iUserAutSize);
	if (0 == iRet)
	{
		fprintf(stderr, "NetClient_ModifyUserAuthority test succeed!");
	}
	else
	{
		fprintf(stderr, "NetClient_ModifyUserAuthority test filed!");
	}
	return 0;
}

int Test_GetUserAuthority()
{
	fprintf(stderr, "You choose to test NetClient_ModifyUserAuthority, number is 483\n");
	fprintf(stderr, "please input user name:\n");
	char cUserName[20] = {0};
	gets_s(cUserName, 18);
	if(0 == strcasecmp("q", cUserName))
	{
		return -1;
	}
	USER_AUTHORITY strUserAut = {0};
	int iUserAutSize = sizeof(USER_AUTHORITY);
	strUserAut.iNeedSize = sizeof(USER_AUTHORITY);
	int iRet = NetClient_GetUserAuthority(g_iLogonID, cUserName, &strUserAut, iUserAutSize);
	if (0 == iRet)
	{
		fprintf(stderr, "0:Local PTZ: %x\n", strUserAut.strAutInfo[0].uiList[0]);
		fprintf(stderr, "1:Local Playback:%x\n", strUserAut.strAutInfo[1].uiList[0]);
		fprintf(stderr, "2:Remote PTZ:%x\n", strUserAut.strAutInfo[2].uiList[0]);
		fprintf(stderr, "3:Remote Playback:%x\n", strUserAut.strAutInfo[3].uiList[0]);
		fprintf(stderr, "4:Remote Preview:%x\n", strUserAut.strAutInfo[4].uiList[0]);
		fprintf(stderr, "5:Local Hand Operate:%x\n", strUserAut.strAutInfo[5].uiList[0]);
		fprintf(stderr, "6:Remote Hand Operate:%x\n", strUserAut.strAutInfo[6].uiList[0]);
		fprintf(stderr, "7:Local Hand Clear Alarm :%d\n", strUserAut.strAutInfo[7].uiList[0]);
		fprintf(stderr, "8:Local Record and Playback:%d \n", strUserAut.strAutInfo[8].uiList[0]);
		fprintf(stderr, "9:Local Log Search:%d \n", strUserAut.strAutInfo[9].uiList[0]);
		fprintf(stderr, "10:Local Alarm Setting:%d \n", strUserAut.strAutInfo[10].uiList[0]);
		fprintf(stderr, "11:Local Channel Management :%d\n", strUserAut.strAutInfo[11].uiList[0]);
		fprintf(stderr, "12:Local Param Setting :%d\n", strUserAut.strAutInfo[12].uiList[0]);
		fprintf(stderr, "13:Local System Setting :%d\n", strUserAut.strAutInfo[13].uiList[0]);
		fprintf(stderr, "14:Local User Management:%d \n", strUserAut.strAutInfo[14].uiList[0]);
		fprintf(stderr, "15:Remote Hand Clear Alarm :%d\n", strUserAut.strAutInfo[15].uiList[0]);
		fprintf(stderr, "16:Remote Shutdown and Reboot:%d\n", strUserAut.strAutInfo[16].uiList[0]);
		fprintf(stderr, "17:Remote Record:%d\n", strUserAut.strAutInfo[17].uiList[0]);
		fprintf(stderr, "18:Remote Log Search:%d\n", strUserAut.strAutInfo[18].uiList[0]);
		fprintf(stderr, "19:Remote Alarm Setting :%d\n", strUserAut.strAutInfo[19].uiList[0]);
		fprintf(stderr, "20:Remote Channel Management:%d\n", strUserAut.strAutInfo[20].uiList[0]);
		fprintf(stderr, "21:Remote Param Setting:%d\n", strUserAut.strAutInfo[21].uiList[0]);
		fprintf(stderr, "22:Remote System Setting:%d\n", strUserAut.strAutInfo[22].uiList[0]);
		fprintf(stderr, "23:Remote User Management:%d\n", strUserAut.strAutInfo[23].uiList[0]);
		fprintf(stderr, "24:Talkback:%d\n", strUserAut.strAutInfo[24].uiList[0]);
		fprintf(stderr, "NetClient_GetUserAuthority test succeed!");
	}
	else
	{
		fprintf(stderr, "NetClient_GetUserAuthority test filed!");
	}
	return 0;
}

int Test_SetDiskGroup()
{
	fprintf(stderr, "You choose to test NetClient_SetDiskGroup, number is 484\n");
	fprintf(stderr, "please input disk group count[1-8]:\n");
	char cTemp[8] = {0};
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iDiskGroupNum = to_int_def(cTemp, -1);
	DISK_GROUP strDiskGroup[MAX_DISK_GROUP_NUM] = {0};
	for (int i=0; i<iDiskGroupNum; i++)
	{
		strDiskGroup[i].iSize = sizeof(DISK_GROUP);
		fprintf(stderr, "please input disk group No[0-7]:\n");
		gets_s(cTemp, 11);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		strDiskGroup[i].iGroupNO = to_int_def(cTemp, -1);

		fprintf(stderr, "please input disk No[1-8] in Bits:\n");
		gets_s(cTemp, 11);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		strDiskGroup[i].uiDiskNO[0] = to_int_def(cTemp, -1);	

		int iChannelNum = 0;
		NetClient_GetChannelNum(g_iLogonID, &iChannelNum);
		fprintf(stderr, "please input channel No[1-%d] in Bits:\n", iChannelNum);
		gets_s(cTemp, 11);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		strDiskGroup[i].uiChannelNO[0] = to_int_def(cTemp, -1);	
	}
	int iRet = NetClient_SetDiskGroup(g_iLogonID, strDiskGroup, iDiskGroupNum);
	if (0 == iRet)
	{
		int iEnableValue = -1;
		iRet = NetClient_GetCommonEnable(g_iLogonID, CI_STORAGE_DISK_GROUP, 0x7FFFFFFF, &iEnableValue);
		iRet = NetClient_SetCommonEnable(g_iLogonID, CI_STORAGE_DISK_GROUP, 0x7FFFFFFF, 1);
		iRet = NetClient_SetCommonEnable(g_iLogonID, CI_STORAGE_DISK_QUOTA, 0x7FFFFFFF, 0);

		if (iEnableValue == 1)
		{	
			iRet = NetClient_Reboot(g_iLogonID);
			fprintf(stderr, "Rebooting...!");
		}
		fprintf(stderr, "NetClient_SetDiskGroup test succeed!");
	}
	else
	{
		fprintf(stderr, "NetClient_SetDiskGroup test filed!");
	}
	return 0;
}

int Test_GetDiskGroup()
{
	fprintf(stderr, "You choose to test NetClient_GetDiskGroup, number is 485\n");
	DISK_GROUP strDiskGroup[MAX_DISK_GROUP_NUM] = {0};
	int iRet = NetClient_GetDiskGroup(g_iLogonID, strDiskGroup, MAX_DISK_GROUP_NUM);
	if (0 == iRet)
	{
		for (int i=0; i<MAX_DISK_GROUP_NUM; i++)
		{
			fprintf(stderr, "Disk group No:%d\n",i);
			fprintf(stderr, "Disk No (in Bits):%d\n",strDiskGroup[i].uiDiskNO[0]);
			fprintf(stderr, "Disk No (in Bits):%d\n", strDiskGroup[i].uiChannelNO[0]);
		}
		fprintf(stderr, "NetClient_GetDiskGroup test succeed!");
	}
	else
	{
		fprintf(stderr, "NetClient_GetDiskGroup test filed!");
	}
	return 0;
}

int Test_SetDiskQuota()
{
	fprintf(stderr, "You choose to test NetClient_SetDiskQuota, number is 486\n");
	fprintf(stderr, "please input channel No[1-32]:\n");
	char cTemp[8] = {0};
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannel = to_int_def(cTemp, -1)-1;
	DISK_QUOTA strDiskQuota = {0};
	strDiskQuota.iSize = sizeof(DISK_QUOTA);
	int iBufSize = sizeof(DISK_QUOTA);
	fprintf(stderr, "please input channel[%d]'s record quota:\n", iChannel);
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strDiskQuota.iRecordQuota = to_int_def(cTemp, -1);

	fprintf(stderr, "please input channel[%d]'s picture quota:\n", iChannel);
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	strDiskQuota.iPictureQuota = to_int_def(cTemp, -1);
	int iRet = NetClient_SetDiskQuota(g_iLogonID, iChannel, &strDiskQuota, iBufSize);
	if (0 == iRet)
	{
		int iEnableValue = -1;
		iRet = NetClient_GetCommonEnable(g_iLogonID, CI_STORAGE_DISK_GROUP, 0x7FFFFFFF, &iEnableValue);
		iRet = NetClient_SetCommonEnable(g_iLogonID, CI_STORAGE_DISK_GROUP, 0x7FFFFFFF, 0);
		iRet = NetClient_SetCommonEnable(g_iLogonID, CI_STORAGE_DISK_QUOTA, 0x7FFFFFFF, 1);

		if (iEnableValue == 0)
		{	
			iRet = NetClient_Reboot(g_iLogonID);	
			fprintf(stderr, "Rebooting...!");
		}
		fprintf(stderr, "NetClient_SetDiskQuota test succeed!");
	}
	else
	{
		fprintf(stderr, "NetClient_SetDiskQuota test filed!");
	}
	return 0;
}

int Test_GetDiskQuotaState()
{
	fprintf(stderr, "You choose to test NetClient_GetDiskQuotaState, number is 487\n");
	fprintf(stderr, "please input channel No[1-32]:\n");
	char cTemp[8] = {0};
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iChannel = to_int_def(cTemp, -1)-1;
	fprintf(stderr, "please input state No:\n");
	fprintf(stderr, "1:Disk[%d] quota \n", iChannel);
	fprintf(stderr, "2:Device total size\n");
	fprintf(stderr, "3:Disk[%d] quota used\n", iChannel);
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	int iStateNo = to_int_def(cTemp, -1);
	int iRet = -1;
	if (iStateNo == CMD_DISK_QUOTA_MAX_USED)
	{
		DISK_QUOTA strDiskQuota = {0};
		strDiskQuota.iSize = sizeof(DISK_QUOTA);
		int iBufSize = sizeof(DISK_QUOTA);
		iRet = NetClient_GetDiskQuotaState(g_iLogonID, iChannel, CMD_DISK_QUOTA_MAX_USED, &strDiskQuota, iBufSize);
		if (0 == iRet)
		{
			fprintf(stderr, "channel[%d]'s record quota is %d\n",iChannel, strDiskQuota.iRecordQuota);
			fprintf(stderr, "channel[%d]'s picture quota is %d\n",iChannel, strDiskQuota.iPictureQuota);
			fprintf(stderr, "NetClient_GetDiskQuotaState test succeed!");
		}
		else
		{
			fprintf(stderr, "NetClient_GetDiskQuotaState test filed!");
		}
	}
	else if (iStateNo == CMD_DISK_QUOTA_TOTAL)
	{
		int iTotalDiskSize = 0;
		int iBufSize = sizeof(iTotalDiskSize);
		iRet = NetClient_GetDiskQuotaState(g_iLogonID, iChannel, CMD_DISK_QUOTA_TOTAL, &iTotalDiskSize, iBufSize);
		if (0 == iRet)
		{
			fprintf(stderr, "Device disk total quota is %d\n",iTotalDiskSize);
			fprintf(stderr, "NetClient_GetDiskQuotaState test succeed!");
		}
		else
		{
			fprintf(stderr, "NetClient_GetDiskQuotaState test filed!");
		}
	}
	else if (iStateNo == CMD_DISK_QUOTA_CURRENT_USED)
	{
		DISK_QUOTA_USED strDiskQuotaUsed = {0};
		strDiskQuotaUsed.iSize = sizeof(DISK_QUOTA_USED);
		int iBufSize = sizeof(DISK_QUOTA_USED);
		iRet = NetClient_GetDiskQuotaState(g_iLogonID, iChannel, CMD_DISK_QUOTA_CURRENT_USED, &strDiskQuotaUsed, iBufSize);
		if (0 == iRet)
		{
			fprintf(stderr, "channel[%d]'s record quota is %s\n",iChannel, strDiskQuotaUsed.cRecordQuota);
			fprintf(stderr, "channel[%d]'s picture quota is %s\n",iChannel, strDiskQuotaUsed.cPictureQuota);
			fprintf(stderr, "NetClient_GetDiskQuotaState test succeed!");
		}
		else
		{
			fprintf(stderr, "NetClient_GetDiskQuotaState test filed!");
		}
	}
	return 0;
}

int Test_SetHolidayPlan()
{
	fprintf(stderr, "You choose to test NetClient_SetHolidayPlan, number is 488\n");
	HOLIDAYPLAN_SCHEDULE tSchedule = {0};
	fprintf(stderr, "please input plan ID[0-9]:\n");
	char cTemp[8] = {0};
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tSchedule.iPlanID = to_int_def(cTemp, -1);
	fprintf(stderr, "please input enable(1:enable,0:disalble):\n");
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tSchedule.iEnable = to_int_def(cTemp, -1);
	fprintf(stderr, "please input plan name:\n");
	gets_s(tSchedule.cPlanName, 32);
	if(0 == strcasecmp("q", tSchedule.cPlanName))
	{
		return -1;
	}
	fprintf(stderr, "please input mode(0:Date,1:Week,2:Month):\n");
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tSchedule.iMode = to_int_def(cTemp, -1);
	if (tSchedule.iMode == 0)
	{
		fprintf(stderr, "please input start time-end time(year.month.day-year.month.day)\n");
		gets_s(cTemp, 30);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		sscanf(cTemp, "%hd.%hd.%hd-%hd.%hd.%hd", 
			&tSchedule.tStartTime.iYear,
			&tSchedule.tStartTime.iMonth,
			&tSchedule.tStartTime.iDay,
			&tSchedule.tEndTime.iYear,
			&tSchedule.tEndTime.iMonth,
			&tSchedule.tEndTime.iDay);
		fprintf(stderr, "%hd.%hd.%hd-%hd.%hd.%hd\n",tSchedule.tStartTime.iYear,tSchedule.tStartTime.iMonth,
			tSchedule.tStartTime.iDay,tSchedule.tEndTime.iYear,tSchedule.tEndTime.iMonth,tSchedule.tEndTime.iDay);

	}
	else if (tSchedule.iMode == 1)
	{
		fprintf(stderr, "please input start time-end time(month.week of month.day of week-month.week of month.day of week)\n");
		gets_s(cTemp, 30);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		sscanf(cTemp, "%hd.%hd.%hd-%hd.%hd.%hd", 
			&tSchedule.tStartTime.iMonth,
			&tSchedule.tStartTime.iWeekOfMonth,
			&tSchedule.tStartTime.iDayOfWeek,
			&tSchedule.tEndTime.iMonth,
			&tSchedule.tEndTime.iWeekOfMonth,
			&tSchedule.tEndTime.iDayOfWeek);
	}
	else if (tSchedule.iMode == 2)
	{
		fprintf(stderr, "please input start time-end time(month.day-month.day)\n");
		gets_s(cTemp, 30);
		if(0 == strcasecmp("q", cTemp))
		{
			return -1;
		}
		sscanf(cTemp, "%hd.%hd-%hd.%hd", 
			&tSchedule.tStartTime.iMonth,
			&tSchedule.tStartTime.iDay,
			&tSchedule.tEndTime.iMonth,
			&tSchedule.tEndTime.iDay);
	}
	int iBufSize = sizeof(HOLIDAYPLAN_SCHEDULE);
	int iRet = NetClient_SetHolidayPlan(g_iLogonID,HOLIDAY_PLAN_CMD_SCHEDULE,&tSchedule,iBufSize);
	if (0 == iRet)
	{
		fprintf(stderr, "NetClient_SetHolidayPlan test succeed!");
	}
	else
	{
		fprintf(stderr, "NetClient_SetHolidayPlan test filed!");
	}
	return 0;
}

int Test_GetHolidayPlan()
{
	fprintf(stderr, "You choose to test NetClient_GetHolidayPlan, number is 489\n");
	HOLIDAYPLAN_SCHEDULE tSchedule = {0};
	fprintf(stderr, "please input plan ID[0-9]:\n");
	char cTemp[8] = {0};
	gets_s(cTemp, 11);
	if(0 == strcasecmp("q", cTemp))
	{
		return -1;
	}
	tSchedule.iPlanID = to_int_def(cTemp, -1);
	int iBufSize = sizeof(HOLIDAYPLAN_SCHEDULE);
	int iRet = NetClient_GetHolidayPlan(g_iLogonID,HOLIDAY_PLAN_CMD_SCHEDULE,&tSchedule,iBufSize);
	if (0 == iRet)
	{
		fprintf(stderr, "Enable(1:enable,0:disalble):%d\n",tSchedule.iEnable);
		fprintf(stderr, "Plan name:%s\n", tSchedule.cPlanName);
		fprintf(stderr, "Mode(0:Date,1:Week,2:Month):%d\n",tSchedule.iMode);
		if (0 == tSchedule.tStartTime.iYear)
		{
			tSchedule.tStartTime.iYear = 1970;
		}
		if (0 == tSchedule.tStartTime.iMonth)
		{
			tSchedule.tStartTime.iMonth = 1;
		}
		if (0 == tSchedule.tStartTime.iDay)
		{
			tSchedule.tStartTime.iDay = 1;
		}
		if (0 == tSchedule.tEndTime.iYear)
		{
			tSchedule.tEndTime.iYear = 1970;
		}
		if (0 == tSchedule.tEndTime.iMonth)
		{
			tSchedule.tEndTime.iMonth = 1;
		}
		if (0 == tSchedule.tEndTime.iDay)
		{
			tSchedule.tEndTime.iDay = 1;
		}
		if (tSchedule.iMode == 0)
		{
			fprintf(stderr, "start time-end time(%d.%d.%d-%d.%d.%d)\n",tSchedule.tStartTime.iYear,
				tSchedule.tStartTime.iMonth,tSchedule.tStartTime.iDay,tSchedule.tEndTime.iYear,
				tSchedule.tEndTime.iMonth,tSchedule.tEndTime.iDay);
		}
		else if (tSchedule.iMode == 1)
		{
			fprintf(stderr, "start time-end time(%d.%d.%d-%d.%d.%d)\n",tSchedule.tStartTime.iMonth,
				tSchedule.tStartTime.iWeekOfMonth,tSchedule.tStartTime.iDayOfWeek,tSchedule.tEndTime.iMonth,
				tSchedule.tEndTime.iWeekOfMonth,tSchedule.tEndTime.iDayOfWeek);
		}
		else if (tSchedule.iMode == 2)
		{
			fprintf(stderr, "start time-end time(%d.%d-%d.%d)\n",tSchedule.tStartTime.iMonth,
				tSchedule.tStartTime.iDay,tSchedule.tEndTime.iMonth,tSchedule.tEndTime.iDay);
		}
		fprintf(stderr, "NetClient_GetHolidayPlan test succeed!");
	}
	else
	{
		fprintf(stderr, "NetClient_GetHolidayPlan test filed!");
	}
	return 0;
}
